
`timescale 1ns / 1ps
// synthesis translate_on
module ADC_TLC549 (
                   // inputs:
                    clk,
                    read_n,
                   // outputs:
                    AD_DATA,
                    AD_CS,
                    AD_CLK,
                    irq,
                    readdata                     
                 )
;

  input           AD_DATA;
  output           AD_CS;
  output           AD_CLK;
  output           irq;
  output   [7: 0]  readdata;
  input            read_n;
  input            clk;
  wire             AD_DATA;
  reg              AD_CS;
  reg              AD_CLK_r;
  reg              AD_CLK_EN;
  reg     [10:0]   DCLK_DIV;
  reg     [4:0]    COUNTER;
  reg     [7:0]   data_out;
  reg     [7:0]   data_reg;
  reg             irq;
  wire    [7: 0] readdata;

parameter CLK_FREQ = 'D50_000_000;
parameter DCLK_FREQ = 'D1_000_000;

assign readdata =  data_out;


always @(posedge clk)
  if(DCLK_DIV < (CLK_FREQ / DCLK_FREQ))
    DCLK_DIV <= DCLK_DIV+1'b1;
  else
    begin 
      DCLK_DIV <= 0;
      AD_CLK_r <= ~AD_CLK_r;
    end


always @(posedge AD_CLK_r)
      COUNTER <= COUNTER+1'b1;

always @(posedge AD_CLK_r)
     if(COUNTER == 0)
       begin
        AD_CS<= 1'b0;
        irq <= 0;
       end
      else if(COUNTER >= 'd2 && COUNTER <= 'd9)
         begin
          data_reg[0] <= AD_DATA;
          data_reg[7:1] <= data_reg[6:0];
          AD_CLK_EN <= 1;
         end
        else if(COUNTER > 9)
          begin
           data_out <= data_reg;
           irq <= 1;
           AD_CS<= 1'b1;
           AD_CLK_EN =1'b0;
          end 

assign AD_CLK =  AD_CLK_EN ? AD_CLK_r : 1'b1;

  //control_slave, which is an e_avalon_slave

endmodule

