module ps2_top(
            //input
              clk,
              kb_data,
              kb_clk,
              reset_n,
              read_n,
           //output
              readdata,      
              irq   
                );

input           read_n;
input           clk;
input           kb_data;
input           kb_clk;
input           reset_n;
//
output  [15:0]  readdata;
output          irq;

wire    [7:0]   asciidata;
wire    [7:0]   scandata;

reg             irq;
reg     [2:0]   cont;
reg             sys_clk;
wire    [7:0]   PA;
wire            ZHJS;

assign readdata = !read_n? {scandata,asciidata}:16'h0000;

always @ (posedge clk or negedge reset_n)
    if(!reset_n)
       cont <= 0;
       else if( cont < 4)
         cont <=  cont + 1;
          else
           begin
            cont <= 0;
            sys_clk <= ~sys_clk;
           end


data_scanC U1(
           .data(scandata),
           .PA(PA),
           .ZHJS(ZHJS),
           .sys_clk(sys_clk),
           .k_data(kb_data),
           .k_clock(kb_clk),
           .reset_n(reset_n)
              );

convert   U2(
            .read_n(read_n),
            .Scan(PA),
            .prepared(ZHJS),
            .clr_n(reset_n),
            .data(asciidata),
            .intr(irq)
             );

endmodule