/****************************************Copyright (c)**************************************************
**                               Guangzou ZLG-MCU Development Co.,LTD.
**                                      graduate school
**                                 http://www.zlgmcu.com
**
**--------------File Info-------------------------------------------------------------------------------
** File name:			pwm_avalon_interface.v
** Last modified Date:	2005-12-13
** Last Version:		1.0
** Descriptions:		PWM logic
**------------------------------------------------------------------------------------------------------
** Created by:			LiuYingbin
** Created date:		2005-12-13
** Version:				1.0
** Descriptions:		The original version
**
**------------------------------------------------------------------------------------------------------
** Modified by:			
** Modified date:		
** Version:				
** Descriptions:		
**
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/

module pwm_avalon_interface(
	//Avalon Signals
	clock,
	reset_n,
	chip_select,
	address,
	write,
	write_data,
	read,
	read_data,
	
	//PWM Output Signals
	pwm_out
 );

		//Avalon_Slave_PWM Avalon I/O
		input 			clock;		 	//System clock - tied to all blocks
		input 			reset_n;		//System reset - tied to all blocks
		input 			chip_select;	//Avalon Chip select
		input [1:0]		address;	    //Avalon Address bus 
		input 			write;			//Avalon Write signal
		input [31:0]	write_data;		//Avalon Write data bus
		input 			read;		    //Avalon Read signal
			
		output [31:0]	read_data;		//Avalon Read data bus
		
		//Avalon_Slave_PWM Exported I/O
		output 			pwm_out;		//PWM output signal
	
wire [31:0] pwm_clock_divide;  		//Clock divide wire from register file to pwm task logic
wire [31:0] pwm_duty_cycle;    		//Duty cycle value from register file to pwm task logic
wire 	      pwm_enable;       	//PWM enable signal from register file to pwm task logic
	

//PWM Instance
pwm_task_logic U1(
	    .clock(clock ),
	    .pwm_enable(pwm_enable),
	    .reset_n(reset_n),
	    //********************
	    .clock_divide(pwm_clock_divide),
	    .duty_cycle(pwm_duty_cycle),
	    .pwm_out(pwm_out)
		);

//Register File instance
pwm_register_file U2(	
		.clock(clock),
		.reset_n(reset_n),
		.chip_select(chip_select),
		.address(address),
		.write(write),
		.write_data(write_data),
		.read(read),
		.read_data(read_data),
		//********************
		.pwm_clock_divide(pwm_clock_divide),
		.pwm_duty_cycle(pwm_duty_cycle),
		.pwm_enable(pwm_enable)
		);

endmodule







