//megafunction wizard: %Altera SOPC Builder%
//GENERATION: STANDARD
//VERSION: WM1.0


//Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
//use of Altera Corporation's design tools, logic functions and other
//software and tools, and its AMPP partner logic functions, and any
//output files any of the foregoing (including device programming or
//simulation files), and any associated documentation or information are
//expressly subject to the terms and conditions of the Altera Program
//License Subscription Agreement or other applicable license agreement,
//including, without limitation, that your use is for the sole purpose
//of programming logic devices manufactured by Altera and sold by Altera
//or its authorized distributors.  Please refer to the applicable
//agreement for further details.

// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module E_RST_s1_arbitrator (
                             // inputs:
                              clk,
                              cpu_0_data_master_address_to_slave,
                              cpu_0_data_master_read,
                              cpu_0_data_master_waitrequest,
                              cpu_0_data_master_write,
                              cpu_0_data_master_writedata,
                              reset_n,

                             // outputs:
                              E_RST_s1_address,
                              E_RST_s1_chipselect,
                              E_RST_s1_reset_n,
                              E_RST_s1_write_n,
                              E_RST_s1_writedata,
                              cpu_0_data_master_granted_E_RST_s1,
                              cpu_0_data_master_qualified_request_E_RST_s1,
                              cpu_0_data_master_read_data_valid_E_RST_s1,
                              cpu_0_data_master_requests_E_RST_s1,
                              d1_E_RST_s1_end_xfer
                           )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output  [  1: 0] E_RST_s1_address;
  output           E_RST_s1_chipselect;
  output           E_RST_s1_reset_n;
  output           E_RST_s1_write_n;
  output           E_RST_s1_writedata;
  output           cpu_0_data_master_granted_E_RST_s1;
  output           cpu_0_data_master_qualified_request_E_RST_s1;
  output           cpu_0_data_master_read_data_valid_E_RST_s1;
  output           cpu_0_data_master_requests_E_RST_s1;
  output           d1_E_RST_s1_end_xfer;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input            reset_n;

  wire    [  1: 0] E_RST_s1_address;
  wire             E_RST_s1_allgrants;
  wire             E_RST_s1_allow_new_arb_cycle;
  wire             E_RST_s1_any_bursting_master_saved_grant;
  wire             E_RST_s1_any_continuerequest;
  wire             E_RST_s1_arb_counter_enable;
  reg     [  2: 0] E_RST_s1_arb_share_counter;
  wire    [  2: 0] E_RST_s1_arb_share_counter_next_value;
  wire    [  2: 0] E_RST_s1_arb_share_set_values;
  wire             E_RST_s1_beginbursttransfer_internal;
  wire             E_RST_s1_begins_xfer;
  wire             E_RST_s1_chipselect;
  wire             E_RST_s1_end_xfer;
  wire             E_RST_s1_firsttransfer;
  wire             E_RST_s1_grant_vector;
  wire             E_RST_s1_in_a_read_cycle;
  wire             E_RST_s1_in_a_write_cycle;
  wire             E_RST_s1_master_qreq_vector;
  wire             E_RST_s1_non_bursting_master_requests;
  reg              E_RST_s1_reg_firsttransfer;
  wire             E_RST_s1_reset_n;
  reg              E_RST_s1_slavearbiterlockenable;
  wire             E_RST_s1_slavearbiterlockenable2;
  wire             E_RST_s1_unreg_firsttransfer;
  wire             E_RST_s1_waits_for_read;
  wire             E_RST_s1_waits_for_write;
  wire             E_RST_s1_write_n;
  wire             E_RST_s1_writedata;
  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_E_RST_s1;
  wire             cpu_0_data_master_qualified_request_E_RST_s1;
  wire             cpu_0_data_master_read_data_valid_E_RST_s1;
  wire             cpu_0_data_master_requests_E_RST_s1;
  wire             cpu_0_data_master_saved_grant_E_RST_s1;
  reg              d1_E_RST_s1_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_E_RST_s1;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 25: 0] shifted_address_to_E_RST_s1_from_cpu_0_data_master;
  wire             wait_for_E_RST_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~E_RST_s1_end_xfer;
    end


  assign E_RST_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_E_RST_s1));
  assign cpu_0_data_master_requests_E_RST_s1 = (({cpu_0_data_master_address_to_slave[25 : 4] , 4'b0} == 26'h20032d0) & (cpu_0_data_master_read | cpu_0_data_master_write)) & cpu_0_data_master_write;
  //E_RST_s1_arb_share_counter set values, which is an e_mux
  assign E_RST_s1_arb_share_set_values = 1;

  //E_RST_s1_non_bursting_master_requests mux, which is an e_mux
  assign E_RST_s1_non_bursting_master_requests = cpu_0_data_master_requests_E_RST_s1;

  //E_RST_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign E_RST_s1_any_bursting_master_saved_grant = 0;

  //E_RST_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign E_RST_s1_arb_share_counter_next_value = E_RST_s1_firsttransfer ? (E_RST_s1_arb_share_set_values - 1) : |E_RST_s1_arb_share_counter ? (E_RST_s1_arb_share_counter - 1) : 0;

  //E_RST_s1_allgrants all slave grants, which is an e_mux
  assign E_RST_s1_allgrants = |E_RST_s1_grant_vector;

  //E_RST_s1_end_xfer assignment, which is an e_assign
  assign E_RST_s1_end_xfer = ~(E_RST_s1_waits_for_read | E_RST_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_E_RST_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_E_RST_s1 = E_RST_s1_end_xfer & (~E_RST_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //E_RST_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign E_RST_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_E_RST_s1 & E_RST_s1_allgrants) | (end_xfer_arb_share_counter_term_E_RST_s1 & ~E_RST_s1_non_bursting_master_requests);

  //E_RST_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          E_RST_s1_arb_share_counter <= 0;
      else if (E_RST_s1_arb_counter_enable)
          E_RST_s1_arb_share_counter <= E_RST_s1_arb_share_counter_next_value;
    end


  //E_RST_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          E_RST_s1_slavearbiterlockenable <= 0;
      else if ((|E_RST_s1_master_qreq_vector & end_xfer_arb_share_counter_term_E_RST_s1) | (end_xfer_arb_share_counter_term_E_RST_s1 & ~E_RST_s1_non_bursting_master_requests))
          E_RST_s1_slavearbiterlockenable <= |E_RST_s1_arb_share_counter_next_value;
    end


  //cpu_0/data_master E_RST/s1 arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = E_RST_s1_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //E_RST_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign E_RST_s1_slavearbiterlockenable2 = |E_RST_s1_arb_share_counter_next_value;

  //cpu_0/data_master E_RST/s1 arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = E_RST_s1_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //E_RST_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  assign E_RST_s1_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_E_RST_s1 = cpu_0_data_master_requests_E_RST_s1 & ~(((~cpu_0_data_master_waitrequest) & cpu_0_data_master_write));
  //E_RST_s1_writedata mux, which is an e_mux
  assign E_RST_s1_writedata = cpu_0_data_master_writedata;

  //master is always granted when requested
  assign cpu_0_data_master_granted_E_RST_s1 = cpu_0_data_master_qualified_request_E_RST_s1;

  //cpu_0/data_master saved-grant E_RST/s1, which is an e_assign
  assign cpu_0_data_master_saved_grant_E_RST_s1 = cpu_0_data_master_requests_E_RST_s1;

  //allow new arb cycle for E_RST/s1, which is an e_assign
  assign E_RST_s1_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign E_RST_s1_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign E_RST_s1_master_qreq_vector = 1;

  //E_RST_s1_reset_n assignment, which is an e_assign
  assign E_RST_s1_reset_n = reset_n;

  assign E_RST_s1_chipselect = cpu_0_data_master_granted_E_RST_s1;
  //E_RST_s1_firsttransfer first transaction, which is an e_assign
  assign E_RST_s1_firsttransfer = E_RST_s1_begins_xfer ? E_RST_s1_unreg_firsttransfer : E_RST_s1_reg_firsttransfer;

  //E_RST_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign E_RST_s1_unreg_firsttransfer = ~(E_RST_s1_slavearbiterlockenable & E_RST_s1_any_continuerequest);

  //E_RST_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          E_RST_s1_reg_firsttransfer <= 1'b1;
      else if (E_RST_s1_begins_xfer)
          E_RST_s1_reg_firsttransfer <= E_RST_s1_unreg_firsttransfer;
    end


  //E_RST_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign E_RST_s1_beginbursttransfer_internal = E_RST_s1_begins_xfer;

  //~E_RST_s1_write_n assignment, which is an e_mux
  assign E_RST_s1_write_n = ~(cpu_0_data_master_granted_E_RST_s1 & cpu_0_data_master_write);

  assign shifted_address_to_E_RST_s1_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //E_RST_s1_address mux, which is an e_mux
  assign E_RST_s1_address = shifted_address_to_E_RST_s1_from_cpu_0_data_master >> 2;

  //d1_E_RST_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_E_RST_s1_end_xfer <= 1;
      else if (1)
          d1_E_RST_s1_end_xfer <= E_RST_s1_end_xfer;
    end


  //E_RST_s1_waits_for_read in a cycle, which is an e_mux
  assign E_RST_s1_waits_for_read = E_RST_s1_in_a_read_cycle & E_RST_s1_begins_xfer;

  //E_RST_s1_in_a_read_cycle assignment, which is an e_assign
  assign E_RST_s1_in_a_read_cycle = cpu_0_data_master_granted_E_RST_s1 & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = E_RST_s1_in_a_read_cycle;

  //E_RST_s1_waits_for_write in a cycle, which is an e_mux
  assign E_RST_s1_waits_for_write = E_RST_s1_in_a_write_cycle & 0;

  //E_RST_s1_in_a_write_cycle assignment, which is an e_assign
  assign E_RST_s1_in_a_write_cycle = cpu_0_data_master_granted_E_RST_s1 & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = E_RST_s1_in_a_write_cycle;

  assign wait_for_E_RST_s1_counter = 0;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //E_RST/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module adc_tlc549_0_avalon_slave_0_arbitrator (
                                                // inputs:
                                                 adc_tlc549_0_avalon_slave_0_irq,
                                                 adc_tlc549_0_avalon_slave_0_readdata,
                                                 clk,
                                                 cpu_0_data_master_address_to_slave,
                                                 cpu_0_data_master_read,
                                                 cpu_0_data_master_waitrequest,
                                                 cpu_0_data_master_write,
                                                 reset_n,

                                                // outputs:
                                                 adc_tlc549_0_avalon_slave_0_irq_from_sa,
                                                 adc_tlc549_0_avalon_slave_0_read_n,
                                                 adc_tlc549_0_avalon_slave_0_readdata_from_sa,
                                                 cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0,
                                                 cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0,
                                                 cpu_0_data_master_read_data_valid_adc_tlc549_0_avalon_slave_0,
                                                 cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0,
                                                 d1_adc_tlc549_0_avalon_slave_0_end_xfer
                                              )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           adc_tlc549_0_avalon_slave_0_irq_from_sa;
  output           adc_tlc549_0_avalon_slave_0_read_n;
  output  [  7: 0] adc_tlc549_0_avalon_slave_0_readdata_from_sa;
  output           cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0;
  output           cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0;
  output           cpu_0_data_master_read_data_valid_adc_tlc549_0_avalon_slave_0;
  output           cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0;
  output           d1_adc_tlc549_0_avalon_slave_0_end_xfer;
  input            adc_tlc549_0_avalon_slave_0_irq;
  input   [  7: 0] adc_tlc549_0_avalon_slave_0_readdata;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input            reset_n;

  wire             adc_tlc549_0_avalon_slave_0_allgrants;
  wire             adc_tlc549_0_avalon_slave_0_allow_new_arb_cycle;
  wire             adc_tlc549_0_avalon_slave_0_any_bursting_master_saved_grant;
  wire             adc_tlc549_0_avalon_slave_0_any_continuerequest;
  wire             adc_tlc549_0_avalon_slave_0_arb_counter_enable;
  reg     [  2: 0] adc_tlc549_0_avalon_slave_0_arb_share_counter;
  wire    [  2: 0] adc_tlc549_0_avalon_slave_0_arb_share_counter_next_value;
  wire    [  2: 0] adc_tlc549_0_avalon_slave_0_arb_share_set_values;
  wire             adc_tlc549_0_avalon_slave_0_beginbursttransfer_internal;
  wire             adc_tlc549_0_avalon_slave_0_begins_xfer;
  wire             adc_tlc549_0_avalon_slave_0_end_xfer;
  wire             adc_tlc549_0_avalon_slave_0_firsttransfer;
  wire             adc_tlc549_0_avalon_slave_0_grant_vector;
  wire             adc_tlc549_0_avalon_slave_0_in_a_read_cycle;
  wire             adc_tlc549_0_avalon_slave_0_in_a_write_cycle;
  wire             adc_tlc549_0_avalon_slave_0_irq_from_sa;
  wire             adc_tlc549_0_avalon_slave_0_master_qreq_vector;
  wire             adc_tlc549_0_avalon_slave_0_non_bursting_master_requests;
  wire             adc_tlc549_0_avalon_slave_0_read_n;
  wire    [  7: 0] adc_tlc549_0_avalon_slave_0_readdata_from_sa;
  reg              adc_tlc549_0_avalon_slave_0_reg_firsttransfer;
  reg              adc_tlc549_0_avalon_slave_0_slavearbiterlockenable;
  wire             adc_tlc549_0_avalon_slave_0_slavearbiterlockenable2;
  wire             adc_tlc549_0_avalon_slave_0_unreg_firsttransfer;
  wire             adc_tlc549_0_avalon_slave_0_waits_for_read;
  wire             adc_tlc549_0_avalon_slave_0_waits_for_write;
  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0;
  wire             cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0;
  wire             cpu_0_data_master_read_data_valid_adc_tlc549_0_avalon_slave_0;
  wire             cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0;
  wire             cpu_0_data_master_saved_grant_adc_tlc549_0_avalon_slave_0;
  reg              d1_adc_tlc549_0_avalon_slave_0_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_adc_tlc549_0_avalon_slave_0;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire             wait_for_adc_tlc549_0_avalon_slave_0_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~adc_tlc549_0_avalon_slave_0_end_xfer;
    end


  assign adc_tlc549_0_avalon_slave_0_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0));
  //assign adc_tlc549_0_avalon_slave_0_readdata_from_sa = adc_tlc549_0_avalon_slave_0_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign adc_tlc549_0_avalon_slave_0_readdata_from_sa = adc_tlc549_0_avalon_slave_0_readdata;

  assign cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0 = (({cpu_0_data_master_address_to_slave[25 : 0] } == 26'h2003352) & (cpu_0_data_master_read | cpu_0_data_master_write)) & cpu_0_data_master_read;
  //adc_tlc549_0_avalon_slave_0_arb_share_counter set values, which is an e_mux
  assign adc_tlc549_0_avalon_slave_0_arb_share_set_values = (cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0)? 4 :
    1;

  //adc_tlc549_0_avalon_slave_0_non_bursting_master_requests mux, which is an e_mux
  assign adc_tlc549_0_avalon_slave_0_non_bursting_master_requests = cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0;

  //adc_tlc549_0_avalon_slave_0_any_bursting_master_saved_grant mux, which is an e_mux
  assign adc_tlc549_0_avalon_slave_0_any_bursting_master_saved_grant = 0;

  //adc_tlc549_0_avalon_slave_0_arb_share_counter_next_value assignment, which is an e_assign
  assign adc_tlc549_0_avalon_slave_0_arb_share_counter_next_value = adc_tlc549_0_avalon_slave_0_firsttransfer ? (adc_tlc549_0_avalon_slave_0_arb_share_set_values - 1) : |adc_tlc549_0_avalon_slave_0_arb_share_counter ? (adc_tlc549_0_avalon_slave_0_arb_share_counter - 1) : 0;

  //adc_tlc549_0_avalon_slave_0_allgrants all slave grants, which is an e_mux
  assign adc_tlc549_0_avalon_slave_0_allgrants = |adc_tlc549_0_avalon_slave_0_grant_vector;

  //adc_tlc549_0_avalon_slave_0_end_xfer assignment, which is an e_assign
  assign adc_tlc549_0_avalon_slave_0_end_xfer = ~(adc_tlc549_0_avalon_slave_0_waits_for_read | adc_tlc549_0_avalon_slave_0_waits_for_write);

  //end_xfer_arb_share_counter_term_adc_tlc549_0_avalon_slave_0 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_adc_tlc549_0_avalon_slave_0 = adc_tlc549_0_avalon_slave_0_end_xfer & (~adc_tlc549_0_avalon_slave_0_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //adc_tlc549_0_avalon_slave_0_arb_share_counter arbitration counter enable, which is an e_assign
  assign adc_tlc549_0_avalon_slave_0_arb_counter_enable = (end_xfer_arb_share_counter_term_adc_tlc549_0_avalon_slave_0 & adc_tlc549_0_avalon_slave_0_allgrants) | (end_xfer_arb_share_counter_term_adc_tlc549_0_avalon_slave_0 & ~adc_tlc549_0_avalon_slave_0_non_bursting_master_requests);

  //adc_tlc549_0_avalon_slave_0_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          adc_tlc549_0_avalon_slave_0_arb_share_counter <= 0;
      else if (adc_tlc549_0_avalon_slave_0_arb_counter_enable)
          adc_tlc549_0_avalon_slave_0_arb_share_counter <= adc_tlc549_0_avalon_slave_0_arb_share_counter_next_value;
    end


  //adc_tlc549_0_avalon_slave_0_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          adc_tlc549_0_avalon_slave_0_slavearbiterlockenable <= 0;
      else if ((|adc_tlc549_0_avalon_slave_0_master_qreq_vector & end_xfer_arb_share_counter_term_adc_tlc549_0_avalon_slave_0) | (end_xfer_arb_share_counter_term_adc_tlc549_0_avalon_slave_0 & ~adc_tlc549_0_avalon_slave_0_non_bursting_master_requests))
          adc_tlc549_0_avalon_slave_0_slavearbiterlockenable <= |adc_tlc549_0_avalon_slave_0_arb_share_counter_next_value;
    end


  //cpu_0/data_master adc_tlc549_0/avalon_slave_0 arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = adc_tlc549_0_avalon_slave_0_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //adc_tlc549_0_avalon_slave_0_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign adc_tlc549_0_avalon_slave_0_slavearbiterlockenable2 = |adc_tlc549_0_avalon_slave_0_arb_share_counter_next_value;

  //cpu_0/data_master adc_tlc549_0/avalon_slave_0 arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = adc_tlc549_0_avalon_slave_0_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //adc_tlc549_0_avalon_slave_0_any_continuerequest at least one master continues requesting, which is an e_assign
  assign adc_tlc549_0_avalon_slave_0_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0 = cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0 & ~((cpu_0_data_master_read & (~cpu_0_data_master_waitrequest)));
  //master is always granted when requested
  assign cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0 = cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0;

  //cpu_0/data_master saved-grant adc_tlc549_0/avalon_slave_0, which is an e_assign
  assign cpu_0_data_master_saved_grant_adc_tlc549_0_avalon_slave_0 = cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0;

  //allow new arb cycle for adc_tlc549_0/avalon_slave_0, which is an e_assign
  assign adc_tlc549_0_avalon_slave_0_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign adc_tlc549_0_avalon_slave_0_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign adc_tlc549_0_avalon_slave_0_master_qreq_vector = 1;

  //adc_tlc549_0_avalon_slave_0_firsttransfer first transaction, which is an e_assign
  assign adc_tlc549_0_avalon_slave_0_firsttransfer = adc_tlc549_0_avalon_slave_0_begins_xfer ? adc_tlc549_0_avalon_slave_0_unreg_firsttransfer : adc_tlc549_0_avalon_slave_0_reg_firsttransfer;

  //adc_tlc549_0_avalon_slave_0_unreg_firsttransfer first transaction, which is an e_assign
  assign adc_tlc549_0_avalon_slave_0_unreg_firsttransfer = ~(adc_tlc549_0_avalon_slave_0_slavearbiterlockenable & adc_tlc549_0_avalon_slave_0_any_continuerequest);

  //adc_tlc549_0_avalon_slave_0_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          adc_tlc549_0_avalon_slave_0_reg_firsttransfer <= 1'b1;
      else if (adc_tlc549_0_avalon_slave_0_begins_xfer)
          adc_tlc549_0_avalon_slave_0_reg_firsttransfer <= adc_tlc549_0_avalon_slave_0_unreg_firsttransfer;
    end


  //adc_tlc549_0_avalon_slave_0_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign adc_tlc549_0_avalon_slave_0_beginbursttransfer_internal = adc_tlc549_0_avalon_slave_0_begins_xfer;

  //~adc_tlc549_0_avalon_slave_0_read_n assignment, which is an e_mux
  assign adc_tlc549_0_avalon_slave_0_read_n = ~(cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0 & cpu_0_data_master_read);

  //d1_adc_tlc549_0_avalon_slave_0_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_adc_tlc549_0_avalon_slave_0_end_xfer <= 1;
      else if (1)
          d1_adc_tlc549_0_avalon_slave_0_end_xfer <= adc_tlc549_0_avalon_slave_0_end_xfer;
    end


  //adc_tlc549_0_avalon_slave_0_waits_for_read in a cycle, which is an e_mux
  assign adc_tlc549_0_avalon_slave_0_waits_for_read = adc_tlc549_0_avalon_slave_0_in_a_read_cycle & 0;

  //adc_tlc549_0_avalon_slave_0_in_a_read_cycle assignment, which is an e_assign
  assign adc_tlc549_0_avalon_slave_0_in_a_read_cycle = cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0 & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = adc_tlc549_0_avalon_slave_0_in_a_read_cycle;

  //adc_tlc549_0_avalon_slave_0_waits_for_write in a cycle, which is an e_mux
  assign adc_tlc549_0_avalon_slave_0_waits_for_write = adc_tlc549_0_avalon_slave_0_in_a_write_cycle & 0;

  //adc_tlc549_0_avalon_slave_0_in_a_write_cycle assignment, which is an e_assign
  assign adc_tlc549_0_avalon_slave_0_in_a_write_cycle = cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0 & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = adc_tlc549_0_avalon_slave_0_in_a_write_cycle;

  assign wait_for_adc_tlc549_0_avalon_slave_0_counter = 0;
  //assign adc_tlc549_0_avalon_slave_0_irq_from_sa = adc_tlc549_0_avalon_slave_0_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign adc_tlc549_0_avalon_slave_0_irq_from_sa = adc_tlc549_0_avalon_slave_0_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //adc_tlc549_0/avalon_slave_0 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module avalon_tlc5620_0_avalon_slave_arbitrator (
                                                  // inputs:
                                                   clk,
                                                   cpu_0_data_master_address_to_slave,
                                                   cpu_0_data_master_read,
                                                   cpu_0_data_master_waitrequest,
                                                   cpu_0_data_master_write,
                                                   cpu_0_data_master_writedata,
                                                   reset_n,

                                                  // outputs:
                                                   avalon_tlc5620_0_avalon_slave_address,
                                                   avalon_tlc5620_0_avalon_slave_chipselect,
                                                   avalon_tlc5620_0_avalon_slave_reset_n,
                                                   avalon_tlc5620_0_avalon_slave_write,
                                                   avalon_tlc5620_0_avalon_slave_writedata,
                                                   cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave,
                                                   cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave,
                                                   cpu_0_data_master_read_data_valid_avalon_tlc5620_0_avalon_slave,
                                                   cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave,
                                                   d1_avalon_tlc5620_0_avalon_slave_end_xfer
                                                )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output  [  1: 0] avalon_tlc5620_0_avalon_slave_address;
  output           avalon_tlc5620_0_avalon_slave_chipselect;
  output           avalon_tlc5620_0_avalon_slave_reset_n;
  output           avalon_tlc5620_0_avalon_slave_write;
  output  [ 31: 0] avalon_tlc5620_0_avalon_slave_writedata;
  output           cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave;
  output           cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave;
  output           cpu_0_data_master_read_data_valid_avalon_tlc5620_0_avalon_slave;
  output           cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave;
  output           d1_avalon_tlc5620_0_avalon_slave_end_xfer;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input            reset_n;

  wire    [  1: 0] avalon_tlc5620_0_avalon_slave_address;
  wire             avalon_tlc5620_0_avalon_slave_allgrants;
  wire             avalon_tlc5620_0_avalon_slave_allow_new_arb_cycle;
  wire             avalon_tlc5620_0_avalon_slave_any_bursting_master_saved_grant;
  wire             avalon_tlc5620_0_avalon_slave_any_continuerequest;
  wire             avalon_tlc5620_0_avalon_slave_arb_counter_enable;
  reg     [  2: 0] avalon_tlc5620_0_avalon_slave_arb_share_counter;
  wire    [  2: 0] avalon_tlc5620_0_avalon_slave_arb_share_counter_next_value;
  wire    [  2: 0] avalon_tlc5620_0_avalon_slave_arb_share_set_values;
  wire             avalon_tlc5620_0_avalon_slave_beginbursttransfer_internal;
  wire             avalon_tlc5620_0_avalon_slave_begins_xfer;
  wire             avalon_tlc5620_0_avalon_slave_chipselect;
  wire             avalon_tlc5620_0_avalon_slave_end_xfer;
  wire             avalon_tlc5620_0_avalon_slave_firsttransfer;
  wire             avalon_tlc5620_0_avalon_slave_grant_vector;
  wire             avalon_tlc5620_0_avalon_slave_in_a_read_cycle;
  wire             avalon_tlc5620_0_avalon_slave_in_a_write_cycle;
  wire             avalon_tlc5620_0_avalon_slave_master_qreq_vector;
  wire             avalon_tlc5620_0_avalon_slave_non_bursting_master_requests;
  reg              avalon_tlc5620_0_avalon_slave_reg_firsttransfer;
  wire             avalon_tlc5620_0_avalon_slave_reset_n;
  reg              avalon_tlc5620_0_avalon_slave_slavearbiterlockenable;
  wire             avalon_tlc5620_0_avalon_slave_slavearbiterlockenable2;
  wire             avalon_tlc5620_0_avalon_slave_unreg_firsttransfer;
  wire             avalon_tlc5620_0_avalon_slave_waits_for_read;
  wire             avalon_tlc5620_0_avalon_slave_waits_for_write;
  wire             avalon_tlc5620_0_avalon_slave_write;
  wire    [ 31: 0] avalon_tlc5620_0_avalon_slave_writedata;
  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave;
  wire             cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave;
  wire             cpu_0_data_master_read_data_valid_avalon_tlc5620_0_avalon_slave;
  wire             cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave;
  wire             cpu_0_data_master_saved_grant_avalon_tlc5620_0_avalon_slave;
  reg              d1_avalon_tlc5620_0_avalon_slave_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_avalon_tlc5620_0_avalon_slave;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 25: 0] shifted_address_to_avalon_tlc5620_0_avalon_slave_from_cpu_0_data_master;
  wire             wait_for_avalon_tlc5620_0_avalon_slave_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~avalon_tlc5620_0_avalon_slave_end_xfer;
    end


  assign avalon_tlc5620_0_avalon_slave_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave));
  assign cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave = (({cpu_0_data_master_address_to_slave[25 : 4] , 4'b0} == 26'h2003310) & (cpu_0_data_master_read | cpu_0_data_master_write)) & cpu_0_data_master_write;
  //avalon_tlc5620_0_avalon_slave_arb_share_counter set values, which is an e_mux
  assign avalon_tlc5620_0_avalon_slave_arb_share_set_values = 1;

  //avalon_tlc5620_0_avalon_slave_non_bursting_master_requests mux, which is an e_mux
  assign avalon_tlc5620_0_avalon_slave_non_bursting_master_requests = cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave;

  //avalon_tlc5620_0_avalon_slave_any_bursting_master_saved_grant mux, which is an e_mux
  assign avalon_tlc5620_0_avalon_slave_any_bursting_master_saved_grant = 0;

  //avalon_tlc5620_0_avalon_slave_arb_share_counter_next_value assignment, which is an e_assign
  assign avalon_tlc5620_0_avalon_slave_arb_share_counter_next_value = avalon_tlc5620_0_avalon_slave_firsttransfer ? (avalon_tlc5620_0_avalon_slave_arb_share_set_values - 1) : |avalon_tlc5620_0_avalon_slave_arb_share_counter ? (avalon_tlc5620_0_avalon_slave_arb_share_counter - 1) : 0;

  //avalon_tlc5620_0_avalon_slave_allgrants all slave grants, which is an e_mux
  assign avalon_tlc5620_0_avalon_slave_allgrants = |avalon_tlc5620_0_avalon_slave_grant_vector;

  //avalon_tlc5620_0_avalon_slave_end_xfer assignment, which is an e_assign
  assign avalon_tlc5620_0_avalon_slave_end_xfer = ~(avalon_tlc5620_0_avalon_slave_waits_for_read | avalon_tlc5620_0_avalon_slave_waits_for_write);

  //end_xfer_arb_share_counter_term_avalon_tlc5620_0_avalon_slave arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_avalon_tlc5620_0_avalon_slave = avalon_tlc5620_0_avalon_slave_end_xfer & (~avalon_tlc5620_0_avalon_slave_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //avalon_tlc5620_0_avalon_slave_arb_share_counter arbitration counter enable, which is an e_assign
  assign avalon_tlc5620_0_avalon_slave_arb_counter_enable = (end_xfer_arb_share_counter_term_avalon_tlc5620_0_avalon_slave & avalon_tlc5620_0_avalon_slave_allgrants) | (end_xfer_arb_share_counter_term_avalon_tlc5620_0_avalon_slave & ~avalon_tlc5620_0_avalon_slave_non_bursting_master_requests);

  //avalon_tlc5620_0_avalon_slave_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          avalon_tlc5620_0_avalon_slave_arb_share_counter <= 0;
      else if (avalon_tlc5620_0_avalon_slave_arb_counter_enable)
          avalon_tlc5620_0_avalon_slave_arb_share_counter <= avalon_tlc5620_0_avalon_slave_arb_share_counter_next_value;
    end


  //avalon_tlc5620_0_avalon_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          avalon_tlc5620_0_avalon_slave_slavearbiterlockenable <= 0;
      else if ((|avalon_tlc5620_0_avalon_slave_master_qreq_vector & end_xfer_arb_share_counter_term_avalon_tlc5620_0_avalon_slave) | (end_xfer_arb_share_counter_term_avalon_tlc5620_0_avalon_slave & ~avalon_tlc5620_0_avalon_slave_non_bursting_master_requests))
          avalon_tlc5620_0_avalon_slave_slavearbiterlockenable <= |avalon_tlc5620_0_avalon_slave_arb_share_counter_next_value;
    end


  //cpu_0/data_master avalon_tlc5620_0/avalon_slave arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = avalon_tlc5620_0_avalon_slave_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //avalon_tlc5620_0_avalon_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign avalon_tlc5620_0_avalon_slave_slavearbiterlockenable2 = |avalon_tlc5620_0_avalon_slave_arb_share_counter_next_value;

  //cpu_0/data_master avalon_tlc5620_0/avalon_slave arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = avalon_tlc5620_0_avalon_slave_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //avalon_tlc5620_0_avalon_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  assign avalon_tlc5620_0_avalon_slave_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave = cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave & ~(((~cpu_0_data_master_waitrequest) & cpu_0_data_master_write));
  //avalon_tlc5620_0_avalon_slave_writedata mux, which is an e_mux
  assign avalon_tlc5620_0_avalon_slave_writedata = cpu_0_data_master_writedata;

  //master is always granted when requested
  assign cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave = cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave;

  //cpu_0/data_master saved-grant avalon_tlc5620_0/avalon_slave, which is an e_assign
  assign cpu_0_data_master_saved_grant_avalon_tlc5620_0_avalon_slave = cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave;

  //allow new arb cycle for avalon_tlc5620_0/avalon_slave, which is an e_assign
  assign avalon_tlc5620_0_avalon_slave_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign avalon_tlc5620_0_avalon_slave_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign avalon_tlc5620_0_avalon_slave_master_qreq_vector = 1;

  //avalon_tlc5620_0_avalon_slave_reset_n assignment, which is an e_assign
  assign avalon_tlc5620_0_avalon_slave_reset_n = reset_n;

  assign avalon_tlc5620_0_avalon_slave_chipselect = cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave;
  //avalon_tlc5620_0_avalon_slave_firsttransfer first transaction, which is an e_assign
  assign avalon_tlc5620_0_avalon_slave_firsttransfer = avalon_tlc5620_0_avalon_slave_begins_xfer ? avalon_tlc5620_0_avalon_slave_unreg_firsttransfer : avalon_tlc5620_0_avalon_slave_reg_firsttransfer;

  //avalon_tlc5620_0_avalon_slave_unreg_firsttransfer first transaction, which is an e_assign
  assign avalon_tlc5620_0_avalon_slave_unreg_firsttransfer = ~(avalon_tlc5620_0_avalon_slave_slavearbiterlockenable & avalon_tlc5620_0_avalon_slave_any_continuerequest);

  //avalon_tlc5620_0_avalon_slave_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          avalon_tlc5620_0_avalon_slave_reg_firsttransfer <= 1'b1;
      else if (avalon_tlc5620_0_avalon_slave_begins_xfer)
          avalon_tlc5620_0_avalon_slave_reg_firsttransfer <= avalon_tlc5620_0_avalon_slave_unreg_firsttransfer;
    end


  //avalon_tlc5620_0_avalon_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign avalon_tlc5620_0_avalon_slave_beginbursttransfer_internal = avalon_tlc5620_0_avalon_slave_begins_xfer;

  //avalon_tlc5620_0_avalon_slave_write assignment, which is an e_mux
  assign avalon_tlc5620_0_avalon_slave_write = cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave & cpu_0_data_master_write;

  assign shifted_address_to_avalon_tlc5620_0_avalon_slave_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //avalon_tlc5620_0_avalon_slave_address mux, which is an e_mux
  assign avalon_tlc5620_0_avalon_slave_address = shifted_address_to_avalon_tlc5620_0_avalon_slave_from_cpu_0_data_master >> 2;

  //d1_avalon_tlc5620_0_avalon_slave_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_avalon_tlc5620_0_avalon_slave_end_xfer <= 1;
      else if (1)
          d1_avalon_tlc5620_0_avalon_slave_end_xfer <= avalon_tlc5620_0_avalon_slave_end_xfer;
    end


  //avalon_tlc5620_0_avalon_slave_waits_for_read in a cycle, which is an e_mux
  assign avalon_tlc5620_0_avalon_slave_waits_for_read = avalon_tlc5620_0_avalon_slave_in_a_read_cycle & avalon_tlc5620_0_avalon_slave_begins_xfer;

  //avalon_tlc5620_0_avalon_slave_in_a_read_cycle assignment, which is an e_assign
  assign avalon_tlc5620_0_avalon_slave_in_a_read_cycle = cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = avalon_tlc5620_0_avalon_slave_in_a_read_cycle;

  //avalon_tlc5620_0_avalon_slave_waits_for_write in a cycle, which is an e_mux
  assign avalon_tlc5620_0_avalon_slave_waits_for_write = avalon_tlc5620_0_avalon_slave_in_a_write_cycle & 0;

  //avalon_tlc5620_0_avalon_slave_in_a_write_cycle assignment, which is an e_assign
  assign avalon_tlc5620_0_avalon_slave_in_a_write_cycle = cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = avalon_tlc5620_0_avalon_slave_in_a_write_cycle;

  assign wait_for_avalon_tlc5620_0_avalon_slave_counter = 0;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //avalon_tlc5620_0/avalon_slave enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module cpu_0_jtag_debug_module_arbitrator (
                                            // inputs:
                                             clk,
                                             cpu_0_data_master_address_to_slave,
                                             cpu_0_data_master_byteenable,
                                             cpu_0_data_master_debugaccess,
                                             cpu_0_data_master_read,
                                             cpu_0_data_master_waitrequest,
                                             cpu_0_data_master_write,
                                             cpu_0_data_master_writedata,
                                             cpu_0_instruction_master_address_to_slave,
                                             cpu_0_instruction_master_latency_counter,
                                             cpu_0_instruction_master_read,
                                             cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register,
                                             cpu_0_jtag_debug_module_readdata,
                                             cpu_0_jtag_debug_module_resetrequest,
                                             reset_n,

                                            // outputs:
                                             cpu_0_data_master_granted_cpu_0_jtag_debug_module,
                                             cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module,
                                             cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module,
                                             cpu_0_data_master_requests_cpu_0_jtag_debug_module,
                                             cpu_0_instruction_master_granted_cpu_0_jtag_debug_module,
                                             cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module,
                                             cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module,
                                             cpu_0_instruction_master_requests_cpu_0_jtag_debug_module,
                                             cpu_0_jtag_debug_module_address,
                                             cpu_0_jtag_debug_module_begintransfer,
                                             cpu_0_jtag_debug_module_byteenable,
                                             cpu_0_jtag_debug_module_chipselect,
                                             cpu_0_jtag_debug_module_debugaccess,
                                             cpu_0_jtag_debug_module_readdata_from_sa,
                                             cpu_0_jtag_debug_module_reset,
                                             cpu_0_jtag_debug_module_resetrequest_from_sa,
                                             cpu_0_jtag_debug_module_write,
                                             cpu_0_jtag_debug_module_writedata,
                                             d1_cpu_0_jtag_debug_module_end_xfer
                                          )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_cpu_0_jtag_debug_module;
  output           cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module;
  output           cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module;
  output           cpu_0_data_master_requests_cpu_0_jtag_debug_module;
  output           cpu_0_instruction_master_granted_cpu_0_jtag_debug_module;
  output           cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module;
  output           cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module;
  output           cpu_0_instruction_master_requests_cpu_0_jtag_debug_module;
  output  [  8: 0] cpu_0_jtag_debug_module_address;
  output           cpu_0_jtag_debug_module_begintransfer;
  output  [  3: 0] cpu_0_jtag_debug_module_byteenable;
  output           cpu_0_jtag_debug_module_chipselect;
  output           cpu_0_jtag_debug_module_debugaccess;
  output  [ 31: 0] cpu_0_jtag_debug_module_readdata_from_sa;
  output           cpu_0_jtag_debug_module_reset;
  output           cpu_0_jtag_debug_module_resetrequest_from_sa;
  output           cpu_0_jtag_debug_module_write;
  output  [ 31: 0] cpu_0_jtag_debug_module_writedata;
  output           d1_cpu_0_jtag_debug_module_end_xfer;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input   [  3: 0] cpu_0_data_master_byteenable;
  input            cpu_0_data_master_debugaccess;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input   [ 25: 0] cpu_0_instruction_master_address_to_slave;
  input   [  1: 0] cpu_0_instruction_master_latency_counter;
  input            cpu_0_instruction_master_read;
  input            cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register;
  input   [ 31: 0] cpu_0_jtag_debug_module_readdata;
  input            cpu_0_jtag_debug_module_resetrequest;
  input            reset_n;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_cpu_0_jtag_debug_module;
  wire             cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module;
  wire             cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module;
  wire             cpu_0_data_master_requests_cpu_0_jtag_debug_module;
  wire             cpu_0_data_master_saved_grant_cpu_0_jtag_debug_module;
  wire             cpu_0_instruction_master_arbiterlock;
  wire             cpu_0_instruction_master_arbiterlock2;
  wire             cpu_0_instruction_master_continuerequest;
  wire             cpu_0_instruction_master_granted_cpu_0_jtag_debug_module;
  wire             cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module;
  wire             cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module;
  wire             cpu_0_instruction_master_requests_cpu_0_jtag_debug_module;
  wire             cpu_0_instruction_master_saved_grant_cpu_0_jtag_debug_module;
  wire    [  8: 0] cpu_0_jtag_debug_module_address;
  wire             cpu_0_jtag_debug_module_allgrants;
  wire             cpu_0_jtag_debug_module_allow_new_arb_cycle;
  wire             cpu_0_jtag_debug_module_any_bursting_master_saved_grant;
  wire             cpu_0_jtag_debug_module_any_continuerequest;
  reg     [  1: 0] cpu_0_jtag_debug_module_arb_addend;
  wire             cpu_0_jtag_debug_module_arb_counter_enable;
  reg     [  2: 0] cpu_0_jtag_debug_module_arb_share_counter;
  wire    [  2: 0] cpu_0_jtag_debug_module_arb_share_counter_next_value;
  wire    [  2: 0] cpu_0_jtag_debug_module_arb_share_set_values;
  wire    [  1: 0] cpu_0_jtag_debug_module_arb_winner;
  wire             cpu_0_jtag_debug_module_arbitration_holdoff_internal;
  wire             cpu_0_jtag_debug_module_beginbursttransfer_internal;
  wire             cpu_0_jtag_debug_module_begins_xfer;
  wire             cpu_0_jtag_debug_module_begintransfer;
  wire    [  3: 0] cpu_0_jtag_debug_module_byteenable;
  wire             cpu_0_jtag_debug_module_chipselect;
  wire    [  3: 0] cpu_0_jtag_debug_module_chosen_master_double_vector;
  wire    [  1: 0] cpu_0_jtag_debug_module_chosen_master_rot_left;
  wire             cpu_0_jtag_debug_module_debugaccess;
  wire             cpu_0_jtag_debug_module_end_xfer;
  wire             cpu_0_jtag_debug_module_firsttransfer;
  wire    [  1: 0] cpu_0_jtag_debug_module_grant_vector;
  wire             cpu_0_jtag_debug_module_in_a_read_cycle;
  wire             cpu_0_jtag_debug_module_in_a_write_cycle;
  wire    [  1: 0] cpu_0_jtag_debug_module_master_qreq_vector;
  wire             cpu_0_jtag_debug_module_non_bursting_master_requests;
  wire    [ 31: 0] cpu_0_jtag_debug_module_readdata_from_sa;
  reg              cpu_0_jtag_debug_module_reg_firsttransfer;
  wire             cpu_0_jtag_debug_module_reset;
  wire             cpu_0_jtag_debug_module_resetrequest_from_sa;
  reg     [  1: 0] cpu_0_jtag_debug_module_saved_chosen_master_vector;
  reg              cpu_0_jtag_debug_module_slavearbiterlockenable;
  wire             cpu_0_jtag_debug_module_slavearbiterlockenable2;
  wire             cpu_0_jtag_debug_module_unreg_firsttransfer;
  wire             cpu_0_jtag_debug_module_waits_for_read;
  wire             cpu_0_jtag_debug_module_waits_for_write;
  wire             cpu_0_jtag_debug_module_write;
  wire    [ 31: 0] cpu_0_jtag_debug_module_writedata;
  reg              d1_cpu_0_jtag_debug_module_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_cpu_0_jtag_debug_module;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  reg              last_cycle_cpu_0_data_master_granted_slave_cpu_0_jtag_debug_module;
  reg              last_cycle_cpu_0_instruction_master_granted_slave_cpu_0_jtag_debug_module;
  wire    [ 25: 0] shifted_address_to_cpu_0_jtag_debug_module_from_cpu_0_data_master;
  wire    [ 25: 0] shifted_address_to_cpu_0_jtag_debug_module_from_cpu_0_instruction_master;
  wire             wait_for_cpu_0_jtag_debug_module_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~cpu_0_jtag_debug_module_end_xfer;
    end


  assign cpu_0_jtag_debug_module_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module | cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module));
  //assign cpu_0_jtag_debug_module_readdata_from_sa = cpu_0_jtag_debug_module_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign cpu_0_jtag_debug_module_readdata_from_sa = cpu_0_jtag_debug_module_readdata;

  assign cpu_0_data_master_requests_cpu_0_jtag_debug_module = ({cpu_0_data_master_address_to_slave[25 : 11] , 11'b0} == 26'h2002800) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //cpu_0_jtag_debug_module_arb_share_counter set values, which is an e_mux
  assign cpu_0_jtag_debug_module_arb_share_set_values = 1;

  //cpu_0_jtag_debug_module_non_bursting_master_requests mux, which is an e_mux
  assign cpu_0_jtag_debug_module_non_bursting_master_requests = cpu_0_data_master_requests_cpu_0_jtag_debug_module |
    cpu_0_instruction_master_requests_cpu_0_jtag_debug_module |
    cpu_0_data_master_requests_cpu_0_jtag_debug_module |
    cpu_0_instruction_master_requests_cpu_0_jtag_debug_module;

  //cpu_0_jtag_debug_module_any_bursting_master_saved_grant mux, which is an e_mux
  assign cpu_0_jtag_debug_module_any_bursting_master_saved_grant = 0;

  //cpu_0_jtag_debug_module_arb_share_counter_next_value assignment, which is an e_assign
  assign cpu_0_jtag_debug_module_arb_share_counter_next_value = cpu_0_jtag_debug_module_firsttransfer ? (cpu_0_jtag_debug_module_arb_share_set_values - 1) : |cpu_0_jtag_debug_module_arb_share_counter ? (cpu_0_jtag_debug_module_arb_share_counter - 1) : 0;

  //cpu_0_jtag_debug_module_allgrants all slave grants, which is an e_mux
  assign cpu_0_jtag_debug_module_allgrants = |cpu_0_jtag_debug_module_grant_vector |
    |cpu_0_jtag_debug_module_grant_vector |
    |cpu_0_jtag_debug_module_grant_vector |
    |cpu_0_jtag_debug_module_grant_vector;

  //cpu_0_jtag_debug_module_end_xfer assignment, which is an e_assign
  assign cpu_0_jtag_debug_module_end_xfer = ~(cpu_0_jtag_debug_module_waits_for_read | cpu_0_jtag_debug_module_waits_for_write);

  //end_xfer_arb_share_counter_term_cpu_0_jtag_debug_module arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_cpu_0_jtag_debug_module = cpu_0_jtag_debug_module_end_xfer & (~cpu_0_jtag_debug_module_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //cpu_0_jtag_debug_module_arb_share_counter arbitration counter enable, which is an e_assign
  assign cpu_0_jtag_debug_module_arb_counter_enable = (end_xfer_arb_share_counter_term_cpu_0_jtag_debug_module & cpu_0_jtag_debug_module_allgrants) | (end_xfer_arb_share_counter_term_cpu_0_jtag_debug_module & ~cpu_0_jtag_debug_module_non_bursting_master_requests);

  //cpu_0_jtag_debug_module_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_jtag_debug_module_arb_share_counter <= 0;
      else if (cpu_0_jtag_debug_module_arb_counter_enable)
          cpu_0_jtag_debug_module_arb_share_counter <= cpu_0_jtag_debug_module_arb_share_counter_next_value;
    end


  //cpu_0_jtag_debug_module_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_jtag_debug_module_slavearbiterlockenable <= 0;
      else if ((|cpu_0_jtag_debug_module_master_qreq_vector & end_xfer_arb_share_counter_term_cpu_0_jtag_debug_module) | (end_xfer_arb_share_counter_term_cpu_0_jtag_debug_module & ~cpu_0_jtag_debug_module_non_bursting_master_requests))
          cpu_0_jtag_debug_module_slavearbiterlockenable <= |cpu_0_jtag_debug_module_arb_share_counter_next_value;
    end


  //cpu_0/data_master cpu_0/jtag_debug_module arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = cpu_0_jtag_debug_module_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //cpu_0_jtag_debug_module_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign cpu_0_jtag_debug_module_slavearbiterlockenable2 = |cpu_0_jtag_debug_module_arb_share_counter_next_value;

  //cpu_0/data_master cpu_0/jtag_debug_module arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = cpu_0_jtag_debug_module_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //cpu_0/instruction_master cpu_0/jtag_debug_module arbiterlock, which is an e_assign
  assign cpu_0_instruction_master_arbiterlock = cpu_0_jtag_debug_module_slavearbiterlockenable & cpu_0_instruction_master_continuerequest;

  //cpu_0/instruction_master cpu_0/jtag_debug_module arbiterlock2, which is an e_assign
  assign cpu_0_instruction_master_arbiterlock2 = cpu_0_jtag_debug_module_slavearbiterlockenable2 & cpu_0_instruction_master_continuerequest;

  //cpu_0/instruction_master granted cpu_0/jtag_debug_module last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_instruction_master_granted_slave_cpu_0_jtag_debug_module <= 0;
      else if (1)
          last_cycle_cpu_0_instruction_master_granted_slave_cpu_0_jtag_debug_module <= cpu_0_instruction_master_saved_grant_cpu_0_jtag_debug_module ? 1 : (cpu_0_jtag_debug_module_arbitration_holdoff_internal | ~cpu_0_instruction_master_requests_cpu_0_jtag_debug_module) ? 0 : last_cycle_cpu_0_instruction_master_granted_slave_cpu_0_jtag_debug_module;
    end


  //cpu_0_instruction_master_continuerequest continued request, which is an e_mux
  assign cpu_0_instruction_master_continuerequest = last_cycle_cpu_0_instruction_master_granted_slave_cpu_0_jtag_debug_module & cpu_0_instruction_master_requests_cpu_0_jtag_debug_module;

  //cpu_0_jtag_debug_module_any_continuerequest at least one master continues requesting, which is an e_mux
  assign cpu_0_jtag_debug_module_any_continuerequest = cpu_0_instruction_master_continuerequest |
    cpu_0_data_master_continuerequest;

  assign cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module = cpu_0_data_master_requests_cpu_0_jtag_debug_module & ~(((~cpu_0_data_master_waitrequest) & cpu_0_data_master_write) | cpu_0_instruction_master_arbiterlock);
  //cpu_0_jtag_debug_module_writedata mux, which is an e_mux
  assign cpu_0_jtag_debug_module_writedata = cpu_0_data_master_writedata;

  //mux cpu_0_jtag_debug_module_debugaccess, which is an e_mux
  assign cpu_0_jtag_debug_module_debugaccess = cpu_0_data_master_debugaccess;

  assign cpu_0_instruction_master_requests_cpu_0_jtag_debug_module = (({cpu_0_instruction_master_address_to_slave[25 : 11] , 11'b0} == 26'h2002800) & (cpu_0_instruction_master_read)) & cpu_0_instruction_master_read;
  //cpu_0/data_master granted cpu_0/jtag_debug_module last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_data_master_granted_slave_cpu_0_jtag_debug_module <= 0;
      else if (1)
          last_cycle_cpu_0_data_master_granted_slave_cpu_0_jtag_debug_module <= cpu_0_data_master_saved_grant_cpu_0_jtag_debug_module ? 1 : (cpu_0_jtag_debug_module_arbitration_holdoff_internal | ~cpu_0_data_master_requests_cpu_0_jtag_debug_module) ? 0 : last_cycle_cpu_0_data_master_granted_slave_cpu_0_jtag_debug_module;
    end


  //cpu_0_data_master_continuerequest continued request, which is an e_mux
  assign cpu_0_data_master_continuerequest = last_cycle_cpu_0_data_master_granted_slave_cpu_0_jtag_debug_module & cpu_0_data_master_requests_cpu_0_jtag_debug_module;

  assign cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module = cpu_0_instruction_master_requests_cpu_0_jtag_debug_module & ~((cpu_0_instruction_master_read & ((cpu_0_instruction_master_latency_counter != 0) | (|cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register))) | cpu_0_data_master_arbiterlock);
  //local readdatavalid cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module, which is an e_mux
  assign cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module = cpu_0_instruction_master_granted_cpu_0_jtag_debug_module & cpu_0_instruction_master_read & ~cpu_0_jtag_debug_module_waits_for_read;

  //allow new arb cycle for cpu_0/jtag_debug_module, which is an e_assign
  assign cpu_0_jtag_debug_module_allow_new_arb_cycle = ~cpu_0_data_master_arbiterlock & ~cpu_0_instruction_master_arbiterlock;

  //cpu_0/instruction_master assignment into master qualified-requests vector for cpu_0/jtag_debug_module, which is an e_assign
  assign cpu_0_jtag_debug_module_master_qreq_vector[0] = cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module;

  //cpu_0/instruction_master grant cpu_0/jtag_debug_module, which is an e_assign
  assign cpu_0_instruction_master_granted_cpu_0_jtag_debug_module = cpu_0_jtag_debug_module_grant_vector[0];

  //cpu_0/instruction_master saved-grant cpu_0/jtag_debug_module, which is an e_assign
  assign cpu_0_instruction_master_saved_grant_cpu_0_jtag_debug_module = cpu_0_jtag_debug_module_arb_winner[0] && cpu_0_instruction_master_requests_cpu_0_jtag_debug_module;

  //cpu_0/data_master assignment into master qualified-requests vector for cpu_0/jtag_debug_module, which is an e_assign
  assign cpu_0_jtag_debug_module_master_qreq_vector[1] = cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module;

  //cpu_0/data_master grant cpu_0/jtag_debug_module, which is an e_assign
  assign cpu_0_data_master_granted_cpu_0_jtag_debug_module = cpu_0_jtag_debug_module_grant_vector[1];

  //cpu_0/data_master saved-grant cpu_0/jtag_debug_module, which is an e_assign
  assign cpu_0_data_master_saved_grant_cpu_0_jtag_debug_module = cpu_0_jtag_debug_module_arb_winner[1] && cpu_0_data_master_requests_cpu_0_jtag_debug_module;

  //cpu_0/jtag_debug_module chosen-master double-vector, which is an e_assign
  assign cpu_0_jtag_debug_module_chosen_master_double_vector = {cpu_0_jtag_debug_module_master_qreq_vector, cpu_0_jtag_debug_module_master_qreq_vector} & ({~cpu_0_jtag_debug_module_master_qreq_vector, ~cpu_0_jtag_debug_module_master_qreq_vector} + cpu_0_jtag_debug_module_arb_addend);

  //stable onehot encoding of arb winner
  assign cpu_0_jtag_debug_module_arb_winner = (cpu_0_jtag_debug_module_allow_new_arb_cycle & | cpu_0_jtag_debug_module_grant_vector) ? cpu_0_jtag_debug_module_grant_vector : cpu_0_jtag_debug_module_saved_chosen_master_vector;

  //saved cpu_0_jtag_debug_module_grant_vector, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_jtag_debug_module_saved_chosen_master_vector <= 0;
      else if (cpu_0_jtag_debug_module_allow_new_arb_cycle)
          cpu_0_jtag_debug_module_saved_chosen_master_vector <= |cpu_0_jtag_debug_module_grant_vector ? cpu_0_jtag_debug_module_grant_vector : cpu_0_jtag_debug_module_saved_chosen_master_vector;
    end


  //onehot encoding of chosen master
  assign cpu_0_jtag_debug_module_grant_vector = {(cpu_0_jtag_debug_module_chosen_master_double_vector[1] | cpu_0_jtag_debug_module_chosen_master_double_vector[3]),
    (cpu_0_jtag_debug_module_chosen_master_double_vector[0] | cpu_0_jtag_debug_module_chosen_master_double_vector[2])};

  //cpu_0/jtag_debug_module chosen master rotated left, which is an e_assign
  assign cpu_0_jtag_debug_module_chosen_master_rot_left = (cpu_0_jtag_debug_module_arb_winner << 1) ? (cpu_0_jtag_debug_module_arb_winner << 1) : 1;

  //cpu_0/jtag_debug_module's addend for next-master-grant
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_jtag_debug_module_arb_addend <= 1;
      else if (|cpu_0_jtag_debug_module_grant_vector)
          cpu_0_jtag_debug_module_arb_addend <= cpu_0_jtag_debug_module_end_xfer? cpu_0_jtag_debug_module_chosen_master_rot_left : cpu_0_jtag_debug_module_grant_vector;
    end


  assign cpu_0_jtag_debug_module_begintransfer = cpu_0_jtag_debug_module_begins_xfer;
  //~cpu_0_jtag_debug_module_reset assignment, which is an e_assign
  assign cpu_0_jtag_debug_module_reset = ~reset_n;

  //assign cpu_0_jtag_debug_module_resetrequest_from_sa = cpu_0_jtag_debug_module_resetrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign cpu_0_jtag_debug_module_resetrequest_from_sa = cpu_0_jtag_debug_module_resetrequest;

  assign cpu_0_jtag_debug_module_chipselect = cpu_0_data_master_granted_cpu_0_jtag_debug_module | cpu_0_instruction_master_granted_cpu_0_jtag_debug_module;
  //cpu_0_jtag_debug_module_firsttransfer first transaction, which is an e_assign
  assign cpu_0_jtag_debug_module_firsttransfer = cpu_0_jtag_debug_module_begins_xfer ? cpu_0_jtag_debug_module_unreg_firsttransfer : cpu_0_jtag_debug_module_reg_firsttransfer;

  //cpu_0_jtag_debug_module_unreg_firsttransfer first transaction, which is an e_assign
  assign cpu_0_jtag_debug_module_unreg_firsttransfer = ~(cpu_0_jtag_debug_module_slavearbiterlockenable & cpu_0_jtag_debug_module_any_continuerequest);

  //cpu_0_jtag_debug_module_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_jtag_debug_module_reg_firsttransfer <= 1'b1;
      else if (cpu_0_jtag_debug_module_begins_xfer)
          cpu_0_jtag_debug_module_reg_firsttransfer <= cpu_0_jtag_debug_module_unreg_firsttransfer;
    end


  //cpu_0_jtag_debug_module_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign cpu_0_jtag_debug_module_beginbursttransfer_internal = cpu_0_jtag_debug_module_begins_xfer;

  //cpu_0_jtag_debug_module_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  assign cpu_0_jtag_debug_module_arbitration_holdoff_internal = cpu_0_jtag_debug_module_begins_xfer & cpu_0_jtag_debug_module_firsttransfer;

  //cpu_0_jtag_debug_module_write assignment, which is an e_mux
  assign cpu_0_jtag_debug_module_write = cpu_0_data_master_granted_cpu_0_jtag_debug_module & cpu_0_data_master_write;

  assign shifted_address_to_cpu_0_jtag_debug_module_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //cpu_0_jtag_debug_module_address mux, which is an e_mux
  assign cpu_0_jtag_debug_module_address = (cpu_0_data_master_granted_cpu_0_jtag_debug_module)? (shifted_address_to_cpu_0_jtag_debug_module_from_cpu_0_data_master >> 2) :
    (shifted_address_to_cpu_0_jtag_debug_module_from_cpu_0_instruction_master >> 2);

  assign shifted_address_to_cpu_0_jtag_debug_module_from_cpu_0_instruction_master = cpu_0_instruction_master_address_to_slave;
  //d1_cpu_0_jtag_debug_module_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_cpu_0_jtag_debug_module_end_xfer <= 1;
      else if (1)
          d1_cpu_0_jtag_debug_module_end_xfer <= cpu_0_jtag_debug_module_end_xfer;
    end


  //cpu_0_jtag_debug_module_waits_for_read in a cycle, which is an e_mux
  assign cpu_0_jtag_debug_module_waits_for_read = cpu_0_jtag_debug_module_in_a_read_cycle & cpu_0_jtag_debug_module_begins_xfer;

  //cpu_0_jtag_debug_module_in_a_read_cycle assignment, which is an e_assign
  assign cpu_0_jtag_debug_module_in_a_read_cycle = (cpu_0_data_master_granted_cpu_0_jtag_debug_module & cpu_0_data_master_read) | (cpu_0_instruction_master_granted_cpu_0_jtag_debug_module & cpu_0_instruction_master_read);

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = cpu_0_jtag_debug_module_in_a_read_cycle;

  //cpu_0_jtag_debug_module_waits_for_write in a cycle, which is an e_mux
  assign cpu_0_jtag_debug_module_waits_for_write = cpu_0_jtag_debug_module_in_a_write_cycle & 0;

  //cpu_0_jtag_debug_module_in_a_write_cycle assignment, which is an e_assign
  assign cpu_0_jtag_debug_module_in_a_write_cycle = cpu_0_data_master_granted_cpu_0_jtag_debug_module & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = cpu_0_jtag_debug_module_in_a_write_cycle;

  assign wait_for_cpu_0_jtag_debug_module_counter = 0;
  //cpu_0_jtag_debug_module_byteenable byte enable port mux, which is an e_mux
  assign cpu_0_jtag_debug_module_byteenable = (cpu_0_data_master_granted_cpu_0_jtag_debug_module)? cpu_0_data_master_byteenable :
    -1;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //cpu_0/jtag_debug_module enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end


  //grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_0_data_master_granted_cpu_0_jtag_debug_module + cpu_0_instruction_master_granted_cpu_0_jtag_debug_module > 1)
        begin
          $write("%0d ns: > 1 of grant signals are active simultaneously", $time);
          $stop;
        end
    end


  //saved_grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_0_data_master_saved_grant_cpu_0_jtag_debug_module + cpu_0_instruction_master_saved_grant_cpu_0_jtag_debug_module > 1)
        begin
          $write("%0d ns: > 1 of saved_grant signals are active simultaneously", $time);
          $stop;
        end
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module cpu_0_custom_instruction_master_arbitrator (
                                                    // inputs:
                                                     clk,
                                                     cpu_0_custom_instruction_master_multi_start,
                                                     cpu_0_fpoint_s1_done_from_sa,
                                                     cpu_0_fpoint_s1_result_from_sa,
                                                     reset_n,

                                                    // outputs:
                                                     cpu_0_custom_instruction_master_multi_done,
                                                     cpu_0_custom_instruction_master_multi_result,
                                                     cpu_0_custom_instruction_master_reset_n,
                                                     cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1,
                                                     cpu_0_fpoint_s1_select
                                                  )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_custom_instruction_master_multi_done;
  output  [ 31: 0] cpu_0_custom_instruction_master_multi_result;
  output           cpu_0_custom_instruction_master_reset_n;
  output           cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1;
  output           cpu_0_fpoint_s1_select;
  input            clk;
  input            cpu_0_custom_instruction_master_multi_start;
  input            cpu_0_fpoint_s1_done_from_sa;
  input   [ 31: 0] cpu_0_fpoint_s1_result_from_sa;
  input            reset_n;

  wire             cpu_0_custom_instruction_master_multi_done;
  wire    [ 31: 0] cpu_0_custom_instruction_master_multi_result;
  wire             cpu_0_custom_instruction_master_reset_n;
  wire             cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1;
  wire             cpu_0_fpoint_s1_select;
  assign cpu_0_fpoint_s1_select = 1'b1;
  assign cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1 = cpu_0_fpoint_s1_select & cpu_0_custom_instruction_master_multi_start;
  //cpu_0_custom_instruction_master_multi_result mux, which is an e_mux
  assign cpu_0_custom_instruction_master_multi_result = {32 {cpu_0_fpoint_s1_select}} & cpu_0_fpoint_s1_result_from_sa;

  //multi_done mux, which is an e_mux
  assign cpu_0_custom_instruction_master_multi_done = {1 {cpu_0_fpoint_s1_select}} & cpu_0_fpoint_s1_done_from_sa;

  //cpu_0_custom_instruction_master_reset_n local reset_n, which is an e_assign
  assign cpu_0_custom_instruction_master_reset_n = reset_n;


endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module cpu_0_data_master_arbitrator (
                                      // inputs:
                                       adc_tlc549_0_avalon_slave_0_irq_from_sa,
                                       adc_tlc549_0_avalon_slave_0_readdata_from_sa,
                                       clk,
                                       cpu_0_data_master_address,
                                       cpu_0_data_master_byteenable_flash_s1,
                                       cpu_0_data_master_byteenable_sdram_0_s1,
                                       cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0,
                                       cpu_0_data_master_debugaccess,
                                       cpu_0_data_master_granted_E_RST_s1,
                                       cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0,
                                       cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave,
                                       cpu_0_data_master_granted_cpu_0_jtag_debug_module,
                                       cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                       cpu_0_data_master_granted_dma_control_port_slave,
                                       cpu_0_data_master_granted_flash_s1,
                                       cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave,
                                       cpu_0_data_master_granted_lcd12864_cs_s1,
                                       cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0,
                                       cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0,
                                       cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave,
                                       cpu_0_data_master_granted_onchip_mem_s1,
                                       cpu_0_data_master_granted_performance_counter_control_slave,
                                       cpu_0_data_master_granted_pio_beep_s1,
                                       cpu_0_data_master_granted_pio_key_s1,
                                       cpu_0_data_master_granted_pio_led_s1,
                                       cpu_0_data_master_granted_ps2_0_avalon_slave_0,
                                       cpu_0_data_master_granted_pwm_interface_0_control_slave,
                                       cpu_0_data_master_granted_sdram_0_s1,
                                       cpu_0_data_master_granted_seg78led_0_avalon_slave_0,
                                       cpu_0_data_master_granted_sysid_control_slave,
                                       cpu_0_data_master_granted_timer_0_s1,
                                       cpu_0_data_master_granted_uart_usb_s1,
                                       cpu_0_data_master_qualified_request_E_RST_s1,
                                       cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0,
                                       cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave,
                                       cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module,
                                       cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                       cpu_0_data_master_qualified_request_dma_control_port_slave,
                                       cpu_0_data_master_qualified_request_flash_s1,
                                       cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave,
                                       cpu_0_data_master_qualified_request_lcd12864_cs_s1,
                                       cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0,
                                       cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0,
                                       cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave,
                                       cpu_0_data_master_qualified_request_onchip_mem_s1,
                                       cpu_0_data_master_qualified_request_performance_counter_control_slave,
                                       cpu_0_data_master_qualified_request_pio_beep_s1,
                                       cpu_0_data_master_qualified_request_pio_key_s1,
                                       cpu_0_data_master_qualified_request_pio_led_s1,
                                       cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0,
                                       cpu_0_data_master_qualified_request_pwm_interface_0_control_slave,
                                       cpu_0_data_master_qualified_request_sdram_0_s1,
                                       cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0,
                                       cpu_0_data_master_qualified_request_sysid_control_slave,
                                       cpu_0_data_master_qualified_request_timer_0_s1,
                                       cpu_0_data_master_qualified_request_uart_usb_s1,
                                       cpu_0_data_master_read,
                                       cpu_0_data_master_read_data_valid_E_RST_s1,
                                       cpu_0_data_master_read_data_valid_adc_tlc549_0_avalon_slave_0,
                                       cpu_0_data_master_read_data_valid_avalon_tlc5620_0_avalon_slave,
                                       cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module,
                                       cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                       cpu_0_data_master_read_data_valid_dma_control_port_slave,
                                       cpu_0_data_master_read_data_valid_flash_s1,
                                       cpu_0_data_master_read_data_valid_jtag_uart_avalon_jtag_slave,
                                       cpu_0_data_master_read_data_valid_lcd12864_cs_s1,
                                       cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0,
                                       cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0,
                                       cpu_0_data_master_read_data_valid_oc_i2c_master_0_avalon_slave,
                                       cpu_0_data_master_read_data_valid_onchip_mem_s1,
                                       cpu_0_data_master_read_data_valid_performance_counter_control_slave,
                                       cpu_0_data_master_read_data_valid_pio_beep_s1,
                                       cpu_0_data_master_read_data_valid_pio_key_s1,
                                       cpu_0_data_master_read_data_valid_pio_led_s1,
                                       cpu_0_data_master_read_data_valid_ps2_0_avalon_slave_0,
                                       cpu_0_data_master_read_data_valid_pwm_interface_0_control_slave,
                                       cpu_0_data_master_read_data_valid_sdram_0_s1,
                                       cpu_0_data_master_read_data_valid_sdram_0_s1_shift_register,
                                       cpu_0_data_master_read_data_valid_seg78led_0_avalon_slave_0,
                                       cpu_0_data_master_read_data_valid_sysid_control_slave,
                                       cpu_0_data_master_read_data_valid_timer_0_s1,
                                       cpu_0_data_master_read_data_valid_uart_usb_s1,
                                       cpu_0_data_master_requests_E_RST_s1,
                                       cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0,
                                       cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave,
                                       cpu_0_data_master_requests_cpu_0_jtag_debug_module,
                                       cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                       cpu_0_data_master_requests_dma_control_port_slave,
                                       cpu_0_data_master_requests_flash_s1,
                                       cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave,
                                       cpu_0_data_master_requests_lcd12864_cs_s1,
                                       cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0,
                                       cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0,
                                       cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave,
                                       cpu_0_data_master_requests_onchip_mem_s1,
                                       cpu_0_data_master_requests_performance_counter_control_slave,
                                       cpu_0_data_master_requests_pio_beep_s1,
                                       cpu_0_data_master_requests_pio_key_s1,
                                       cpu_0_data_master_requests_pio_led_s1,
                                       cpu_0_data_master_requests_ps2_0_avalon_slave_0,
                                       cpu_0_data_master_requests_pwm_interface_0_control_slave,
                                       cpu_0_data_master_requests_sdram_0_s1,
                                       cpu_0_data_master_requests_seg78led_0_avalon_slave_0,
                                       cpu_0_data_master_requests_sysid_control_slave,
                                       cpu_0_data_master_requests_timer_0_s1,
                                       cpu_0_data_master_requests_uart_usb_s1,
                                       cpu_0_data_master_write,
                                       cpu_0_data_master_writedata,
                                       cpu_0_jtag_debug_module_readdata_from_sa,
                                       ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0,
                                       ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1,
                                       d1_E_RST_s1_end_xfer,
                                       d1_adc_tlc549_0_avalon_slave_0_end_xfer,
                                       d1_avalon_tlc5620_0_avalon_slave_end_xfer,
                                       d1_cpu_0_jtag_debug_module_end_xfer,
                                       d1_dma_control_port_slave_end_xfer,
                                       d1_irq_from_the_ctrl_rtl8019_0,
                                       d1_jtag_uart_avalon_jtag_slave_end_xfer,
                                       d1_lcd12864_cs_s1_end_xfer,
                                       d1_oc_i2c_master_0_avalon_slave_end_xfer,
                                       d1_onchip_mem_s1_end_xfer,
                                       d1_performance_counter_control_slave_end_xfer,
                                       d1_pio_beep_s1_end_xfer,
                                       d1_pio_key_s1_end_xfer,
                                       d1_pio_led_s1_end_xfer,
                                       d1_ps2_0_avalon_slave_0_end_xfer,
                                       d1_pwm_interface_0_control_slave_end_xfer,
                                       d1_sdram_0_s1_end_xfer,
                                       d1_seg78led_0_avalon_slave_0_end_xfer,
                                       d1_sysid_control_slave_end_xfer,
                                       d1_timer_0_s1_end_xfer,
                                       d1_tri_state_bridge_0_avalon_slave_end_xfer,
                                       d1_uart_usb_s1_end_xfer,
                                       dma_control_port_slave_irq_from_sa,
                                       dma_control_port_slave_readdata_from_sa,
                                       flash_s1_wait_counter_eq_0,
                                       flash_s1_wait_counter_eq_1,
                                       incoming_tri_state_bridge_0_data,
                                       incoming_tri_state_bridge_0_data_with_Xs_converted_to_0,
                                       jtag_uart_avalon_jtag_slave_irq_from_sa,
                                       jtag_uart_avalon_jtag_slave_readdata_from_sa,
                                       jtag_uart_avalon_jtag_slave_waitrequest_from_sa,
                                       lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0,
                                       lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1,
                                       lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0,
                                       lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1,
                                       oc_i2c_master_0_avalon_slave_irq_from_sa,
                                       oc_i2c_master_0_avalon_slave_readdata_from_sa,
                                       oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa,
                                       onchip_mem_s1_readdata_from_sa,
                                       performance_counter_control_slave_readdata_from_sa,
                                       pio_key_s1_irq_from_sa,
                                       pio_key_s1_readdata_from_sa,
                                       ps2_0_avalon_slave_0_irq_from_sa,
                                       ps2_0_avalon_slave_0_readdata_from_sa,
                                       pwm_interface_0_control_slave_readdata_from_sa,
                                       registered_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                       registered_cpu_0_data_master_read_data_valid_flash_s1,
                                       registered_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0,
                                       registered_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0,
                                       registered_cpu_0_data_master_read_data_valid_onchip_mem_s1,
                                       registered_cpu_0_data_master_read_data_valid_performance_counter_control_slave,
                                       reset_n,
                                       sdram_0_s1_readdata_from_sa,
                                       sdram_0_s1_waitrequest_from_sa,
                                       seg78led_0_avalon_slave_0_readdata_from_sa,
                                       seg78led_0_avalon_slave_0_wait_counter_eq_0,
                                       seg78led_0_avalon_slave_0_wait_counter_eq_1,
                                       sysid_control_slave_readdata_from_sa,
                                       timer_0_s1_irq_from_sa,
                                       timer_0_s1_readdata_from_sa,
                                       uart_usb_s1_irq_from_sa,
                                       uart_usb_s1_readdata_from_sa,

                                      // outputs:
                                       cpu_0_data_master_address_to_slave,
                                       cpu_0_data_master_dbs_address,
                                       cpu_0_data_master_dbs_write_16,
                                       cpu_0_data_master_dbs_write_8,
                                       cpu_0_data_master_irq,
                                       cpu_0_data_master_no_byte_enables_and_last_term,
                                       cpu_0_data_master_readdata,
                                       cpu_0_data_master_waitrequest
                                    )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output  [ 25: 0] cpu_0_data_master_address_to_slave;
  output  [  1: 0] cpu_0_data_master_dbs_address;
  output  [ 15: 0] cpu_0_data_master_dbs_write_16;
  output  [  7: 0] cpu_0_data_master_dbs_write_8;
  output  [ 31: 0] cpu_0_data_master_irq;
  output           cpu_0_data_master_no_byte_enables_and_last_term;
  output  [ 31: 0] cpu_0_data_master_readdata;
  output           cpu_0_data_master_waitrequest;
  input            adc_tlc549_0_avalon_slave_0_irq_from_sa;
  input   [  7: 0] adc_tlc549_0_avalon_slave_0_readdata_from_sa;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address;
  input            cpu_0_data_master_byteenable_flash_s1;
  input   [  1: 0] cpu_0_data_master_byteenable_sdram_0_s1;
  input            cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0;
  input            cpu_0_data_master_debugaccess;
  input            cpu_0_data_master_granted_E_RST_s1;
  input            cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0;
  input            cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave;
  input            cpu_0_data_master_granted_cpu_0_jtag_debug_module;
  input            cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0;
  input            cpu_0_data_master_granted_dma_control_port_slave;
  input            cpu_0_data_master_granted_flash_s1;
  input            cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave;
  input            cpu_0_data_master_granted_lcd12864_cs_s1;
  input            cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0;
  input            cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0;
  input            cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave;
  input            cpu_0_data_master_granted_onchip_mem_s1;
  input            cpu_0_data_master_granted_performance_counter_control_slave;
  input            cpu_0_data_master_granted_pio_beep_s1;
  input            cpu_0_data_master_granted_pio_key_s1;
  input            cpu_0_data_master_granted_pio_led_s1;
  input            cpu_0_data_master_granted_ps2_0_avalon_slave_0;
  input            cpu_0_data_master_granted_pwm_interface_0_control_slave;
  input            cpu_0_data_master_granted_sdram_0_s1;
  input            cpu_0_data_master_granted_seg78led_0_avalon_slave_0;
  input            cpu_0_data_master_granted_sysid_control_slave;
  input            cpu_0_data_master_granted_timer_0_s1;
  input            cpu_0_data_master_granted_uart_usb_s1;
  input            cpu_0_data_master_qualified_request_E_RST_s1;
  input            cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0;
  input            cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave;
  input            cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module;
  input            cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0;
  input            cpu_0_data_master_qualified_request_dma_control_port_slave;
  input            cpu_0_data_master_qualified_request_flash_s1;
  input            cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave;
  input            cpu_0_data_master_qualified_request_lcd12864_cs_s1;
  input            cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0;
  input            cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0;
  input            cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave;
  input            cpu_0_data_master_qualified_request_onchip_mem_s1;
  input            cpu_0_data_master_qualified_request_performance_counter_control_slave;
  input            cpu_0_data_master_qualified_request_pio_beep_s1;
  input            cpu_0_data_master_qualified_request_pio_key_s1;
  input            cpu_0_data_master_qualified_request_pio_led_s1;
  input            cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0;
  input            cpu_0_data_master_qualified_request_pwm_interface_0_control_slave;
  input            cpu_0_data_master_qualified_request_sdram_0_s1;
  input            cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0;
  input            cpu_0_data_master_qualified_request_sysid_control_slave;
  input            cpu_0_data_master_qualified_request_timer_0_s1;
  input            cpu_0_data_master_qualified_request_uart_usb_s1;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_read_data_valid_E_RST_s1;
  input            cpu_0_data_master_read_data_valid_adc_tlc549_0_avalon_slave_0;
  input            cpu_0_data_master_read_data_valid_avalon_tlc5620_0_avalon_slave;
  input            cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module;
  input            cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0;
  input            cpu_0_data_master_read_data_valid_dma_control_port_slave;
  input            cpu_0_data_master_read_data_valid_flash_s1;
  input            cpu_0_data_master_read_data_valid_jtag_uart_avalon_jtag_slave;
  input            cpu_0_data_master_read_data_valid_lcd12864_cs_s1;
  input            cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0;
  input            cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0;
  input            cpu_0_data_master_read_data_valid_oc_i2c_master_0_avalon_slave;
  input            cpu_0_data_master_read_data_valid_onchip_mem_s1;
  input            cpu_0_data_master_read_data_valid_performance_counter_control_slave;
  input            cpu_0_data_master_read_data_valid_pio_beep_s1;
  input            cpu_0_data_master_read_data_valid_pio_key_s1;
  input            cpu_0_data_master_read_data_valid_pio_led_s1;
  input            cpu_0_data_master_read_data_valid_ps2_0_avalon_slave_0;
  input            cpu_0_data_master_read_data_valid_pwm_interface_0_control_slave;
  input            cpu_0_data_master_read_data_valid_sdram_0_s1;
  input            cpu_0_data_master_read_data_valid_sdram_0_s1_shift_register;
  input            cpu_0_data_master_read_data_valid_seg78led_0_avalon_slave_0;
  input            cpu_0_data_master_read_data_valid_sysid_control_slave;
  input            cpu_0_data_master_read_data_valid_timer_0_s1;
  input            cpu_0_data_master_read_data_valid_uart_usb_s1;
  input            cpu_0_data_master_requests_E_RST_s1;
  input            cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0;
  input            cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave;
  input            cpu_0_data_master_requests_cpu_0_jtag_debug_module;
  input            cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0;
  input            cpu_0_data_master_requests_dma_control_port_slave;
  input            cpu_0_data_master_requests_flash_s1;
  input            cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave;
  input            cpu_0_data_master_requests_lcd12864_cs_s1;
  input            cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0;
  input            cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0;
  input            cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave;
  input            cpu_0_data_master_requests_onchip_mem_s1;
  input            cpu_0_data_master_requests_performance_counter_control_slave;
  input            cpu_0_data_master_requests_pio_beep_s1;
  input            cpu_0_data_master_requests_pio_key_s1;
  input            cpu_0_data_master_requests_pio_led_s1;
  input            cpu_0_data_master_requests_ps2_0_avalon_slave_0;
  input            cpu_0_data_master_requests_pwm_interface_0_control_slave;
  input            cpu_0_data_master_requests_sdram_0_s1;
  input            cpu_0_data_master_requests_seg78led_0_avalon_slave_0;
  input            cpu_0_data_master_requests_sysid_control_slave;
  input            cpu_0_data_master_requests_timer_0_s1;
  input            cpu_0_data_master_requests_uart_usb_s1;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input   [ 31: 0] cpu_0_jtag_debug_module_readdata_from_sa;
  input            ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0;
  input            ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1;
  input            d1_E_RST_s1_end_xfer;
  input            d1_adc_tlc549_0_avalon_slave_0_end_xfer;
  input            d1_avalon_tlc5620_0_avalon_slave_end_xfer;
  input            d1_cpu_0_jtag_debug_module_end_xfer;
  input            d1_dma_control_port_slave_end_xfer;
  input            d1_irq_from_the_ctrl_rtl8019_0;
  input            d1_jtag_uart_avalon_jtag_slave_end_xfer;
  input            d1_lcd12864_cs_s1_end_xfer;
  input            d1_oc_i2c_master_0_avalon_slave_end_xfer;
  input            d1_onchip_mem_s1_end_xfer;
  input            d1_performance_counter_control_slave_end_xfer;
  input            d1_pio_beep_s1_end_xfer;
  input            d1_pio_key_s1_end_xfer;
  input            d1_pio_led_s1_end_xfer;
  input            d1_ps2_0_avalon_slave_0_end_xfer;
  input            d1_pwm_interface_0_control_slave_end_xfer;
  input            d1_sdram_0_s1_end_xfer;
  input            d1_seg78led_0_avalon_slave_0_end_xfer;
  input            d1_sysid_control_slave_end_xfer;
  input            d1_timer_0_s1_end_xfer;
  input            d1_tri_state_bridge_0_avalon_slave_end_xfer;
  input            d1_uart_usb_s1_end_xfer;
  input            dma_control_port_slave_irq_from_sa;
  input   [ 25: 0] dma_control_port_slave_readdata_from_sa;
  input            flash_s1_wait_counter_eq_0;
  input            flash_s1_wait_counter_eq_1;
  input   [  7: 0] incoming_tri_state_bridge_0_data;
  input   [  7: 0] incoming_tri_state_bridge_0_data_with_Xs_converted_to_0;
  input            jtag_uart_avalon_jtag_slave_irq_from_sa;
  input   [ 31: 0] jtag_uart_avalon_jtag_slave_readdata_from_sa;
  input            jtag_uart_avalon_jtag_slave_waitrequest_from_sa;
  input            lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0;
  input            lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1;
  input            lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0;
  input            lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1;
  input            oc_i2c_master_0_avalon_slave_irq_from_sa;
  input   [ 31: 0] oc_i2c_master_0_avalon_slave_readdata_from_sa;
  input            oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa;
  input   [ 31: 0] onchip_mem_s1_readdata_from_sa;
  input   [ 31: 0] performance_counter_control_slave_readdata_from_sa;
  input            pio_key_s1_irq_from_sa;
  input   [  3: 0] pio_key_s1_readdata_from_sa;
  input            ps2_0_avalon_slave_0_irq_from_sa;
  input   [ 15: 0] ps2_0_avalon_slave_0_readdata_from_sa;
  input   [ 31: 0] pwm_interface_0_control_slave_readdata_from_sa;
  input            registered_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0;
  input            registered_cpu_0_data_master_read_data_valid_flash_s1;
  input            registered_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0;
  input            registered_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0;
  input            registered_cpu_0_data_master_read_data_valid_onchip_mem_s1;
  input            registered_cpu_0_data_master_read_data_valid_performance_counter_control_slave;
  input            reset_n;
  input   [ 15: 0] sdram_0_s1_readdata_from_sa;
  input            sdram_0_s1_waitrequest_from_sa;
  input   [  7: 0] seg78led_0_avalon_slave_0_readdata_from_sa;
  input            seg78led_0_avalon_slave_0_wait_counter_eq_0;
  input            seg78led_0_avalon_slave_0_wait_counter_eq_1;
  input   [ 31: 0] sysid_control_slave_readdata_from_sa;
  input            timer_0_s1_irq_from_sa;
  input   [ 15: 0] timer_0_s1_readdata_from_sa;
  input            uart_usb_s1_irq_from_sa;
  input   [ 15: 0] uart_usb_s1_readdata_from_sa;

  wire    [ 25: 0] cpu_0_data_master_address_to_slave;
  reg     [  1: 0] cpu_0_data_master_dbs_address;
  wire    [  1: 0] cpu_0_data_master_dbs_increment;
  wire    [ 15: 0] cpu_0_data_master_dbs_write_16;
  wire    [  7: 0] cpu_0_data_master_dbs_write_8;
  wire    [ 31: 0] cpu_0_data_master_irq;
  reg              cpu_0_data_master_no_byte_enables_and_last_term;
  wire    [ 31: 0] cpu_0_data_master_readdata;
  wire             cpu_0_data_master_run;
  reg              cpu_0_data_master_waitrequest;
  reg     [ 15: 0] dbs_16_reg_segment_0;
  reg     [  7: 0] dbs_8_reg_segment_0;
  reg     [  7: 0] dbs_8_reg_segment_1;
  reg     [  7: 0] dbs_8_reg_segment_2;
  wire             dbs_count_enable;
  wire             dbs_counter_overflow;
  wire             last_dbs_term_and_run;
  wire    [  1: 0] next_dbs_address;
  wire    [ 15: 0] p1_dbs_16_reg_segment_0;
  wire    [  7: 0] p1_dbs_8_reg_segment_0;
  wire    [  7: 0] p1_dbs_8_reg_segment_1;
  wire    [  7: 0] p1_dbs_8_reg_segment_2;
  wire    [ 31: 0] p1_registered_cpu_0_data_master_readdata;
  wire             pre_dbs_count_enable;
  wire             r_0;
  wire             r_1;
  wire             r_2;
  wire             r_3;
  wire             r_4;
  reg     [ 31: 0] registered_cpu_0_data_master_readdata;
  //r_0 master_run cascaded wait assignment, which is an e_assign
  assign r_0 = 1 & (cpu_0_data_master_qualified_request_E_RST_s1 | ~cpu_0_data_master_requests_E_RST_s1) & ((~cpu_0_data_master_qualified_request_E_RST_s1 | ~cpu_0_data_master_read | (1 & 1 & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_E_RST_s1 | ~cpu_0_data_master_write | (1 & cpu_0_data_master_write))) & 1 & (cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0 | ~cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0) & ((~cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0 | ~cpu_0_data_master_read | (1 & (cpu_0_data_master_dbs_address[1] & cpu_0_data_master_dbs_address[0]) & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0 | ~cpu_0_data_master_write | (1 & (cpu_0_data_master_dbs_address[1] & cpu_0_data_master_dbs_address[0]) & cpu_0_data_master_write))) & 1 & (cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave | ~cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave) & ((~cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave | ~cpu_0_data_master_read | (1 & 1 & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave | ~cpu_0_data_master_write | (1 & cpu_0_data_master_write))) & 1 & (cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module | ~cpu_0_data_master_requests_cpu_0_jtag_debug_module) & (cpu_0_data_master_granted_cpu_0_jtag_debug_module | ~cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module) & ((~cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module | ~cpu_0_data_master_read | (1 & 1 & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module | ~cpu_0_data_master_write | (1 & cpu_0_data_master_write))) & 1 & ((~cpu_0_data_master_qualified_request_dma_control_port_slave | ~(cpu_0_data_master_read | cpu_0_data_master_write) | (1 & 1 & (cpu_0_data_master_read | cpu_0_data_master_write)))) & ((~cpu_0_data_master_qualified_request_dma_control_port_slave | ~(cpu_0_data_master_read | cpu_0_data_master_write) | (1 & 1 & (cpu_0_data_master_read | cpu_0_data_master_write))));

  //cascaded wait assignment, which is an e_assign
  assign cpu_0_data_master_run = r_0 & r_1 & r_2 & r_3 & r_4;

  //r_1 master_run cascaded wait assignment, which is an e_assign
  assign r_1 = 1 & (cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave | ~cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave) & ((~cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave | ~(cpu_0_data_master_read | cpu_0_data_master_write) | (1 & ~jtag_uart_avalon_jtag_slave_waitrequest_from_sa & (cpu_0_data_master_read | cpu_0_data_master_write)))) & ((~cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave | ~(cpu_0_data_master_read | cpu_0_data_master_write) | (1 & ~jtag_uart_avalon_jtag_slave_waitrequest_from_sa & (cpu_0_data_master_read | cpu_0_data_master_write)))) & 1 & (cpu_0_data_master_qualified_request_lcd12864_cs_s1 | ~cpu_0_data_master_requests_lcd12864_cs_s1) & ((~cpu_0_data_master_qualified_request_lcd12864_cs_s1 | ~cpu_0_data_master_read | (1 & 1 & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_lcd12864_cs_s1 | ~cpu_0_data_master_write | (1 & cpu_0_data_master_write))) & 1 & (cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave | ~cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave) & ((~cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave | ~(cpu_0_data_master_read | cpu_0_data_master_write) | (1 & oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa & (cpu_0_data_master_read | cpu_0_data_master_write)))) & ((~cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave | ~(cpu_0_data_master_read | cpu_0_data_master_write) | (1 & oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa & (cpu_0_data_master_read | cpu_0_data_master_write)))) & 1 & (cpu_0_data_master_qualified_request_onchip_mem_s1 | registered_cpu_0_data_master_read_data_valid_onchip_mem_s1 | ~cpu_0_data_master_requests_onchip_mem_s1) & (cpu_0_data_master_granted_onchip_mem_s1 | ~cpu_0_data_master_qualified_request_onchip_mem_s1) & ((~cpu_0_data_master_qualified_request_onchip_mem_s1 | ~cpu_0_data_master_read | (registered_cpu_0_data_master_read_data_valid_onchip_mem_s1 & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_onchip_mem_s1 | ~(cpu_0_data_master_read | cpu_0_data_master_write) | (1 & (cpu_0_data_master_read | cpu_0_data_master_write)))) & 1 & (cpu_0_data_master_qualified_request_performance_counter_control_slave | registered_cpu_0_data_master_read_data_valid_performance_counter_control_slave | ~cpu_0_data_master_requests_performance_counter_control_slave) & ((~cpu_0_data_master_qualified_request_performance_counter_control_slave | ~cpu_0_data_master_read | (registered_cpu_0_data_master_read_data_valid_performance_counter_control_slave & cpu_0_data_master_read)));

  //r_2 master_run cascaded wait assignment, which is an e_assign
  assign r_2 = ((~cpu_0_data_master_qualified_request_performance_counter_control_slave | ~(cpu_0_data_master_read | cpu_0_data_master_write) | (1 & (cpu_0_data_master_read | cpu_0_data_master_write)))) & 1 & (cpu_0_data_master_qualified_request_pio_beep_s1 | ~cpu_0_data_master_requests_pio_beep_s1) & ((~cpu_0_data_master_qualified_request_pio_beep_s1 | ~cpu_0_data_master_read | (1 & 1 & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_pio_beep_s1 | ~cpu_0_data_master_write | (1 & cpu_0_data_master_write))) & 1 & (cpu_0_data_master_qualified_request_pio_key_s1 | ~cpu_0_data_master_requests_pio_key_s1) & ((~cpu_0_data_master_qualified_request_pio_key_s1 | ~cpu_0_data_master_read | (1 & 1 & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_pio_key_s1 | ~cpu_0_data_master_write | (1 & cpu_0_data_master_write))) & 1 & (cpu_0_data_master_qualified_request_pio_led_s1 | ~cpu_0_data_master_requests_pio_led_s1) & ((~cpu_0_data_master_qualified_request_pio_led_s1 | ~cpu_0_data_master_read | (1 & 1 & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_pio_led_s1 | ~cpu_0_data_master_write | (1 & cpu_0_data_master_write))) & 1 & (cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0 | ~cpu_0_data_master_requests_ps2_0_avalon_slave_0) & ((~cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0 | ~cpu_0_data_master_read | (1 & (cpu_0_data_master_dbs_address[1]) & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0 | ~cpu_0_data_master_write | (1 & (cpu_0_data_master_dbs_address[1]) & cpu_0_data_master_write))) & 1 & (cpu_0_data_master_qualified_request_pwm_interface_0_control_slave | ~cpu_0_data_master_requests_pwm_interface_0_control_slave) & ((~cpu_0_data_master_qualified_request_pwm_interface_0_control_slave | ~(cpu_0_data_master_read | cpu_0_data_master_write) | (1 & (cpu_0_data_master_read | cpu_0_data_master_write))));

  //r_3 master_run cascaded wait assignment, which is an e_assign
  assign r_3 = ((~cpu_0_data_master_qualified_request_pwm_interface_0_control_slave | ~(cpu_0_data_master_read | cpu_0_data_master_write) | (1 & (cpu_0_data_master_read | cpu_0_data_master_write)))) & 1 & (cpu_0_data_master_qualified_request_sdram_0_s1 | (cpu_0_data_master_read_data_valid_sdram_0_s1 & cpu_0_data_master_dbs_address[1]) | (cpu_0_data_master_write & !cpu_0_data_master_byteenable_sdram_0_s1 & cpu_0_data_master_dbs_address[1]) | ~cpu_0_data_master_requests_sdram_0_s1) & (cpu_0_data_master_granted_sdram_0_s1 | ~cpu_0_data_master_qualified_request_sdram_0_s1) & ((~cpu_0_data_master_qualified_request_sdram_0_s1 | ~cpu_0_data_master_read | (cpu_0_data_master_read_data_valid_sdram_0_s1 & (cpu_0_data_master_dbs_address[1]) & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_sdram_0_s1 | ~cpu_0_data_master_write | (1 & ~sdram_0_s1_waitrequest_from_sa & (cpu_0_data_master_dbs_address[1]) & cpu_0_data_master_write))) & 1 & ((cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0 | ((cpu_0_data_master_write & !cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0 & cpu_0_data_master_dbs_address[1] & cpu_0_data_master_dbs_address[0])) | ~cpu_0_data_master_requests_seg78led_0_avalon_slave_0)) & (cpu_0_data_master_granted_seg78led_0_avalon_slave_0 | ~cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0) & ((~cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0 | ~cpu_0_data_master_read | (1 & seg78led_0_avalon_slave_0_wait_counter_eq_1 & (cpu_0_data_master_dbs_address[1] & cpu_0_data_master_dbs_address[0]) & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0 | ~cpu_0_data_master_write | (1 & seg78led_0_avalon_slave_0_wait_counter_eq_1 & (cpu_0_data_master_dbs_address[1] & cpu_0_data_master_dbs_address[0]) & cpu_0_data_master_write))) & 1 & ((~cpu_0_data_master_qualified_request_sysid_control_slave | ~cpu_0_data_master_read | (1 & 1 & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_sysid_control_slave | ~cpu_0_data_master_write | (1 & cpu_0_data_master_write))) & 1 & (cpu_0_data_master_qualified_request_timer_0_s1 | ~cpu_0_data_master_requests_timer_0_s1) & ((~cpu_0_data_master_qualified_request_timer_0_s1 | ~cpu_0_data_master_read | (1 & 1 & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_timer_0_s1 | ~cpu_0_data_master_write | (1 & cpu_0_data_master_write))) & 1 & (cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0 | registered_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0 | ~cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0);

  //r_4 master_run cascaded wait assignment, which is an e_assign
  assign r_4 = (cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0 | registered_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0 | ~cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0) & ((cpu_0_data_master_qualified_request_flash_s1 | (registered_cpu_0_data_master_read_data_valid_flash_s1 & cpu_0_data_master_dbs_address[1] & cpu_0_data_master_dbs_address[0]) | ((cpu_0_data_master_write & !cpu_0_data_master_byteenable_flash_s1 & cpu_0_data_master_dbs_address[1] & cpu_0_data_master_dbs_address[0])) | ~cpu_0_data_master_requests_flash_s1)) & (cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0 | registered_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0 | ~cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0) & (cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 | ~cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0) & (cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 | ~cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0) & (cpu_0_data_master_granted_flash_s1 | ~cpu_0_data_master_qualified_request_flash_s1) & (cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 | ~cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0) & ((~cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0 | ~cpu_0_data_master_read | (registered_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0 & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0 | ~cpu_0_data_master_write | (1 & ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1 & cpu_0_data_master_write))) & ((~cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0 | ~cpu_0_data_master_read | (registered_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0 & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0 | ~cpu_0_data_master_write | (1 & lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1 & cpu_0_data_master_write))) & ((~cpu_0_data_master_qualified_request_flash_s1 | ~cpu_0_data_master_read | (registered_cpu_0_data_master_read_data_valid_flash_s1 & (cpu_0_data_master_dbs_address[1] & cpu_0_data_master_dbs_address[0]) & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_flash_s1 | ~cpu_0_data_master_write | (1 & flash_s1_wait_counter_eq_1 & (cpu_0_data_master_dbs_address[1] & cpu_0_data_master_dbs_address[0]) & cpu_0_data_master_write))) & ((~cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0 | ~cpu_0_data_master_read | (registered_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0 & cpu_0_data_master_read))) & ((~cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0 | ~cpu_0_data_master_write | (1 & lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1 & cpu_0_data_master_write))) & 1 & ((~cpu_0_data_master_qualified_request_uart_usb_s1 | ~(cpu_0_data_master_read | cpu_0_data_master_write) | (1 & 1 & (cpu_0_data_master_read | cpu_0_data_master_write)))) & ((~cpu_0_data_master_qualified_request_uart_usb_s1 | ~(cpu_0_data_master_read | cpu_0_data_master_write) | (1 & 1 & (cpu_0_data_master_read | cpu_0_data_master_write))));

  //optimize select-logic by passing only those address bits which matter.
  assign cpu_0_data_master_address_to_slave = cpu_0_data_master_address[25 : 0];

  //actual waitrequest port, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_data_master_waitrequest <= ~0;
      else if (1)
          cpu_0_data_master_waitrequest <= ~((~(cpu_0_data_master_read | cpu_0_data_master_write))? 0: (cpu_0_data_master_run & cpu_0_data_master_waitrequest));
    end


  //input to dbs-8 stored 0, which is an e_mux
  assign p1_dbs_8_reg_segment_0 = (cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0)? adc_tlc549_0_avalon_slave_0_readdata_from_sa :
    (cpu_0_data_master_requests_seg78led_0_avalon_slave_0)? seg78led_0_avalon_slave_0_readdata_from_sa :
    incoming_tri_state_bridge_0_data_with_Xs_converted_to_0;

  //dbs register for dbs-8 segment 0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dbs_8_reg_segment_0 <= 0;
      else if (dbs_count_enable & ((cpu_0_data_master_dbs_address[1 : 0]) == 0))
          dbs_8_reg_segment_0 <= p1_dbs_8_reg_segment_0;
    end


  //input to dbs-8 stored 1, which is an e_mux
  assign p1_dbs_8_reg_segment_1 = (cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0)? adc_tlc549_0_avalon_slave_0_readdata_from_sa :
    (cpu_0_data_master_requests_seg78led_0_avalon_slave_0)? seg78led_0_avalon_slave_0_readdata_from_sa :
    incoming_tri_state_bridge_0_data_with_Xs_converted_to_0;

  //dbs register for dbs-8 segment 1, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dbs_8_reg_segment_1 <= 0;
      else if (dbs_count_enable & ((cpu_0_data_master_dbs_address[1 : 0]) == 1))
          dbs_8_reg_segment_1 <= p1_dbs_8_reg_segment_1;
    end


  //input to dbs-8 stored 2, which is an e_mux
  assign p1_dbs_8_reg_segment_2 = (cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0)? adc_tlc549_0_avalon_slave_0_readdata_from_sa :
    (cpu_0_data_master_requests_seg78led_0_avalon_slave_0)? seg78led_0_avalon_slave_0_readdata_from_sa :
    incoming_tri_state_bridge_0_data_with_Xs_converted_to_0;

  //dbs register for dbs-8 segment 2, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dbs_8_reg_segment_2 <= 0;
      else if (dbs_count_enable & ((cpu_0_data_master_dbs_address[1 : 0]) == 2))
          dbs_8_reg_segment_2 <= p1_dbs_8_reg_segment_2;
    end


  //unpredictable registered wait state incoming data, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          registered_cpu_0_data_master_readdata <= 0;
      else if (1)
          registered_cpu_0_data_master_readdata <= p1_registered_cpu_0_data_master_readdata;
    end


  //registered readdata mux, which is an e_mux
  assign p1_registered_cpu_0_data_master_readdata = ({32 {~cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0}} | {adc_tlc549_0_avalon_slave_0_readdata_from_sa[7 : 0],
    dbs_8_reg_segment_2,
    dbs_8_reg_segment_1,
    dbs_8_reg_segment_0}) &
    ({32 {~cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave}} | jtag_uart_avalon_jtag_slave_readdata_from_sa) &
    ({32 {~cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave}} | oc_i2c_master_0_avalon_slave_readdata_from_sa) &
    ({32 {~cpu_0_data_master_requests_ps2_0_avalon_slave_0}} | {ps2_0_avalon_slave_0_readdata_from_sa[15 : 0],
    dbs_16_reg_segment_0}) &
    ({32 {~cpu_0_data_master_requests_pwm_interface_0_control_slave}} | pwm_interface_0_control_slave_readdata_from_sa) &
    ({32 {~cpu_0_data_master_requests_sdram_0_s1}} | {sdram_0_s1_readdata_from_sa[15 : 0],
    dbs_16_reg_segment_0});

  //cpu_0/data_master readdata mux, which is an e_mux
  assign cpu_0_data_master_readdata = ({32 {~cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0}} | registered_cpu_0_data_master_readdata) &
    ({32 {~cpu_0_data_master_requests_cpu_0_jtag_debug_module}} | cpu_0_jtag_debug_module_readdata_from_sa) &
    ({32 {~cpu_0_data_master_requests_dma_control_port_slave}} | dma_control_port_slave_readdata_from_sa) &
    ({32 {~cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave}} | registered_cpu_0_data_master_readdata) &
    ({32 {~cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave}} | registered_cpu_0_data_master_readdata) &
    ({32 {~cpu_0_data_master_requests_onchip_mem_s1}} | onchip_mem_s1_readdata_from_sa) &
    ({32 {~cpu_0_data_master_requests_performance_counter_control_slave}} | performance_counter_control_slave_readdata_from_sa) &
    ({32 {~cpu_0_data_master_requests_pio_key_s1}} | pio_key_s1_readdata_from_sa) &
    ({32 {~cpu_0_data_master_requests_ps2_0_avalon_slave_0}} | registered_cpu_0_data_master_readdata) &
    ({32 {~cpu_0_data_master_requests_pwm_interface_0_control_slave}} | registered_cpu_0_data_master_readdata) &
    ({32 {~cpu_0_data_master_requests_sdram_0_s1}} | registered_cpu_0_data_master_readdata) &
    ({32 {~cpu_0_data_master_requests_seg78led_0_avalon_slave_0}} | {seg78led_0_avalon_slave_0_readdata_from_sa[7 : 0],
    dbs_8_reg_segment_2,
    dbs_8_reg_segment_1,
    dbs_8_reg_segment_0}) &
    ({32 {~cpu_0_data_master_requests_sysid_control_slave}} | sysid_control_slave_readdata_from_sa) &
    ({32 {~cpu_0_data_master_requests_timer_0_s1}} | timer_0_s1_readdata_from_sa) &
    ({32 {~cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0}} | incoming_tri_state_bridge_0_data) &
    ({32 {~cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0}} | incoming_tri_state_bridge_0_data) &
    ({32 {~cpu_0_data_master_requests_flash_s1}} | {incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[7 : 0],
    dbs_8_reg_segment_2,
    dbs_8_reg_segment_1,
    dbs_8_reg_segment_0}) &
    ({32 {~cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0}} | incoming_tri_state_bridge_0_data) &
    ({32 {~cpu_0_data_master_requests_uart_usb_s1}} | uart_usb_s1_readdata_from_sa);

  //dbs count increment, which is an e_mux
  assign cpu_0_data_master_dbs_increment = (cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0)? 1 :
    (cpu_0_data_master_requests_ps2_0_avalon_slave_0)? 2 :
    (cpu_0_data_master_requests_sdram_0_s1)? 2 :
    (cpu_0_data_master_requests_seg78led_0_avalon_slave_0)? 1 :
    (cpu_0_data_master_requests_flash_s1)? 1 :
    0;

  //dbs counter overflow, which is an e_assign
  assign dbs_counter_overflow = cpu_0_data_master_dbs_address[1] & !(next_dbs_address[1]);

  //next master address, which is an e_assign
  assign next_dbs_address = cpu_0_data_master_dbs_address + cpu_0_data_master_dbs_increment;

  //dbs count enable, which is an e_mux
  assign dbs_count_enable = pre_dbs_count_enable &
    (~(cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0 & ~cpu_0_data_master_waitrequest)) &
    (~(cpu_0_data_master_requests_ps2_0_avalon_slave_0 & ~cpu_0_data_master_waitrequest)) &
    (~(cpu_0_data_master_requests_sdram_0_s1 & ~cpu_0_data_master_waitrequest));

  //dbs counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_data_master_dbs_address <= 0;
      else if (dbs_count_enable)
          cpu_0_data_master_dbs_address <= next_dbs_address;
    end


  //pre dbs count enable, which is an e_mux
  assign pre_dbs_count_enable = (cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0 & cpu_0_data_master_read & 1 & 1) |
    (cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0 & cpu_0_data_master_write & 1 & 1) |
    (cpu_0_data_master_granted_ps2_0_avalon_slave_0 & cpu_0_data_master_read & 1 & 1) |
    (cpu_0_data_master_granted_ps2_0_avalon_slave_0 & cpu_0_data_master_write & 1 & 1) |
    (((~cpu_0_data_master_no_byte_enables_and_last_term) & cpu_0_data_master_requests_sdram_0_s1 & cpu_0_data_master_write & !cpu_0_data_master_byteenable_sdram_0_s1)) |
    cpu_0_data_master_read_data_valid_sdram_0_s1 |
    (cpu_0_data_master_granted_sdram_0_s1 & cpu_0_data_master_write & 1 & 1 & ~sdram_0_s1_waitrequest_from_sa) |
    (((~cpu_0_data_master_no_byte_enables_and_last_term) & cpu_0_data_master_requests_seg78led_0_avalon_slave_0 & cpu_0_data_master_write & !cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0)) |
    ((cpu_0_data_master_granted_seg78led_0_avalon_slave_0 & cpu_0_data_master_read & 1 & 1 & ({seg78led_0_avalon_slave_0_wait_counter_eq_0 & ~d1_seg78led_0_avalon_slave_0_end_xfer}))) |
    ((cpu_0_data_master_granted_seg78led_0_avalon_slave_0 & cpu_0_data_master_write & 1 & 1 & ({seg78led_0_avalon_slave_0_wait_counter_eq_0 & ~d1_seg78led_0_avalon_slave_0_end_xfer}))) |
    (((~cpu_0_data_master_no_byte_enables_and_last_term) & cpu_0_data_master_requests_flash_s1 & cpu_0_data_master_write & !cpu_0_data_master_byteenable_flash_s1)) |
    cpu_0_data_master_read_data_valid_flash_s1 |
    ((cpu_0_data_master_granted_flash_s1 & cpu_0_data_master_write & 1 & 1 & ({flash_s1_wait_counter_eq_0 & ~d1_tri_state_bridge_0_avalon_slave_end_xfer})));

  //irq assign, which is an e_assign
  assign cpu_0_data_master_irq = {1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    jtag_uart_avalon_jtag_slave_irq_from_sa,
    oc_i2c_master_0_avalon_slave_irq_from_sa,
    adc_tlc549_0_avalon_slave_0_irq_from_sa,
    pio_key_s1_irq_from_sa,
    timer_0_s1_irq_from_sa,
    uart_usb_s1_irq_from_sa,
    ps2_0_avalon_slave_0_irq_from_sa,
    dma_control_port_slave_irq_from_sa,
    d1_irq_from_the_ctrl_rtl8019_0};

  //input to dbs-16 stored 0, which is an e_mux
  assign p1_dbs_16_reg_segment_0 = (cpu_0_data_master_requests_ps2_0_avalon_slave_0)? ps2_0_avalon_slave_0_readdata_from_sa :
    sdram_0_s1_readdata_from_sa;

  //dbs register for dbs-16 segment 0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dbs_16_reg_segment_0 <= 0;
      else if (dbs_count_enable & ((cpu_0_data_master_dbs_address[1]) == 0))
          dbs_16_reg_segment_0 <= p1_dbs_16_reg_segment_0;
    end


  //no_byte_enables_and_last_term, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_data_master_no_byte_enables_and_last_term <= 0;
      else if (1)
          cpu_0_data_master_no_byte_enables_and_last_term <= last_dbs_term_and_run;
    end


  //compute the last dbs term, which is an e_mux
  assign last_dbs_term_and_run = (cpu_0_data_master_requests_sdram_0_s1)? (((cpu_0_data_master_dbs_address == 2'b10) & cpu_0_data_master_write & !cpu_0_data_master_byteenable_sdram_0_s1)) :
    (cpu_0_data_master_requests_seg78led_0_avalon_slave_0)? (((cpu_0_data_master_dbs_address == 2'b11) & cpu_0_data_master_write & !cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0)) :
    (((cpu_0_data_master_dbs_address == 2'b11) & cpu_0_data_master_write & !cpu_0_data_master_byteenable_flash_s1));

  //mux write dbs 1, which is an e_mux
  assign cpu_0_data_master_dbs_write_16 = (cpu_0_data_master_dbs_address[1])? cpu_0_data_master_writedata[31 : 16] :
    cpu_0_data_master_writedata[15 : 0];

  //mux write dbs 2, which is an e_mux
  assign cpu_0_data_master_dbs_write_8 = ((cpu_0_data_master_dbs_address[1 : 0] == 0))? cpu_0_data_master_writedata[7 : 0] :
    ((cpu_0_data_master_dbs_address[1 : 0] == 1))? cpu_0_data_master_writedata[15 : 8] :
    ((cpu_0_data_master_dbs_address[1 : 0] == 2))? cpu_0_data_master_writedata[23 : 16] :
    ((cpu_0_data_master_dbs_address[1 : 0] == 3))? cpu_0_data_master_writedata[31 : 24] :
    ((cpu_0_data_master_dbs_address[1 : 0] == 0))? cpu_0_data_master_writedata[7 : 0] :
    ((cpu_0_data_master_dbs_address[1 : 0] == 1))? cpu_0_data_master_writedata[15 : 8] :
    ((cpu_0_data_master_dbs_address[1 : 0] == 2))? cpu_0_data_master_writedata[23 : 16] :
    cpu_0_data_master_writedata[31 : 24];


endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module cpu_0_instruction_master_arbitrator (
                                             // inputs:
                                              clk,
                                              cpu_0_instruction_master_address,
                                              cpu_0_instruction_master_granted_cpu_0_jtag_debug_module,
                                              cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                              cpu_0_instruction_master_granted_flash_s1,
                                              cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0,
                                              cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0,
                                              cpu_0_instruction_master_granted_onchip_mem_s1,
                                              cpu_0_instruction_master_granted_sdram_0_s1,
                                              cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0,
                                              cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module,
                                              cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                              cpu_0_instruction_master_qualified_request_flash_s1,
                                              cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0,
                                              cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0,
                                              cpu_0_instruction_master_qualified_request_onchip_mem_s1,
                                              cpu_0_instruction_master_qualified_request_sdram_0_s1,
                                              cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0,
                                              cpu_0_instruction_master_read,
                                              cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module,
                                              cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                              cpu_0_instruction_master_read_data_valid_flash_s1,
                                              cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0,
                                              cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0,
                                              cpu_0_instruction_master_read_data_valid_onchip_mem_s1,
                                              cpu_0_instruction_master_read_data_valid_sdram_0_s1,
                                              cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register,
                                              cpu_0_instruction_master_read_data_valid_seg78led_0_avalon_slave_0,
                                              cpu_0_instruction_master_requests_cpu_0_jtag_debug_module,
                                              cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                              cpu_0_instruction_master_requests_flash_s1,
                                              cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0,
                                              cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0,
                                              cpu_0_instruction_master_requests_onchip_mem_s1,
                                              cpu_0_instruction_master_requests_sdram_0_s1,
                                              cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0,
                                              cpu_0_jtag_debug_module_readdata_from_sa,
                                              ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0,
                                              ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1,
                                              d1_cpu_0_jtag_debug_module_end_xfer,
                                              d1_onchip_mem_s1_end_xfer,
                                              d1_sdram_0_s1_end_xfer,
                                              d1_seg78led_0_avalon_slave_0_end_xfer,
                                              d1_tri_state_bridge_0_avalon_slave_end_xfer,
                                              flash_s1_wait_counter_eq_0,
                                              flash_s1_wait_counter_eq_1,
                                              incoming_tri_state_bridge_0_data,
                                              lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0,
                                              lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1,
                                              lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0,
                                              lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1,
                                              onchip_mem_s1_readdata_from_sa,
                                              reset_n,
                                              sdram_0_s1_readdata_from_sa,
                                              sdram_0_s1_waitrequest_from_sa,
                                              seg78led_0_avalon_slave_0_readdata_from_sa,
                                              seg78led_0_avalon_slave_0_wait_counter_eq_0,
                                              seg78led_0_avalon_slave_0_wait_counter_eq_1,

                                             // outputs:
                                              cpu_0_instruction_master_address_to_slave,
                                              cpu_0_instruction_master_dbs_address,
                                              cpu_0_instruction_master_latency_counter,
                                              cpu_0_instruction_master_readdata,
                                              cpu_0_instruction_master_readdatavalid,
                                              cpu_0_instruction_master_waitrequest
                                           )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output  [ 25: 0] cpu_0_instruction_master_address_to_slave;
  output  [  1: 0] cpu_0_instruction_master_dbs_address;
  output  [  1: 0] cpu_0_instruction_master_latency_counter;
  output  [ 31: 0] cpu_0_instruction_master_readdata;
  output           cpu_0_instruction_master_readdatavalid;
  output           cpu_0_instruction_master_waitrequest;
  input            clk;
  input   [ 25: 0] cpu_0_instruction_master_address;
  input            cpu_0_instruction_master_granted_cpu_0_jtag_debug_module;
  input            cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0;
  input            cpu_0_instruction_master_granted_flash_s1;
  input            cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0;
  input            cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0;
  input            cpu_0_instruction_master_granted_onchip_mem_s1;
  input            cpu_0_instruction_master_granted_sdram_0_s1;
  input            cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0;
  input            cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module;
  input            cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0;
  input            cpu_0_instruction_master_qualified_request_flash_s1;
  input            cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0;
  input            cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0;
  input            cpu_0_instruction_master_qualified_request_onchip_mem_s1;
  input            cpu_0_instruction_master_qualified_request_sdram_0_s1;
  input            cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0;
  input            cpu_0_instruction_master_read;
  input            cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module;
  input            cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0;
  input            cpu_0_instruction_master_read_data_valid_flash_s1;
  input            cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0;
  input            cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0;
  input            cpu_0_instruction_master_read_data_valid_onchip_mem_s1;
  input            cpu_0_instruction_master_read_data_valid_sdram_0_s1;
  input            cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register;
  input            cpu_0_instruction_master_read_data_valid_seg78led_0_avalon_slave_0;
  input            cpu_0_instruction_master_requests_cpu_0_jtag_debug_module;
  input            cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0;
  input            cpu_0_instruction_master_requests_flash_s1;
  input            cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0;
  input            cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0;
  input            cpu_0_instruction_master_requests_onchip_mem_s1;
  input            cpu_0_instruction_master_requests_sdram_0_s1;
  input            cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0;
  input   [ 31: 0] cpu_0_jtag_debug_module_readdata_from_sa;
  input            ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0;
  input            ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1;
  input            d1_cpu_0_jtag_debug_module_end_xfer;
  input            d1_onchip_mem_s1_end_xfer;
  input            d1_sdram_0_s1_end_xfer;
  input            d1_seg78led_0_avalon_slave_0_end_xfer;
  input            d1_tri_state_bridge_0_avalon_slave_end_xfer;
  input            flash_s1_wait_counter_eq_0;
  input            flash_s1_wait_counter_eq_1;
  input   [  7: 0] incoming_tri_state_bridge_0_data;
  input            lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0;
  input            lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1;
  input            lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0;
  input            lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1;
  input   [ 31: 0] onchip_mem_s1_readdata_from_sa;
  input            reset_n;
  input   [ 15: 0] sdram_0_s1_readdata_from_sa;
  input            sdram_0_s1_waitrequest_from_sa;
  input   [  7: 0] seg78led_0_avalon_slave_0_readdata_from_sa;
  input            seg78led_0_avalon_slave_0_wait_counter_eq_0;
  input            seg78led_0_avalon_slave_0_wait_counter_eq_1;

  reg              active_and_waiting_last_time;
  reg     [ 25: 0] cpu_0_instruction_master_address_last_time;
  wire    [ 25: 0] cpu_0_instruction_master_address_to_slave;
  reg     [  1: 0] cpu_0_instruction_master_dbs_address;
  wire    [  1: 0] cpu_0_instruction_master_dbs_increment;
  reg     [  1: 0] cpu_0_instruction_master_dbs_rdv_counter;
  wire    [  1: 0] cpu_0_instruction_master_dbs_rdv_counter_inc;
  wire             cpu_0_instruction_master_is_granted_some_slave;
  reg     [  1: 0] cpu_0_instruction_master_latency_counter;
  wire    [  1: 0] cpu_0_instruction_master_next_dbs_rdv_counter;
  reg              cpu_0_instruction_master_read_but_no_slave_selected;
  reg              cpu_0_instruction_master_read_last_time;
  wire    [ 31: 0] cpu_0_instruction_master_readdata;
  wire             cpu_0_instruction_master_readdatavalid;
  wire             cpu_0_instruction_master_run;
  wire             cpu_0_instruction_master_waitrequest;
  reg     [  7: 0] dbs_8_reg_segment_0;
  reg     [  7: 0] dbs_8_reg_segment_1;
  reg     [  7: 0] dbs_8_reg_segment_2;
  wire             dbs_count_enable;
  wire             dbs_counter_overflow;
  reg     [ 15: 0] dbs_latent_16_reg_segment_0;
  reg     [  7: 0] dbs_latent_8_reg_segment_0;
  reg     [  7: 0] dbs_latent_8_reg_segment_1;
  reg     [  7: 0] dbs_latent_8_reg_segment_2;
  wire             dbs_rdv_count_enable;
  wire             dbs_rdv_counter_overflow;
  wire    [  1: 0] latency_load_value;
  wire    [  1: 0] next_dbs_address;
  wire    [  1: 0] p1_cpu_0_instruction_master_latency_counter;
  wire    [  7: 0] p1_dbs_8_reg_segment_0;
  wire    [  7: 0] p1_dbs_8_reg_segment_1;
  wire    [  7: 0] p1_dbs_8_reg_segment_2;
  wire    [ 15: 0] p1_dbs_latent_16_reg_segment_0;
  wire    [  7: 0] p1_dbs_latent_8_reg_segment_0;
  wire    [  7: 0] p1_dbs_latent_8_reg_segment_1;
  wire    [  7: 0] p1_dbs_latent_8_reg_segment_2;
  wire             pre_dbs_count_enable;
  wire             pre_flush_cpu_0_instruction_master_readdatavalid;
  wire             r_0;
  wire             r_1;
  wire             r_3;
  wire             r_4;
  //r_0 master_run cascaded wait assignment, which is an e_assign
  assign r_0 = 1 & (cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module | ~cpu_0_instruction_master_requests_cpu_0_jtag_debug_module) & (cpu_0_instruction_master_granted_cpu_0_jtag_debug_module | ~cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module) & ((~cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module | ~cpu_0_instruction_master_read | (1 & ~d1_cpu_0_jtag_debug_module_end_xfer & cpu_0_instruction_master_read)));

  //cascaded wait assignment, which is an e_assign
  assign cpu_0_instruction_master_run = r_0 & r_1 & r_3 & r_4;

  //r_1 master_run cascaded wait assignment, which is an e_assign
  assign r_1 = 1 & (cpu_0_instruction_master_qualified_request_onchip_mem_s1 | ~cpu_0_instruction_master_requests_onchip_mem_s1) & (cpu_0_instruction_master_granted_onchip_mem_s1 | ~cpu_0_instruction_master_qualified_request_onchip_mem_s1) & ((~cpu_0_instruction_master_qualified_request_onchip_mem_s1 | ~cpu_0_instruction_master_read | (1 & cpu_0_instruction_master_read)));

  //r_3 master_run cascaded wait assignment, which is an e_assign
  assign r_3 = 1 & (cpu_0_instruction_master_qualified_request_sdram_0_s1 | ~cpu_0_instruction_master_requests_sdram_0_s1) & (cpu_0_instruction_master_granted_sdram_0_s1 | ~cpu_0_instruction_master_qualified_request_sdram_0_s1) & ((~cpu_0_instruction_master_qualified_request_sdram_0_s1 | ~cpu_0_instruction_master_read | (1 & ~sdram_0_s1_waitrequest_from_sa & (cpu_0_instruction_master_dbs_address[1]) & cpu_0_instruction_master_read))) & 1 & (cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0 | ~cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0) & (cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0 | ~cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0) & ((~cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0 | ~cpu_0_instruction_master_read | (1 & ((seg78led_0_avalon_slave_0_wait_counter_eq_0 & ~d1_seg78led_0_avalon_slave_0_end_xfer)) & (cpu_0_instruction_master_dbs_address[1] & cpu_0_instruction_master_dbs_address[0]) & cpu_0_instruction_master_read)));

  //r_4 master_run cascaded wait assignment, which is an e_assign
  assign r_4 = 1 & (cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0 | ~cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0) & (cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0 | ~cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0) & (cpu_0_instruction_master_qualified_request_flash_s1 | ~cpu_0_instruction_master_requests_flash_s1) & (cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0 | ~cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0) & (cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 | ~cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0) & (cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 | ~cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0) & (cpu_0_instruction_master_granted_flash_s1 | ~cpu_0_instruction_master_qualified_request_flash_s1) & (cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 | ~cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0) & ((~cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0 | ~cpu_0_instruction_master_read | (1 & ((ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0 & ~d1_tri_state_bridge_0_avalon_slave_end_xfer)) & cpu_0_instruction_master_read))) & ((~cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0 | ~cpu_0_instruction_master_read | (1 & ((lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0 & ~d1_tri_state_bridge_0_avalon_slave_end_xfer)) & cpu_0_instruction_master_read))) & ((~cpu_0_instruction_master_qualified_request_flash_s1 | ~cpu_0_instruction_master_read | (1 & ((flash_s1_wait_counter_eq_0 & ~d1_tri_state_bridge_0_avalon_slave_end_xfer)) & (cpu_0_instruction_master_dbs_address[1] & cpu_0_instruction_master_dbs_address[0]) & cpu_0_instruction_master_read))) & ((~cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0 | ~cpu_0_instruction_master_read | (1 & ((lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0 & ~d1_tri_state_bridge_0_avalon_slave_end_xfer)) & cpu_0_instruction_master_read)));

  //optimize select-logic by passing only those address bits which matter.
  assign cpu_0_instruction_master_address_to_slave = cpu_0_instruction_master_address[25 : 0];

  //cpu_0_instruction_master_read_but_no_slave_selected assignment, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_instruction_master_read_but_no_slave_selected <= 0;
      else if (1)
          cpu_0_instruction_master_read_but_no_slave_selected <= cpu_0_instruction_master_read & cpu_0_instruction_master_run & ~cpu_0_instruction_master_is_granted_some_slave;
    end


  //some slave is getting selected, which is an e_mux
  assign cpu_0_instruction_master_is_granted_some_slave = cpu_0_instruction_master_granted_cpu_0_jtag_debug_module |
    cpu_0_instruction_master_granted_onchip_mem_s1 |
    cpu_0_instruction_master_granted_sdram_0_s1 |
    cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0 |
    cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 |
    cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 |
    cpu_0_instruction_master_granted_flash_s1 |
    cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0;

  //latent slave read data valids which may be flushed, which is an e_mux
  assign pre_flush_cpu_0_instruction_master_readdatavalid = cpu_0_instruction_master_read_data_valid_onchip_mem_s1 |
    (cpu_0_instruction_master_read_data_valid_sdram_0_s1 & dbs_rdv_counter_overflow) |
    cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0 |
    cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0 |
    (cpu_0_instruction_master_read_data_valid_flash_s1 & dbs_rdv_counter_overflow) |
    cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0;

  //latent slave read data valid which is not flushed, which is an e_mux
  assign cpu_0_instruction_master_readdatavalid = cpu_0_instruction_master_read_but_no_slave_selected |
    pre_flush_cpu_0_instruction_master_readdatavalid |
    cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module |
    cpu_0_instruction_master_read_but_no_slave_selected |
    pre_flush_cpu_0_instruction_master_readdatavalid |
    cpu_0_instruction_master_read_but_no_slave_selected |
    pre_flush_cpu_0_instruction_master_readdatavalid |
    cpu_0_instruction_master_read_but_no_slave_selected |
    pre_flush_cpu_0_instruction_master_readdatavalid |
    (cpu_0_instruction_master_read_data_valid_seg78led_0_avalon_slave_0 & dbs_counter_overflow) |
    cpu_0_instruction_master_read_but_no_slave_selected |
    pre_flush_cpu_0_instruction_master_readdatavalid |
    cpu_0_instruction_master_read_but_no_slave_selected |
    pre_flush_cpu_0_instruction_master_readdatavalid |
    cpu_0_instruction_master_read_but_no_slave_selected |
    pre_flush_cpu_0_instruction_master_readdatavalid |
    cpu_0_instruction_master_read_but_no_slave_selected |
    pre_flush_cpu_0_instruction_master_readdatavalid;

  //cpu_0/instruction_master readdata mux, which is an e_mux
  assign cpu_0_instruction_master_readdata = ({32 {~(cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module & cpu_0_instruction_master_read)}} | cpu_0_jtag_debug_module_readdata_from_sa) &
    ({32 {~cpu_0_instruction_master_read_data_valid_onchip_mem_s1}} | onchip_mem_s1_readdata_from_sa) &
    ({32 {~cpu_0_instruction_master_read_data_valid_sdram_0_s1}} | {sdram_0_s1_readdata_from_sa[15 : 0],
    dbs_latent_16_reg_segment_0}) &
    ({32 {~(cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0 & cpu_0_instruction_master_read)}} | {seg78led_0_avalon_slave_0_readdata_from_sa[7 : 0],
    dbs_8_reg_segment_2,
    dbs_8_reg_segment_1,
    dbs_8_reg_segment_0}) &
    ({32 {~cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0}} | incoming_tri_state_bridge_0_data) &
    ({32 {~cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0}} | incoming_tri_state_bridge_0_data) &
    ({32 {~cpu_0_instruction_master_read_data_valid_flash_s1}} | {incoming_tri_state_bridge_0_data[7 : 0],
    dbs_latent_8_reg_segment_2,
    dbs_latent_8_reg_segment_1,
    dbs_latent_8_reg_segment_0}) &
    ({32 {~cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0}} | incoming_tri_state_bridge_0_data);

  //actual waitrequest port, which is an e_assign
  assign cpu_0_instruction_master_waitrequest = ~cpu_0_instruction_master_run;

  //latent max counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_instruction_master_latency_counter <= 0;
      else if (1)
          cpu_0_instruction_master_latency_counter <= p1_cpu_0_instruction_master_latency_counter;
    end


  //latency counter load mux, which is an e_mux
  assign p1_cpu_0_instruction_master_latency_counter = ((cpu_0_instruction_master_run & cpu_0_instruction_master_read))? latency_load_value :
    (cpu_0_instruction_master_latency_counter)? cpu_0_instruction_master_latency_counter - 1 :
    0;

  //read latency load values, which is an e_mux
  assign latency_load_value = ({2 {cpu_0_instruction_master_requests_onchip_mem_s1}} & 1) |
    ({2 {cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0}} & 2) |
    ({2 {cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0}} & 2) |
    ({2 {cpu_0_instruction_master_requests_flash_s1}} & 2) |
    ({2 {cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0}} & 2);

  //input to latent dbs-16 stored 0, which is an e_mux
  assign p1_dbs_latent_16_reg_segment_0 = sdram_0_s1_readdata_from_sa;

  //dbs register for latent dbs-16 segment 0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dbs_latent_16_reg_segment_0 <= 0;
      else if (dbs_rdv_count_enable & ((cpu_0_instruction_master_dbs_rdv_counter[1]) == 0))
          dbs_latent_16_reg_segment_0 <= p1_dbs_latent_16_reg_segment_0;
    end


  //dbs count increment, which is an e_mux
  assign cpu_0_instruction_master_dbs_increment = (cpu_0_instruction_master_requests_sdram_0_s1)? 2 :
    (cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0)? 1 :
    (cpu_0_instruction_master_requests_flash_s1)? 1 :
    0;

  //dbs counter overflow, which is an e_assign
  assign dbs_counter_overflow = cpu_0_instruction_master_dbs_address[1] & !(next_dbs_address[1]);

  //next master address, which is an e_assign
  assign next_dbs_address = cpu_0_instruction_master_dbs_address + cpu_0_instruction_master_dbs_increment;

  //dbs count enable, which is an e_mux
  assign dbs_count_enable = pre_dbs_count_enable;

  //dbs counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_instruction_master_dbs_address <= 0;
      else if (dbs_count_enable)
          cpu_0_instruction_master_dbs_address <= next_dbs_address;
    end


  //p1 dbs rdv counter, which is an e_assign
  assign cpu_0_instruction_master_next_dbs_rdv_counter = cpu_0_instruction_master_dbs_rdv_counter + cpu_0_instruction_master_dbs_rdv_counter_inc;

  //cpu_0_instruction_master_rdv_inc_mux, which is an e_mux
  assign cpu_0_instruction_master_dbs_rdv_counter_inc = (cpu_0_instruction_master_read_data_valid_sdram_0_s1)? 2 :
    1;

  //master any slave rdv, which is an e_mux
  assign dbs_rdv_count_enable = cpu_0_instruction_master_read_data_valid_sdram_0_s1 |
    cpu_0_instruction_master_read_data_valid_flash_s1;

  //dbs rdv counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_instruction_master_dbs_rdv_counter <= 0;
      else if (dbs_rdv_count_enable)
          cpu_0_instruction_master_dbs_rdv_counter <= cpu_0_instruction_master_next_dbs_rdv_counter;
    end


  //dbs rdv counter overflow, which is an e_assign
  assign dbs_rdv_counter_overflow = cpu_0_instruction_master_dbs_rdv_counter[1] & ~cpu_0_instruction_master_next_dbs_rdv_counter[1];

  //pre dbs count enable, which is an e_mux
  assign pre_dbs_count_enable = (cpu_0_instruction_master_granted_sdram_0_s1 & cpu_0_instruction_master_read & 1 & 1 & ~sdram_0_s1_waitrequest_from_sa) |
    ((cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0 & cpu_0_instruction_master_read & 1 & 1 & ({seg78led_0_avalon_slave_0_wait_counter_eq_0 & ~d1_seg78led_0_avalon_slave_0_end_xfer}))) |
    ((cpu_0_instruction_master_granted_flash_s1 & cpu_0_instruction_master_read & 1 & 1 & ({flash_s1_wait_counter_eq_0 & ~d1_tri_state_bridge_0_avalon_slave_end_xfer})));

  //input to dbs-8 stored 0, which is an e_mux
  assign p1_dbs_8_reg_segment_0 = seg78led_0_avalon_slave_0_readdata_from_sa;

  //dbs register for dbs-8 segment 0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dbs_8_reg_segment_0 <= 0;
      else if (dbs_count_enable & ((cpu_0_instruction_master_dbs_address[1 : 0]) == 0))
          dbs_8_reg_segment_0 <= p1_dbs_8_reg_segment_0;
    end


  //input to dbs-8 stored 1, which is an e_mux
  assign p1_dbs_8_reg_segment_1 = seg78led_0_avalon_slave_0_readdata_from_sa;

  //dbs register for dbs-8 segment 1, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dbs_8_reg_segment_1 <= 0;
      else if (dbs_count_enable & ((cpu_0_instruction_master_dbs_address[1 : 0]) == 1))
          dbs_8_reg_segment_1 <= p1_dbs_8_reg_segment_1;
    end


  //input to dbs-8 stored 2, which is an e_mux
  assign p1_dbs_8_reg_segment_2 = seg78led_0_avalon_slave_0_readdata_from_sa;

  //dbs register for dbs-8 segment 2, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dbs_8_reg_segment_2 <= 0;
      else if (dbs_count_enable & ((cpu_0_instruction_master_dbs_address[1 : 0]) == 2))
          dbs_8_reg_segment_2 <= p1_dbs_8_reg_segment_2;
    end


  //input to latent dbs-8 stored 0, which is an e_mux
  assign p1_dbs_latent_8_reg_segment_0 = incoming_tri_state_bridge_0_data;

  //dbs register for latent dbs-8 segment 0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dbs_latent_8_reg_segment_0 <= 0;
      else if (dbs_rdv_count_enable & ((cpu_0_instruction_master_dbs_rdv_counter[1 : 0]) == 0))
          dbs_latent_8_reg_segment_0 <= p1_dbs_latent_8_reg_segment_0;
    end


  //input to latent dbs-8 stored 1, which is an e_mux
  assign p1_dbs_latent_8_reg_segment_1 = incoming_tri_state_bridge_0_data;

  //dbs register for latent dbs-8 segment 1, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dbs_latent_8_reg_segment_1 <= 0;
      else if (dbs_rdv_count_enable & ((cpu_0_instruction_master_dbs_rdv_counter[1 : 0]) == 1))
          dbs_latent_8_reg_segment_1 <= p1_dbs_latent_8_reg_segment_1;
    end


  //input to latent dbs-8 stored 2, which is an e_mux
  assign p1_dbs_latent_8_reg_segment_2 = incoming_tri_state_bridge_0_data;

  //dbs register for latent dbs-8 segment 2, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dbs_latent_8_reg_segment_2 <= 0;
      else if (dbs_rdv_count_enable & ((cpu_0_instruction_master_dbs_rdv_counter[1 : 0]) == 2))
          dbs_latent_8_reg_segment_2 <= p1_dbs_latent_8_reg_segment_2;
    end



//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //cpu_0_instruction_master_address check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_instruction_master_address_last_time <= 0;
      else if (1)
          cpu_0_instruction_master_address_last_time <= cpu_0_instruction_master_address;
    end


  //cpu_0/instruction_master waited last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          active_and_waiting_last_time <= 0;
      else if (1)
          active_and_waiting_last_time <= cpu_0_instruction_master_waitrequest & (cpu_0_instruction_master_read);
    end


  //cpu_0_instruction_master_address matches last port_name, which is an e_process
  always @(active_and_waiting_last_time or cpu_0_instruction_master_address or cpu_0_instruction_master_address_last_time)
    begin
      if (active_and_waiting_last_time & (cpu_0_instruction_master_address != cpu_0_instruction_master_address_last_time))
        begin
          $write("%0d ns: cpu_0_instruction_master_address did not heed wait!!!", $time);
          $stop;
        end
    end


  //cpu_0_instruction_master_read check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_instruction_master_read_last_time <= 0;
      else if (1)
          cpu_0_instruction_master_read_last_time <= cpu_0_instruction_master_read;
    end


  //cpu_0_instruction_master_read matches last port_name, which is an e_process
  always @(active_and_waiting_last_time or cpu_0_instruction_master_read or cpu_0_instruction_master_read_last_time)
    begin
      if (active_and_waiting_last_time & (cpu_0_instruction_master_read != cpu_0_instruction_master_read_last_time))
        begin
          $write("%0d ns: cpu_0_instruction_master_read did not heed wait!!!", $time);
          $stop;
        end
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module cpu_0_fpoint_s1_arbitrator (
                                    // inputs:
                                     clk,
                                     cpu_0_custom_instruction_master_multi_clk_en,
                                     cpu_0_custom_instruction_master_multi_dataa,
                                     cpu_0_custom_instruction_master_multi_datab,
                                     cpu_0_custom_instruction_master_multi_n,
                                     cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1,
                                     cpu_0_fpoint_s1_done,
                                     cpu_0_fpoint_s1_result,
                                     cpu_0_fpoint_s1_select,
                                     reset_n,

                                    // outputs:
                                     cpu_0_fpoint_s1_clk_en,
                                     cpu_0_fpoint_s1_dataa,
                                     cpu_0_fpoint_s1_datab,
                                     cpu_0_fpoint_s1_done_from_sa,
                                     cpu_0_fpoint_s1_n,
                                     cpu_0_fpoint_s1_reset,
                                     cpu_0_fpoint_s1_result_from_sa,
                                     cpu_0_fpoint_s1_start
                                  )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_fpoint_s1_clk_en;
  output  [ 31: 0] cpu_0_fpoint_s1_dataa;
  output  [ 31: 0] cpu_0_fpoint_s1_datab;
  output           cpu_0_fpoint_s1_done_from_sa;
  output  [  1: 0] cpu_0_fpoint_s1_n;
  output           cpu_0_fpoint_s1_reset;
  output  [ 31: 0] cpu_0_fpoint_s1_result_from_sa;
  output           cpu_0_fpoint_s1_start;
  input            clk;
  input            cpu_0_custom_instruction_master_multi_clk_en;
  input   [ 31: 0] cpu_0_custom_instruction_master_multi_dataa;
  input   [ 31: 0] cpu_0_custom_instruction_master_multi_datab;
  input   [  7: 0] cpu_0_custom_instruction_master_multi_n;
  input            cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1;
  input            cpu_0_fpoint_s1_done;
  input   [ 31: 0] cpu_0_fpoint_s1_result;
  input            cpu_0_fpoint_s1_select;
  input            reset_n;

  wire             cpu_0_fpoint_s1_clk_en;
  wire    [ 31: 0] cpu_0_fpoint_s1_dataa;
  wire    [ 31: 0] cpu_0_fpoint_s1_datab;
  wire             cpu_0_fpoint_s1_done_from_sa;
  wire    [  1: 0] cpu_0_fpoint_s1_n;
  wire             cpu_0_fpoint_s1_reset;
  wire    [ 31: 0] cpu_0_fpoint_s1_result_from_sa;
  wire             cpu_0_fpoint_s1_start;
  assign cpu_0_fpoint_s1_clk_en = cpu_0_custom_instruction_master_multi_clk_en;
  assign cpu_0_fpoint_s1_dataa = cpu_0_custom_instruction_master_multi_dataa;
  assign cpu_0_fpoint_s1_datab = cpu_0_custom_instruction_master_multi_datab;
  assign cpu_0_fpoint_s1_n = cpu_0_custom_instruction_master_multi_n;
  assign cpu_0_fpoint_s1_start = cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1;
  //assign cpu_0_fpoint_s1_result_from_sa = cpu_0_fpoint_s1_result so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign cpu_0_fpoint_s1_result_from_sa = cpu_0_fpoint_s1_result;

  //assign cpu_0_fpoint_s1_done_from_sa = cpu_0_fpoint_s1_done so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign cpu_0_fpoint_s1_done_from_sa = cpu_0_fpoint_s1_done;

  //cpu_0_fpoint/s1 local reset_n, which is an e_assign
  assign cpu_0_fpoint_s1_reset = ~reset_n;


endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module dma_control_port_slave_arbitrator (
                                           // inputs:
                                            clk,
                                            cpu_0_data_master_address_to_slave,
                                            cpu_0_data_master_read,
                                            cpu_0_data_master_write,
                                            cpu_0_data_master_writedata,
                                            dma_control_port_slave_irq,
                                            dma_control_port_slave_readdata,
                                            dma_control_port_slave_readyfordata,
                                            reset_n,

                                           // outputs:
                                            cpu_0_data_master_granted_dma_control_port_slave,
                                            cpu_0_data_master_qualified_request_dma_control_port_slave,
                                            cpu_0_data_master_read_data_valid_dma_control_port_slave,
                                            cpu_0_data_master_requests_dma_control_port_slave,
                                            d1_dma_control_port_slave_end_xfer,
                                            dma_control_port_slave_address,
                                            dma_control_port_slave_chipselect,
                                            dma_control_port_slave_irq_from_sa,
                                            dma_control_port_slave_readdata_from_sa,
                                            dma_control_port_slave_readyfordata_from_sa,
                                            dma_control_port_slave_reset_n,
                                            dma_control_port_slave_write_n,
                                            dma_control_port_slave_writedata
                                         )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_dma_control_port_slave;
  output           cpu_0_data_master_qualified_request_dma_control_port_slave;
  output           cpu_0_data_master_read_data_valid_dma_control_port_slave;
  output           cpu_0_data_master_requests_dma_control_port_slave;
  output           d1_dma_control_port_slave_end_xfer;
  output  [  2: 0] dma_control_port_slave_address;
  output           dma_control_port_slave_chipselect;
  output           dma_control_port_slave_irq_from_sa;
  output  [ 25: 0] dma_control_port_slave_readdata_from_sa;
  output           dma_control_port_slave_readyfordata_from_sa;
  output           dma_control_port_slave_reset_n;
  output           dma_control_port_slave_write_n;
  output  [ 25: 0] dma_control_port_slave_writedata;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input            dma_control_port_slave_irq;
  input   [ 25: 0] dma_control_port_slave_readdata;
  input            dma_control_port_slave_readyfordata;
  input            reset_n;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_dma_control_port_slave;
  wire             cpu_0_data_master_qualified_request_dma_control_port_slave;
  wire             cpu_0_data_master_read_data_valid_dma_control_port_slave;
  wire             cpu_0_data_master_requests_dma_control_port_slave;
  wire             cpu_0_data_master_saved_grant_dma_control_port_slave;
  reg              d1_dma_control_port_slave_end_xfer;
  reg              d1_reasons_to_wait;
  wire    [  2: 0] dma_control_port_slave_address;
  wire             dma_control_port_slave_allgrants;
  wire             dma_control_port_slave_allow_new_arb_cycle;
  wire             dma_control_port_slave_any_bursting_master_saved_grant;
  wire             dma_control_port_slave_any_continuerequest;
  wire             dma_control_port_slave_arb_counter_enable;
  reg     [  2: 0] dma_control_port_slave_arb_share_counter;
  wire    [  2: 0] dma_control_port_slave_arb_share_counter_next_value;
  wire    [  2: 0] dma_control_port_slave_arb_share_set_values;
  wire             dma_control_port_slave_beginbursttransfer_internal;
  wire             dma_control_port_slave_begins_xfer;
  wire             dma_control_port_slave_chipselect;
  wire             dma_control_port_slave_end_xfer;
  wire             dma_control_port_slave_firsttransfer;
  wire             dma_control_port_slave_grant_vector;
  wire             dma_control_port_slave_in_a_read_cycle;
  wire             dma_control_port_slave_in_a_write_cycle;
  wire             dma_control_port_slave_irq_from_sa;
  wire             dma_control_port_slave_master_qreq_vector;
  wire             dma_control_port_slave_non_bursting_master_requests;
  wire    [ 25: 0] dma_control_port_slave_readdata_from_sa;
  wire             dma_control_port_slave_readyfordata_from_sa;
  reg              dma_control_port_slave_reg_firsttransfer;
  wire             dma_control_port_slave_reset_n;
  reg              dma_control_port_slave_slavearbiterlockenable;
  wire             dma_control_port_slave_slavearbiterlockenable2;
  wire             dma_control_port_slave_unreg_firsttransfer;
  wire             dma_control_port_slave_waits_for_read;
  wire             dma_control_port_slave_waits_for_write;
  wire             dma_control_port_slave_write_n;
  wire    [ 25: 0] dma_control_port_slave_writedata;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_dma_control_port_slave;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 25: 0] shifted_address_to_dma_control_port_slave_from_cpu_0_data_master;
  wire             wait_for_dma_control_port_slave_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~dma_control_port_slave_end_xfer;
    end


  assign dma_control_port_slave_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_dma_control_port_slave));
  //assign dma_control_port_slave_readdata_from_sa = dma_control_port_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign dma_control_port_slave_readdata_from_sa = dma_control_port_slave_readdata;

  assign cpu_0_data_master_requests_dma_control_port_slave = ({cpu_0_data_master_address_to_slave[25 : 5] , 5'b0} == 26'h2003260) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //assign dma_control_port_slave_readyfordata_from_sa = dma_control_port_slave_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign dma_control_port_slave_readyfordata_from_sa = dma_control_port_slave_readyfordata;

  //dma_control_port_slave_arb_share_counter set values, which is an e_mux
  assign dma_control_port_slave_arb_share_set_values = 1;

  //dma_control_port_slave_non_bursting_master_requests mux, which is an e_mux
  assign dma_control_port_slave_non_bursting_master_requests = cpu_0_data_master_requests_dma_control_port_slave;

  //dma_control_port_slave_any_bursting_master_saved_grant mux, which is an e_mux
  assign dma_control_port_slave_any_bursting_master_saved_grant = 0;

  //dma_control_port_slave_arb_share_counter_next_value assignment, which is an e_assign
  assign dma_control_port_slave_arb_share_counter_next_value = dma_control_port_slave_firsttransfer ? (dma_control_port_slave_arb_share_set_values - 1) : |dma_control_port_slave_arb_share_counter ? (dma_control_port_slave_arb_share_counter - 1) : 0;

  //dma_control_port_slave_allgrants all slave grants, which is an e_mux
  assign dma_control_port_slave_allgrants = |dma_control_port_slave_grant_vector;

  //dma_control_port_slave_end_xfer assignment, which is an e_assign
  assign dma_control_port_slave_end_xfer = ~(dma_control_port_slave_waits_for_read | dma_control_port_slave_waits_for_write);

  //end_xfer_arb_share_counter_term_dma_control_port_slave arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_dma_control_port_slave = dma_control_port_slave_end_xfer & (~dma_control_port_slave_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //dma_control_port_slave_arb_share_counter arbitration counter enable, which is an e_assign
  assign dma_control_port_slave_arb_counter_enable = (end_xfer_arb_share_counter_term_dma_control_port_slave & dma_control_port_slave_allgrants) | (end_xfer_arb_share_counter_term_dma_control_port_slave & ~dma_control_port_slave_non_bursting_master_requests);

  //dma_control_port_slave_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_control_port_slave_arb_share_counter <= 0;
      else if (dma_control_port_slave_arb_counter_enable)
          dma_control_port_slave_arb_share_counter <= dma_control_port_slave_arb_share_counter_next_value;
    end


  //dma_control_port_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_control_port_slave_slavearbiterlockenable <= 0;
      else if ((|dma_control_port_slave_master_qreq_vector & end_xfer_arb_share_counter_term_dma_control_port_slave) | (end_xfer_arb_share_counter_term_dma_control_port_slave & ~dma_control_port_slave_non_bursting_master_requests))
          dma_control_port_slave_slavearbiterlockenable <= |dma_control_port_slave_arb_share_counter_next_value;
    end


  //cpu_0/data_master dma/control_port_slave arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = dma_control_port_slave_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //dma_control_port_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign dma_control_port_slave_slavearbiterlockenable2 = |dma_control_port_slave_arb_share_counter_next_value;

  //cpu_0/data_master dma/control_port_slave arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = dma_control_port_slave_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //dma_control_port_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  assign dma_control_port_slave_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_dma_control_port_slave = cpu_0_data_master_requests_dma_control_port_slave;
  //dma_control_port_slave_writedata mux, which is an e_mux
  assign dma_control_port_slave_writedata = cpu_0_data_master_writedata;

  //master is always granted when requested
  assign cpu_0_data_master_granted_dma_control_port_slave = cpu_0_data_master_qualified_request_dma_control_port_slave;

  //cpu_0/data_master saved-grant dma/control_port_slave, which is an e_assign
  assign cpu_0_data_master_saved_grant_dma_control_port_slave = cpu_0_data_master_requests_dma_control_port_slave;

  //allow new arb cycle for dma/control_port_slave, which is an e_assign
  assign dma_control_port_slave_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign dma_control_port_slave_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign dma_control_port_slave_master_qreq_vector = 1;

  //dma_control_port_slave_reset_n assignment, which is an e_assign
  assign dma_control_port_slave_reset_n = reset_n;

  assign dma_control_port_slave_chipselect = cpu_0_data_master_granted_dma_control_port_slave;
  //dma_control_port_slave_firsttransfer first transaction, which is an e_assign
  assign dma_control_port_slave_firsttransfer = dma_control_port_slave_begins_xfer ? dma_control_port_slave_unreg_firsttransfer : dma_control_port_slave_reg_firsttransfer;

  //dma_control_port_slave_unreg_firsttransfer first transaction, which is an e_assign
  assign dma_control_port_slave_unreg_firsttransfer = ~(dma_control_port_slave_slavearbiterlockenable & dma_control_port_slave_any_continuerequest);

  //dma_control_port_slave_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_control_port_slave_reg_firsttransfer <= 1'b1;
      else if (dma_control_port_slave_begins_xfer)
          dma_control_port_slave_reg_firsttransfer <= dma_control_port_slave_unreg_firsttransfer;
    end


  //dma_control_port_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign dma_control_port_slave_beginbursttransfer_internal = dma_control_port_slave_begins_xfer;

  //~dma_control_port_slave_write_n assignment, which is an e_mux
  assign dma_control_port_slave_write_n = ~(cpu_0_data_master_granted_dma_control_port_slave & cpu_0_data_master_write);

  assign shifted_address_to_dma_control_port_slave_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //dma_control_port_slave_address mux, which is an e_mux
  assign dma_control_port_slave_address = shifted_address_to_dma_control_port_slave_from_cpu_0_data_master >> 2;

  //d1_dma_control_port_slave_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_dma_control_port_slave_end_xfer <= 1;
      else if (1)
          d1_dma_control_port_slave_end_xfer <= dma_control_port_slave_end_xfer;
    end


  //dma_control_port_slave_waits_for_read in a cycle, which is an e_mux
  assign dma_control_port_slave_waits_for_read = dma_control_port_slave_in_a_read_cycle & dma_control_port_slave_begins_xfer;

  //dma_control_port_slave_in_a_read_cycle assignment, which is an e_assign
  assign dma_control_port_slave_in_a_read_cycle = cpu_0_data_master_granted_dma_control_port_slave & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = dma_control_port_slave_in_a_read_cycle;

  //dma_control_port_slave_waits_for_write in a cycle, which is an e_mux
  assign dma_control_port_slave_waits_for_write = dma_control_port_slave_in_a_write_cycle & dma_control_port_slave_begins_xfer;

  //dma_control_port_slave_in_a_write_cycle assignment, which is an e_assign
  assign dma_control_port_slave_in_a_write_cycle = cpu_0_data_master_granted_dma_control_port_slave & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = dma_control_port_slave_in_a_write_cycle;

  assign wait_for_dma_control_port_slave_counter = 0;
  //assign dma_control_port_slave_irq_from_sa = dma_control_port_slave_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign dma_control_port_slave_irq_from_sa = dma_control_port_slave_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //dma/control_port_slave enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module dma_read_master_arbitrator (
                                    // inputs:
                                     clk,
                                     d1_onchip_mem_s1_end_xfer,
                                     d1_sdram_0_s1_end_xfer,
                                     dma_read_master_address,
                                     dma_read_master_chipselect,
                                     dma_read_master_flush,
                                     dma_read_master_granted_onchip_mem_s1,
                                     dma_read_master_granted_sdram_0_s1,
                                     dma_read_master_qualified_request_onchip_mem_s1,
                                     dma_read_master_qualified_request_sdram_0_s1,
                                     dma_read_master_read_data_valid_onchip_mem_s1,
                                     dma_read_master_read_data_valid_sdram_0_s1,
                                     dma_read_master_read_data_valid_sdram_0_s1_shift_register,
                                     dma_read_master_read_n,
                                     dma_read_master_requests_onchip_mem_s1,
                                     dma_read_master_requests_sdram_0_s1,
                                     onchip_mem_s1_readdata_from_sa,
                                     reset_n,
                                     sdram_0_s1_readdata_from_sa,
                                     sdram_0_s1_waitrequest_from_sa,

                                    // outputs:
                                     dma_read_master_address_to_slave,
                                     dma_read_master_dbs_address,
                                     dma_read_master_flush_qualified_exported,
                                     dma_read_master_latency_counter,
                                     dma_read_master_readdata,
                                     dma_read_master_readdatavalid,
                                     dma_read_master_waitrequest
                                  )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output  [ 25: 0] dma_read_master_address_to_slave;
  output  [  1: 0] dma_read_master_dbs_address;
  output           dma_read_master_flush_qualified_exported;
  output           dma_read_master_latency_counter;
  output  [ 31: 0] dma_read_master_readdata;
  output           dma_read_master_readdatavalid;
  output           dma_read_master_waitrequest;
  input            clk;
  input            d1_onchip_mem_s1_end_xfer;
  input            d1_sdram_0_s1_end_xfer;
  input   [ 25: 0] dma_read_master_address;
  input            dma_read_master_chipselect;
  input            dma_read_master_flush;
  input            dma_read_master_granted_onchip_mem_s1;
  input            dma_read_master_granted_sdram_0_s1;
  input            dma_read_master_qualified_request_onchip_mem_s1;
  input            dma_read_master_qualified_request_sdram_0_s1;
  input            dma_read_master_read_data_valid_onchip_mem_s1;
  input            dma_read_master_read_data_valid_sdram_0_s1;
  input            dma_read_master_read_data_valid_sdram_0_s1_shift_register;
  input            dma_read_master_read_n;
  input            dma_read_master_requests_onchip_mem_s1;
  input            dma_read_master_requests_sdram_0_s1;
  input   [ 31: 0] onchip_mem_s1_readdata_from_sa;
  input            reset_n;
  input   [ 15: 0] sdram_0_s1_readdata_from_sa;
  input            sdram_0_s1_waitrequest_from_sa;

  reg              active_and_waiting_last_time;
  wire             dbs_count_enable;
  wire             dbs_counter_overflow;
  reg     [ 15: 0] dbs_latent_16_reg_segment_0;
  wire             dbs_rdv_count_enable;
  wire             dbs_rdv_counter_overflow;
  reg     [ 25: 0] dma_read_master_address_last_time;
  wire    [ 25: 0] dma_read_master_address_to_slave;
  reg              dma_read_master_chipselect_last_time;
  reg     [  1: 0] dma_read_master_dbs_address;
  wire    [  1: 0] dma_read_master_dbs_increment;
  reg     [  1: 0] dma_read_master_dbs_rdv_counter;
  wire    [  1: 0] dma_read_master_dbs_rdv_counter_inc;
  wire             dma_read_master_flush_qualified;
  wire             dma_read_master_flush_qualified_exported;
  wire             dma_read_master_is_granted_some_slave;
  reg              dma_read_master_latency_counter;
  wire    [  1: 0] dma_read_master_next_dbs_rdv_counter;
  reg              dma_read_master_read_but_no_slave_selected;
  reg              dma_read_master_read_n_last_time;
  wire    [ 31: 0] dma_read_master_readdata;
  wire             dma_read_master_readdatavalid;
  wire             dma_read_master_run;
  reg              dma_read_master_run_delayed;
  wire             dma_read_master_waitrequest;
  wire             latency_load_value;
  wire    [  1: 0] next_dbs_address;
  wire    [ 15: 0] p1_dbs_latent_16_reg_segment_0;
  wire             p1_dma_read_master_latency_counter;
  wire             pre_dbs_count_enable;
  wire             pre_flush_dma_read_master_readdatavalid;
  wire             r_1;
  wire             r_3;
  //r_1 master_run cascaded wait assignment, which is an e_assign
  assign r_1 = 1 & (dma_read_master_qualified_request_onchip_mem_s1 | ~dma_read_master_requests_onchip_mem_s1) & (dma_read_master_granted_onchip_mem_s1 | ~dma_read_master_qualified_request_onchip_mem_s1) & ((~dma_read_master_qualified_request_onchip_mem_s1 | ~(~dma_read_master_read_n & dma_read_master_chipselect) | (1 & (~dma_read_master_read_n & dma_read_master_chipselect))));

  //cascaded wait assignment, which is an e_assign
  assign dma_read_master_run = r_1 & r_3;

  //r_3 master_run cascaded wait assignment, which is an e_assign
  assign r_3 = 1 & (dma_read_master_qualified_request_sdram_0_s1 | ~dma_read_master_requests_sdram_0_s1) & (dma_read_master_granted_sdram_0_s1 | ~dma_read_master_qualified_request_sdram_0_s1) & ((~dma_read_master_qualified_request_sdram_0_s1 | ~(~dma_read_master_read_n & dma_read_master_chipselect) | (1 & ~sdram_0_s1_waitrequest_from_sa & (dma_read_master_dbs_address[1]) & (~dma_read_master_read_n & dma_read_master_chipselect))));

  //optimize select-logic by passing only those address bits which matter.
  assign dma_read_master_address_to_slave = dma_read_master_address[25 : 0];

  //dma_read_master_read_but_no_slave_selected assignment, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_read_master_read_but_no_slave_selected <= 0;
      else if (1)
          dma_read_master_read_but_no_slave_selected <= (~dma_read_master_read_n & dma_read_master_chipselect) & dma_read_master_run & ~dma_read_master_is_granted_some_slave;
    end


  //some slave is getting selected, which is an e_mux
  assign dma_read_master_is_granted_some_slave = dma_read_master_granted_onchip_mem_s1 |
    dma_read_master_granted_sdram_0_s1;

  //latent slave read data valids which may be flushed, which is an e_mux
  assign pre_flush_dma_read_master_readdatavalid = dma_read_master_read_data_valid_onchip_mem_s1 |
    (dma_read_master_read_data_valid_sdram_0_s1 & dbs_rdv_counter_overflow);

  //run delay, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_read_master_run_delayed <= 0;
      else if (1)
          dma_read_master_run_delayed <= dma_read_master_run;
    end


  //The Flushificator, which is an e_assign
  assign dma_read_master_flush_qualified = dma_read_master_flush && dma_read_master_run_delayed;

  //latent slave read data valid which is not flushed, which is an e_mux
  assign dma_read_master_readdatavalid = dma_read_master_read_but_no_slave_selected |
    (pre_flush_dma_read_master_readdatavalid & ~dma_read_master_flush_qualified) |
    dma_read_master_read_but_no_slave_selected |
    (pre_flush_dma_read_master_readdatavalid & ~dma_read_master_flush_qualified);

  //The Exported Flushificator, which is an e_assign
  assign dma_read_master_flush_qualified_exported = dma_read_master_flush_qualified;

  //dma/read_master readdata mux, which is an e_mux
  assign dma_read_master_readdata = ({32 {~dma_read_master_read_data_valid_onchip_mem_s1}} | onchip_mem_s1_readdata_from_sa) &
    ({32 {~dma_read_master_read_data_valid_sdram_0_s1}} | {sdram_0_s1_readdata_from_sa[15 : 0],
    dbs_latent_16_reg_segment_0});

  //actual waitrequest port, which is an e_assign
  assign dma_read_master_waitrequest = ~dma_read_master_run;

  //latent max counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_read_master_latency_counter <= 0;
      else if (1)
          dma_read_master_latency_counter <= p1_dma_read_master_latency_counter;
    end


  //latency counter load mux, which is an e_mux
  assign p1_dma_read_master_latency_counter = ((dma_read_master_run & (~dma_read_master_read_n & dma_read_master_chipselect)))? latency_load_value :
    (dma_read_master_latency_counter)? dma_read_master_latency_counter - 1 :
    0;

  //read latency load values, which is an e_mux
  assign latency_load_value = {1 {dma_read_master_requests_onchip_mem_s1}} & 1;

  //input to latent dbs-16 stored 0, which is an e_mux
  assign p1_dbs_latent_16_reg_segment_0 = sdram_0_s1_readdata_from_sa;

  //dbs register for latent dbs-16 segment 0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dbs_latent_16_reg_segment_0 <= 0;
      else if (dbs_rdv_count_enable & ((dma_read_master_dbs_rdv_counter[1]) == 0))
          dbs_latent_16_reg_segment_0 <= p1_dbs_latent_16_reg_segment_0;
    end


  //dbs count increment, which is an e_mux
  assign dma_read_master_dbs_increment = (dma_read_master_requests_sdram_0_s1)? 2 :
    0;

  //dbs counter overflow, which is an e_assign
  assign dbs_counter_overflow = dma_read_master_dbs_address[1] & !(next_dbs_address[1]);

  //next master address, which is an e_assign
  assign next_dbs_address = dma_read_master_dbs_address + dma_read_master_dbs_increment;

  //dbs count enable, which is an e_mux
  assign dbs_count_enable = pre_dbs_count_enable;

  //dbs counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_read_master_dbs_address <= 0;
      else if (dbs_count_enable)
          dma_read_master_dbs_address <= next_dbs_address;
    end


  //p1 dbs rdv counter, which is an e_assign
  assign dma_read_master_next_dbs_rdv_counter = dma_read_master_dbs_rdv_counter + dma_read_master_dbs_rdv_counter_inc;

  //dma_read_master_rdv_inc_mux, which is an e_mux
  assign dma_read_master_dbs_rdv_counter_inc = 2;

  //master any slave rdv, which is an e_mux
  assign dbs_rdv_count_enable = dma_read_master_read_data_valid_sdram_0_s1;

  //dbs rdv counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_read_master_dbs_rdv_counter <= 0;
      else if (dbs_rdv_count_enable | dma_read_master_flush_qualified)
          if (dma_read_master_flush_qualified)
              dma_read_master_dbs_rdv_counter <= 0;
          else 
            dma_read_master_dbs_rdv_counter <= dma_read_master_next_dbs_rdv_counter;
    end


  //dbs rdv counter overflow, which is an e_assign
  assign dbs_rdv_counter_overflow = dma_read_master_dbs_rdv_counter[1] & ~dma_read_master_next_dbs_rdv_counter[1];

  //pre dbs count enable, which is an e_mux
  assign pre_dbs_count_enable = dma_read_master_granted_sdram_0_s1 & (~dma_read_master_read_n & dma_read_master_chipselect) & 1 & 1 & ~sdram_0_s1_waitrequest_from_sa;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //dma_read_master_address check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_read_master_address_last_time <= 0;
      else if (1)
          dma_read_master_address_last_time <= dma_read_master_address;
    end


  //dma/read_master waited last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          active_and_waiting_last_time <= 0;
      else if (1)
          active_and_waiting_last_time <= dma_read_master_waitrequest & dma_read_master_chipselect;
    end


  //dma_read_master_address matches last port_name, which is an e_process
  always @(active_and_waiting_last_time or dma_read_master_address or dma_read_master_address_last_time)
    begin
      if (active_and_waiting_last_time & (dma_read_master_address != dma_read_master_address_last_time))
        begin
          $write("%0d ns: dma_read_master_address did not heed wait!!!", $time);
          $stop;
        end
    end


  //dma_read_master_chipselect check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_read_master_chipselect_last_time <= 0;
      else if (1)
          dma_read_master_chipselect_last_time <= dma_read_master_chipselect;
    end


  //dma_read_master_chipselect matches last port_name, which is an e_process
  always @(active_and_waiting_last_time or dma_read_master_chipselect or dma_read_master_chipselect_last_time)
    begin
      if (active_and_waiting_last_time & (dma_read_master_chipselect != dma_read_master_chipselect_last_time))
        begin
          $write("%0d ns: dma_read_master_chipselect did not heed wait!!!", $time);
          $stop;
        end
    end


  //~dma_read_master_read_n check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_read_master_read_n_last_time <= ~0;
      else if (1)
          dma_read_master_read_n_last_time <= dma_read_master_read_n;
    end


  //~dma_read_master_read_n matches last port_name, which is an e_process
  always @(active_and_waiting_last_time or dma_read_master_read_n or dma_read_master_read_n_last_time)
    begin
      if (active_and_waiting_last_time & (~dma_read_master_read_n != ~dma_read_master_read_n_last_time))
        begin
          $write("%0d ns: ~dma_read_master_read_n did not heed wait!!!", $time);
          $stop;
        end
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module dma_write_master_arbitrator (
                                     // inputs:
                                      clk,
                                      d1_onchip_mem_s1_end_xfer,
                                      d1_sdram_0_s1_end_xfer,
                                      dma_write_master_address,
                                      dma_write_master_byteenable_sdram_0_s1,
                                      dma_write_master_chipselect,
                                      dma_write_master_granted_onchip_mem_s1,
                                      dma_write_master_granted_sdram_0_s1,
                                      dma_write_master_qualified_request_onchip_mem_s1,
                                      dma_write_master_qualified_request_sdram_0_s1,
                                      dma_write_master_requests_onchip_mem_s1,
                                      dma_write_master_requests_sdram_0_s1,
                                      dma_write_master_write_n,
                                      dma_write_master_writedata,
                                      reset_n,
                                      sdram_0_s1_waitrequest_from_sa,

                                     // outputs:
                                      dma_write_master_address_to_slave,
                                      dma_write_master_dbs_address,
                                      dma_write_master_dbs_write_16,
                                      dma_write_master_waitrequest
                                   )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output  [ 25: 0] dma_write_master_address_to_slave;
  output  [  1: 0] dma_write_master_dbs_address;
  output  [ 15: 0] dma_write_master_dbs_write_16;
  output           dma_write_master_waitrequest;
  input            clk;
  input            d1_onchip_mem_s1_end_xfer;
  input            d1_sdram_0_s1_end_xfer;
  input   [ 25: 0] dma_write_master_address;
  input   [  1: 0] dma_write_master_byteenable_sdram_0_s1;
  input            dma_write_master_chipselect;
  input            dma_write_master_granted_onchip_mem_s1;
  input            dma_write_master_granted_sdram_0_s1;
  input            dma_write_master_qualified_request_onchip_mem_s1;
  input            dma_write_master_qualified_request_sdram_0_s1;
  input            dma_write_master_requests_onchip_mem_s1;
  input            dma_write_master_requests_sdram_0_s1;
  input            dma_write_master_write_n;
  input   [ 31: 0] dma_write_master_writedata;
  input            reset_n;
  input            sdram_0_s1_waitrequest_from_sa;

  reg              active_and_waiting_last_time;
  wire             dbs_count_enable;
  wire             dbs_counter_overflow;
  reg     [ 25: 0] dma_write_master_address_last_time;
  wire    [ 25: 0] dma_write_master_address_to_slave;
  reg              dma_write_master_chipselect_last_time;
  reg     [  1: 0] dma_write_master_dbs_address;
  wire    [  1: 0] dma_write_master_dbs_increment;
  wire    [ 15: 0] dma_write_master_dbs_write_16;
  wire             dma_write_master_run;
  wire             dma_write_master_waitrequest;
  reg              dma_write_master_write_n_last_time;
  reg     [ 31: 0] dma_write_master_writedata_last_time;
  wire    [  1: 0] next_dbs_address;
  wire             pre_dbs_count_enable;
  wire             r_1;
  wire             r_3;
  //r_1 master_run cascaded wait assignment, which is an e_assign
  assign r_1 = 1 & (dma_write_master_qualified_request_onchip_mem_s1 | ~dma_write_master_requests_onchip_mem_s1) & (dma_write_master_granted_onchip_mem_s1 | ~dma_write_master_qualified_request_onchip_mem_s1) & ((~dma_write_master_qualified_request_onchip_mem_s1 | ~dma_write_master_chipselect | (1 & dma_write_master_chipselect)));

  //cascaded wait assignment, which is an e_assign
  assign dma_write_master_run = r_1 & r_3;

  //r_3 master_run cascaded wait assignment, which is an e_assign
  assign r_3 = 1 & ((dma_write_master_qualified_request_sdram_0_s1 | ((~dma_write_master_write_n & dma_write_master_chipselect) & !dma_write_master_byteenable_sdram_0_s1 & dma_write_master_dbs_address[1]) | ~dma_write_master_requests_sdram_0_s1)) & (dma_write_master_granted_sdram_0_s1 | ~dma_write_master_qualified_request_sdram_0_s1) & ((~dma_write_master_qualified_request_sdram_0_s1 | ~(~dma_write_master_write_n & dma_write_master_chipselect) | (1 & ~sdram_0_s1_waitrequest_from_sa & (dma_write_master_dbs_address[1]) & (~dma_write_master_write_n & dma_write_master_chipselect))));

  //optimize select-logic by passing only those address bits which matter.
  assign dma_write_master_address_to_slave = dma_write_master_address[25 : 0];

  //actual waitrequest port, which is an e_assign
  assign dma_write_master_waitrequest = ~dma_write_master_run;

  //pre dbs count enable, which is an e_mux
  assign pre_dbs_count_enable = (((~0) & dma_write_master_requests_sdram_0_s1 & (~dma_write_master_write_n & dma_write_master_chipselect) & !dma_write_master_byteenable_sdram_0_s1)) |
    ((dma_write_master_granted_sdram_0_s1 & (~dma_write_master_write_n & dma_write_master_chipselect) & 1 & 1 & ~sdram_0_s1_waitrequest_from_sa));

  //mux write dbs 1, which is an e_mux
  assign dma_write_master_dbs_write_16 = (dma_write_master_dbs_address[1])? dma_write_master_writedata[31 : 16] :
    dma_write_master_writedata[15 : 0];

  //dbs count increment, which is an e_mux
  assign dma_write_master_dbs_increment = (dma_write_master_requests_sdram_0_s1)? 2 :
    0;

  //dbs counter overflow, which is an e_assign
  assign dbs_counter_overflow = dma_write_master_dbs_address[1] & !(next_dbs_address[1]);

  //next master address, which is an e_assign
  assign next_dbs_address = dma_write_master_dbs_address + dma_write_master_dbs_increment;

  //dbs count enable, which is an e_mux
  assign dbs_count_enable = pre_dbs_count_enable;

  //dbs counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_write_master_dbs_address <= 0;
      else if (dbs_count_enable)
          dma_write_master_dbs_address <= next_dbs_address;
    end



//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //dma_write_master_address check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_write_master_address_last_time <= 0;
      else if (1)
          dma_write_master_address_last_time <= dma_write_master_address;
    end


  //dma/write_master waited last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          active_and_waiting_last_time <= 0;
      else if (1)
          active_and_waiting_last_time <= dma_write_master_waitrequest & dma_write_master_chipselect;
    end


  //dma_write_master_address matches last port_name, which is an e_process
  always @(active_and_waiting_last_time or dma_write_master_address or dma_write_master_address_last_time)
    begin
      if (active_and_waiting_last_time & (dma_write_master_address != dma_write_master_address_last_time))
        begin
          $write("%0d ns: dma_write_master_address did not heed wait!!!", $time);
          $stop;
        end
    end


  //dma_write_master_chipselect check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_write_master_chipselect_last_time <= 0;
      else if (1)
          dma_write_master_chipselect_last_time <= dma_write_master_chipselect;
    end


  //dma_write_master_chipselect matches last port_name, which is an e_process
  always @(active_and_waiting_last_time or dma_write_master_chipselect or dma_write_master_chipselect_last_time)
    begin
      if (active_and_waiting_last_time & (dma_write_master_chipselect != dma_write_master_chipselect_last_time))
        begin
          $write("%0d ns: dma_write_master_chipselect did not heed wait!!!", $time);
          $stop;
        end
    end


  //~dma_write_master_write_n check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_write_master_write_n_last_time <= ~0;
      else if (1)
          dma_write_master_write_n_last_time <= dma_write_master_write_n;
    end


  //~dma_write_master_write_n matches last port_name, which is an e_process
  always @(active_and_waiting_last_time or dma_write_master_write_n or dma_write_master_write_n_last_time)
    begin
      if (active_and_waiting_last_time & (~dma_write_master_write_n != ~dma_write_master_write_n_last_time))
        begin
          $write("%0d ns: ~dma_write_master_write_n did not heed wait!!!", $time);
          $stop;
        end
    end


  //dma_write_master_writedata check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_write_master_writedata_last_time <= 0;
      else if (1)
          dma_write_master_writedata_last_time <= dma_write_master_writedata;
    end


  //dma_write_master_writedata matches last port_name, which is an e_process
  always @(active_and_waiting_last_time or dma_write_master_chipselect or dma_write_master_write_n or dma_write_master_writedata or dma_write_master_writedata_last_time)
    begin
      if (active_and_waiting_last_time & (dma_write_master_writedata != dma_write_master_writedata_last_time) & (~dma_write_master_write_n & dma_write_master_chipselect))
        begin
          $write("%0d ns: dma_write_master_writedata did not heed wait!!!", $time);
          $stop;
        end
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module jtag_uart_avalon_jtag_slave_arbitrator (
                                                // inputs:
                                                 clk,
                                                 cpu_0_data_master_address_to_slave,
                                                 cpu_0_data_master_read,
                                                 cpu_0_data_master_waitrequest,
                                                 cpu_0_data_master_write,
                                                 cpu_0_data_master_writedata,
                                                 jtag_uart_avalon_jtag_slave_dataavailable,
                                                 jtag_uart_avalon_jtag_slave_irq,
                                                 jtag_uart_avalon_jtag_slave_readdata,
                                                 jtag_uart_avalon_jtag_slave_readyfordata,
                                                 jtag_uart_avalon_jtag_slave_waitrequest,
                                                 reset_n,

                                                // outputs:
                                                 cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave,
                                                 cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave,
                                                 cpu_0_data_master_read_data_valid_jtag_uart_avalon_jtag_slave,
                                                 cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave,
                                                 d1_jtag_uart_avalon_jtag_slave_end_xfer,
                                                 jtag_uart_avalon_jtag_slave_address,
                                                 jtag_uart_avalon_jtag_slave_chipselect,
                                                 jtag_uart_avalon_jtag_slave_dataavailable_from_sa,
                                                 jtag_uart_avalon_jtag_slave_irq_from_sa,
                                                 jtag_uart_avalon_jtag_slave_read_n,
                                                 jtag_uart_avalon_jtag_slave_readdata_from_sa,
                                                 jtag_uart_avalon_jtag_slave_readyfordata_from_sa,
                                                 jtag_uart_avalon_jtag_slave_reset_n,
                                                 jtag_uart_avalon_jtag_slave_waitrequest_from_sa,
                                                 jtag_uart_avalon_jtag_slave_write_n,
                                                 jtag_uart_avalon_jtag_slave_writedata
                                              )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave;
  output           cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave;
  output           cpu_0_data_master_read_data_valid_jtag_uart_avalon_jtag_slave;
  output           cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave;
  output           d1_jtag_uart_avalon_jtag_slave_end_xfer;
  output           jtag_uart_avalon_jtag_slave_address;
  output           jtag_uart_avalon_jtag_slave_chipselect;
  output           jtag_uart_avalon_jtag_slave_dataavailable_from_sa;
  output           jtag_uart_avalon_jtag_slave_irq_from_sa;
  output           jtag_uart_avalon_jtag_slave_read_n;
  output  [ 31: 0] jtag_uart_avalon_jtag_slave_readdata_from_sa;
  output           jtag_uart_avalon_jtag_slave_readyfordata_from_sa;
  output           jtag_uart_avalon_jtag_slave_reset_n;
  output           jtag_uart_avalon_jtag_slave_waitrequest_from_sa;
  output           jtag_uart_avalon_jtag_slave_write_n;
  output  [ 31: 0] jtag_uart_avalon_jtag_slave_writedata;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input            jtag_uart_avalon_jtag_slave_dataavailable;
  input            jtag_uart_avalon_jtag_slave_irq;
  input   [ 31: 0] jtag_uart_avalon_jtag_slave_readdata;
  input            jtag_uart_avalon_jtag_slave_readyfordata;
  input            jtag_uart_avalon_jtag_slave_waitrequest;
  input            reset_n;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave;
  wire             cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave;
  wire             cpu_0_data_master_read_data_valid_jtag_uart_avalon_jtag_slave;
  wire             cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave;
  wire             cpu_0_data_master_saved_grant_jtag_uart_avalon_jtag_slave;
  reg              d1_jtag_uart_avalon_jtag_slave_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire             jtag_uart_avalon_jtag_slave_address;
  wire             jtag_uart_avalon_jtag_slave_allgrants;
  wire             jtag_uart_avalon_jtag_slave_allow_new_arb_cycle;
  wire             jtag_uart_avalon_jtag_slave_any_bursting_master_saved_grant;
  wire             jtag_uart_avalon_jtag_slave_any_continuerequest;
  wire             jtag_uart_avalon_jtag_slave_arb_counter_enable;
  reg     [  2: 0] jtag_uart_avalon_jtag_slave_arb_share_counter;
  wire    [  2: 0] jtag_uart_avalon_jtag_slave_arb_share_counter_next_value;
  wire    [  2: 0] jtag_uart_avalon_jtag_slave_arb_share_set_values;
  wire             jtag_uart_avalon_jtag_slave_beginbursttransfer_internal;
  wire             jtag_uart_avalon_jtag_slave_begins_xfer;
  wire             jtag_uart_avalon_jtag_slave_chipselect;
  wire             jtag_uart_avalon_jtag_slave_dataavailable_from_sa;
  wire             jtag_uart_avalon_jtag_slave_end_xfer;
  wire             jtag_uart_avalon_jtag_slave_firsttransfer;
  wire             jtag_uart_avalon_jtag_slave_grant_vector;
  wire             jtag_uart_avalon_jtag_slave_in_a_read_cycle;
  wire             jtag_uart_avalon_jtag_slave_in_a_write_cycle;
  wire             jtag_uart_avalon_jtag_slave_irq_from_sa;
  wire             jtag_uart_avalon_jtag_slave_master_qreq_vector;
  wire             jtag_uart_avalon_jtag_slave_non_bursting_master_requests;
  wire             jtag_uart_avalon_jtag_slave_read_n;
  wire    [ 31: 0] jtag_uart_avalon_jtag_slave_readdata_from_sa;
  wire             jtag_uart_avalon_jtag_slave_readyfordata_from_sa;
  reg              jtag_uart_avalon_jtag_slave_reg_firsttransfer;
  wire             jtag_uart_avalon_jtag_slave_reset_n;
  reg              jtag_uart_avalon_jtag_slave_slavearbiterlockenable;
  wire             jtag_uart_avalon_jtag_slave_slavearbiterlockenable2;
  wire             jtag_uart_avalon_jtag_slave_unreg_firsttransfer;
  wire             jtag_uart_avalon_jtag_slave_waitrequest_from_sa;
  wire             jtag_uart_avalon_jtag_slave_waits_for_read;
  wire             jtag_uart_avalon_jtag_slave_waits_for_write;
  wire             jtag_uart_avalon_jtag_slave_write_n;
  wire    [ 31: 0] jtag_uart_avalon_jtag_slave_writedata;
  wire    [ 25: 0] shifted_address_to_jtag_uart_avalon_jtag_slave_from_cpu_0_data_master;
  wire             wait_for_jtag_uart_avalon_jtag_slave_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~jtag_uart_avalon_jtag_slave_end_xfer;
    end


  assign jtag_uart_avalon_jtag_slave_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave));
  //assign jtag_uart_avalon_jtag_slave_readdata_from_sa = jtag_uart_avalon_jtag_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_readdata_from_sa = jtag_uart_avalon_jtag_slave_readdata;

  assign cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave = ({cpu_0_data_master_address_to_slave[25 : 3] , 3'b0} == 26'h2003348) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //assign jtag_uart_avalon_jtag_slave_dataavailable_from_sa = jtag_uart_avalon_jtag_slave_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_dataavailable_from_sa = jtag_uart_avalon_jtag_slave_dataavailable;

  //assign jtag_uart_avalon_jtag_slave_readyfordata_from_sa = jtag_uart_avalon_jtag_slave_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_readyfordata_from_sa = jtag_uart_avalon_jtag_slave_readyfordata;

  //assign jtag_uart_avalon_jtag_slave_waitrequest_from_sa = jtag_uart_avalon_jtag_slave_waitrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_waitrequest_from_sa = jtag_uart_avalon_jtag_slave_waitrequest;

  //jtag_uart_avalon_jtag_slave_arb_share_counter set values, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_arb_share_set_values = 1;

  //jtag_uart_avalon_jtag_slave_non_bursting_master_requests mux, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_non_bursting_master_requests = cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave;

  //jtag_uart_avalon_jtag_slave_any_bursting_master_saved_grant mux, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_any_bursting_master_saved_grant = 0;

  //jtag_uart_avalon_jtag_slave_arb_share_counter_next_value assignment, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_arb_share_counter_next_value = jtag_uart_avalon_jtag_slave_firsttransfer ? (jtag_uart_avalon_jtag_slave_arb_share_set_values - 1) : |jtag_uart_avalon_jtag_slave_arb_share_counter ? (jtag_uart_avalon_jtag_slave_arb_share_counter - 1) : 0;

  //jtag_uart_avalon_jtag_slave_allgrants all slave grants, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_allgrants = |jtag_uart_avalon_jtag_slave_grant_vector;

  //jtag_uart_avalon_jtag_slave_end_xfer assignment, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_end_xfer = ~(jtag_uart_avalon_jtag_slave_waits_for_read | jtag_uart_avalon_jtag_slave_waits_for_write);

  //end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave = jtag_uart_avalon_jtag_slave_end_xfer & (~jtag_uart_avalon_jtag_slave_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //jtag_uart_avalon_jtag_slave_arb_share_counter arbitration counter enable, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_arb_counter_enable = (end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave & jtag_uart_avalon_jtag_slave_allgrants) | (end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave & ~jtag_uart_avalon_jtag_slave_non_bursting_master_requests);

  //jtag_uart_avalon_jtag_slave_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          jtag_uart_avalon_jtag_slave_arb_share_counter <= 0;
      else if (jtag_uart_avalon_jtag_slave_arb_counter_enable)
          jtag_uart_avalon_jtag_slave_arb_share_counter <= jtag_uart_avalon_jtag_slave_arb_share_counter_next_value;
    end


  //jtag_uart_avalon_jtag_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          jtag_uart_avalon_jtag_slave_slavearbiterlockenable <= 0;
      else if ((|jtag_uart_avalon_jtag_slave_master_qreq_vector & end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave) | (end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave & ~jtag_uart_avalon_jtag_slave_non_bursting_master_requests))
          jtag_uart_avalon_jtag_slave_slavearbiterlockenable <= |jtag_uart_avalon_jtag_slave_arb_share_counter_next_value;
    end


  //cpu_0/data_master jtag_uart/avalon_jtag_slave arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = jtag_uart_avalon_jtag_slave_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //jtag_uart_avalon_jtag_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_slavearbiterlockenable2 = |jtag_uart_avalon_jtag_slave_arb_share_counter_next_value;

  //cpu_0/data_master jtag_uart/avalon_jtag_slave arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = jtag_uart_avalon_jtag_slave_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //jtag_uart_avalon_jtag_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave = cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave & ~((cpu_0_data_master_read & (~cpu_0_data_master_waitrequest)) | ((~cpu_0_data_master_waitrequest) & cpu_0_data_master_write));
  //jtag_uart_avalon_jtag_slave_writedata mux, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_writedata = cpu_0_data_master_writedata;

  //master is always granted when requested
  assign cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave = cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave;

  //cpu_0/data_master saved-grant jtag_uart/avalon_jtag_slave, which is an e_assign
  assign cpu_0_data_master_saved_grant_jtag_uart_avalon_jtag_slave = cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave;

  //allow new arb cycle for jtag_uart/avalon_jtag_slave, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign jtag_uart_avalon_jtag_slave_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign jtag_uart_avalon_jtag_slave_master_qreq_vector = 1;

  //jtag_uart_avalon_jtag_slave_reset_n assignment, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_reset_n = reset_n;

  assign jtag_uart_avalon_jtag_slave_chipselect = cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave;
  //jtag_uart_avalon_jtag_slave_firsttransfer first transaction, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_firsttransfer = jtag_uart_avalon_jtag_slave_begins_xfer ? jtag_uart_avalon_jtag_slave_unreg_firsttransfer : jtag_uart_avalon_jtag_slave_reg_firsttransfer;

  //jtag_uart_avalon_jtag_slave_unreg_firsttransfer first transaction, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_unreg_firsttransfer = ~(jtag_uart_avalon_jtag_slave_slavearbiterlockenable & jtag_uart_avalon_jtag_slave_any_continuerequest);

  //jtag_uart_avalon_jtag_slave_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          jtag_uart_avalon_jtag_slave_reg_firsttransfer <= 1'b1;
      else if (jtag_uart_avalon_jtag_slave_begins_xfer)
          jtag_uart_avalon_jtag_slave_reg_firsttransfer <= jtag_uart_avalon_jtag_slave_unreg_firsttransfer;
    end


  //jtag_uart_avalon_jtag_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_beginbursttransfer_internal = jtag_uart_avalon_jtag_slave_begins_xfer;

  //~jtag_uart_avalon_jtag_slave_read_n assignment, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_read_n = ~(cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave & cpu_0_data_master_read);

  //~jtag_uart_avalon_jtag_slave_write_n assignment, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_write_n = ~(cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave & cpu_0_data_master_write);

  assign shifted_address_to_jtag_uart_avalon_jtag_slave_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //jtag_uart_avalon_jtag_slave_address mux, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_address = shifted_address_to_jtag_uart_avalon_jtag_slave_from_cpu_0_data_master >> 2;

  //d1_jtag_uart_avalon_jtag_slave_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_jtag_uart_avalon_jtag_slave_end_xfer <= 1;
      else if (1)
          d1_jtag_uart_avalon_jtag_slave_end_xfer <= jtag_uart_avalon_jtag_slave_end_xfer;
    end


  //jtag_uart_avalon_jtag_slave_waits_for_read in a cycle, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_waits_for_read = jtag_uart_avalon_jtag_slave_in_a_read_cycle & jtag_uart_avalon_jtag_slave_waitrequest_from_sa;

  //jtag_uart_avalon_jtag_slave_in_a_read_cycle assignment, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_in_a_read_cycle = cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = jtag_uart_avalon_jtag_slave_in_a_read_cycle;

  //jtag_uart_avalon_jtag_slave_waits_for_write in a cycle, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_waits_for_write = jtag_uart_avalon_jtag_slave_in_a_write_cycle & jtag_uart_avalon_jtag_slave_waitrequest_from_sa;

  //jtag_uart_avalon_jtag_slave_in_a_write_cycle assignment, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_in_a_write_cycle = cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = jtag_uart_avalon_jtag_slave_in_a_write_cycle;

  assign wait_for_jtag_uart_avalon_jtag_slave_counter = 0;
  //assign jtag_uart_avalon_jtag_slave_irq_from_sa = jtag_uart_avalon_jtag_slave_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_irq_from_sa = jtag_uart_avalon_jtag_slave_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //jtag_uart/avalon_jtag_slave enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module lcd12864_cs_s1_arbitrator (
                                   // inputs:
                                    clk,
                                    cpu_0_data_master_address_to_slave,
                                    cpu_0_data_master_read,
                                    cpu_0_data_master_waitrequest,
                                    cpu_0_data_master_write,
                                    cpu_0_data_master_writedata,
                                    reset_n,

                                   // outputs:
                                    cpu_0_data_master_granted_lcd12864_cs_s1,
                                    cpu_0_data_master_qualified_request_lcd12864_cs_s1,
                                    cpu_0_data_master_read_data_valid_lcd12864_cs_s1,
                                    cpu_0_data_master_requests_lcd12864_cs_s1,
                                    d1_lcd12864_cs_s1_end_xfer,
                                    lcd12864_cs_s1_address,
                                    lcd12864_cs_s1_chipselect,
                                    lcd12864_cs_s1_reset_n,
                                    lcd12864_cs_s1_write_n,
                                    lcd12864_cs_s1_writedata
                                 )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_lcd12864_cs_s1;
  output           cpu_0_data_master_qualified_request_lcd12864_cs_s1;
  output           cpu_0_data_master_read_data_valid_lcd12864_cs_s1;
  output           cpu_0_data_master_requests_lcd12864_cs_s1;
  output           d1_lcd12864_cs_s1_end_xfer;
  output  [  1: 0] lcd12864_cs_s1_address;
  output           lcd12864_cs_s1_chipselect;
  output           lcd12864_cs_s1_reset_n;
  output           lcd12864_cs_s1_write_n;
  output  [  1: 0] lcd12864_cs_s1_writedata;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input            reset_n;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_lcd12864_cs_s1;
  wire             cpu_0_data_master_qualified_request_lcd12864_cs_s1;
  wire             cpu_0_data_master_read_data_valid_lcd12864_cs_s1;
  wire             cpu_0_data_master_requests_lcd12864_cs_s1;
  wire             cpu_0_data_master_saved_grant_lcd12864_cs_s1;
  reg              d1_lcd12864_cs_s1_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_lcd12864_cs_s1;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [  1: 0] lcd12864_cs_s1_address;
  wire             lcd12864_cs_s1_allgrants;
  wire             lcd12864_cs_s1_allow_new_arb_cycle;
  wire             lcd12864_cs_s1_any_bursting_master_saved_grant;
  wire             lcd12864_cs_s1_any_continuerequest;
  wire             lcd12864_cs_s1_arb_counter_enable;
  reg     [  2: 0] lcd12864_cs_s1_arb_share_counter;
  wire    [  2: 0] lcd12864_cs_s1_arb_share_counter_next_value;
  wire    [  2: 0] lcd12864_cs_s1_arb_share_set_values;
  wire             lcd12864_cs_s1_beginbursttransfer_internal;
  wire             lcd12864_cs_s1_begins_xfer;
  wire             lcd12864_cs_s1_chipselect;
  wire             lcd12864_cs_s1_end_xfer;
  wire             lcd12864_cs_s1_firsttransfer;
  wire             lcd12864_cs_s1_grant_vector;
  wire             lcd12864_cs_s1_in_a_read_cycle;
  wire             lcd12864_cs_s1_in_a_write_cycle;
  wire             lcd12864_cs_s1_master_qreq_vector;
  wire             lcd12864_cs_s1_non_bursting_master_requests;
  reg              lcd12864_cs_s1_reg_firsttransfer;
  wire             lcd12864_cs_s1_reset_n;
  reg              lcd12864_cs_s1_slavearbiterlockenable;
  wire             lcd12864_cs_s1_slavearbiterlockenable2;
  wire             lcd12864_cs_s1_unreg_firsttransfer;
  wire             lcd12864_cs_s1_waits_for_read;
  wire             lcd12864_cs_s1_waits_for_write;
  wire             lcd12864_cs_s1_write_n;
  wire    [  1: 0] lcd12864_cs_s1_writedata;
  wire    [ 25: 0] shifted_address_to_lcd12864_cs_s1_from_cpu_0_data_master;
  wire             wait_for_lcd12864_cs_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~lcd12864_cs_s1_end_xfer;
    end


  assign lcd12864_cs_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_lcd12864_cs_s1));
  assign cpu_0_data_master_requests_lcd12864_cs_s1 = (({cpu_0_data_master_address_to_slave[25 : 4] , 4'b0} == 26'h20032c0) & (cpu_0_data_master_read | cpu_0_data_master_write)) & cpu_0_data_master_write;
  //lcd12864_cs_s1_arb_share_counter set values, which is an e_mux
  assign lcd12864_cs_s1_arb_share_set_values = 1;

  //lcd12864_cs_s1_non_bursting_master_requests mux, which is an e_mux
  assign lcd12864_cs_s1_non_bursting_master_requests = cpu_0_data_master_requests_lcd12864_cs_s1;

  //lcd12864_cs_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign lcd12864_cs_s1_any_bursting_master_saved_grant = 0;

  //lcd12864_cs_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign lcd12864_cs_s1_arb_share_counter_next_value = lcd12864_cs_s1_firsttransfer ? (lcd12864_cs_s1_arb_share_set_values - 1) : |lcd12864_cs_s1_arb_share_counter ? (lcd12864_cs_s1_arb_share_counter - 1) : 0;

  //lcd12864_cs_s1_allgrants all slave grants, which is an e_mux
  assign lcd12864_cs_s1_allgrants = |lcd12864_cs_s1_grant_vector;

  //lcd12864_cs_s1_end_xfer assignment, which is an e_assign
  assign lcd12864_cs_s1_end_xfer = ~(lcd12864_cs_s1_waits_for_read | lcd12864_cs_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_lcd12864_cs_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_lcd12864_cs_s1 = lcd12864_cs_s1_end_xfer & (~lcd12864_cs_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //lcd12864_cs_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign lcd12864_cs_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_lcd12864_cs_s1 & lcd12864_cs_s1_allgrants) | (end_xfer_arb_share_counter_term_lcd12864_cs_s1 & ~lcd12864_cs_s1_non_bursting_master_requests);

  //lcd12864_cs_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          lcd12864_cs_s1_arb_share_counter <= 0;
      else if (lcd12864_cs_s1_arb_counter_enable)
          lcd12864_cs_s1_arb_share_counter <= lcd12864_cs_s1_arb_share_counter_next_value;
    end


  //lcd12864_cs_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          lcd12864_cs_s1_slavearbiterlockenable <= 0;
      else if ((|lcd12864_cs_s1_master_qreq_vector & end_xfer_arb_share_counter_term_lcd12864_cs_s1) | (end_xfer_arb_share_counter_term_lcd12864_cs_s1 & ~lcd12864_cs_s1_non_bursting_master_requests))
          lcd12864_cs_s1_slavearbiterlockenable <= |lcd12864_cs_s1_arb_share_counter_next_value;
    end


  //cpu_0/data_master lcd12864_cs/s1 arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = lcd12864_cs_s1_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //lcd12864_cs_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign lcd12864_cs_s1_slavearbiterlockenable2 = |lcd12864_cs_s1_arb_share_counter_next_value;

  //cpu_0/data_master lcd12864_cs/s1 arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = lcd12864_cs_s1_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //lcd12864_cs_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  assign lcd12864_cs_s1_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_lcd12864_cs_s1 = cpu_0_data_master_requests_lcd12864_cs_s1 & ~(((~cpu_0_data_master_waitrequest) & cpu_0_data_master_write));
  //lcd12864_cs_s1_writedata mux, which is an e_mux
  assign lcd12864_cs_s1_writedata = cpu_0_data_master_writedata;

  //master is always granted when requested
  assign cpu_0_data_master_granted_lcd12864_cs_s1 = cpu_0_data_master_qualified_request_lcd12864_cs_s1;

  //cpu_0/data_master saved-grant lcd12864_cs/s1, which is an e_assign
  assign cpu_0_data_master_saved_grant_lcd12864_cs_s1 = cpu_0_data_master_requests_lcd12864_cs_s1;

  //allow new arb cycle for lcd12864_cs/s1, which is an e_assign
  assign lcd12864_cs_s1_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign lcd12864_cs_s1_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign lcd12864_cs_s1_master_qreq_vector = 1;

  //lcd12864_cs_s1_reset_n assignment, which is an e_assign
  assign lcd12864_cs_s1_reset_n = reset_n;

  assign lcd12864_cs_s1_chipselect = cpu_0_data_master_granted_lcd12864_cs_s1;
  //lcd12864_cs_s1_firsttransfer first transaction, which is an e_assign
  assign lcd12864_cs_s1_firsttransfer = lcd12864_cs_s1_begins_xfer ? lcd12864_cs_s1_unreg_firsttransfer : lcd12864_cs_s1_reg_firsttransfer;

  //lcd12864_cs_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign lcd12864_cs_s1_unreg_firsttransfer = ~(lcd12864_cs_s1_slavearbiterlockenable & lcd12864_cs_s1_any_continuerequest);

  //lcd12864_cs_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          lcd12864_cs_s1_reg_firsttransfer <= 1'b1;
      else if (lcd12864_cs_s1_begins_xfer)
          lcd12864_cs_s1_reg_firsttransfer <= lcd12864_cs_s1_unreg_firsttransfer;
    end


  //lcd12864_cs_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign lcd12864_cs_s1_beginbursttransfer_internal = lcd12864_cs_s1_begins_xfer;

  //~lcd12864_cs_s1_write_n assignment, which is an e_mux
  assign lcd12864_cs_s1_write_n = ~(cpu_0_data_master_granted_lcd12864_cs_s1 & cpu_0_data_master_write);

  assign shifted_address_to_lcd12864_cs_s1_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //lcd12864_cs_s1_address mux, which is an e_mux
  assign lcd12864_cs_s1_address = shifted_address_to_lcd12864_cs_s1_from_cpu_0_data_master >> 2;

  //d1_lcd12864_cs_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_lcd12864_cs_s1_end_xfer <= 1;
      else if (1)
          d1_lcd12864_cs_s1_end_xfer <= lcd12864_cs_s1_end_xfer;
    end


  //lcd12864_cs_s1_waits_for_read in a cycle, which is an e_mux
  assign lcd12864_cs_s1_waits_for_read = lcd12864_cs_s1_in_a_read_cycle & lcd12864_cs_s1_begins_xfer;

  //lcd12864_cs_s1_in_a_read_cycle assignment, which is an e_assign
  assign lcd12864_cs_s1_in_a_read_cycle = cpu_0_data_master_granted_lcd12864_cs_s1 & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = lcd12864_cs_s1_in_a_read_cycle;

  //lcd12864_cs_s1_waits_for_write in a cycle, which is an e_mux
  assign lcd12864_cs_s1_waits_for_write = lcd12864_cs_s1_in_a_write_cycle & 0;

  //lcd12864_cs_s1_in_a_write_cycle assignment, which is an e_assign
  assign lcd12864_cs_s1_in_a_write_cycle = cpu_0_data_master_granted_lcd12864_cs_s1 & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = lcd12864_cs_s1_in_a_write_cycle;

  assign wait_for_lcd12864_cs_s1_counter = 0;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //lcd12864_cs/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module oc_i2c_master_0_avalon_slave_arbitrator (
                                                 // inputs:
                                                  clk,
                                                  cpu_0_data_master_address_to_slave,
                                                  cpu_0_data_master_read,
                                                  cpu_0_data_master_waitrequest,
                                                  cpu_0_data_master_write,
                                                  cpu_0_data_master_writedata,
                                                  oc_i2c_master_0_avalon_slave_irq,
                                                  oc_i2c_master_0_avalon_slave_readdata,
                                                  oc_i2c_master_0_avalon_slave_waitrequest_n,
                                                  oc_i2c_master_0_avalon_slave_wishbone_err,
                                                  reset_n,

                                                 // outputs:
                                                  cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave,
                                                  cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave,
                                                  cpu_0_data_master_read_data_valid_oc_i2c_master_0_avalon_slave,
                                                  cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave,
                                                  d1_oc_i2c_master_0_avalon_slave_end_xfer,
                                                  oc_i2c_master_0_avalon_slave_address,
                                                  oc_i2c_master_0_avalon_slave_chipselect,
                                                  oc_i2c_master_0_avalon_slave_irq_from_sa,
                                                  oc_i2c_master_0_avalon_slave_readdata_from_sa,
                                                  oc_i2c_master_0_avalon_slave_reset,
                                                  oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa,
                                                  oc_i2c_master_0_avalon_slave_wishbone_err_from_sa,
                                                  oc_i2c_master_0_avalon_slave_write,
                                                  oc_i2c_master_0_avalon_slave_writedata
                                               )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave;
  output           cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave;
  output           cpu_0_data_master_read_data_valid_oc_i2c_master_0_avalon_slave;
  output           cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave;
  output           d1_oc_i2c_master_0_avalon_slave_end_xfer;
  output  [  2: 0] oc_i2c_master_0_avalon_slave_address;
  output           oc_i2c_master_0_avalon_slave_chipselect;
  output           oc_i2c_master_0_avalon_slave_irq_from_sa;
  output  [ 31: 0] oc_i2c_master_0_avalon_slave_readdata_from_sa;
  output           oc_i2c_master_0_avalon_slave_reset;
  output           oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa;
  output           oc_i2c_master_0_avalon_slave_wishbone_err_from_sa;
  output           oc_i2c_master_0_avalon_slave_write;
  output  [ 31: 0] oc_i2c_master_0_avalon_slave_writedata;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input            oc_i2c_master_0_avalon_slave_irq;
  input   [ 31: 0] oc_i2c_master_0_avalon_slave_readdata;
  input            oc_i2c_master_0_avalon_slave_waitrequest_n;
  input            oc_i2c_master_0_avalon_slave_wishbone_err;
  input            reset_n;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave;
  wire             cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave;
  wire             cpu_0_data_master_read_data_valid_oc_i2c_master_0_avalon_slave;
  wire             cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave;
  wire             cpu_0_data_master_saved_grant_oc_i2c_master_0_avalon_slave;
  reg              d1_oc_i2c_master_0_avalon_slave_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_oc_i2c_master_0_avalon_slave;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [  2: 0] oc_i2c_master_0_avalon_slave_address;
  wire             oc_i2c_master_0_avalon_slave_allgrants;
  wire             oc_i2c_master_0_avalon_slave_allow_new_arb_cycle;
  wire             oc_i2c_master_0_avalon_slave_any_bursting_master_saved_grant;
  wire             oc_i2c_master_0_avalon_slave_any_continuerequest;
  wire             oc_i2c_master_0_avalon_slave_arb_counter_enable;
  reg     [  2: 0] oc_i2c_master_0_avalon_slave_arb_share_counter;
  wire    [  2: 0] oc_i2c_master_0_avalon_slave_arb_share_counter_next_value;
  wire    [  2: 0] oc_i2c_master_0_avalon_slave_arb_share_set_values;
  wire             oc_i2c_master_0_avalon_slave_beginbursttransfer_internal;
  wire             oc_i2c_master_0_avalon_slave_begins_xfer;
  wire             oc_i2c_master_0_avalon_slave_chipselect;
  wire             oc_i2c_master_0_avalon_slave_end_xfer;
  wire             oc_i2c_master_0_avalon_slave_firsttransfer;
  wire             oc_i2c_master_0_avalon_slave_grant_vector;
  wire             oc_i2c_master_0_avalon_slave_in_a_read_cycle;
  wire             oc_i2c_master_0_avalon_slave_in_a_write_cycle;
  wire             oc_i2c_master_0_avalon_slave_irq_from_sa;
  wire             oc_i2c_master_0_avalon_slave_master_qreq_vector;
  wire             oc_i2c_master_0_avalon_slave_non_bursting_master_requests;
  wire    [ 31: 0] oc_i2c_master_0_avalon_slave_readdata_from_sa;
  reg              oc_i2c_master_0_avalon_slave_reg_firsttransfer;
  wire             oc_i2c_master_0_avalon_slave_reset;
  reg              oc_i2c_master_0_avalon_slave_slavearbiterlockenable;
  wire             oc_i2c_master_0_avalon_slave_slavearbiterlockenable2;
  wire             oc_i2c_master_0_avalon_slave_unreg_firsttransfer;
  wire             oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa;
  wire             oc_i2c_master_0_avalon_slave_waits_for_read;
  wire             oc_i2c_master_0_avalon_slave_waits_for_write;
  wire             oc_i2c_master_0_avalon_slave_wishbone_err_from_sa;
  wire             oc_i2c_master_0_avalon_slave_write;
  wire    [ 31: 0] oc_i2c_master_0_avalon_slave_writedata;
  wire    [ 25: 0] shifted_address_to_oc_i2c_master_0_avalon_slave_from_cpu_0_data_master;
  wire             wait_for_oc_i2c_master_0_avalon_slave_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~oc_i2c_master_0_avalon_slave_end_xfer;
    end


  assign oc_i2c_master_0_avalon_slave_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave));
  //assign oc_i2c_master_0_avalon_slave_readdata_from_sa = oc_i2c_master_0_avalon_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_readdata_from_sa = oc_i2c_master_0_avalon_slave_readdata;

  assign cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave = ({cpu_0_data_master_address_to_slave[25 : 5] , 5'b0} == 26'h2003240) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //assign oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa = oc_i2c_master_0_avalon_slave_waitrequest_n so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa = oc_i2c_master_0_avalon_slave_waitrequest_n;

  //oc_i2c_master_0_avalon_slave_arb_share_counter set values, which is an e_mux
  assign oc_i2c_master_0_avalon_slave_arb_share_set_values = 1;

  //oc_i2c_master_0_avalon_slave_non_bursting_master_requests mux, which is an e_mux
  assign oc_i2c_master_0_avalon_slave_non_bursting_master_requests = cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave;

  //oc_i2c_master_0_avalon_slave_any_bursting_master_saved_grant mux, which is an e_mux
  assign oc_i2c_master_0_avalon_slave_any_bursting_master_saved_grant = 0;

  //oc_i2c_master_0_avalon_slave_arb_share_counter_next_value assignment, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_arb_share_counter_next_value = oc_i2c_master_0_avalon_slave_firsttransfer ? (oc_i2c_master_0_avalon_slave_arb_share_set_values - 1) : |oc_i2c_master_0_avalon_slave_arb_share_counter ? (oc_i2c_master_0_avalon_slave_arb_share_counter - 1) : 0;

  //oc_i2c_master_0_avalon_slave_allgrants all slave grants, which is an e_mux
  assign oc_i2c_master_0_avalon_slave_allgrants = |oc_i2c_master_0_avalon_slave_grant_vector;

  //oc_i2c_master_0_avalon_slave_end_xfer assignment, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_end_xfer = ~(oc_i2c_master_0_avalon_slave_waits_for_read | oc_i2c_master_0_avalon_slave_waits_for_write);

  //end_xfer_arb_share_counter_term_oc_i2c_master_0_avalon_slave arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_oc_i2c_master_0_avalon_slave = oc_i2c_master_0_avalon_slave_end_xfer & (~oc_i2c_master_0_avalon_slave_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //oc_i2c_master_0_avalon_slave_arb_share_counter arbitration counter enable, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_arb_counter_enable = (end_xfer_arb_share_counter_term_oc_i2c_master_0_avalon_slave & oc_i2c_master_0_avalon_slave_allgrants) | (end_xfer_arb_share_counter_term_oc_i2c_master_0_avalon_slave & ~oc_i2c_master_0_avalon_slave_non_bursting_master_requests);

  //oc_i2c_master_0_avalon_slave_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          oc_i2c_master_0_avalon_slave_arb_share_counter <= 0;
      else if (oc_i2c_master_0_avalon_slave_arb_counter_enable)
          oc_i2c_master_0_avalon_slave_arb_share_counter <= oc_i2c_master_0_avalon_slave_arb_share_counter_next_value;
    end


  //oc_i2c_master_0_avalon_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          oc_i2c_master_0_avalon_slave_slavearbiterlockenable <= 0;
      else if ((|oc_i2c_master_0_avalon_slave_master_qreq_vector & end_xfer_arb_share_counter_term_oc_i2c_master_0_avalon_slave) | (end_xfer_arb_share_counter_term_oc_i2c_master_0_avalon_slave & ~oc_i2c_master_0_avalon_slave_non_bursting_master_requests))
          oc_i2c_master_0_avalon_slave_slavearbiterlockenable <= |oc_i2c_master_0_avalon_slave_arb_share_counter_next_value;
    end


  //cpu_0/data_master oc_i2c_master_0/avalon_slave arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = oc_i2c_master_0_avalon_slave_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //oc_i2c_master_0_avalon_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_slavearbiterlockenable2 = |oc_i2c_master_0_avalon_slave_arb_share_counter_next_value;

  //cpu_0/data_master oc_i2c_master_0/avalon_slave arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = oc_i2c_master_0_avalon_slave_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //oc_i2c_master_0_avalon_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave = cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave & ~((cpu_0_data_master_read & (~cpu_0_data_master_waitrequest)) | ((~cpu_0_data_master_waitrequest) & cpu_0_data_master_write));
  //oc_i2c_master_0_avalon_slave_writedata mux, which is an e_mux
  assign oc_i2c_master_0_avalon_slave_writedata = cpu_0_data_master_writedata;

  //assign oc_i2c_master_0_avalon_slave_wishbone_err_from_sa = oc_i2c_master_0_avalon_slave_wishbone_err so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_wishbone_err_from_sa = oc_i2c_master_0_avalon_slave_wishbone_err;

  //master is always granted when requested
  assign cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave = cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave;

  //cpu_0/data_master saved-grant oc_i2c_master_0/avalon_slave, which is an e_assign
  assign cpu_0_data_master_saved_grant_oc_i2c_master_0_avalon_slave = cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave;

  //allow new arb cycle for oc_i2c_master_0/avalon_slave, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign oc_i2c_master_0_avalon_slave_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign oc_i2c_master_0_avalon_slave_master_qreq_vector = 1;

  //~oc_i2c_master_0_avalon_slave_reset assignment, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_reset = ~reset_n;

  assign oc_i2c_master_0_avalon_slave_chipselect = cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave;
  //oc_i2c_master_0_avalon_slave_firsttransfer first transaction, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_firsttransfer = oc_i2c_master_0_avalon_slave_begins_xfer ? oc_i2c_master_0_avalon_slave_unreg_firsttransfer : oc_i2c_master_0_avalon_slave_reg_firsttransfer;

  //oc_i2c_master_0_avalon_slave_unreg_firsttransfer first transaction, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_unreg_firsttransfer = ~(oc_i2c_master_0_avalon_slave_slavearbiterlockenable & oc_i2c_master_0_avalon_slave_any_continuerequest);

  //oc_i2c_master_0_avalon_slave_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          oc_i2c_master_0_avalon_slave_reg_firsttransfer <= 1'b1;
      else if (oc_i2c_master_0_avalon_slave_begins_xfer)
          oc_i2c_master_0_avalon_slave_reg_firsttransfer <= oc_i2c_master_0_avalon_slave_unreg_firsttransfer;
    end


  //oc_i2c_master_0_avalon_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_beginbursttransfer_internal = oc_i2c_master_0_avalon_slave_begins_xfer;

  //oc_i2c_master_0_avalon_slave_write assignment, which is an e_mux
  assign oc_i2c_master_0_avalon_slave_write = cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave & cpu_0_data_master_write;

  assign shifted_address_to_oc_i2c_master_0_avalon_slave_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //oc_i2c_master_0_avalon_slave_address mux, which is an e_mux
  assign oc_i2c_master_0_avalon_slave_address = shifted_address_to_oc_i2c_master_0_avalon_slave_from_cpu_0_data_master >> 2;

  //d1_oc_i2c_master_0_avalon_slave_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_oc_i2c_master_0_avalon_slave_end_xfer <= 1;
      else if (1)
          d1_oc_i2c_master_0_avalon_slave_end_xfer <= oc_i2c_master_0_avalon_slave_end_xfer;
    end


  //oc_i2c_master_0_avalon_slave_waits_for_read in a cycle, which is an e_mux
  assign oc_i2c_master_0_avalon_slave_waits_for_read = oc_i2c_master_0_avalon_slave_in_a_read_cycle & ~oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa;

  //oc_i2c_master_0_avalon_slave_in_a_read_cycle assignment, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_in_a_read_cycle = cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = oc_i2c_master_0_avalon_slave_in_a_read_cycle;

  //oc_i2c_master_0_avalon_slave_waits_for_write in a cycle, which is an e_mux
  assign oc_i2c_master_0_avalon_slave_waits_for_write = oc_i2c_master_0_avalon_slave_in_a_write_cycle & ~oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa;

  //oc_i2c_master_0_avalon_slave_in_a_write_cycle assignment, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_in_a_write_cycle = cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = oc_i2c_master_0_avalon_slave_in_a_write_cycle;

  assign wait_for_oc_i2c_master_0_avalon_slave_counter = 0;
  //assign oc_i2c_master_0_avalon_slave_irq_from_sa = oc_i2c_master_0_avalon_slave_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign oc_i2c_master_0_avalon_slave_irq_from_sa = oc_i2c_master_0_avalon_slave_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //oc_i2c_master_0/avalon_slave enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module onchip_mem_s1_arbitrator (
                                  // inputs:
                                   clk,
                                   cpu_0_data_master_address_to_slave,
                                   cpu_0_data_master_byteenable,
                                   cpu_0_data_master_read,
                                   cpu_0_data_master_waitrequest,
                                   cpu_0_data_master_write,
                                   cpu_0_data_master_writedata,
                                   cpu_0_instruction_master_address_to_slave,
                                   cpu_0_instruction_master_latency_counter,
                                   cpu_0_instruction_master_read,
                                   cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register,
                                   dma_read_master_address_to_slave,
                                   dma_read_master_chipselect,
                                   dma_read_master_flush_qualified_exported,
                                   dma_read_master_latency_counter,
                                   dma_read_master_read_data_valid_sdram_0_s1_shift_register,
                                   dma_read_master_read_n,
                                   dma_write_master_address_to_slave,
                                   dma_write_master_byteenable,
                                   dma_write_master_chipselect,
                                   dma_write_master_write_n,
                                   dma_write_master_writedata,
                                   onchip_mem_s1_readdata,
                                   reset_n,

                                  // outputs:
                                   cpu_0_data_master_granted_onchip_mem_s1,
                                   cpu_0_data_master_qualified_request_onchip_mem_s1,
                                   cpu_0_data_master_read_data_valid_onchip_mem_s1,
                                   cpu_0_data_master_requests_onchip_mem_s1,
                                   cpu_0_instruction_master_granted_onchip_mem_s1,
                                   cpu_0_instruction_master_qualified_request_onchip_mem_s1,
                                   cpu_0_instruction_master_read_data_valid_onchip_mem_s1,
                                   cpu_0_instruction_master_requests_onchip_mem_s1,
                                   d1_onchip_mem_s1_end_xfer,
                                   dma_read_master_granted_onchip_mem_s1,
                                   dma_read_master_qualified_request_onchip_mem_s1,
                                   dma_read_master_read_data_valid_onchip_mem_s1,
                                   dma_read_master_requests_onchip_mem_s1,
                                   dma_write_master_granted_onchip_mem_s1,
                                   dma_write_master_qualified_request_onchip_mem_s1,
                                   dma_write_master_requests_onchip_mem_s1,
                                   onchip_mem_s1_address,
                                   onchip_mem_s1_byteenable,
                                   onchip_mem_s1_chipselect,
                                   onchip_mem_s1_clken,
                                   onchip_mem_s1_readdata_from_sa,
                                   onchip_mem_s1_write,
                                   onchip_mem_s1_writedata,
                                   registered_cpu_0_data_master_read_data_valid_onchip_mem_s1
                                )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_onchip_mem_s1;
  output           cpu_0_data_master_qualified_request_onchip_mem_s1;
  output           cpu_0_data_master_read_data_valid_onchip_mem_s1;
  output           cpu_0_data_master_requests_onchip_mem_s1;
  output           cpu_0_instruction_master_granted_onchip_mem_s1;
  output           cpu_0_instruction_master_qualified_request_onchip_mem_s1;
  output           cpu_0_instruction_master_read_data_valid_onchip_mem_s1;
  output           cpu_0_instruction_master_requests_onchip_mem_s1;
  output           d1_onchip_mem_s1_end_xfer;
  output           dma_read_master_granted_onchip_mem_s1;
  output           dma_read_master_qualified_request_onchip_mem_s1;
  output           dma_read_master_read_data_valid_onchip_mem_s1;
  output           dma_read_master_requests_onchip_mem_s1;
  output           dma_write_master_granted_onchip_mem_s1;
  output           dma_write_master_qualified_request_onchip_mem_s1;
  output           dma_write_master_requests_onchip_mem_s1;
  output  [  9: 0] onchip_mem_s1_address;
  output  [  3: 0] onchip_mem_s1_byteenable;
  output           onchip_mem_s1_chipselect;
  output           onchip_mem_s1_clken;
  output  [ 31: 0] onchip_mem_s1_readdata_from_sa;
  output           onchip_mem_s1_write;
  output  [ 31: 0] onchip_mem_s1_writedata;
  output           registered_cpu_0_data_master_read_data_valid_onchip_mem_s1;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input   [  3: 0] cpu_0_data_master_byteenable;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input   [ 25: 0] cpu_0_instruction_master_address_to_slave;
  input   [  1: 0] cpu_0_instruction_master_latency_counter;
  input            cpu_0_instruction_master_read;
  input            cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register;
  input   [ 25: 0] dma_read_master_address_to_slave;
  input            dma_read_master_chipselect;
  input            dma_read_master_flush_qualified_exported;
  input            dma_read_master_latency_counter;
  input            dma_read_master_read_data_valid_sdram_0_s1_shift_register;
  input            dma_read_master_read_n;
  input   [ 25: 0] dma_write_master_address_to_slave;
  input   [  3: 0] dma_write_master_byteenable;
  input            dma_write_master_chipselect;
  input            dma_write_master_write_n;
  input   [ 31: 0] dma_write_master_writedata;
  input   [ 31: 0] onchip_mem_s1_readdata;
  input            reset_n;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_onchip_mem_s1;
  wire             cpu_0_data_master_qualified_request_onchip_mem_s1;
  wire             cpu_0_data_master_read_data_valid_onchip_mem_s1;
  reg              cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register;
  wire             cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register_in;
  wire             cpu_0_data_master_requests_onchip_mem_s1;
  wire             cpu_0_data_master_saved_grant_onchip_mem_s1;
  wire             cpu_0_instruction_master_arbiterlock;
  wire             cpu_0_instruction_master_arbiterlock2;
  wire             cpu_0_instruction_master_continuerequest;
  wire             cpu_0_instruction_master_granted_onchip_mem_s1;
  wire             cpu_0_instruction_master_qualified_request_onchip_mem_s1;
  wire             cpu_0_instruction_master_read_data_valid_onchip_mem_s1;
  reg              cpu_0_instruction_master_read_data_valid_onchip_mem_s1_shift_register;
  wire             cpu_0_instruction_master_read_data_valid_onchip_mem_s1_shift_register_in;
  wire             cpu_0_instruction_master_requests_onchip_mem_s1;
  wire             cpu_0_instruction_master_saved_grant_onchip_mem_s1;
  reg              d1_onchip_mem_s1_end_xfer;
  reg              d1_reasons_to_wait;
  wire             dma_read_master_arbiterlock;
  wire             dma_read_master_arbiterlock2;
  wire             dma_read_master_continuerequest;
  wire             dma_read_master_granted_onchip_mem_s1;
  wire             dma_read_master_qualified_request_onchip_mem_s1;
  wire             dma_read_master_read_data_valid_onchip_mem_s1;
  reg              dma_read_master_read_data_valid_onchip_mem_s1_shift_register;
  wire             dma_read_master_read_data_valid_onchip_mem_s1_shift_register_in;
  wire             dma_read_master_requests_onchip_mem_s1;
  wire             dma_read_master_saved_grant_onchip_mem_s1;
  wire             dma_write_master_arbiterlock;
  wire             dma_write_master_arbiterlock2;
  wire             dma_write_master_continuerequest;
  wire             dma_write_master_granted_onchip_mem_s1;
  wire             dma_write_master_qualified_request_onchip_mem_s1;
  wire             dma_write_master_requests_onchip_mem_s1;
  wire             dma_write_master_saved_grant_onchip_mem_s1;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_onchip_mem_s1;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  reg              last_cycle_cpu_0_data_master_granted_slave_onchip_mem_s1;
  reg              last_cycle_cpu_0_instruction_master_granted_slave_onchip_mem_s1;
  reg              last_cycle_dma_read_master_granted_slave_onchip_mem_s1;
  reg              last_cycle_dma_write_master_granted_slave_onchip_mem_s1;
  wire    [  9: 0] onchip_mem_s1_address;
  wire             onchip_mem_s1_allgrants;
  wire             onchip_mem_s1_allow_new_arb_cycle;
  wire             onchip_mem_s1_any_bursting_master_saved_grant;
  wire             onchip_mem_s1_any_continuerequest;
  reg     [  3: 0] onchip_mem_s1_arb_addend;
  wire             onchip_mem_s1_arb_counter_enable;
  reg     [  2: 0] onchip_mem_s1_arb_share_counter;
  wire    [  2: 0] onchip_mem_s1_arb_share_counter_next_value;
  wire    [  2: 0] onchip_mem_s1_arb_share_set_values;
  wire    [  3: 0] onchip_mem_s1_arb_winner;
  wire             onchip_mem_s1_arbitration_holdoff_internal;
  wire             onchip_mem_s1_beginbursttransfer_internal;
  wire             onchip_mem_s1_begins_xfer;
  wire    [  3: 0] onchip_mem_s1_byteenable;
  wire             onchip_mem_s1_chipselect;
  wire    [  7: 0] onchip_mem_s1_chosen_master_double_vector;
  wire    [  3: 0] onchip_mem_s1_chosen_master_rot_left;
  wire             onchip_mem_s1_clken;
  wire             onchip_mem_s1_end_xfer;
  wire             onchip_mem_s1_firsttransfer;
  wire    [  3: 0] onchip_mem_s1_grant_vector;
  wire             onchip_mem_s1_in_a_read_cycle;
  wire             onchip_mem_s1_in_a_write_cycle;
  wire    [  3: 0] onchip_mem_s1_master_qreq_vector;
  wire             onchip_mem_s1_non_bursting_master_requests;
  wire    [ 31: 0] onchip_mem_s1_readdata_from_sa;
  reg              onchip_mem_s1_reg_firsttransfer;
  reg     [  3: 0] onchip_mem_s1_saved_chosen_master_vector;
  reg              onchip_mem_s1_slavearbiterlockenable;
  wire             onchip_mem_s1_slavearbiterlockenable2;
  wire             onchip_mem_s1_unreg_firsttransfer;
  wire             onchip_mem_s1_waits_for_read;
  wire             onchip_mem_s1_waits_for_write;
  wire             onchip_mem_s1_write;
  wire    [ 31: 0] onchip_mem_s1_writedata;
  wire             p1_cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register;
  wire             p1_cpu_0_instruction_master_read_data_valid_onchip_mem_s1_shift_register;
  wire             p1_dma_read_master_read_data_valid_onchip_mem_s1_shift_register;
  wire             registered_cpu_0_data_master_read_data_valid_onchip_mem_s1;
  wire    [ 25: 0] shifted_address_to_onchip_mem_s1_from_cpu_0_data_master;
  wire    [ 25: 0] shifted_address_to_onchip_mem_s1_from_cpu_0_instruction_master;
  wire    [ 25: 0] shifted_address_to_onchip_mem_s1_from_dma_read_master;
  wire    [ 25: 0] shifted_address_to_onchip_mem_s1_from_dma_write_master;
  wire             wait_for_onchip_mem_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~onchip_mem_s1_end_xfer;
    end


  assign onchip_mem_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_onchip_mem_s1 | cpu_0_instruction_master_qualified_request_onchip_mem_s1 | dma_read_master_qualified_request_onchip_mem_s1 | dma_write_master_qualified_request_onchip_mem_s1));
  //assign onchip_mem_s1_readdata_from_sa = onchip_mem_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign onchip_mem_s1_readdata_from_sa = onchip_mem_s1_readdata;

  assign cpu_0_data_master_requests_onchip_mem_s1 = ({cpu_0_data_master_address_to_slave[25 : 12] , 12'b0} == 26'h2001000) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //registered rdv signal_name registered_cpu_0_data_master_read_data_valid_onchip_mem_s1 assignment, which is an e_assign
  assign registered_cpu_0_data_master_read_data_valid_onchip_mem_s1 = cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register_in;

  //onchip_mem_s1_arb_share_counter set values, which is an e_mux
  assign onchip_mem_s1_arb_share_set_values = 1;

  //onchip_mem_s1_non_bursting_master_requests mux, which is an e_mux
  assign onchip_mem_s1_non_bursting_master_requests = cpu_0_data_master_requests_onchip_mem_s1 |
    cpu_0_instruction_master_requests_onchip_mem_s1 |
    dma_read_master_requests_onchip_mem_s1 |
    dma_write_master_requests_onchip_mem_s1 |
    cpu_0_data_master_requests_onchip_mem_s1 |
    cpu_0_instruction_master_requests_onchip_mem_s1 |
    dma_read_master_requests_onchip_mem_s1 |
    dma_write_master_requests_onchip_mem_s1 |
    cpu_0_data_master_requests_onchip_mem_s1 |
    cpu_0_instruction_master_requests_onchip_mem_s1 |
    dma_read_master_requests_onchip_mem_s1 |
    dma_write_master_requests_onchip_mem_s1 |
    cpu_0_data_master_requests_onchip_mem_s1 |
    cpu_0_instruction_master_requests_onchip_mem_s1 |
    dma_read_master_requests_onchip_mem_s1 |
    dma_write_master_requests_onchip_mem_s1;

  //onchip_mem_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign onchip_mem_s1_any_bursting_master_saved_grant = 0;

  //onchip_mem_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign onchip_mem_s1_arb_share_counter_next_value = onchip_mem_s1_firsttransfer ? (onchip_mem_s1_arb_share_set_values - 1) : |onchip_mem_s1_arb_share_counter ? (onchip_mem_s1_arb_share_counter - 1) : 0;

  //onchip_mem_s1_allgrants all slave grants, which is an e_mux
  assign onchip_mem_s1_allgrants = |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector |
    |onchip_mem_s1_grant_vector;

  //onchip_mem_s1_end_xfer assignment, which is an e_assign
  assign onchip_mem_s1_end_xfer = ~(onchip_mem_s1_waits_for_read | onchip_mem_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_onchip_mem_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_onchip_mem_s1 = onchip_mem_s1_end_xfer & (~onchip_mem_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //onchip_mem_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign onchip_mem_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_onchip_mem_s1 & onchip_mem_s1_allgrants) | (end_xfer_arb_share_counter_term_onchip_mem_s1 & ~onchip_mem_s1_non_bursting_master_requests);

  //onchip_mem_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          onchip_mem_s1_arb_share_counter <= 0;
      else if (onchip_mem_s1_arb_counter_enable)
          onchip_mem_s1_arb_share_counter <= onchip_mem_s1_arb_share_counter_next_value;
    end


  //onchip_mem_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          onchip_mem_s1_slavearbiterlockenable <= 0;
      else if ((|onchip_mem_s1_master_qreq_vector & end_xfer_arb_share_counter_term_onchip_mem_s1) | (end_xfer_arb_share_counter_term_onchip_mem_s1 & ~onchip_mem_s1_non_bursting_master_requests))
          onchip_mem_s1_slavearbiterlockenable <= |onchip_mem_s1_arb_share_counter_next_value;
    end


  //cpu_0/data_master onchip_mem/s1 arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = onchip_mem_s1_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //onchip_mem_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign onchip_mem_s1_slavearbiterlockenable2 = |onchip_mem_s1_arb_share_counter_next_value;

  //cpu_0/data_master onchip_mem/s1 arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = onchip_mem_s1_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //cpu_0/instruction_master onchip_mem/s1 arbiterlock, which is an e_assign
  assign cpu_0_instruction_master_arbiterlock = onchip_mem_s1_slavearbiterlockenable & cpu_0_instruction_master_continuerequest;

  //cpu_0/instruction_master onchip_mem/s1 arbiterlock2, which is an e_assign
  assign cpu_0_instruction_master_arbiterlock2 = onchip_mem_s1_slavearbiterlockenable2 & cpu_0_instruction_master_continuerequest;

  //cpu_0/instruction_master granted onchip_mem/s1 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_instruction_master_granted_slave_onchip_mem_s1 <= 0;
      else if (1)
          last_cycle_cpu_0_instruction_master_granted_slave_onchip_mem_s1 <= cpu_0_instruction_master_saved_grant_onchip_mem_s1 ? 1 : (onchip_mem_s1_arbitration_holdoff_internal | ~cpu_0_instruction_master_requests_onchip_mem_s1) ? 0 : last_cycle_cpu_0_instruction_master_granted_slave_onchip_mem_s1;
    end


  //cpu_0_instruction_master_continuerequest continued request, which is an e_mux
  assign cpu_0_instruction_master_continuerequest = (last_cycle_cpu_0_instruction_master_granted_slave_onchip_mem_s1 & cpu_0_instruction_master_requests_onchip_mem_s1) |
    (last_cycle_cpu_0_instruction_master_granted_slave_onchip_mem_s1 & cpu_0_instruction_master_requests_onchip_mem_s1) |
    (last_cycle_cpu_0_instruction_master_granted_slave_onchip_mem_s1 & cpu_0_instruction_master_requests_onchip_mem_s1);

  //onchip_mem_s1_any_continuerequest at least one master continues requesting, which is an e_mux
  assign onchip_mem_s1_any_continuerequest = cpu_0_instruction_master_continuerequest |
    dma_read_master_continuerequest |
    dma_write_master_continuerequest |
    cpu_0_data_master_continuerequest |
    dma_read_master_continuerequest |
    dma_write_master_continuerequest |
    cpu_0_data_master_continuerequest |
    cpu_0_instruction_master_continuerequest |
    dma_write_master_continuerequest |
    cpu_0_data_master_continuerequest |
    cpu_0_instruction_master_continuerequest |
    dma_read_master_continuerequest;

  //dma/read_master onchip_mem/s1 arbiterlock, which is an e_assign
  assign dma_read_master_arbiterlock = onchip_mem_s1_slavearbiterlockenable & dma_read_master_continuerequest;

  //dma/read_master onchip_mem/s1 arbiterlock2, which is an e_assign
  assign dma_read_master_arbiterlock2 = onchip_mem_s1_slavearbiterlockenable2 & dma_read_master_continuerequest;

  //dma/read_master granted onchip_mem/s1 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_dma_read_master_granted_slave_onchip_mem_s1 <= 0;
      else if (1)
          last_cycle_dma_read_master_granted_slave_onchip_mem_s1 <= dma_read_master_saved_grant_onchip_mem_s1 ? 1 : (onchip_mem_s1_arbitration_holdoff_internal | ~dma_read_master_requests_onchip_mem_s1) ? 0 : last_cycle_dma_read_master_granted_slave_onchip_mem_s1;
    end


  //dma_read_master_continuerequest continued request, which is an e_mux
  assign dma_read_master_continuerequest = (last_cycle_dma_read_master_granted_slave_onchip_mem_s1 & dma_read_master_requests_onchip_mem_s1) |
    (last_cycle_dma_read_master_granted_slave_onchip_mem_s1 & dma_read_master_requests_onchip_mem_s1) |
    (last_cycle_dma_read_master_granted_slave_onchip_mem_s1 & dma_read_master_requests_onchip_mem_s1);

  //dma/write_master onchip_mem/s1 arbiterlock, which is an e_assign
  assign dma_write_master_arbiterlock = onchip_mem_s1_slavearbiterlockenable & dma_write_master_continuerequest;

  //dma/write_master onchip_mem/s1 arbiterlock2, which is an e_assign
  assign dma_write_master_arbiterlock2 = onchip_mem_s1_slavearbiterlockenable2 & dma_write_master_continuerequest;

  //dma/write_master granted onchip_mem/s1 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_dma_write_master_granted_slave_onchip_mem_s1 <= 0;
      else if (1)
          last_cycle_dma_write_master_granted_slave_onchip_mem_s1 <= dma_write_master_saved_grant_onchip_mem_s1 ? 1 : (onchip_mem_s1_arbitration_holdoff_internal | ~dma_write_master_requests_onchip_mem_s1) ? 0 : last_cycle_dma_write_master_granted_slave_onchip_mem_s1;
    end


  //dma_write_master_continuerequest continued request, which is an e_mux
  assign dma_write_master_continuerequest = (last_cycle_dma_write_master_granted_slave_onchip_mem_s1 & dma_write_master_requests_onchip_mem_s1) |
    (last_cycle_dma_write_master_granted_slave_onchip_mem_s1 & dma_write_master_requests_onchip_mem_s1) |
    (last_cycle_dma_write_master_granted_slave_onchip_mem_s1 & dma_write_master_requests_onchip_mem_s1);

  assign cpu_0_data_master_qualified_request_onchip_mem_s1 = cpu_0_data_master_requests_onchip_mem_s1 & ~((cpu_0_data_master_read & ((|cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register))) | ((~cpu_0_data_master_waitrequest) & cpu_0_data_master_write) | cpu_0_instruction_master_arbiterlock | dma_read_master_arbiterlock | dma_write_master_arbiterlock);
  //cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  assign cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register_in = cpu_0_data_master_granted_onchip_mem_s1 & cpu_0_data_master_read & ~onchip_mem_s1_waits_for_read & ~(|cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register);

  //shift register p1 cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register = {cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register, cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register_in};

  //cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register <= 0;
      else if (1)
          cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register <= p1_cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register;
    end


  //local readdatavalid cpu_0_data_master_read_data_valid_onchip_mem_s1, which is an e_mux
  assign cpu_0_data_master_read_data_valid_onchip_mem_s1 = cpu_0_data_master_read_data_valid_onchip_mem_s1_shift_register;

  //onchip_mem_s1_writedata mux, which is an e_mux
  assign onchip_mem_s1_writedata = (cpu_0_data_master_granted_onchip_mem_s1)? cpu_0_data_master_writedata :
    dma_write_master_writedata;

  //mux onchip_mem_s1_clken, which is an e_mux
  assign onchip_mem_s1_clken = 1'b1;

  assign cpu_0_instruction_master_requests_onchip_mem_s1 = (({cpu_0_instruction_master_address_to_slave[25 : 12] , 12'b0} == 26'h2001000) & (cpu_0_instruction_master_read)) & cpu_0_instruction_master_read;
  //cpu_0/data_master granted onchip_mem/s1 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_data_master_granted_slave_onchip_mem_s1 <= 0;
      else if (1)
          last_cycle_cpu_0_data_master_granted_slave_onchip_mem_s1 <= cpu_0_data_master_saved_grant_onchip_mem_s1 ? 1 : (onchip_mem_s1_arbitration_holdoff_internal | ~cpu_0_data_master_requests_onchip_mem_s1) ? 0 : last_cycle_cpu_0_data_master_granted_slave_onchip_mem_s1;
    end


  //cpu_0_data_master_continuerequest continued request, which is an e_mux
  assign cpu_0_data_master_continuerequest = (last_cycle_cpu_0_data_master_granted_slave_onchip_mem_s1 & cpu_0_data_master_requests_onchip_mem_s1) |
    (last_cycle_cpu_0_data_master_granted_slave_onchip_mem_s1 & cpu_0_data_master_requests_onchip_mem_s1) |
    (last_cycle_cpu_0_data_master_granted_slave_onchip_mem_s1 & cpu_0_data_master_requests_onchip_mem_s1);

  assign cpu_0_instruction_master_qualified_request_onchip_mem_s1 = cpu_0_instruction_master_requests_onchip_mem_s1 & ~((cpu_0_instruction_master_read & ((1 < cpu_0_instruction_master_latency_counter) | (|cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register))) | cpu_0_data_master_arbiterlock | dma_read_master_arbiterlock | dma_write_master_arbiterlock);
  //cpu_0_instruction_master_read_data_valid_onchip_mem_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  assign cpu_0_instruction_master_read_data_valid_onchip_mem_s1_shift_register_in = cpu_0_instruction_master_granted_onchip_mem_s1 & cpu_0_instruction_master_read & ~onchip_mem_s1_waits_for_read;

  //shift register p1 cpu_0_instruction_master_read_data_valid_onchip_mem_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_cpu_0_instruction_master_read_data_valid_onchip_mem_s1_shift_register = {cpu_0_instruction_master_read_data_valid_onchip_mem_s1_shift_register, cpu_0_instruction_master_read_data_valid_onchip_mem_s1_shift_register_in};

  //cpu_0_instruction_master_read_data_valid_onchip_mem_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_instruction_master_read_data_valid_onchip_mem_s1_shift_register <= 0;
      else if (1)
          cpu_0_instruction_master_read_data_valid_onchip_mem_s1_shift_register <= p1_cpu_0_instruction_master_read_data_valid_onchip_mem_s1_shift_register;
    end


  //local readdatavalid cpu_0_instruction_master_read_data_valid_onchip_mem_s1, which is an e_mux
  assign cpu_0_instruction_master_read_data_valid_onchip_mem_s1 = cpu_0_instruction_master_read_data_valid_onchip_mem_s1_shift_register;

  assign dma_read_master_requests_onchip_mem_s1 = (({dma_read_master_address_to_slave[25 : 12] , 12'b0} == 26'h2001000) & dma_read_master_chipselect) & (~dma_read_master_read_n & dma_read_master_chipselect);
  assign dma_read_master_qualified_request_onchip_mem_s1 = dma_read_master_requests_onchip_mem_s1 & ~(((~dma_read_master_read_n & dma_read_master_chipselect) & ((1 < dma_read_master_latency_counter) | (|dma_read_master_read_data_valid_sdram_0_s1_shift_register))) | cpu_0_data_master_arbiterlock | cpu_0_instruction_master_arbiterlock | dma_write_master_arbiterlock);
  //dma_read_master_read_data_valid_onchip_mem_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  assign dma_read_master_read_data_valid_onchip_mem_s1_shift_register_in = dma_read_master_granted_onchip_mem_s1 & (~dma_read_master_read_n & dma_read_master_chipselect) & ~onchip_mem_s1_waits_for_read;

  //shift register p1 dma_read_master_read_data_valid_onchip_mem_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_dma_read_master_read_data_valid_onchip_mem_s1_shift_register = (dma_read_master_flush_qualified_exported)? dma_read_master_read_data_valid_onchip_mem_s1_shift_register_in :
    {dma_read_master_read_data_valid_onchip_mem_s1_shift_register, dma_read_master_read_data_valid_onchip_mem_s1_shift_register_in};

  //dma_read_master_read_data_valid_onchip_mem_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          dma_read_master_read_data_valid_onchip_mem_s1_shift_register <= 0;
      else if (1)
          dma_read_master_read_data_valid_onchip_mem_s1_shift_register <= p1_dma_read_master_read_data_valid_onchip_mem_s1_shift_register;
    end


  //local readdatavalid dma_read_master_read_data_valid_onchip_mem_s1, which is an e_mux
  assign dma_read_master_read_data_valid_onchip_mem_s1 = dma_read_master_read_data_valid_onchip_mem_s1_shift_register;

  assign dma_write_master_requests_onchip_mem_s1 = (({dma_write_master_address_to_slave[25 : 12] , 12'b0} == 26'h2001000) & dma_write_master_chipselect) & (~dma_write_master_write_n & dma_write_master_chipselect);
  assign dma_write_master_qualified_request_onchip_mem_s1 = dma_write_master_requests_onchip_mem_s1 & ~(cpu_0_data_master_arbiterlock | cpu_0_instruction_master_arbiterlock | dma_read_master_arbiterlock);
  //allow new arb cycle for onchip_mem/s1, which is an e_assign
  assign onchip_mem_s1_allow_new_arb_cycle = ~cpu_0_data_master_arbiterlock & ~cpu_0_instruction_master_arbiterlock & ~dma_read_master_arbiterlock & ~dma_write_master_arbiterlock;

  //dma/write_master assignment into master qualified-requests vector for onchip_mem/s1, which is an e_assign
  assign onchip_mem_s1_master_qreq_vector[0] = dma_write_master_qualified_request_onchip_mem_s1;

  //dma/write_master grant onchip_mem/s1, which is an e_assign
  assign dma_write_master_granted_onchip_mem_s1 = onchip_mem_s1_grant_vector[0];

  //dma/write_master saved-grant onchip_mem/s1, which is an e_assign
  assign dma_write_master_saved_grant_onchip_mem_s1 = onchip_mem_s1_arb_winner[0] && dma_write_master_requests_onchip_mem_s1;

  //dma/read_master assignment into master qualified-requests vector for onchip_mem/s1, which is an e_assign
  assign onchip_mem_s1_master_qreq_vector[1] = dma_read_master_qualified_request_onchip_mem_s1;

  //dma/read_master grant onchip_mem/s1, which is an e_assign
  assign dma_read_master_granted_onchip_mem_s1 = onchip_mem_s1_grant_vector[1];

  //dma/read_master saved-grant onchip_mem/s1, which is an e_assign
  assign dma_read_master_saved_grant_onchip_mem_s1 = onchip_mem_s1_arb_winner[1] && dma_read_master_requests_onchip_mem_s1;

  //cpu_0/instruction_master assignment into master qualified-requests vector for onchip_mem/s1, which is an e_assign
  assign onchip_mem_s1_master_qreq_vector[2] = cpu_0_instruction_master_qualified_request_onchip_mem_s1;

  //cpu_0/instruction_master grant onchip_mem/s1, which is an e_assign
  assign cpu_0_instruction_master_granted_onchip_mem_s1 = onchip_mem_s1_grant_vector[2];

  //cpu_0/instruction_master saved-grant onchip_mem/s1, which is an e_assign
  assign cpu_0_instruction_master_saved_grant_onchip_mem_s1 = onchip_mem_s1_arb_winner[2] && cpu_0_instruction_master_requests_onchip_mem_s1;

  //cpu_0/data_master assignment into master qualified-requests vector for onchip_mem/s1, which is an e_assign
  assign onchip_mem_s1_master_qreq_vector[3] = cpu_0_data_master_qualified_request_onchip_mem_s1;

  //cpu_0/data_master grant onchip_mem/s1, which is an e_assign
  assign cpu_0_data_master_granted_onchip_mem_s1 = onchip_mem_s1_grant_vector[3];

  //cpu_0/data_master saved-grant onchip_mem/s1, which is an e_assign
  assign cpu_0_data_master_saved_grant_onchip_mem_s1 = onchip_mem_s1_arb_winner[3] && cpu_0_data_master_requests_onchip_mem_s1;

  //onchip_mem/s1 chosen-master double-vector, which is an e_assign
  assign onchip_mem_s1_chosen_master_double_vector = {onchip_mem_s1_master_qreq_vector, onchip_mem_s1_master_qreq_vector} & ({~onchip_mem_s1_master_qreq_vector, ~onchip_mem_s1_master_qreq_vector} + onchip_mem_s1_arb_addend);

  //stable onehot encoding of arb winner
  assign onchip_mem_s1_arb_winner = (onchip_mem_s1_allow_new_arb_cycle & | onchip_mem_s1_grant_vector) ? onchip_mem_s1_grant_vector : onchip_mem_s1_saved_chosen_master_vector;

  //saved onchip_mem_s1_grant_vector, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          onchip_mem_s1_saved_chosen_master_vector <= 0;
      else if (onchip_mem_s1_allow_new_arb_cycle)
          onchip_mem_s1_saved_chosen_master_vector <= |onchip_mem_s1_grant_vector ? onchip_mem_s1_grant_vector : onchip_mem_s1_saved_chosen_master_vector;
    end


  //onehot encoding of chosen master
  assign onchip_mem_s1_grant_vector = {(onchip_mem_s1_chosen_master_double_vector[3] | onchip_mem_s1_chosen_master_double_vector[7]),
    (onchip_mem_s1_chosen_master_double_vector[2] | onchip_mem_s1_chosen_master_double_vector[6]),
    (onchip_mem_s1_chosen_master_double_vector[1] | onchip_mem_s1_chosen_master_double_vector[5]),
    (onchip_mem_s1_chosen_master_double_vector[0] | onchip_mem_s1_chosen_master_double_vector[4])};

  //onchip_mem/s1 chosen master rotated left, which is an e_assign
  assign onchip_mem_s1_chosen_master_rot_left = (onchip_mem_s1_arb_winner << 1) ? (onchip_mem_s1_arb_winner << 1) : 1;

  //onchip_mem/s1's addend for next-master-grant
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          onchip_mem_s1_arb_addend <= 1;
      else if (|onchip_mem_s1_grant_vector)
          onchip_mem_s1_arb_addend <= onchip_mem_s1_end_xfer? onchip_mem_s1_chosen_master_rot_left : onchip_mem_s1_grant_vector;
    end


  assign onchip_mem_s1_chipselect = cpu_0_data_master_granted_onchip_mem_s1 | cpu_0_instruction_master_granted_onchip_mem_s1 | dma_read_master_granted_onchip_mem_s1 | dma_write_master_granted_onchip_mem_s1;
  //onchip_mem_s1_firsttransfer first transaction, which is an e_assign
  assign onchip_mem_s1_firsttransfer = onchip_mem_s1_begins_xfer ? onchip_mem_s1_unreg_firsttransfer : onchip_mem_s1_reg_firsttransfer;

  //onchip_mem_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign onchip_mem_s1_unreg_firsttransfer = ~(onchip_mem_s1_slavearbiterlockenable & onchip_mem_s1_any_continuerequest);

  //onchip_mem_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          onchip_mem_s1_reg_firsttransfer <= 1'b1;
      else if (onchip_mem_s1_begins_xfer)
          onchip_mem_s1_reg_firsttransfer <= onchip_mem_s1_unreg_firsttransfer;
    end


  //onchip_mem_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign onchip_mem_s1_beginbursttransfer_internal = onchip_mem_s1_begins_xfer;

  //onchip_mem_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  assign onchip_mem_s1_arbitration_holdoff_internal = onchip_mem_s1_begins_xfer & onchip_mem_s1_firsttransfer;

  //onchip_mem_s1_write assignment, which is an e_mux
  assign onchip_mem_s1_write = (cpu_0_data_master_granted_onchip_mem_s1 & cpu_0_data_master_write) | (dma_write_master_granted_onchip_mem_s1 & (~dma_write_master_write_n & dma_write_master_chipselect));

  assign shifted_address_to_onchip_mem_s1_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //onchip_mem_s1_address mux, which is an e_mux
  assign onchip_mem_s1_address = (cpu_0_data_master_granted_onchip_mem_s1)? (shifted_address_to_onchip_mem_s1_from_cpu_0_data_master >> 2) :
    (cpu_0_instruction_master_granted_onchip_mem_s1)? (shifted_address_to_onchip_mem_s1_from_cpu_0_instruction_master >> 2) :
    (dma_read_master_granted_onchip_mem_s1)? (shifted_address_to_onchip_mem_s1_from_dma_read_master >> 2) :
    (shifted_address_to_onchip_mem_s1_from_dma_write_master >> 2);

  assign shifted_address_to_onchip_mem_s1_from_cpu_0_instruction_master = cpu_0_instruction_master_address_to_slave;
  assign shifted_address_to_onchip_mem_s1_from_dma_read_master = dma_read_master_address_to_slave;
  assign shifted_address_to_onchip_mem_s1_from_dma_write_master = dma_write_master_address_to_slave;
  //d1_onchip_mem_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_onchip_mem_s1_end_xfer <= 1;
      else if (1)
          d1_onchip_mem_s1_end_xfer <= onchip_mem_s1_end_xfer;
    end


  //onchip_mem_s1_waits_for_read in a cycle, which is an e_mux
  assign onchip_mem_s1_waits_for_read = onchip_mem_s1_in_a_read_cycle & 0;

  //onchip_mem_s1_in_a_read_cycle assignment, which is an e_assign
  assign onchip_mem_s1_in_a_read_cycle = (cpu_0_data_master_granted_onchip_mem_s1 & cpu_0_data_master_read) | (cpu_0_instruction_master_granted_onchip_mem_s1 & cpu_0_instruction_master_read) | (dma_read_master_granted_onchip_mem_s1 & (~dma_read_master_read_n & dma_read_master_chipselect));

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = onchip_mem_s1_in_a_read_cycle;

  //onchip_mem_s1_waits_for_write in a cycle, which is an e_mux
  assign onchip_mem_s1_waits_for_write = onchip_mem_s1_in_a_write_cycle & 0;

  //onchip_mem_s1_in_a_write_cycle assignment, which is an e_assign
  assign onchip_mem_s1_in_a_write_cycle = (cpu_0_data_master_granted_onchip_mem_s1 & cpu_0_data_master_write) | (dma_write_master_granted_onchip_mem_s1 & (~dma_write_master_write_n & dma_write_master_chipselect));

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = onchip_mem_s1_in_a_write_cycle;

  assign wait_for_onchip_mem_s1_counter = 0;
  //onchip_mem_s1_byteenable byte enable port mux, which is an e_mux
  assign onchip_mem_s1_byteenable = (cpu_0_data_master_granted_onchip_mem_s1)? cpu_0_data_master_byteenable :
    (dma_write_master_granted_onchip_mem_s1)? dma_write_master_byteenable :
    -1;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //onchip_mem/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end


  //grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_0_data_master_granted_onchip_mem_s1 + cpu_0_instruction_master_granted_onchip_mem_s1 + dma_read_master_granted_onchip_mem_s1 + dma_write_master_granted_onchip_mem_s1 > 1)
        begin
          $write("%0d ns: > 1 of grant signals are active simultaneously", $time);
          $stop;
        end
    end


  //saved_grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_0_data_master_saved_grant_onchip_mem_s1 + cpu_0_instruction_master_saved_grant_onchip_mem_s1 + dma_read_master_saved_grant_onchip_mem_s1 + dma_write_master_saved_grant_onchip_mem_s1 > 1)
        begin
          $write("%0d ns: > 1 of saved_grant signals are active simultaneously", $time);
          $stop;
        end
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module performance_counter_control_slave_arbitrator (
                                                      // inputs:
                                                       clk,
                                                       cpu_0_data_master_address_to_slave,
                                                       cpu_0_data_master_read,
                                                       cpu_0_data_master_waitrequest,
                                                       cpu_0_data_master_write,
                                                       cpu_0_data_master_writedata,
                                                       performance_counter_control_slave_readdata,
                                                       reset_n,

                                                      // outputs:
                                                       cpu_0_data_master_granted_performance_counter_control_slave,
                                                       cpu_0_data_master_qualified_request_performance_counter_control_slave,
                                                       cpu_0_data_master_read_data_valid_performance_counter_control_slave,
                                                       cpu_0_data_master_requests_performance_counter_control_slave,
                                                       d1_performance_counter_control_slave_end_xfer,
                                                       performance_counter_control_slave_address,
                                                       performance_counter_control_slave_begintransfer,
                                                       performance_counter_control_slave_readdata_from_sa,
                                                       performance_counter_control_slave_reset_n,
                                                       performance_counter_control_slave_write,
                                                       performance_counter_control_slave_writedata,
                                                       registered_cpu_0_data_master_read_data_valid_performance_counter_control_slave
                                                    )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_performance_counter_control_slave;
  output           cpu_0_data_master_qualified_request_performance_counter_control_slave;
  output           cpu_0_data_master_read_data_valid_performance_counter_control_slave;
  output           cpu_0_data_master_requests_performance_counter_control_slave;
  output           d1_performance_counter_control_slave_end_xfer;
  output  [  3: 0] performance_counter_control_slave_address;
  output           performance_counter_control_slave_begintransfer;
  output  [ 31: 0] performance_counter_control_slave_readdata_from_sa;
  output           performance_counter_control_slave_reset_n;
  output           performance_counter_control_slave_write;
  output  [ 31: 0] performance_counter_control_slave_writedata;
  output           registered_cpu_0_data_master_read_data_valid_performance_counter_control_slave;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input   [ 31: 0] performance_counter_control_slave_readdata;
  input            reset_n;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_performance_counter_control_slave;
  wire             cpu_0_data_master_qualified_request_performance_counter_control_slave;
  wire             cpu_0_data_master_read_data_valid_performance_counter_control_slave;
  reg              cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register;
  wire             cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register_in;
  wire             cpu_0_data_master_requests_performance_counter_control_slave;
  wire             cpu_0_data_master_saved_grant_performance_counter_control_slave;
  reg              d1_performance_counter_control_slave_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_performance_counter_control_slave;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire             p1_cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register;
  wire    [  3: 0] performance_counter_control_slave_address;
  wire             performance_counter_control_slave_allgrants;
  wire             performance_counter_control_slave_allow_new_arb_cycle;
  wire             performance_counter_control_slave_any_bursting_master_saved_grant;
  wire             performance_counter_control_slave_any_continuerequest;
  wire             performance_counter_control_slave_arb_counter_enable;
  reg     [  2: 0] performance_counter_control_slave_arb_share_counter;
  wire    [  2: 0] performance_counter_control_slave_arb_share_counter_next_value;
  wire    [  2: 0] performance_counter_control_slave_arb_share_set_values;
  wire             performance_counter_control_slave_beginbursttransfer_internal;
  wire             performance_counter_control_slave_begins_xfer;
  wire             performance_counter_control_slave_begintransfer;
  wire             performance_counter_control_slave_end_xfer;
  wire             performance_counter_control_slave_firsttransfer;
  wire             performance_counter_control_slave_grant_vector;
  wire             performance_counter_control_slave_in_a_read_cycle;
  wire             performance_counter_control_slave_in_a_write_cycle;
  wire             performance_counter_control_slave_master_qreq_vector;
  wire             performance_counter_control_slave_non_bursting_master_requests;
  wire    [ 31: 0] performance_counter_control_slave_readdata_from_sa;
  reg              performance_counter_control_slave_reg_firsttransfer;
  wire             performance_counter_control_slave_reset_n;
  reg              performance_counter_control_slave_slavearbiterlockenable;
  wire             performance_counter_control_slave_slavearbiterlockenable2;
  wire             performance_counter_control_slave_unreg_firsttransfer;
  wire             performance_counter_control_slave_waits_for_read;
  wire             performance_counter_control_slave_waits_for_write;
  wire             performance_counter_control_slave_write;
  wire    [ 31: 0] performance_counter_control_slave_writedata;
  wire             registered_cpu_0_data_master_read_data_valid_performance_counter_control_slave;
  wire    [ 25: 0] shifted_address_to_performance_counter_control_slave_from_cpu_0_data_master;
  wire             wait_for_performance_counter_control_slave_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~performance_counter_control_slave_end_xfer;
    end


  assign performance_counter_control_slave_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_performance_counter_control_slave));
  //assign performance_counter_control_slave_readdata_from_sa = performance_counter_control_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign performance_counter_control_slave_readdata_from_sa = performance_counter_control_slave_readdata;

  assign cpu_0_data_master_requests_performance_counter_control_slave = ({cpu_0_data_master_address_to_slave[25 : 6] , 6'b0} == 26'h0) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //registered rdv signal_name registered_cpu_0_data_master_read_data_valid_performance_counter_control_slave assignment, which is an e_assign
  assign registered_cpu_0_data_master_read_data_valid_performance_counter_control_slave = cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register_in;

  //performance_counter_control_slave_arb_share_counter set values, which is an e_mux
  assign performance_counter_control_slave_arb_share_set_values = 1;

  //performance_counter_control_slave_non_bursting_master_requests mux, which is an e_mux
  assign performance_counter_control_slave_non_bursting_master_requests = cpu_0_data_master_requests_performance_counter_control_slave;

  //performance_counter_control_slave_any_bursting_master_saved_grant mux, which is an e_mux
  assign performance_counter_control_slave_any_bursting_master_saved_grant = 0;

  //performance_counter_control_slave_arb_share_counter_next_value assignment, which is an e_assign
  assign performance_counter_control_slave_arb_share_counter_next_value = performance_counter_control_slave_firsttransfer ? (performance_counter_control_slave_arb_share_set_values - 1) : |performance_counter_control_slave_arb_share_counter ? (performance_counter_control_slave_arb_share_counter - 1) : 0;

  //performance_counter_control_slave_allgrants all slave grants, which is an e_mux
  assign performance_counter_control_slave_allgrants = |performance_counter_control_slave_grant_vector;

  //performance_counter_control_slave_end_xfer assignment, which is an e_assign
  assign performance_counter_control_slave_end_xfer = ~(performance_counter_control_slave_waits_for_read | performance_counter_control_slave_waits_for_write);

  //end_xfer_arb_share_counter_term_performance_counter_control_slave arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_performance_counter_control_slave = performance_counter_control_slave_end_xfer & (~performance_counter_control_slave_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //performance_counter_control_slave_arb_share_counter arbitration counter enable, which is an e_assign
  assign performance_counter_control_slave_arb_counter_enable = (end_xfer_arb_share_counter_term_performance_counter_control_slave & performance_counter_control_slave_allgrants) | (end_xfer_arb_share_counter_term_performance_counter_control_slave & ~performance_counter_control_slave_non_bursting_master_requests);

  //performance_counter_control_slave_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          performance_counter_control_slave_arb_share_counter <= 0;
      else if (performance_counter_control_slave_arb_counter_enable)
          performance_counter_control_slave_arb_share_counter <= performance_counter_control_slave_arb_share_counter_next_value;
    end


  //performance_counter_control_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          performance_counter_control_slave_slavearbiterlockenable <= 0;
      else if ((|performance_counter_control_slave_master_qreq_vector & end_xfer_arb_share_counter_term_performance_counter_control_slave) | (end_xfer_arb_share_counter_term_performance_counter_control_slave & ~performance_counter_control_slave_non_bursting_master_requests))
          performance_counter_control_slave_slavearbiterlockenable <= |performance_counter_control_slave_arb_share_counter_next_value;
    end


  //cpu_0/data_master performance_counter/control_slave arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = performance_counter_control_slave_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //performance_counter_control_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign performance_counter_control_slave_slavearbiterlockenable2 = |performance_counter_control_slave_arb_share_counter_next_value;

  //cpu_0/data_master performance_counter/control_slave arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = performance_counter_control_slave_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //performance_counter_control_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  assign performance_counter_control_slave_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_performance_counter_control_slave = cpu_0_data_master_requests_performance_counter_control_slave & ~((cpu_0_data_master_read & ((|cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register))) | ((~cpu_0_data_master_waitrequest) & cpu_0_data_master_write));
  //cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register_in mux for readlatency shift register, which is an e_mux
  assign cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register_in = cpu_0_data_master_granted_performance_counter_control_slave & cpu_0_data_master_read & ~performance_counter_control_slave_waits_for_read & ~(|cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register);

  //shift register p1 cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register = {cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register, cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register_in};

  //cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register <= 0;
      else if (1)
          cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register <= p1_cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register;
    end


  //local readdatavalid cpu_0_data_master_read_data_valid_performance_counter_control_slave, which is an e_mux
  assign cpu_0_data_master_read_data_valid_performance_counter_control_slave = cpu_0_data_master_read_data_valid_performance_counter_control_slave_shift_register;

  //performance_counter_control_slave_writedata mux, which is an e_mux
  assign performance_counter_control_slave_writedata = cpu_0_data_master_writedata;

  //master is always granted when requested
  assign cpu_0_data_master_granted_performance_counter_control_slave = cpu_0_data_master_qualified_request_performance_counter_control_slave;

  //cpu_0/data_master saved-grant performance_counter/control_slave, which is an e_assign
  assign cpu_0_data_master_saved_grant_performance_counter_control_slave = cpu_0_data_master_requests_performance_counter_control_slave;

  //allow new arb cycle for performance_counter/control_slave, which is an e_assign
  assign performance_counter_control_slave_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign performance_counter_control_slave_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign performance_counter_control_slave_master_qreq_vector = 1;

  assign performance_counter_control_slave_begintransfer = performance_counter_control_slave_begins_xfer;
  //performance_counter_control_slave_reset_n assignment, which is an e_assign
  assign performance_counter_control_slave_reset_n = reset_n;

  //performance_counter_control_slave_firsttransfer first transaction, which is an e_assign
  assign performance_counter_control_slave_firsttransfer = performance_counter_control_slave_begins_xfer ? performance_counter_control_slave_unreg_firsttransfer : performance_counter_control_slave_reg_firsttransfer;

  //performance_counter_control_slave_unreg_firsttransfer first transaction, which is an e_assign
  assign performance_counter_control_slave_unreg_firsttransfer = ~(performance_counter_control_slave_slavearbiterlockenable & performance_counter_control_slave_any_continuerequest);

  //performance_counter_control_slave_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          performance_counter_control_slave_reg_firsttransfer <= 1'b1;
      else if (performance_counter_control_slave_begins_xfer)
          performance_counter_control_slave_reg_firsttransfer <= performance_counter_control_slave_unreg_firsttransfer;
    end


  //performance_counter_control_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign performance_counter_control_slave_beginbursttransfer_internal = performance_counter_control_slave_begins_xfer;

  //performance_counter_control_slave_write assignment, which is an e_mux
  assign performance_counter_control_slave_write = cpu_0_data_master_granted_performance_counter_control_slave & cpu_0_data_master_write;

  assign shifted_address_to_performance_counter_control_slave_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //performance_counter_control_slave_address mux, which is an e_mux
  assign performance_counter_control_slave_address = shifted_address_to_performance_counter_control_slave_from_cpu_0_data_master >> 2;

  //d1_performance_counter_control_slave_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_performance_counter_control_slave_end_xfer <= 1;
      else if (1)
          d1_performance_counter_control_slave_end_xfer <= performance_counter_control_slave_end_xfer;
    end


  //performance_counter_control_slave_waits_for_read in a cycle, which is an e_mux
  assign performance_counter_control_slave_waits_for_read = performance_counter_control_slave_in_a_read_cycle & 0;

  //performance_counter_control_slave_in_a_read_cycle assignment, which is an e_assign
  assign performance_counter_control_slave_in_a_read_cycle = cpu_0_data_master_granted_performance_counter_control_slave & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = performance_counter_control_slave_in_a_read_cycle;

  //performance_counter_control_slave_waits_for_write in a cycle, which is an e_mux
  assign performance_counter_control_slave_waits_for_write = performance_counter_control_slave_in_a_write_cycle & 0;

  //performance_counter_control_slave_in_a_write_cycle assignment, which is an e_assign
  assign performance_counter_control_slave_in_a_write_cycle = cpu_0_data_master_granted_performance_counter_control_slave & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = performance_counter_control_slave_in_a_write_cycle;

  assign wait_for_performance_counter_control_slave_counter = 0;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //performance_counter/control_slave enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module pio_beep_s1_arbitrator (
                                // inputs:
                                 clk,
                                 cpu_0_data_master_address_to_slave,
                                 cpu_0_data_master_read,
                                 cpu_0_data_master_waitrequest,
                                 cpu_0_data_master_write,
                                 cpu_0_data_master_writedata,
                                 reset_n,

                                // outputs:
                                 cpu_0_data_master_granted_pio_beep_s1,
                                 cpu_0_data_master_qualified_request_pio_beep_s1,
                                 cpu_0_data_master_read_data_valid_pio_beep_s1,
                                 cpu_0_data_master_requests_pio_beep_s1,
                                 d1_pio_beep_s1_end_xfer,
                                 pio_beep_s1_address,
                                 pio_beep_s1_chipselect,
                                 pio_beep_s1_reset_n,
                                 pio_beep_s1_write_n,
                                 pio_beep_s1_writedata
                              )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_pio_beep_s1;
  output           cpu_0_data_master_qualified_request_pio_beep_s1;
  output           cpu_0_data_master_read_data_valid_pio_beep_s1;
  output           cpu_0_data_master_requests_pio_beep_s1;
  output           d1_pio_beep_s1_end_xfer;
  output  [  1: 0] pio_beep_s1_address;
  output           pio_beep_s1_chipselect;
  output           pio_beep_s1_reset_n;
  output           pio_beep_s1_write_n;
  output           pio_beep_s1_writedata;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input            reset_n;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_pio_beep_s1;
  wire             cpu_0_data_master_qualified_request_pio_beep_s1;
  wire             cpu_0_data_master_read_data_valid_pio_beep_s1;
  wire             cpu_0_data_master_requests_pio_beep_s1;
  wire             cpu_0_data_master_saved_grant_pio_beep_s1;
  reg              d1_pio_beep_s1_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_pio_beep_s1;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [  1: 0] pio_beep_s1_address;
  wire             pio_beep_s1_allgrants;
  wire             pio_beep_s1_allow_new_arb_cycle;
  wire             pio_beep_s1_any_bursting_master_saved_grant;
  wire             pio_beep_s1_any_continuerequest;
  wire             pio_beep_s1_arb_counter_enable;
  reg     [  2: 0] pio_beep_s1_arb_share_counter;
  wire    [  2: 0] pio_beep_s1_arb_share_counter_next_value;
  wire    [  2: 0] pio_beep_s1_arb_share_set_values;
  wire             pio_beep_s1_beginbursttransfer_internal;
  wire             pio_beep_s1_begins_xfer;
  wire             pio_beep_s1_chipselect;
  wire             pio_beep_s1_end_xfer;
  wire             pio_beep_s1_firsttransfer;
  wire             pio_beep_s1_grant_vector;
  wire             pio_beep_s1_in_a_read_cycle;
  wire             pio_beep_s1_in_a_write_cycle;
  wire             pio_beep_s1_master_qreq_vector;
  wire             pio_beep_s1_non_bursting_master_requests;
  reg              pio_beep_s1_reg_firsttransfer;
  wire             pio_beep_s1_reset_n;
  reg              pio_beep_s1_slavearbiterlockenable;
  wire             pio_beep_s1_slavearbiterlockenable2;
  wire             pio_beep_s1_unreg_firsttransfer;
  wire             pio_beep_s1_waits_for_read;
  wire             pio_beep_s1_waits_for_write;
  wire             pio_beep_s1_write_n;
  wire             pio_beep_s1_writedata;
  wire    [ 25: 0] shifted_address_to_pio_beep_s1_from_cpu_0_data_master;
  wire             wait_for_pio_beep_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~pio_beep_s1_end_xfer;
    end


  assign pio_beep_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_pio_beep_s1));
  assign cpu_0_data_master_requests_pio_beep_s1 = (({cpu_0_data_master_address_to_slave[25 : 4] , 4'b0} == 26'h20032f0) & (cpu_0_data_master_read | cpu_0_data_master_write)) & cpu_0_data_master_write;
  //pio_beep_s1_arb_share_counter set values, which is an e_mux
  assign pio_beep_s1_arb_share_set_values = 1;

  //pio_beep_s1_non_bursting_master_requests mux, which is an e_mux
  assign pio_beep_s1_non_bursting_master_requests = cpu_0_data_master_requests_pio_beep_s1;

  //pio_beep_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign pio_beep_s1_any_bursting_master_saved_grant = 0;

  //pio_beep_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign pio_beep_s1_arb_share_counter_next_value = pio_beep_s1_firsttransfer ? (pio_beep_s1_arb_share_set_values - 1) : |pio_beep_s1_arb_share_counter ? (pio_beep_s1_arb_share_counter - 1) : 0;

  //pio_beep_s1_allgrants all slave grants, which is an e_mux
  assign pio_beep_s1_allgrants = |pio_beep_s1_grant_vector;

  //pio_beep_s1_end_xfer assignment, which is an e_assign
  assign pio_beep_s1_end_xfer = ~(pio_beep_s1_waits_for_read | pio_beep_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_pio_beep_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_pio_beep_s1 = pio_beep_s1_end_xfer & (~pio_beep_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //pio_beep_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign pio_beep_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_pio_beep_s1 & pio_beep_s1_allgrants) | (end_xfer_arb_share_counter_term_pio_beep_s1 & ~pio_beep_s1_non_bursting_master_requests);

  //pio_beep_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          pio_beep_s1_arb_share_counter <= 0;
      else if (pio_beep_s1_arb_counter_enable)
          pio_beep_s1_arb_share_counter <= pio_beep_s1_arb_share_counter_next_value;
    end


  //pio_beep_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          pio_beep_s1_slavearbiterlockenable <= 0;
      else if ((|pio_beep_s1_master_qreq_vector & end_xfer_arb_share_counter_term_pio_beep_s1) | (end_xfer_arb_share_counter_term_pio_beep_s1 & ~pio_beep_s1_non_bursting_master_requests))
          pio_beep_s1_slavearbiterlockenable <= |pio_beep_s1_arb_share_counter_next_value;
    end


  //cpu_0/data_master pio_beep/s1 arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = pio_beep_s1_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //pio_beep_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign pio_beep_s1_slavearbiterlockenable2 = |pio_beep_s1_arb_share_counter_next_value;

  //cpu_0/data_master pio_beep/s1 arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = pio_beep_s1_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //pio_beep_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  assign pio_beep_s1_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_pio_beep_s1 = cpu_0_data_master_requests_pio_beep_s1 & ~(((~cpu_0_data_master_waitrequest) & cpu_0_data_master_write));
  //pio_beep_s1_writedata mux, which is an e_mux
  assign pio_beep_s1_writedata = cpu_0_data_master_writedata;

  //master is always granted when requested
  assign cpu_0_data_master_granted_pio_beep_s1 = cpu_0_data_master_qualified_request_pio_beep_s1;

  //cpu_0/data_master saved-grant pio_beep/s1, which is an e_assign
  assign cpu_0_data_master_saved_grant_pio_beep_s1 = cpu_0_data_master_requests_pio_beep_s1;

  //allow new arb cycle for pio_beep/s1, which is an e_assign
  assign pio_beep_s1_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign pio_beep_s1_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign pio_beep_s1_master_qreq_vector = 1;

  //pio_beep_s1_reset_n assignment, which is an e_assign
  assign pio_beep_s1_reset_n = reset_n;

  assign pio_beep_s1_chipselect = cpu_0_data_master_granted_pio_beep_s1;
  //pio_beep_s1_firsttransfer first transaction, which is an e_assign
  assign pio_beep_s1_firsttransfer = pio_beep_s1_begins_xfer ? pio_beep_s1_unreg_firsttransfer : pio_beep_s1_reg_firsttransfer;

  //pio_beep_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign pio_beep_s1_unreg_firsttransfer = ~(pio_beep_s1_slavearbiterlockenable & pio_beep_s1_any_continuerequest);

  //pio_beep_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          pio_beep_s1_reg_firsttransfer <= 1'b1;
      else if (pio_beep_s1_begins_xfer)
          pio_beep_s1_reg_firsttransfer <= pio_beep_s1_unreg_firsttransfer;
    end


  //pio_beep_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign pio_beep_s1_beginbursttransfer_internal = pio_beep_s1_begins_xfer;

  //~pio_beep_s1_write_n assignment, which is an e_mux
  assign pio_beep_s1_write_n = ~(cpu_0_data_master_granted_pio_beep_s1 & cpu_0_data_master_write);

  assign shifted_address_to_pio_beep_s1_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //pio_beep_s1_address mux, which is an e_mux
  assign pio_beep_s1_address = shifted_address_to_pio_beep_s1_from_cpu_0_data_master >> 2;

  //d1_pio_beep_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_pio_beep_s1_end_xfer <= 1;
      else if (1)
          d1_pio_beep_s1_end_xfer <= pio_beep_s1_end_xfer;
    end


  //pio_beep_s1_waits_for_read in a cycle, which is an e_mux
  assign pio_beep_s1_waits_for_read = pio_beep_s1_in_a_read_cycle & pio_beep_s1_begins_xfer;

  //pio_beep_s1_in_a_read_cycle assignment, which is an e_assign
  assign pio_beep_s1_in_a_read_cycle = cpu_0_data_master_granted_pio_beep_s1 & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = pio_beep_s1_in_a_read_cycle;

  //pio_beep_s1_waits_for_write in a cycle, which is an e_mux
  assign pio_beep_s1_waits_for_write = pio_beep_s1_in_a_write_cycle & 0;

  //pio_beep_s1_in_a_write_cycle assignment, which is an e_assign
  assign pio_beep_s1_in_a_write_cycle = cpu_0_data_master_granted_pio_beep_s1 & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = pio_beep_s1_in_a_write_cycle;

  assign wait_for_pio_beep_s1_counter = 0;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //pio_beep/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module pio_key_s1_arbitrator (
                               // inputs:
                                clk,
                                cpu_0_data_master_address_to_slave,
                                cpu_0_data_master_read,
                                cpu_0_data_master_waitrequest,
                                cpu_0_data_master_write,
                                cpu_0_data_master_writedata,
                                pio_key_s1_irq,
                                pio_key_s1_readdata,
                                reset_n,

                               // outputs:
                                cpu_0_data_master_granted_pio_key_s1,
                                cpu_0_data_master_qualified_request_pio_key_s1,
                                cpu_0_data_master_read_data_valid_pio_key_s1,
                                cpu_0_data_master_requests_pio_key_s1,
                                d1_pio_key_s1_end_xfer,
                                pio_key_s1_address,
                                pio_key_s1_chipselect,
                                pio_key_s1_irq_from_sa,
                                pio_key_s1_readdata_from_sa,
                                pio_key_s1_reset_n,
                                pio_key_s1_write_n,
                                pio_key_s1_writedata
                             )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_pio_key_s1;
  output           cpu_0_data_master_qualified_request_pio_key_s1;
  output           cpu_0_data_master_read_data_valid_pio_key_s1;
  output           cpu_0_data_master_requests_pio_key_s1;
  output           d1_pio_key_s1_end_xfer;
  output  [  1: 0] pio_key_s1_address;
  output           pio_key_s1_chipselect;
  output           pio_key_s1_irq_from_sa;
  output  [  3: 0] pio_key_s1_readdata_from_sa;
  output           pio_key_s1_reset_n;
  output           pio_key_s1_write_n;
  output  [  3: 0] pio_key_s1_writedata;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input            pio_key_s1_irq;
  input   [  3: 0] pio_key_s1_readdata;
  input            reset_n;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_pio_key_s1;
  wire             cpu_0_data_master_qualified_request_pio_key_s1;
  wire             cpu_0_data_master_read_data_valid_pio_key_s1;
  wire             cpu_0_data_master_requests_pio_key_s1;
  wire             cpu_0_data_master_saved_grant_pio_key_s1;
  reg              d1_pio_key_s1_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_pio_key_s1;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [  1: 0] pio_key_s1_address;
  wire             pio_key_s1_allgrants;
  wire             pio_key_s1_allow_new_arb_cycle;
  wire             pio_key_s1_any_bursting_master_saved_grant;
  wire             pio_key_s1_any_continuerequest;
  wire             pio_key_s1_arb_counter_enable;
  reg     [  2: 0] pio_key_s1_arb_share_counter;
  wire    [  2: 0] pio_key_s1_arb_share_counter_next_value;
  wire    [  2: 0] pio_key_s1_arb_share_set_values;
  wire             pio_key_s1_beginbursttransfer_internal;
  wire             pio_key_s1_begins_xfer;
  wire             pio_key_s1_chipselect;
  wire             pio_key_s1_end_xfer;
  wire             pio_key_s1_firsttransfer;
  wire             pio_key_s1_grant_vector;
  wire             pio_key_s1_in_a_read_cycle;
  wire             pio_key_s1_in_a_write_cycle;
  wire             pio_key_s1_irq_from_sa;
  wire             pio_key_s1_master_qreq_vector;
  wire             pio_key_s1_non_bursting_master_requests;
  wire    [  3: 0] pio_key_s1_readdata_from_sa;
  reg              pio_key_s1_reg_firsttransfer;
  wire             pio_key_s1_reset_n;
  reg              pio_key_s1_slavearbiterlockenable;
  wire             pio_key_s1_slavearbiterlockenable2;
  wire             pio_key_s1_unreg_firsttransfer;
  wire             pio_key_s1_waits_for_read;
  wire             pio_key_s1_waits_for_write;
  wire             pio_key_s1_write_n;
  wire    [  3: 0] pio_key_s1_writedata;
  wire    [ 25: 0] shifted_address_to_pio_key_s1_from_cpu_0_data_master;
  wire             wait_for_pio_key_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~pio_key_s1_end_xfer;
    end


  assign pio_key_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_pio_key_s1));
  //assign pio_key_s1_readdata_from_sa = pio_key_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign pio_key_s1_readdata_from_sa = pio_key_s1_readdata;

  assign cpu_0_data_master_requests_pio_key_s1 = ({cpu_0_data_master_address_to_slave[25 : 4] , 4'b0} == 26'h2003300) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //pio_key_s1_arb_share_counter set values, which is an e_mux
  assign pio_key_s1_arb_share_set_values = 1;

  //pio_key_s1_non_bursting_master_requests mux, which is an e_mux
  assign pio_key_s1_non_bursting_master_requests = cpu_0_data_master_requests_pio_key_s1;

  //pio_key_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign pio_key_s1_any_bursting_master_saved_grant = 0;

  //pio_key_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign pio_key_s1_arb_share_counter_next_value = pio_key_s1_firsttransfer ? (pio_key_s1_arb_share_set_values - 1) : |pio_key_s1_arb_share_counter ? (pio_key_s1_arb_share_counter - 1) : 0;

  //pio_key_s1_allgrants all slave grants, which is an e_mux
  assign pio_key_s1_allgrants = |pio_key_s1_grant_vector;

  //pio_key_s1_end_xfer assignment, which is an e_assign
  assign pio_key_s1_end_xfer = ~(pio_key_s1_waits_for_read | pio_key_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_pio_key_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_pio_key_s1 = pio_key_s1_end_xfer & (~pio_key_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //pio_key_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign pio_key_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_pio_key_s1 & pio_key_s1_allgrants) | (end_xfer_arb_share_counter_term_pio_key_s1 & ~pio_key_s1_non_bursting_master_requests);

  //pio_key_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          pio_key_s1_arb_share_counter <= 0;
      else if (pio_key_s1_arb_counter_enable)
          pio_key_s1_arb_share_counter <= pio_key_s1_arb_share_counter_next_value;
    end


  //pio_key_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          pio_key_s1_slavearbiterlockenable <= 0;
      else if ((|pio_key_s1_master_qreq_vector & end_xfer_arb_share_counter_term_pio_key_s1) | (end_xfer_arb_share_counter_term_pio_key_s1 & ~pio_key_s1_non_bursting_master_requests))
          pio_key_s1_slavearbiterlockenable <= |pio_key_s1_arb_share_counter_next_value;
    end


  //cpu_0/data_master pio_key/s1 arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = pio_key_s1_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //pio_key_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign pio_key_s1_slavearbiterlockenable2 = |pio_key_s1_arb_share_counter_next_value;

  //cpu_0/data_master pio_key/s1 arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = pio_key_s1_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //pio_key_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  assign pio_key_s1_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_pio_key_s1 = cpu_0_data_master_requests_pio_key_s1 & ~(((~cpu_0_data_master_waitrequest) & cpu_0_data_master_write));
  //pio_key_s1_writedata mux, which is an e_mux
  assign pio_key_s1_writedata = cpu_0_data_master_writedata;

  //master is always granted when requested
  assign cpu_0_data_master_granted_pio_key_s1 = cpu_0_data_master_qualified_request_pio_key_s1;

  //cpu_0/data_master saved-grant pio_key/s1, which is an e_assign
  assign cpu_0_data_master_saved_grant_pio_key_s1 = cpu_0_data_master_requests_pio_key_s1;

  //allow new arb cycle for pio_key/s1, which is an e_assign
  assign pio_key_s1_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign pio_key_s1_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign pio_key_s1_master_qreq_vector = 1;

  //pio_key_s1_reset_n assignment, which is an e_assign
  assign pio_key_s1_reset_n = reset_n;

  assign pio_key_s1_chipselect = cpu_0_data_master_granted_pio_key_s1;
  //pio_key_s1_firsttransfer first transaction, which is an e_assign
  assign pio_key_s1_firsttransfer = pio_key_s1_begins_xfer ? pio_key_s1_unreg_firsttransfer : pio_key_s1_reg_firsttransfer;

  //pio_key_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign pio_key_s1_unreg_firsttransfer = ~(pio_key_s1_slavearbiterlockenable & pio_key_s1_any_continuerequest);

  //pio_key_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          pio_key_s1_reg_firsttransfer <= 1'b1;
      else if (pio_key_s1_begins_xfer)
          pio_key_s1_reg_firsttransfer <= pio_key_s1_unreg_firsttransfer;
    end


  //pio_key_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign pio_key_s1_beginbursttransfer_internal = pio_key_s1_begins_xfer;

  //~pio_key_s1_write_n assignment, which is an e_mux
  assign pio_key_s1_write_n = ~(cpu_0_data_master_granted_pio_key_s1 & cpu_0_data_master_write);

  assign shifted_address_to_pio_key_s1_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //pio_key_s1_address mux, which is an e_mux
  assign pio_key_s1_address = shifted_address_to_pio_key_s1_from_cpu_0_data_master >> 2;

  //d1_pio_key_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_pio_key_s1_end_xfer <= 1;
      else if (1)
          d1_pio_key_s1_end_xfer <= pio_key_s1_end_xfer;
    end


  //pio_key_s1_waits_for_read in a cycle, which is an e_mux
  assign pio_key_s1_waits_for_read = pio_key_s1_in_a_read_cycle & pio_key_s1_begins_xfer;

  //pio_key_s1_in_a_read_cycle assignment, which is an e_assign
  assign pio_key_s1_in_a_read_cycle = cpu_0_data_master_granted_pio_key_s1 & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = pio_key_s1_in_a_read_cycle;

  //pio_key_s1_waits_for_write in a cycle, which is an e_mux
  assign pio_key_s1_waits_for_write = pio_key_s1_in_a_write_cycle & 0;

  //pio_key_s1_in_a_write_cycle assignment, which is an e_assign
  assign pio_key_s1_in_a_write_cycle = cpu_0_data_master_granted_pio_key_s1 & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = pio_key_s1_in_a_write_cycle;

  assign wait_for_pio_key_s1_counter = 0;
  //assign pio_key_s1_irq_from_sa = pio_key_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign pio_key_s1_irq_from_sa = pio_key_s1_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //pio_key/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module pio_led_s1_arbitrator (
                               // inputs:
                                clk,
                                cpu_0_data_master_address_to_slave,
                                cpu_0_data_master_read,
                                cpu_0_data_master_waitrequest,
                                cpu_0_data_master_write,
                                cpu_0_data_master_writedata,
                                reset_n,

                               // outputs:
                                cpu_0_data_master_granted_pio_led_s1,
                                cpu_0_data_master_qualified_request_pio_led_s1,
                                cpu_0_data_master_read_data_valid_pio_led_s1,
                                cpu_0_data_master_requests_pio_led_s1,
                                d1_pio_led_s1_end_xfer,
                                pio_led_s1_address,
                                pio_led_s1_chipselect,
                                pio_led_s1_reset_n,
                                pio_led_s1_write_n,
                                pio_led_s1_writedata
                             )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_pio_led_s1;
  output           cpu_0_data_master_qualified_request_pio_led_s1;
  output           cpu_0_data_master_read_data_valid_pio_led_s1;
  output           cpu_0_data_master_requests_pio_led_s1;
  output           d1_pio_led_s1_end_xfer;
  output  [  1: 0] pio_led_s1_address;
  output           pio_led_s1_chipselect;
  output           pio_led_s1_reset_n;
  output           pio_led_s1_write_n;
  output  [  3: 0] pio_led_s1_writedata;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input            reset_n;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_pio_led_s1;
  wire             cpu_0_data_master_qualified_request_pio_led_s1;
  wire             cpu_0_data_master_read_data_valid_pio_led_s1;
  wire             cpu_0_data_master_requests_pio_led_s1;
  wire             cpu_0_data_master_saved_grant_pio_led_s1;
  reg              d1_pio_led_s1_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_pio_led_s1;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [  1: 0] pio_led_s1_address;
  wire             pio_led_s1_allgrants;
  wire             pio_led_s1_allow_new_arb_cycle;
  wire             pio_led_s1_any_bursting_master_saved_grant;
  wire             pio_led_s1_any_continuerequest;
  wire             pio_led_s1_arb_counter_enable;
  reg     [  2: 0] pio_led_s1_arb_share_counter;
  wire    [  2: 0] pio_led_s1_arb_share_counter_next_value;
  wire    [  2: 0] pio_led_s1_arb_share_set_values;
  wire             pio_led_s1_beginbursttransfer_internal;
  wire             pio_led_s1_begins_xfer;
  wire             pio_led_s1_chipselect;
  wire             pio_led_s1_end_xfer;
  wire             pio_led_s1_firsttransfer;
  wire             pio_led_s1_grant_vector;
  wire             pio_led_s1_in_a_read_cycle;
  wire             pio_led_s1_in_a_write_cycle;
  wire             pio_led_s1_master_qreq_vector;
  wire             pio_led_s1_non_bursting_master_requests;
  reg              pio_led_s1_reg_firsttransfer;
  wire             pio_led_s1_reset_n;
  reg              pio_led_s1_slavearbiterlockenable;
  wire             pio_led_s1_slavearbiterlockenable2;
  wire             pio_led_s1_unreg_firsttransfer;
  wire             pio_led_s1_waits_for_read;
  wire             pio_led_s1_waits_for_write;
  wire             pio_led_s1_write_n;
  wire    [  3: 0] pio_led_s1_writedata;
  wire    [ 25: 0] shifted_address_to_pio_led_s1_from_cpu_0_data_master;
  wire             wait_for_pio_led_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~pio_led_s1_end_xfer;
    end


  assign pio_led_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_pio_led_s1));
  assign cpu_0_data_master_requests_pio_led_s1 = (({cpu_0_data_master_address_to_slave[25 : 4] , 4'b0} == 26'h20032e0) & (cpu_0_data_master_read | cpu_0_data_master_write)) & cpu_0_data_master_write;
  //pio_led_s1_arb_share_counter set values, which is an e_mux
  assign pio_led_s1_arb_share_set_values = 1;

  //pio_led_s1_non_bursting_master_requests mux, which is an e_mux
  assign pio_led_s1_non_bursting_master_requests = cpu_0_data_master_requests_pio_led_s1;

  //pio_led_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign pio_led_s1_any_bursting_master_saved_grant = 0;

  //pio_led_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign pio_led_s1_arb_share_counter_next_value = pio_led_s1_firsttransfer ? (pio_led_s1_arb_share_set_values - 1) : |pio_led_s1_arb_share_counter ? (pio_led_s1_arb_share_counter - 1) : 0;

  //pio_led_s1_allgrants all slave grants, which is an e_mux
  assign pio_led_s1_allgrants = |pio_led_s1_grant_vector;

  //pio_led_s1_end_xfer assignment, which is an e_assign
  assign pio_led_s1_end_xfer = ~(pio_led_s1_waits_for_read | pio_led_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_pio_led_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_pio_led_s1 = pio_led_s1_end_xfer & (~pio_led_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //pio_led_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign pio_led_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_pio_led_s1 & pio_led_s1_allgrants) | (end_xfer_arb_share_counter_term_pio_led_s1 & ~pio_led_s1_non_bursting_master_requests);

  //pio_led_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          pio_led_s1_arb_share_counter <= 0;
      else if (pio_led_s1_arb_counter_enable)
          pio_led_s1_arb_share_counter <= pio_led_s1_arb_share_counter_next_value;
    end


  //pio_led_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          pio_led_s1_slavearbiterlockenable <= 0;
      else if ((|pio_led_s1_master_qreq_vector & end_xfer_arb_share_counter_term_pio_led_s1) | (end_xfer_arb_share_counter_term_pio_led_s1 & ~pio_led_s1_non_bursting_master_requests))
          pio_led_s1_slavearbiterlockenable <= |pio_led_s1_arb_share_counter_next_value;
    end


  //cpu_0/data_master pio_led/s1 arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = pio_led_s1_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //pio_led_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign pio_led_s1_slavearbiterlockenable2 = |pio_led_s1_arb_share_counter_next_value;

  //cpu_0/data_master pio_led/s1 arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = pio_led_s1_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //pio_led_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  assign pio_led_s1_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_pio_led_s1 = cpu_0_data_master_requests_pio_led_s1 & ~(((~cpu_0_data_master_waitrequest) & cpu_0_data_master_write));
  //pio_led_s1_writedata mux, which is an e_mux
  assign pio_led_s1_writedata = cpu_0_data_master_writedata;

  //master is always granted when requested
  assign cpu_0_data_master_granted_pio_led_s1 = cpu_0_data_master_qualified_request_pio_led_s1;

  //cpu_0/data_master saved-grant pio_led/s1, which is an e_assign
  assign cpu_0_data_master_saved_grant_pio_led_s1 = cpu_0_data_master_requests_pio_led_s1;

  //allow new arb cycle for pio_led/s1, which is an e_assign
  assign pio_led_s1_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign pio_led_s1_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign pio_led_s1_master_qreq_vector = 1;

  //pio_led_s1_reset_n assignment, which is an e_assign
  assign pio_led_s1_reset_n = reset_n;

  assign pio_led_s1_chipselect = cpu_0_data_master_granted_pio_led_s1;
  //pio_led_s1_firsttransfer first transaction, which is an e_assign
  assign pio_led_s1_firsttransfer = pio_led_s1_begins_xfer ? pio_led_s1_unreg_firsttransfer : pio_led_s1_reg_firsttransfer;

  //pio_led_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign pio_led_s1_unreg_firsttransfer = ~(pio_led_s1_slavearbiterlockenable & pio_led_s1_any_continuerequest);

  //pio_led_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          pio_led_s1_reg_firsttransfer <= 1'b1;
      else if (pio_led_s1_begins_xfer)
          pio_led_s1_reg_firsttransfer <= pio_led_s1_unreg_firsttransfer;
    end


  //pio_led_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign pio_led_s1_beginbursttransfer_internal = pio_led_s1_begins_xfer;

  //~pio_led_s1_write_n assignment, which is an e_mux
  assign pio_led_s1_write_n = ~(cpu_0_data_master_granted_pio_led_s1 & cpu_0_data_master_write);

  assign shifted_address_to_pio_led_s1_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //pio_led_s1_address mux, which is an e_mux
  assign pio_led_s1_address = shifted_address_to_pio_led_s1_from_cpu_0_data_master >> 2;

  //d1_pio_led_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_pio_led_s1_end_xfer <= 1;
      else if (1)
          d1_pio_led_s1_end_xfer <= pio_led_s1_end_xfer;
    end


  //pio_led_s1_waits_for_read in a cycle, which is an e_mux
  assign pio_led_s1_waits_for_read = pio_led_s1_in_a_read_cycle & pio_led_s1_begins_xfer;

  //pio_led_s1_in_a_read_cycle assignment, which is an e_assign
  assign pio_led_s1_in_a_read_cycle = cpu_0_data_master_granted_pio_led_s1 & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = pio_led_s1_in_a_read_cycle;

  //pio_led_s1_waits_for_write in a cycle, which is an e_mux
  assign pio_led_s1_waits_for_write = pio_led_s1_in_a_write_cycle & 0;

  //pio_led_s1_in_a_write_cycle assignment, which is an e_assign
  assign pio_led_s1_in_a_write_cycle = cpu_0_data_master_granted_pio_led_s1 & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = pio_led_s1_in_a_write_cycle;

  assign wait_for_pio_led_s1_counter = 0;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //pio_led/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module ps2_0_avalon_slave_0_arbitrator (
                                         // inputs:
                                          clk,
                                          cpu_0_data_master_address_to_slave,
                                          cpu_0_data_master_dbs_address,
                                          cpu_0_data_master_read,
                                          cpu_0_data_master_waitrequest,
                                          cpu_0_data_master_write,
                                          ps2_0_avalon_slave_0_irq,
                                          ps2_0_avalon_slave_0_readdata,
                                          reset_n,

                                         // outputs:
                                          cpu_0_data_master_granted_ps2_0_avalon_slave_0,
                                          cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0,
                                          cpu_0_data_master_read_data_valid_ps2_0_avalon_slave_0,
                                          cpu_0_data_master_requests_ps2_0_avalon_slave_0,
                                          d1_ps2_0_avalon_slave_0_end_xfer,
                                          ps2_0_avalon_slave_0_irq_from_sa,
                                          ps2_0_avalon_slave_0_read_n,
                                          ps2_0_avalon_slave_0_readdata_from_sa
                                       )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_ps2_0_avalon_slave_0;
  output           cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0;
  output           cpu_0_data_master_read_data_valid_ps2_0_avalon_slave_0;
  output           cpu_0_data_master_requests_ps2_0_avalon_slave_0;
  output           d1_ps2_0_avalon_slave_0_end_xfer;
  output           ps2_0_avalon_slave_0_irq_from_sa;
  output           ps2_0_avalon_slave_0_read_n;
  output  [ 15: 0] ps2_0_avalon_slave_0_readdata_from_sa;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input   [  1: 0] cpu_0_data_master_dbs_address;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input            ps2_0_avalon_slave_0_irq;
  input   [ 15: 0] ps2_0_avalon_slave_0_readdata;
  input            reset_n;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_ps2_0_avalon_slave_0;
  wire             cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0;
  wire             cpu_0_data_master_read_data_valid_ps2_0_avalon_slave_0;
  wire             cpu_0_data_master_requests_ps2_0_avalon_slave_0;
  wire             cpu_0_data_master_saved_grant_ps2_0_avalon_slave_0;
  reg              d1_ps2_0_avalon_slave_0_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_ps2_0_avalon_slave_0;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire             ps2_0_avalon_slave_0_allgrants;
  wire             ps2_0_avalon_slave_0_allow_new_arb_cycle;
  wire             ps2_0_avalon_slave_0_any_bursting_master_saved_grant;
  wire             ps2_0_avalon_slave_0_any_continuerequest;
  wire             ps2_0_avalon_slave_0_arb_counter_enable;
  reg     [  2: 0] ps2_0_avalon_slave_0_arb_share_counter;
  wire    [  2: 0] ps2_0_avalon_slave_0_arb_share_counter_next_value;
  wire    [  2: 0] ps2_0_avalon_slave_0_arb_share_set_values;
  wire             ps2_0_avalon_slave_0_beginbursttransfer_internal;
  wire             ps2_0_avalon_slave_0_begins_xfer;
  wire             ps2_0_avalon_slave_0_end_xfer;
  wire             ps2_0_avalon_slave_0_firsttransfer;
  wire             ps2_0_avalon_slave_0_grant_vector;
  wire             ps2_0_avalon_slave_0_in_a_read_cycle;
  wire             ps2_0_avalon_slave_0_in_a_write_cycle;
  wire             ps2_0_avalon_slave_0_irq_from_sa;
  wire             ps2_0_avalon_slave_0_master_qreq_vector;
  wire             ps2_0_avalon_slave_0_non_bursting_master_requests;
  wire             ps2_0_avalon_slave_0_read_n;
  wire    [ 15: 0] ps2_0_avalon_slave_0_readdata_from_sa;
  reg              ps2_0_avalon_slave_0_reg_firsttransfer;
  reg              ps2_0_avalon_slave_0_slavearbiterlockenable;
  wire             ps2_0_avalon_slave_0_slavearbiterlockenable2;
  wire             ps2_0_avalon_slave_0_unreg_firsttransfer;
  wire             ps2_0_avalon_slave_0_waits_for_read;
  wire             ps2_0_avalon_slave_0_waits_for_write;
  wire    [ 25: 0] shifted_address_to_ps2_0_avalon_slave_0_from_cpu_0_data_master;
  wire             wait_for_ps2_0_avalon_slave_0_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~ps2_0_avalon_slave_0_end_xfer;
    end


  assign ps2_0_avalon_slave_0_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0));
  //assign ps2_0_avalon_slave_0_readdata_from_sa = ps2_0_avalon_slave_0_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign ps2_0_avalon_slave_0_readdata_from_sa = ps2_0_avalon_slave_0_readdata;

  assign cpu_0_data_master_requests_ps2_0_avalon_slave_0 = (({cpu_0_data_master_address_to_slave[25 : 1] , 1'b0} == 26'h2003350) & (cpu_0_data_master_read | cpu_0_data_master_write)) & cpu_0_data_master_read;
  //ps2_0_avalon_slave_0_arb_share_counter set values, which is an e_mux
  assign ps2_0_avalon_slave_0_arb_share_set_values = (cpu_0_data_master_granted_ps2_0_avalon_slave_0)? 2 :
    1;

  //ps2_0_avalon_slave_0_non_bursting_master_requests mux, which is an e_mux
  assign ps2_0_avalon_slave_0_non_bursting_master_requests = cpu_0_data_master_requests_ps2_0_avalon_slave_0;

  //ps2_0_avalon_slave_0_any_bursting_master_saved_grant mux, which is an e_mux
  assign ps2_0_avalon_slave_0_any_bursting_master_saved_grant = 0;

  //ps2_0_avalon_slave_0_arb_share_counter_next_value assignment, which is an e_assign
  assign ps2_0_avalon_slave_0_arb_share_counter_next_value = ps2_0_avalon_slave_0_firsttransfer ? (ps2_0_avalon_slave_0_arb_share_set_values - 1) : |ps2_0_avalon_slave_0_arb_share_counter ? (ps2_0_avalon_slave_0_arb_share_counter - 1) : 0;

  //ps2_0_avalon_slave_0_allgrants all slave grants, which is an e_mux
  assign ps2_0_avalon_slave_0_allgrants = |ps2_0_avalon_slave_0_grant_vector;

  //ps2_0_avalon_slave_0_end_xfer assignment, which is an e_assign
  assign ps2_0_avalon_slave_0_end_xfer = ~(ps2_0_avalon_slave_0_waits_for_read | ps2_0_avalon_slave_0_waits_for_write);

  //end_xfer_arb_share_counter_term_ps2_0_avalon_slave_0 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_ps2_0_avalon_slave_0 = ps2_0_avalon_slave_0_end_xfer & (~ps2_0_avalon_slave_0_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //ps2_0_avalon_slave_0_arb_share_counter arbitration counter enable, which is an e_assign
  assign ps2_0_avalon_slave_0_arb_counter_enable = (end_xfer_arb_share_counter_term_ps2_0_avalon_slave_0 & ps2_0_avalon_slave_0_allgrants) | (end_xfer_arb_share_counter_term_ps2_0_avalon_slave_0 & ~ps2_0_avalon_slave_0_non_bursting_master_requests);

  //ps2_0_avalon_slave_0_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          ps2_0_avalon_slave_0_arb_share_counter <= 0;
      else if (ps2_0_avalon_slave_0_arb_counter_enable)
          ps2_0_avalon_slave_0_arb_share_counter <= ps2_0_avalon_slave_0_arb_share_counter_next_value;
    end


  //ps2_0_avalon_slave_0_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          ps2_0_avalon_slave_0_slavearbiterlockenable <= 0;
      else if ((|ps2_0_avalon_slave_0_master_qreq_vector & end_xfer_arb_share_counter_term_ps2_0_avalon_slave_0) | (end_xfer_arb_share_counter_term_ps2_0_avalon_slave_0 & ~ps2_0_avalon_slave_0_non_bursting_master_requests))
          ps2_0_avalon_slave_0_slavearbiterlockenable <= |ps2_0_avalon_slave_0_arb_share_counter_next_value;
    end


  //cpu_0/data_master ps2_0/avalon_slave_0 arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = ps2_0_avalon_slave_0_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //ps2_0_avalon_slave_0_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign ps2_0_avalon_slave_0_slavearbiterlockenable2 = |ps2_0_avalon_slave_0_arb_share_counter_next_value;

  //cpu_0/data_master ps2_0/avalon_slave_0 arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = ps2_0_avalon_slave_0_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //ps2_0_avalon_slave_0_any_continuerequest at least one master continues requesting, which is an e_assign
  assign ps2_0_avalon_slave_0_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0 = cpu_0_data_master_requests_ps2_0_avalon_slave_0 & ~((cpu_0_data_master_read & (~cpu_0_data_master_waitrequest)));
  //master is always granted when requested
  assign cpu_0_data_master_granted_ps2_0_avalon_slave_0 = cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0;

  //cpu_0/data_master saved-grant ps2_0/avalon_slave_0, which is an e_assign
  assign cpu_0_data_master_saved_grant_ps2_0_avalon_slave_0 = cpu_0_data_master_requests_ps2_0_avalon_slave_0;

  //allow new arb cycle for ps2_0/avalon_slave_0, which is an e_assign
  assign ps2_0_avalon_slave_0_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign ps2_0_avalon_slave_0_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign ps2_0_avalon_slave_0_master_qreq_vector = 1;

  //ps2_0_avalon_slave_0_firsttransfer first transaction, which is an e_assign
  assign ps2_0_avalon_slave_0_firsttransfer = ps2_0_avalon_slave_0_begins_xfer ? ps2_0_avalon_slave_0_unreg_firsttransfer : ps2_0_avalon_slave_0_reg_firsttransfer;

  //ps2_0_avalon_slave_0_unreg_firsttransfer first transaction, which is an e_assign
  assign ps2_0_avalon_slave_0_unreg_firsttransfer = ~(ps2_0_avalon_slave_0_slavearbiterlockenable & ps2_0_avalon_slave_0_any_continuerequest);

  //ps2_0_avalon_slave_0_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          ps2_0_avalon_slave_0_reg_firsttransfer <= 1'b1;
      else if (ps2_0_avalon_slave_0_begins_xfer)
          ps2_0_avalon_slave_0_reg_firsttransfer <= ps2_0_avalon_slave_0_unreg_firsttransfer;
    end


  //ps2_0_avalon_slave_0_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign ps2_0_avalon_slave_0_beginbursttransfer_internal = ps2_0_avalon_slave_0_begins_xfer;

  //~ps2_0_avalon_slave_0_read_n assignment, which is an e_mux
  assign ps2_0_avalon_slave_0_read_n = ~(cpu_0_data_master_granted_ps2_0_avalon_slave_0 & cpu_0_data_master_read);

  assign shifted_address_to_ps2_0_avalon_slave_0_from_cpu_0_data_master = {cpu_0_data_master_address_to_slave >> 2,
    cpu_0_data_master_dbs_address[1],
    {1 {1'b0}}};

  //d1_ps2_0_avalon_slave_0_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_ps2_0_avalon_slave_0_end_xfer <= 1;
      else if (1)
          d1_ps2_0_avalon_slave_0_end_xfer <= ps2_0_avalon_slave_0_end_xfer;
    end


  //ps2_0_avalon_slave_0_waits_for_read in a cycle, which is an e_mux
  assign ps2_0_avalon_slave_0_waits_for_read = ps2_0_avalon_slave_0_in_a_read_cycle & 0;

  //ps2_0_avalon_slave_0_in_a_read_cycle assignment, which is an e_assign
  assign ps2_0_avalon_slave_0_in_a_read_cycle = cpu_0_data_master_granted_ps2_0_avalon_slave_0 & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = ps2_0_avalon_slave_0_in_a_read_cycle;

  //ps2_0_avalon_slave_0_waits_for_write in a cycle, which is an e_mux
  assign ps2_0_avalon_slave_0_waits_for_write = ps2_0_avalon_slave_0_in_a_write_cycle & 0;

  //ps2_0_avalon_slave_0_in_a_write_cycle assignment, which is an e_assign
  assign ps2_0_avalon_slave_0_in_a_write_cycle = cpu_0_data_master_granted_ps2_0_avalon_slave_0 & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = ps2_0_avalon_slave_0_in_a_write_cycle;

  assign wait_for_ps2_0_avalon_slave_0_counter = 0;
  //assign ps2_0_avalon_slave_0_irq_from_sa = ps2_0_avalon_slave_0_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign ps2_0_avalon_slave_0_irq_from_sa = ps2_0_avalon_slave_0_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //ps2_0/avalon_slave_0 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module nios_reset_clk_domain_synch_module (
                                            // inputs:
                                             clk,
                                             data_in,
                                             reset_n,

                                            // outputs:
                                             data_out
                                          )
;

  output           data_out;
  input            clk;
  input            data_in;
  input            reset_n;

  reg              data_in_d1 /* synthesis ALTERA_ATTRIBUTE = "MAX_DELAY=\"100ns\" ; PRESERVE_REGISTER=ON ; SUPPRESS_DA_RULE_INTERNAL=R101"  */;
  reg              data_out /* synthesis ALTERA_ATTRIBUTE = "PRESERVE_REGISTER=ON ; SUPPRESS_DA_RULE_INTERNAL=R101"  */;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          data_in_d1 <= 0;
      else if (1)
          data_in_d1 <= data_in;
    end


  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          data_out <= 0;
      else if (1)
          data_out <= data_in_d1;
    end



endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module pwm_interface_0_control_slave_arbitrator (
                                                  // inputs:
                                                   clk,
                                                   cpu_0_data_master_address_to_slave,
                                                   cpu_0_data_master_read,
                                                   cpu_0_data_master_waitrequest,
                                                   cpu_0_data_master_write,
                                                   cpu_0_data_master_writedata,
                                                   pwm_interface_0_control_slave_readdata,
                                                   reset_n,

                                                  // outputs:
                                                   cpu_0_data_master_granted_pwm_interface_0_control_slave,
                                                   cpu_0_data_master_qualified_request_pwm_interface_0_control_slave,
                                                   cpu_0_data_master_read_data_valid_pwm_interface_0_control_slave,
                                                   cpu_0_data_master_requests_pwm_interface_0_control_slave,
                                                   d1_pwm_interface_0_control_slave_end_xfer,
                                                   pwm_interface_0_control_slave_address,
                                                   pwm_interface_0_control_slave_chipselect,
                                                   pwm_interface_0_control_slave_read,
                                                   pwm_interface_0_control_slave_readdata_from_sa,
                                                   pwm_interface_0_control_slave_write,
                                                   pwm_interface_0_control_slave_writedata
                                                )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_pwm_interface_0_control_slave;
  output           cpu_0_data_master_qualified_request_pwm_interface_0_control_slave;
  output           cpu_0_data_master_read_data_valid_pwm_interface_0_control_slave;
  output           cpu_0_data_master_requests_pwm_interface_0_control_slave;
  output           d1_pwm_interface_0_control_slave_end_xfer;
  output  [  1: 0] pwm_interface_0_control_slave_address;
  output           pwm_interface_0_control_slave_chipselect;
  output           pwm_interface_0_control_slave_read;
  output  [ 31: 0] pwm_interface_0_control_slave_readdata_from_sa;
  output           pwm_interface_0_control_slave_write;
  output  [ 31: 0] pwm_interface_0_control_slave_writedata;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input   [ 31: 0] pwm_interface_0_control_slave_readdata;
  input            reset_n;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_pwm_interface_0_control_slave;
  wire             cpu_0_data_master_qualified_request_pwm_interface_0_control_slave;
  wire             cpu_0_data_master_read_data_valid_pwm_interface_0_control_slave;
  wire             cpu_0_data_master_requests_pwm_interface_0_control_slave;
  wire             cpu_0_data_master_saved_grant_pwm_interface_0_control_slave;
  reg              d1_pwm_interface_0_control_slave_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_pwm_interface_0_control_slave;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [  1: 0] pwm_interface_0_control_slave_address;
  wire             pwm_interface_0_control_slave_allgrants;
  wire             pwm_interface_0_control_slave_allow_new_arb_cycle;
  wire             pwm_interface_0_control_slave_any_bursting_master_saved_grant;
  wire             pwm_interface_0_control_slave_any_continuerequest;
  wire             pwm_interface_0_control_slave_arb_counter_enable;
  reg     [  2: 0] pwm_interface_0_control_slave_arb_share_counter;
  wire    [  2: 0] pwm_interface_0_control_slave_arb_share_counter_next_value;
  wire    [  2: 0] pwm_interface_0_control_slave_arb_share_set_values;
  wire             pwm_interface_0_control_slave_beginbursttransfer_internal;
  wire             pwm_interface_0_control_slave_begins_xfer;
  wire             pwm_interface_0_control_slave_chipselect;
  wire             pwm_interface_0_control_slave_end_xfer;
  wire             pwm_interface_0_control_slave_firsttransfer;
  wire             pwm_interface_0_control_slave_grant_vector;
  wire             pwm_interface_0_control_slave_in_a_read_cycle;
  wire             pwm_interface_0_control_slave_in_a_write_cycle;
  wire             pwm_interface_0_control_slave_master_qreq_vector;
  wire             pwm_interface_0_control_slave_non_bursting_master_requests;
  wire             pwm_interface_0_control_slave_read;
  wire    [ 31: 0] pwm_interface_0_control_slave_readdata_from_sa;
  reg              pwm_interface_0_control_slave_reg_firsttransfer;
  reg              pwm_interface_0_control_slave_slavearbiterlockenable;
  wire             pwm_interface_0_control_slave_slavearbiterlockenable2;
  wire             pwm_interface_0_control_slave_unreg_firsttransfer;
  wire             pwm_interface_0_control_slave_waits_for_read;
  wire             pwm_interface_0_control_slave_waits_for_write;
  wire             pwm_interface_0_control_slave_write;
  wire    [ 31: 0] pwm_interface_0_control_slave_writedata;
  wire    [ 25: 0] shifted_address_to_pwm_interface_0_control_slave_from_cpu_0_data_master;
  wire             wait_for_pwm_interface_0_control_slave_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~pwm_interface_0_control_slave_end_xfer;
    end


  assign pwm_interface_0_control_slave_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_pwm_interface_0_control_slave));
  //assign pwm_interface_0_control_slave_readdata_from_sa = pwm_interface_0_control_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign pwm_interface_0_control_slave_readdata_from_sa = pwm_interface_0_control_slave_readdata;

  assign cpu_0_data_master_requests_pwm_interface_0_control_slave = ({cpu_0_data_master_address_to_slave[25 : 4] , 4'b0} == 26'h2003320) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //pwm_interface_0_control_slave_arb_share_counter set values, which is an e_mux
  assign pwm_interface_0_control_slave_arb_share_set_values = 1;

  //pwm_interface_0_control_slave_non_bursting_master_requests mux, which is an e_mux
  assign pwm_interface_0_control_slave_non_bursting_master_requests = cpu_0_data_master_requests_pwm_interface_0_control_slave;

  //pwm_interface_0_control_slave_any_bursting_master_saved_grant mux, which is an e_mux
  assign pwm_interface_0_control_slave_any_bursting_master_saved_grant = 0;

  //pwm_interface_0_control_slave_arb_share_counter_next_value assignment, which is an e_assign
  assign pwm_interface_0_control_slave_arb_share_counter_next_value = pwm_interface_0_control_slave_firsttransfer ? (pwm_interface_0_control_slave_arb_share_set_values - 1) : |pwm_interface_0_control_slave_arb_share_counter ? (pwm_interface_0_control_slave_arb_share_counter - 1) : 0;

  //pwm_interface_0_control_slave_allgrants all slave grants, which is an e_mux
  assign pwm_interface_0_control_slave_allgrants = |pwm_interface_0_control_slave_grant_vector;

  //pwm_interface_0_control_slave_end_xfer assignment, which is an e_assign
  assign pwm_interface_0_control_slave_end_xfer = ~(pwm_interface_0_control_slave_waits_for_read | pwm_interface_0_control_slave_waits_for_write);

  //end_xfer_arb_share_counter_term_pwm_interface_0_control_slave arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_pwm_interface_0_control_slave = pwm_interface_0_control_slave_end_xfer & (~pwm_interface_0_control_slave_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //pwm_interface_0_control_slave_arb_share_counter arbitration counter enable, which is an e_assign
  assign pwm_interface_0_control_slave_arb_counter_enable = (end_xfer_arb_share_counter_term_pwm_interface_0_control_slave & pwm_interface_0_control_slave_allgrants) | (end_xfer_arb_share_counter_term_pwm_interface_0_control_slave & ~pwm_interface_0_control_slave_non_bursting_master_requests);

  //pwm_interface_0_control_slave_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          pwm_interface_0_control_slave_arb_share_counter <= 0;
      else if (pwm_interface_0_control_slave_arb_counter_enable)
          pwm_interface_0_control_slave_arb_share_counter <= pwm_interface_0_control_slave_arb_share_counter_next_value;
    end


  //pwm_interface_0_control_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          pwm_interface_0_control_slave_slavearbiterlockenable <= 0;
      else if ((|pwm_interface_0_control_slave_master_qreq_vector & end_xfer_arb_share_counter_term_pwm_interface_0_control_slave) | (end_xfer_arb_share_counter_term_pwm_interface_0_control_slave & ~pwm_interface_0_control_slave_non_bursting_master_requests))
          pwm_interface_0_control_slave_slavearbiterlockenable <= |pwm_interface_0_control_slave_arb_share_counter_next_value;
    end


  //cpu_0/data_master pwm_interface_0/control_slave arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = pwm_interface_0_control_slave_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //pwm_interface_0_control_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign pwm_interface_0_control_slave_slavearbiterlockenable2 = |pwm_interface_0_control_slave_arb_share_counter_next_value;

  //cpu_0/data_master pwm_interface_0/control_slave arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = pwm_interface_0_control_slave_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //pwm_interface_0_control_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  assign pwm_interface_0_control_slave_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_pwm_interface_0_control_slave = cpu_0_data_master_requests_pwm_interface_0_control_slave & ~((cpu_0_data_master_read & (~cpu_0_data_master_waitrequest)) | ((~cpu_0_data_master_waitrequest) & cpu_0_data_master_write));
  //pwm_interface_0_control_slave_writedata mux, which is an e_mux
  assign pwm_interface_0_control_slave_writedata = cpu_0_data_master_writedata;

  //master is always granted when requested
  assign cpu_0_data_master_granted_pwm_interface_0_control_slave = cpu_0_data_master_qualified_request_pwm_interface_0_control_slave;

  //cpu_0/data_master saved-grant pwm_interface_0/control_slave, which is an e_assign
  assign cpu_0_data_master_saved_grant_pwm_interface_0_control_slave = cpu_0_data_master_requests_pwm_interface_0_control_slave;

  //allow new arb cycle for pwm_interface_0/control_slave, which is an e_assign
  assign pwm_interface_0_control_slave_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign pwm_interface_0_control_slave_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign pwm_interface_0_control_slave_master_qreq_vector = 1;

  assign pwm_interface_0_control_slave_chipselect = cpu_0_data_master_granted_pwm_interface_0_control_slave;
  //pwm_interface_0_control_slave_firsttransfer first transaction, which is an e_assign
  assign pwm_interface_0_control_slave_firsttransfer = pwm_interface_0_control_slave_begins_xfer ? pwm_interface_0_control_slave_unreg_firsttransfer : pwm_interface_0_control_slave_reg_firsttransfer;

  //pwm_interface_0_control_slave_unreg_firsttransfer first transaction, which is an e_assign
  assign pwm_interface_0_control_slave_unreg_firsttransfer = ~(pwm_interface_0_control_slave_slavearbiterlockenable & pwm_interface_0_control_slave_any_continuerequest);

  //pwm_interface_0_control_slave_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          pwm_interface_0_control_slave_reg_firsttransfer <= 1'b1;
      else if (pwm_interface_0_control_slave_begins_xfer)
          pwm_interface_0_control_slave_reg_firsttransfer <= pwm_interface_0_control_slave_unreg_firsttransfer;
    end


  //pwm_interface_0_control_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign pwm_interface_0_control_slave_beginbursttransfer_internal = pwm_interface_0_control_slave_begins_xfer;

  //pwm_interface_0_control_slave_read assignment, which is an e_mux
  assign pwm_interface_0_control_slave_read = cpu_0_data_master_granted_pwm_interface_0_control_slave & cpu_0_data_master_read;

  //pwm_interface_0_control_slave_write assignment, which is an e_mux
  assign pwm_interface_0_control_slave_write = cpu_0_data_master_granted_pwm_interface_0_control_slave & cpu_0_data_master_write;

  assign shifted_address_to_pwm_interface_0_control_slave_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //pwm_interface_0_control_slave_address mux, which is an e_mux
  assign pwm_interface_0_control_slave_address = shifted_address_to_pwm_interface_0_control_slave_from_cpu_0_data_master >> 2;

  //d1_pwm_interface_0_control_slave_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_pwm_interface_0_control_slave_end_xfer <= 1;
      else if (1)
          d1_pwm_interface_0_control_slave_end_xfer <= pwm_interface_0_control_slave_end_xfer;
    end


  //pwm_interface_0_control_slave_waits_for_read in a cycle, which is an e_mux
  assign pwm_interface_0_control_slave_waits_for_read = pwm_interface_0_control_slave_in_a_read_cycle & 0;

  //pwm_interface_0_control_slave_in_a_read_cycle assignment, which is an e_assign
  assign pwm_interface_0_control_slave_in_a_read_cycle = cpu_0_data_master_granted_pwm_interface_0_control_slave & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = pwm_interface_0_control_slave_in_a_read_cycle;

  //pwm_interface_0_control_slave_waits_for_write in a cycle, which is an e_mux
  assign pwm_interface_0_control_slave_waits_for_write = pwm_interface_0_control_slave_in_a_write_cycle & 0;

  //pwm_interface_0_control_slave_in_a_write_cycle assignment, which is an e_assign
  assign pwm_interface_0_control_slave_in_a_write_cycle = cpu_0_data_master_granted_pwm_interface_0_control_slave & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = pwm_interface_0_control_slave_in_a_write_cycle;

  assign wait_for_pwm_interface_0_control_slave_counter = 0;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //pwm_interface_0/control_slave enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module rdv_fifo_for_cpu_0_data_master_to_sdram_0_s1_module (
                                                             // inputs:
                                                              clear_fifo,
                                                              clk,
                                                              data_in,
                                                              read,
                                                              reset_n,
                                                              sync_reset,
                                                              write,

                                                             // outputs:
                                                              data_out,
                                                              empty,
                                                              fifo_contains_ones_n,
                                                              full
                                                           )
;

  output           data_out;
  output           empty;
  output           fifo_contains_ones_n;
  output           full;
  input            clear_fifo;
  input            clk;
  input            data_in;
  input            read;
  input            reset_n;
  input            sync_reset;
  input            write;

  wire             data_out;
  wire             empty;
  reg              fifo_contains_ones_n;
  wire             full;
  reg              full_0;
  reg              full_1;
  reg              full_2;
  reg              full_3;
  reg              full_4;
  reg              full_5;
  reg              full_6;
  wire             full_7;
  reg     [  3: 0] how_many_ones;
  wire    [  3: 0] one_count_minus_one;
  wire    [  3: 0] one_count_plus_one;
  wire             p0_full_0;
  wire             p0_stage_0;
  wire             p1_full_1;
  wire             p1_stage_1;
  wire             p2_full_2;
  wire             p2_stage_2;
  wire             p3_full_3;
  wire             p3_stage_3;
  wire             p4_full_4;
  wire             p4_stage_4;
  wire             p5_full_5;
  wire             p5_stage_5;
  wire             p6_full_6;
  wire             p6_stage_6;
  reg              stage_0;
  reg              stage_1;
  reg              stage_2;
  reg              stage_3;
  reg              stage_4;
  reg              stage_5;
  reg              stage_6;
  wire    [  3: 0] updated_one_count;
  assign data_out = stage_0;
  assign full = full_6;
  assign empty = !full_0;
  assign full_7 = 0;
  //data_6, which is an e_mux
  assign p6_stage_6 = ((full_7 & ~clear_fifo) == 0)? data_in :
    data_in;

  //data_reg_6, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_6 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_6))
          if (sync_reset & full_6 & !((full_7 == 0) & read & write))
              stage_6 <= 0;
          else 
            stage_6 <= p6_stage_6;
    end


  //control_6, which is an e_mux
  assign p6_full_6 = ((read & !write) == 0)? full_5 :
    0;

  //control_reg_6, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_6 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_6 <= 0;
          else 
            full_6 <= p6_full_6;
    end


  //data_5, which is an e_mux
  assign p5_stage_5 = ((full_6 & ~clear_fifo) == 0)? data_in :
    stage_6;

  //data_reg_5, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_5 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_5))
          if (sync_reset & full_5 & !((full_6 == 0) & read & write))
              stage_5 <= 0;
          else 
            stage_5 <= p5_stage_5;
    end


  //control_5, which is an e_mux
  assign p5_full_5 = ((read & !write) == 0)? full_4 :
    full_6;

  //control_reg_5, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_5 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_5 <= 0;
          else 
            full_5 <= p5_full_5;
    end


  //data_4, which is an e_mux
  assign p4_stage_4 = ((full_5 & ~clear_fifo) == 0)? data_in :
    stage_5;

  //data_reg_4, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_4 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_4))
          if (sync_reset & full_4 & !((full_5 == 0) & read & write))
              stage_4 <= 0;
          else 
            stage_4 <= p4_stage_4;
    end


  //control_4, which is an e_mux
  assign p4_full_4 = ((read & !write) == 0)? full_3 :
    full_5;

  //control_reg_4, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_4 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_4 <= 0;
          else 
            full_4 <= p4_full_4;
    end


  //data_3, which is an e_mux
  assign p3_stage_3 = ((full_4 & ~clear_fifo) == 0)? data_in :
    stage_4;

  //data_reg_3, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_3 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_3))
          if (sync_reset & full_3 & !((full_4 == 0) & read & write))
              stage_3 <= 0;
          else 
            stage_3 <= p3_stage_3;
    end


  //control_3, which is an e_mux
  assign p3_full_3 = ((read & !write) == 0)? full_2 :
    full_4;

  //control_reg_3, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_3 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_3 <= 0;
          else 
            full_3 <= p3_full_3;
    end


  //data_2, which is an e_mux
  assign p2_stage_2 = ((full_3 & ~clear_fifo) == 0)? data_in :
    stage_3;

  //data_reg_2, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_2 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_2))
          if (sync_reset & full_2 & !((full_3 == 0) & read & write))
              stage_2 <= 0;
          else 
            stage_2 <= p2_stage_2;
    end


  //control_2, which is an e_mux
  assign p2_full_2 = ((read & !write) == 0)? full_1 :
    full_3;

  //control_reg_2, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_2 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_2 <= 0;
          else 
            full_2 <= p2_full_2;
    end


  //data_1, which is an e_mux
  assign p1_stage_1 = ((full_2 & ~clear_fifo) == 0)? data_in :
    stage_2;

  //data_reg_1, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_1 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_1))
          if (sync_reset & full_1 & !((full_2 == 0) & read & write))
              stage_1 <= 0;
          else 
            stage_1 <= p1_stage_1;
    end


  //control_1, which is an e_mux
  assign p1_full_1 = ((read & !write) == 0)? full_0 :
    full_2;

  //control_reg_1, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_1 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_1 <= 0;
          else 
            full_1 <= p1_full_1;
    end


  //data_0, which is an e_mux
  assign p0_stage_0 = ((full_1 & ~clear_fifo) == 0)? data_in :
    stage_1;

  //data_reg_0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_0 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_0))
          if (sync_reset & full_0 & !((full_1 == 0) & read & write))
              stage_0 <= 0;
          else 
            stage_0 <= p0_stage_0;
    end


  //control_0, which is an e_mux
  assign p0_full_0 = ((read & !write) == 0)? 1 :
    full_1;

  //control_reg_0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_0 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo & ~write)
              full_0 <= 0;
          else 
            full_0 <= p0_full_0;
    end


  assign one_count_plus_one = how_many_ones + 1;
  assign one_count_minus_one = how_many_ones - 1;
  //updated_one_count, which is an e_mux
  assign updated_one_count = ((((clear_fifo | sync_reset) & !write)))? 0 :
    ((((clear_fifo | sync_reset) & write)))? |data_in :
    ((read & (|data_in) & write & (|stage_0)))? how_many_ones :
    ((write & (|data_in)))? one_count_plus_one :
    ((read & (|stage_0)))? one_count_minus_one :
    how_many_ones;

  //counts how many ones in the data pipeline, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          how_many_ones <= 0;
      else if (clear_fifo | sync_reset | read | write)
          how_many_ones <= updated_one_count;
    end


  //this fifo contains ones in the data pipeline, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          fifo_contains_ones_n <= 1;
      else if (clear_fifo | sync_reset | read | write)
          fifo_contains_ones_n <= ~(|updated_one_count);
    end



endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module rdv_fifo_for_cpu_0_instruction_master_to_sdram_0_s1_module (
                                                                    // inputs:
                                                                     clear_fifo,
                                                                     clk,
                                                                     data_in,
                                                                     read,
                                                                     reset_n,
                                                                     sync_reset,
                                                                     write,

                                                                    // outputs:
                                                                     data_out,
                                                                     empty,
                                                                     fifo_contains_ones_n,
                                                                     full
                                                                  )
;

  output           data_out;
  output           empty;
  output           fifo_contains_ones_n;
  output           full;
  input            clear_fifo;
  input            clk;
  input            data_in;
  input            read;
  input            reset_n;
  input            sync_reset;
  input            write;

  wire             data_out;
  wire             empty;
  reg              fifo_contains_ones_n;
  wire             full;
  reg              full_0;
  reg              full_1;
  reg              full_2;
  reg              full_3;
  reg              full_4;
  reg              full_5;
  reg              full_6;
  wire             full_7;
  reg     [  3: 0] how_many_ones;
  wire    [  3: 0] one_count_minus_one;
  wire    [  3: 0] one_count_plus_one;
  wire             p0_full_0;
  wire             p0_stage_0;
  wire             p1_full_1;
  wire             p1_stage_1;
  wire             p2_full_2;
  wire             p2_stage_2;
  wire             p3_full_3;
  wire             p3_stage_3;
  wire             p4_full_4;
  wire             p4_stage_4;
  wire             p5_full_5;
  wire             p5_stage_5;
  wire             p6_full_6;
  wire             p6_stage_6;
  reg              stage_0;
  reg              stage_1;
  reg              stage_2;
  reg              stage_3;
  reg              stage_4;
  reg              stage_5;
  reg              stage_6;
  wire    [  3: 0] updated_one_count;
  assign data_out = stage_0;
  assign full = full_6;
  assign empty = !full_0;
  assign full_7 = 0;
  //data_6, which is an e_mux
  assign p6_stage_6 = ((full_7 & ~clear_fifo) == 0)? data_in :
    data_in;

  //data_reg_6, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_6 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_6))
          if (sync_reset & full_6 & !((full_7 == 0) & read & write))
              stage_6 <= 0;
          else 
            stage_6 <= p6_stage_6;
    end


  //control_6, which is an e_mux
  assign p6_full_6 = ((read & !write) == 0)? full_5 :
    0;

  //control_reg_6, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_6 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_6 <= 0;
          else 
            full_6 <= p6_full_6;
    end


  //data_5, which is an e_mux
  assign p5_stage_5 = ((full_6 & ~clear_fifo) == 0)? data_in :
    stage_6;

  //data_reg_5, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_5 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_5))
          if (sync_reset & full_5 & !((full_6 == 0) & read & write))
              stage_5 <= 0;
          else 
            stage_5 <= p5_stage_5;
    end


  //control_5, which is an e_mux
  assign p5_full_5 = ((read & !write) == 0)? full_4 :
    full_6;

  //control_reg_5, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_5 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_5 <= 0;
          else 
            full_5 <= p5_full_5;
    end


  //data_4, which is an e_mux
  assign p4_stage_4 = ((full_5 & ~clear_fifo) == 0)? data_in :
    stage_5;

  //data_reg_4, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_4 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_4))
          if (sync_reset & full_4 & !((full_5 == 0) & read & write))
              stage_4 <= 0;
          else 
            stage_4 <= p4_stage_4;
    end


  //control_4, which is an e_mux
  assign p4_full_4 = ((read & !write) == 0)? full_3 :
    full_5;

  //control_reg_4, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_4 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_4 <= 0;
          else 
            full_4 <= p4_full_4;
    end


  //data_3, which is an e_mux
  assign p3_stage_3 = ((full_4 & ~clear_fifo) == 0)? data_in :
    stage_4;

  //data_reg_3, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_3 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_3))
          if (sync_reset & full_3 & !((full_4 == 0) & read & write))
              stage_3 <= 0;
          else 
            stage_3 <= p3_stage_3;
    end


  //control_3, which is an e_mux
  assign p3_full_3 = ((read & !write) == 0)? full_2 :
    full_4;

  //control_reg_3, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_3 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_3 <= 0;
          else 
            full_3 <= p3_full_3;
    end


  //data_2, which is an e_mux
  assign p2_stage_2 = ((full_3 & ~clear_fifo) == 0)? data_in :
    stage_3;

  //data_reg_2, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_2 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_2))
          if (sync_reset & full_2 & !((full_3 == 0) & read & write))
              stage_2 <= 0;
          else 
            stage_2 <= p2_stage_2;
    end


  //control_2, which is an e_mux
  assign p2_full_2 = ((read & !write) == 0)? full_1 :
    full_3;

  //control_reg_2, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_2 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_2 <= 0;
          else 
            full_2 <= p2_full_2;
    end


  //data_1, which is an e_mux
  assign p1_stage_1 = ((full_2 & ~clear_fifo) == 0)? data_in :
    stage_2;

  //data_reg_1, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_1 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_1))
          if (sync_reset & full_1 & !((full_2 == 0) & read & write))
              stage_1 <= 0;
          else 
            stage_1 <= p1_stage_1;
    end


  //control_1, which is an e_mux
  assign p1_full_1 = ((read & !write) == 0)? full_0 :
    full_2;

  //control_reg_1, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_1 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_1 <= 0;
          else 
            full_1 <= p1_full_1;
    end


  //data_0, which is an e_mux
  assign p0_stage_0 = ((full_1 & ~clear_fifo) == 0)? data_in :
    stage_1;

  //data_reg_0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_0 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_0))
          if (sync_reset & full_0 & !((full_1 == 0) & read & write))
              stage_0 <= 0;
          else 
            stage_0 <= p0_stage_0;
    end


  //control_0, which is an e_mux
  assign p0_full_0 = ((read & !write) == 0)? 1 :
    full_1;

  //control_reg_0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_0 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo & ~write)
              full_0 <= 0;
          else 
            full_0 <= p0_full_0;
    end


  assign one_count_plus_one = how_many_ones + 1;
  assign one_count_minus_one = how_many_ones - 1;
  //updated_one_count, which is an e_mux
  assign updated_one_count = ((((clear_fifo | sync_reset) & !write)))? 0 :
    ((((clear_fifo | sync_reset) & write)))? |data_in :
    ((read & (|data_in) & write & (|stage_0)))? how_many_ones :
    ((write & (|data_in)))? one_count_plus_one :
    ((read & (|stage_0)))? one_count_minus_one :
    how_many_ones;

  //counts how many ones in the data pipeline, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          how_many_ones <= 0;
      else if (clear_fifo | sync_reset | read | write)
          how_many_ones <= updated_one_count;
    end


  //this fifo contains ones in the data pipeline, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          fifo_contains_ones_n <= 1;
      else if (clear_fifo | sync_reset | read | write)
          fifo_contains_ones_n <= ~(|updated_one_count);
    end



endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module rdv_fifo_for_dma_read_master_to_sdram_0_s1_module (
                                                           // inputs:
                                                            clear_fifo,
                                                            clk,
                                                            data_in,
                                                            read,
                                                            reset_n,
                                                            sync_reset,
                                                            write,

                                                           // outputs:
                                                            data_out,
                                                            empty,
                                                            fifo_contains_ones_n,
                                                            full
                                                         )
;

  output           data_out;
  output           empty;
  output           fifo_contains_ones_n;
  output           full;
  input            clear_fifo;
  input            clk;
  input            data_in;
  input            read;
  input            reset_n;
  input            sync_reset;
  input            write;

  wire             data_out;
  wire             empty;
  reg              fifo_contains_ones_n;
  wire             full;
  reg              full_0;
  reg              full_1;
  reg              full_2;
  reg              full_3;
  reg              full_4;
  reg              full_5;
  reg              full_6;
  wire             full_7;
  reg     [  3: 0] how_many_ones;
  wire    [  3: 0] one_count_minus_one;
  wire    [  3: 0] one_count_plus_one;
  wire             p0_full_0;
  wire             p0_stage_0;
  wire             p1_full_1;
  wire             p1_stage_1;
  wire             p2_full_2;
  wire             p2_stage_2;
  wire             p3_full_3;
  wire             p3_stage_3;
  wire             p4_full_4;
  wire             p4_stage_4;
  wire             p5_full_5;
  wire             p5_stage_5;
  wire             p6_full_6;
  wire             p6_stage_6;
  reg              stage_0;
  reg              stage_1;
  reg              stage_2;
  reg              stage_3;
  reg              stage_4;
  reg              stage_5;
  reg              stage_6;
  wire    [  3: 0] updated_one_count;
  assign data_out = stage_0;
  assign full = full_6;
  assign empty = !full_0;
  assign full_7 = 0;
  //data_6, which is an e_mux
  assign p6_stage_6 = ((full_7 & ~clear_fifo) == 0)? data_in :
    data_in;

  //data_reg_6, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_6 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_6))
          if (sync_reset & full_6 & !((full_7 == 0) & read & write))
              stage_6 <= 0;
          else 
            stage_6 <= p6_stage_6;
    end


  //control_6, which is an e_mux
  assign p6_full_6 = ((read & !write) == 0)? full_5 :
    0;

  //control_reg_6, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_6 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_6 <= 0;
          else 
            full_6 <= p6_full_6;
    end


  //data_5, which is an e_mux
  assign p5_stage_5 = ((full_6 & ~clear_fifo) == 0)? data_in :
    stage_6;

  //data_reg_5, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_5 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_5))
          if (sync_reset & full_5 & !((full_6 == 0) & read & write))
              stage_5 <= 0;
          else 
            stage_5 <= p5_stage_5;
    end


  //control_5, which is an e_mux
  assign p5_full_5 = ((read & !write) == 0)? full_4 :
    full_6;

  //control_reg_5, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_5 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_5 <= 0;
          else 
            full_5 <= p5_full_5;
    end


  //data_4, which is an e_mux
  assign p4_stage_4 = ((full_5 & ~clear_fifo) == 0)? data_in :
    stage_5;

  //data_reg_4, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_4 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_4))
          if (sync_reset & full_4 & !((full_5 == 0) & read & write))
              stage_4 <= 0;
          else 
            stage_4 <= p4_stage_4;
    end


  //control_4, which is an e_mux
  assign p4_full_4 = ((read & !write) == 0)? full_3 :
    full_5;

  //control_reg_4, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_4 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_4 <= 0;
          else 
            full_4 <= p4_full_4;
    end


  //data_3, which is an e_mux
  assign p3_stage_3 = ((full_4 & ~clear_fifo) == 0)? data_in :
    stage_4;

  //data_reg_3, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_3 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_3))
          if (sync_reset & full_3 & !((full_4 == 0) & read & write))
              stage_3 <= 0;
          else 
            stage_3 <= p3_stage_3;
    end


  //control_3, which is an e_mux
  assign p3_full_3 = ((read & !write) == 0)? full_2 :
    full_4;

  //control_reg_3, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_3 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_3 <= 0;
          else 
            full_3 <= p3_full_3;
    end


  //data_2, which is an e_mux
  assign p2_stage_2 = ((full_3 & ~clear_fifo) == 0)? data_in :
    stage_3;

  //data_reg_2, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_2 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_2))
          if (sync_reset & full_2 & !((full_3 == 0) & read & write))
              stage_2 <= 0;
          else 
            stage_2 <= p2_stage_2;
    end


  //control_2, which is an e_mux
  assign p2_full_2 = ((read & !write) == 0)? full_1 :
    full_3;

  //control_reg_2, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_2 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_2 <= 0;
          else 
            full_2 <= p2_full_2;
    end


  //data_1, which is an e_mux
  assign p1_stage_1 = ((full_2 & ~clear_fifo) == 0)? data_in :
    stage_2;

  //data_reg_1, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_1 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_1))
          if (sync_reset & full_1 & !((full_2 == 0) & read & write))
              stage_1 <= 0;
          else 
            stage_1 <= p1_stage_1;
    end


  //control_1, which is an e_mux
  assign p1_full_1 = ((read & !write) == 0)? full_0 :
    full_2;

  //control_reg_1, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_1 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo)
              full_1 <= 0;
          else 
            full_1 <= p1_full_1;
    end


  //data_0, which is an e_mux
  assign p0_stage_0 = ((full_1 & ~clear_fifo) == 0)? data_in :
    stage_1;

  //data_reg_0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          stage_0 <= 0;
      else if (clear_fifo | sync_reset | read | (write & !full_0))
          if (sync_reset & full_0 & !((full_1 == 0) & read & write))
              stage_0 <= 0;
          else 
            stage_0 <= p0_stage_0;
    end


  //control_0, which is an e_mux
  assign p0_full_0 = ((read & !write) == 0)? 1 :
    full_1;

  //control_reg_0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          full_0 <= 0;
      else if (clear_fifo | (read ^ write) | (write & !full_0))
          if (clear_fifo & ~write)
              full_0 <= 0;
          else 
            full_0 <= p0_full_0;
    end


  assign one_count_plus_one = how_many_ones + 1;
  assign one_count_minus_one = how_many_ones - 1;
  //updated_one_count, which is an e_mux
  assign updated_one_count = ((((clear_fifo | sync_reset) & !write)))? 0 :
    ((((clear_fifo | sync_reset) & write)))? |data_in :
    ((read & (|data_in) & write & (|stage_0)))? how_many_ones :
    ((write & (|data_in)))? one_count_plus_one :
    ((read & (|stage_0)))? one_count_minus_one :
    how_many_ones;

  //counts how many ones in the data pipeline, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          how_many_ones <= 0;
      else if (clear_fifo | sync_reset | read | write)
          how_many_ones <= updated_one_count;
    end


  //this fifo contains ones in the data pipeline, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          fifo_contains_ones_n <= 1;
      else if (clear_fifo | sync_reset | read | write)
          fifo_contains_ones_n <= ~(|updated_one_count);
    end



endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module sdram_0_s1_arbitrator (
                               // inputs:
                                clk,
                                cpu_0_data_master_address_to_slave,
                                cpu_0_data_master_byteenable,
                                cpu_0_data_master_dbs_address,
                                cpu_0_data_master_dbs_write_16,
                                cpu_0_data_master_no_byte_enables_and_last_term,
                                cpu_0_data_master_read,
                                cpu_0_data_master_waitrequest,
                                cpu_0_data_master_write,
                                cpu_0_instruction_master_address_to_slave,
                                cpu_0_instruction_master_dbs_address,
                                cpu_0_instruction_master_latency_counter,
                                cpu_0_instruction_master_read,
                                dma_read_master_address_to_slave,
                                dma_read_master_chipselect,
                                dma_read_master_dbs_address,
                                dma_read_master_flush_qualified_exported,
                                dma_read_master_latency_counter,
                                dma_read_master_read_n,
                                dma_write_master_address_to_slave,
                                dma_write_master_byteenable,
                                dma_write_master_chipselect,
                                dma_write_master_dbs_address,
                                dma_write_master_dbs_write_16,
                                dma_write_master_write_n,
                                reset_n,
                                sdram_0_s1_readdata,
                                sdram_0_s1_readdatavalid,
                                sdram_0_s1_waitrequest,

                               // outputs:
                                cpu_0_data_master_byteenable_sdram_0_s1,
                                cpu_0_data_master_granted_sdram_0_s1,
                                cpu_0_data_master_qualified_request_sdram_0_s1,
                                cpu_0_data_master_read_data_valid_sdram_0_s1,
                                cpu_0_data_master_read_data_valid_sdram_0_s1_shift_register,
                                cpu_0_data_master_requests_sdram_0_s1,
                                cpu_0_instruction_master_granted_sdram_0_s1,
                                cpu_0_instruction_master_qualified_request_sdram_0_s1,
                                cpu_0_instruction_master_read_data_valid_sdram_0_s1,
                                cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register,
                                cpu_0_instruction_master_requests_sdram_0_s1,
                                d1_sdram_0_s1_end_xfer,
                                dma_read_master_granted_sdram_0_s1,
                                dma_read_master_qualified_request_sdram_0_s1,
                                dma_read_master_read_data_valid_sdram_0_s1,
                                dma_read_master_read_data_valid_sdram_0_s1_shift_register,
                                dma_read_master_requests_sdram_0_s1,
                                dma_write_master_byteenable_sdram_0_s1,
                                dma_write_master_granted_sdram_0_s1,
                                dma_write_master_qualified_request_sdram_0_s1,
                                dma_write_master_requests_sdram_0_s1,
                                sdram_0_s1_address,
                                sdram_0_s1_byteenable_n,
                                sdram_0_s1_chipselect,
                                sdram_0_s1_read_n,
                                sdram_0_s1_readdata_from_sa,
                                sdram_0_s1_reset_n,
                                sdram_0_s1_waitrequest_from_sa,
                                sdram_0_s1_write_n,
                                sdram_0_s1_writedata
                             )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output  [  1: 0] cpu_0_data_master_byteenable_sdram_0_s1;
  output           cpu_0_data_master_granted_sdram_0_s1;
  output           cpu_0_data_master_qualified_request_sdram_0_s1;
  output           cpu_0_data_master_read_data_valid_sdram_0_s1;
  output           cpu_0_data_master_read_data_valid_sdram_0_s1_shift_register;
  output           cpu_0_data_master_requests_sdram_0_s1;
  output           cpu_0_instruction_master_granted_sdram_0_s1;
  output           cpu_0_instruction_master_qualified_request_sdram_0_s1;
  output           cpu_0_instruction_master_read_data_valid_sdram_0_s1;
  output           cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register;
  output           cpu_0_instruction_master_requests_sdram_0_s1;
  output           d1_sdram_0_s1_end_xfer;
  output           dma_read_master_granted_sdram_0_s1;
  output           dma_read_master_qualified_request_sdram_0_s1;
  output           dma_read_master_read_data_valid_sdram_0_s1;
  output           dma_read_master_read_data_valid_sdram_0_s1_shift_register;
  output           dma_read_master_requests_sdram_0_s1;
  output  [  1: 0] dma_write_master_byteenable_sdram_0_s1;
  output           dma_write_master_granted_sdram_0_s1;
  output           dma_write_master_qualified_request_sdram_0_s1;
  output           dma_write_master_requests_sdram_0_s1;
  output  [ 21: 0] sdram_0_s1_address;
  output  [  1: 0] sdram_0_s1_byteenable_n;
  output           sdram_0_s1_chipselect;
  output           sdram_0_s1_read_n;
  output  [ 15: 0] sdram_0_s1_readdata_from_sa;
  output           sdram_0_s1_reset_n;
  output           sdram_0_s1_waitrequest_from_sa;
  output           sdram_0_s1_write_n;
  output  [ 15: 0] sdram_0_s1_writedata;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input   [  3: 0] cpu_0_data_master_byteenable;
  input   [  1: 0] cpu_0_data_master_dbs_address;
  input   [ 15: 0] cpu_0_data_master_dbs_write_16;
  input            cpu_0_data_master_no_byte_enables_and_last_term;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input   [ 25: 0] cpu_0_instruction_master_address_to_slave;
  input   [  1: 0] cpu_0_instruction_master_dbs_address;
  input   [  1: 0] cpu_0_instruction_master_latency_counter;
  input            cpu_0_instruction_master_read;
  input   [ 25: 0] dma_read_master_address_to_slave;
  input            dma_read_master_chipselect;
  input   [  1: 0] dma_read_master_dbs_address;
  input            dma_read_master_flush_qualified_exported;
  input            dma_read_master_latency_counter;
  input            dma_read_master_read_n;
  input   [ 25: 0] dma_write_master_address_to_slave;
  input   [  3: 0] dma_write_master_byteenable;
  input            dma_write_master_chipselect;
  input   [  1: 0] dma_write_master_dbs_address;
  input   [ 15: 0] dma_write_master_dbs_write_16;
  input            dma_write_master_write_n;
  input            reset_n;
  input   [ 15: 0] sdram_0_s1_readdata;
  input            sdram_0_s1_readdatavalid;
  input            sdram_0_s1_waitrequest;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire    [  1: 0] cpu_0_data_master_byteenable_sdram_0_s1;
  wire    [  1: 0] cpu_0_data_master_byteenable_sdram_0_s1_segment_0;
  wire    [  1: 0] cpu_0_data_master_byteenable_sdram_0_s1_segment_1;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_sdram_0_s1;
  wire             cpu_0_data_master_qualified_request_sdram_0_s1;
  wire             cpu_0_data_master_rdv_fifo_empty_sdram_0_s1;
  wire             cpu_0_data_master_rdv_fifo_output_from_sdram_0_s1;
  wire             cpu_0_data_master_read_data_valid_sdram_0_s1;
  wire             cpu_0_data_master_read_data_valid_sdram_0_s1_shift_register;
  wire             cpu_0_data_master_requests_sdram_0_s1;
  wire             cpu_0_data_master_saved_grant_sdram_0_s1;
  wire             cpu_0_instruction_master_arbiterlock;
  wire             cpu_0_instruction_master_arbiterlock2;
  wire             cpu_0_instruction_master_continuerequest;
  wire             cpu_0_instruction_master_granted_sdram_0_s1;
  wire             cpu_0_instruction_master_qualified_request_sdram_0_s1;
  wire             cpu_0_instruction_master_rdv_fifo_empty_sdram_0_s1;
  wire             cpu_0_instruction_master_rdv_fifo_output_from_sdram_0_s1;
  wire             cpu_0_instruction_master_read_data_valid_sdram_0_s1;
  wire             cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register;
  wire             cpu_0_instruction_master_requests_sdram_0_s1;
  wire             cpu_0_instruction_master_saved_grant_sdram_0_s1;
  reg              d1_reasons_to_wait;
  reg              d1_sdram_0_s1_end_xfer;
  wire             dma_read_master_arbiterlock;
  wire             dma_read_master_arbiterlock2;
  wire             dma_read_master_continuerequest;
  wire             dma_read_master_granted_sdram_0_s1;
  wire             dma_read_master_qualified_request_sdram_0_s1;
  wire             dma_read_master_rdv_fifo_empty_sdram_0_s1;
  wire             dma_read_master_rdv_fifo_output_from_sdram_0_s1;
  wire             dma_read_master_read_data_valid_sdram_0_s1;
  wire             dma_read_master_read_data_valid_sdram_0_s1_shift_register;
  wire             dma_read_master_requests_sdram_0_s1;
  wire             dma_read_master_saved_grant_sdram_0_s1;
  wire             dma_write_master_arbiterlock;
  wire             dma_write_master_arbiterlock2;
  wire    [  1: 0] dma_write_master_byteenable_sdram_0_s1;
  wire    [  1: 0] dma_write_master_byteenable_sdram_0_s1_segment_0;
  wire    [  1: 0] dma_write_master_byteenable_sdram_0_s1_segment_1;
  wire             dma_write_master_continuerequest;
  wire             dma_write_master_granted_sdram_0_s1;
  wire             dma_write_master_qualified_request_sdram_0_s1;
  wire             dma_write_master_requests_sdram_0_s1;
  wire             dma_write_master_saved_grant_sdram_0_s1;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_sdram_0_s1;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  reg              last_cycle_cpu_0_data_master_granted_slave_sdram_0_s1;
  reg              last_cycle_cpu_0_instruction_master_granted_slave_sdram_0_s1;
  reg              last_cycle_dma_read_master_granted_slave_sdram_0_s1;
  reg              last_cycle_dma_write_master_granted_slave_sdram_0_s1;
  wire    [ 21: 0] sdram_0_s1_address;
  wire             sdram_0_s1_allgrants;
  wire             sdram_0_s1_allow_new_arb_cycle;
  wire             sdram_0_s1_any_bursting_master_saved_grant;
  wire             sdram_0_s1_any_continuerequest;
  reg     [  3: 0] sdram_0_s1_arb_addend;
  wire             sdram_0_s1_arb_counter_enable;
  reg     [  2: 0] sdram_0_s1_arb_share_counter;
  wire    [  2: 0] sdram_0_s1_arb_share_counter_next_value;
  wire    [  2: 0] sdram_0_s1_arb_share_set_values;
  wire    [  3: 0] sdram_0_s1_arb_winner;
  wire             sdram_0_s1_arbitration_holdoff_internal;
  wire             sdram_0_s1_beginbursttransfer_internal;
  wire             sdram_0_s1_begins_xfer;
  wire    [  1: 0] sdram_0_s1_byteenable_n;
  wire             sdram_0_s1_chipselect;
  wire    [  7: 0] sdram_0_s1_chosen_master_double_vector;
  wire    [  3: 0] sdram_0_s1_chosen_master_rot_left;
  wire             sdram_0_s1_end_xfer;
  wire             sdram_0_s1_firsttransfer;
  wire    [  3: 0] sdram_0_s1_grant_vector;
  wire             sdram_0_s1_in_a_read_cycle;
  wire             sdram_0_s1_in_a_write_cycle;
  wire    [  3: 0] sdram_0_s1_master_qreq_vector;
  wire             sdram_0_s1_move_on_to_next_transaction;
  wire             sdram_0_s1_non_bursting_master_requests;
  wire             sdram_0_s1_read_n;
  wire    [ 15: 0] sdram_0_s1_readdata_from_sa;
  wire             sdram_0_s1_readdatavalid_from_sa;
  reg              sdram_0_s1_reg_firsttransfer;
  wire             sdram_0_s1_reset_n;
  reg     [  3: 0] sdram_0_s1_saved_chosen_master_vector;
  reg              sdram_0_s1_slavearbiterlockenable;
  wire             sdram_0_s1_slavearbiterlockenable2;
  wire             sdram_0_s1_unreg_firsttransfer;
  wire             sdram_0_s1_waitrequest_from_sa;
  wire             sdram_0_s1_waits_for_read;
  wire             sdram_0_s1_waits_for_write;
  wire             sdram_0_s1_write_n;
  wire    [ 15: 0] sdram_0_s1_writedata;
  wire    [ 25: 0] shifted_address_to_sdram_0_s1_from_cpu_0_data_master;
  wire    [ 25: 0] shifted_address_to_sdram_0_s1_from_cpu_0_instruction_master;
  wire    [ 25: 0] shifted_address_to_sdram_0_s1_from_dma_read_master;
  wire    [ 25: 0] shifted_address_to_sdram_0_s1_from_dma_write_master;
  wire             wait_for_sdram_0_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~sdram_0_s1_end_xfer;
    end


  assign sdram_0_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_sdram_0_s1 | cpu_0_instruction_master_qualified_request_sdram_0_s1 | dma_read_master_qualified_request_sdram_0_s1 | dma_write_master_qualified_request_sdram_0_s1));
  //assign sdram_0_s1_readdatavalid_from_sa = sdram_0_s1_readdatavalid so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign sdram_0_s1_readdatavalid_from_sa = sdram_0_s1_readdatavalid;

  //assign sdram_0_s1_readdata_from_sa = sdram_0_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign sdram_0_s1_readdata_from_sa = sdram_0_s1_readdata;

  assign cpu_0_data_master_requests_sdram_0_s1 = ({cpu_0_data_master_address_to_slave[25 : 23] , 23'b0} == 26'h1800000) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //assign sdram_0_s1_waitrequest_from_sa = sdram_0_s1_waitrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign sdram_0_s1_waitrequest_from_sa = sdram_0_s1_waitrequest;

  //sdram_0_s1_arb_share_counter set values, which is an e_mux
  assign sdram_0_s1_arb_share_set_values = (cpu_0_data_master_granted_sdram_0_s1)? 2 :
    (cpu_0_instruction_master_granted_sdram_0_s1)? 2 :
    (dma_read_master_granted_sdram_0_s1)? 2 :
    (dma_write_master_granted_sdram_0_s1)? 2 :
    (cpu_0_data_master_granted_sdram_0_s1)? 2 :
    (cpu_0_instruction_master_granted_sdram_0_s1)? 2 :
    (dma_read_master_granted_sdram_0_s1)? 2 :
    (dma_write_master_granted_sdram_0_s1)? 2 :
    (cpu_0_data_master_granted_sdram_0_s1)? 2 :
    (cpu_0_instruction_master_granted_sdram_0_s1)? 2 :
    (dma_read_master_granted_sdram_0_s1)? 2 :
    (dma_write_master_granted_sdram_0_s1)? 2 :
    (cpu_0_data_master_granted_sdram_0_s1)? 2 :
    (cpu_0_instruction_master_granted_sdram_0_s1)? 2 :
    (dma_read_master_granted_sdram_0_s1)? 2 :
    (dma_write_master_granted_sdram_0_s1)? 2 :
    1;

  //sdram_0_s1_non_bursting_master_requests mux, which is an e_mux
  assign sdram_0_s1_non_bursting_master_requests = cpu_0_data_master_requests_sdram_0_s1 |
    cpu_0_instruction_master_requests_sdram_0_s1 |
    dma_read_master_requests_sdram_0_s1 |
    dma_write_master_requests_sdram_0_s1 |
    cpu_0_data_master_requests_sdram_0_s1 |
    cpu_0_instruction_master_requests_sdram_0_s1 |
    dma_read_master_requests_sdram_0_s1 |
    dma_write_master_requests_sdram_0_s1 |
    cpu_0_data_master_requests_sdram_0_s1 |
    cpu_0_instruction_master_requests_sdram_0_s1 |
    dma_read_master_requests_sdram_0_s1 |
    dma_write_master_requests_sdram_0_s1 |
    cpu_0_data_master_requests_sdram_0_s1 |
    cpu_0_instruction_master_requests_sdram_0_s1 |
    dma_read_master_requests_sdram_0_s1 |
    dma_write_master_requests_sdram_0_s1;

  //sdram_0_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign sdram_0_s1_any_bursting_master_saved_grant = 0;

  //sdram_0_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign sdram_0_s1_arb_share_counter_next_value = sdram_0_s1_firsttransfer ? (sdram_0_s1_arb_share_set_values - 1) : |sdram_0_s1_arb_share_counter ? (sdram_0_s1_arb_share_counter - 1) : 0;

  //sdram_0_s1_allgrants all slave grants, which is an e_mux
  assign sdram_0_s1_allgrants = |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector |
    |sdram_0_s1_grant_vector;

  //sdram_0_s1_end_xfer assignment, which is an e_assign
  assign sdram_0_s1_end_xfer = ~(sdram_0_s1_waits_for_read | sdram_0_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_sdram_0_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_sdram_0_s1 = sdram_0_s1_end_xfer & (~sdram_0_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //sdram_0_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign sdram_0_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_sdram_0_s1 & sdram_0_s1_allgrants) | (end_xfer_arb_share_counter_term_sdram_0_s1 & ~sdram_0_s1_non_bursting_master_requests);

  //sdram_0_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          sdram_0_s1_arb_share_counter <= 0;
      else if (sdram_0_s1_arb_counter_enable)
          sdram_0_s1_arb_share_counter <= sdram_0_s1_arb_share_counter_next_value;
    end


  //sdram_0_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          sdram_0_s1_slavearbiterlockenable <= 0;
      else if ((|sdram_0_s1_master_qreq_vector & end_xfer_arb_share_counter_term_sdram_0_s1) | (end_xfer_arb_share_counter_term_sdram_0_s1 & ~sdram_0_s1_non_bursting_master_requests))
          sdram_0_s1_slavearbiterlockenable <= |sdram_0_s1_arb_share_counter_next_value;
    end


  //cpu_0/data_master sdram_0/s1 arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = sdram_0_s1_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //sdram_0_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign sdram_0_s1_slavearbiterlockenable2 = |sdram_0_s1_arb_share_counter_next_value;

  //cpu_0/data_master sdram_0/s1 arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = sdram_0_s1_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //cpu_0/instruction_master sdram_0/s1 arbiterlock, which is an e_assign
  assign cpu_0_instruction_master_arbiterlock = sdram_0_s1_slavearbiterlockenable & cpu_0_instruction_master_continuerequest;

  //cpu_0/instruction_master sdram_0/s1 arbiterlock2, which is an e_assign
  assign cpu_0_instruction_master_arbiterlock2 = sdram_0_s1_slavearbiterlockenable2 & cpu_0_instruction_master_continuerequest;

  //cpu_0/instruction_master granted sdram_0/s1 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_instruction_master_granted_slave_sdram_0_s1 <= 0;
      else if (1)
          last_cycle_cpu_0_instruction_master_granted_slave_sdram_0_s1 <= cpu_0_instruction_master_saved_grant_sdram_0_s1 ? 1 : (sdram_0_s1_arbitration_holdoff_internal | ~cpu_0_instruction_master_requests_sdram_0_s1) ? 0 : last_cycle_cpu_0_instruction_master_granted_slave_sdram_0_s1;
    end


  //cpu_0_instruction_master_continuerequest continued request, which is an e_mux
  assign cpu_0_instruction_master_continuerequest = (last_cycle_cpu_0_instruction_master_granted_slave_sdram_0_s1 & cpu_0_instruction_master_requests_sdram_0_s1) |
    (last_cycle_cpu_0_instruction_master_granted_slave_sdram_0_s1 & cpu_0_instruction_master_requests_sdram_0_s1) |
    (last_cycle_cpu_0_instruction_master_granted_slave_sdram_0_s1 & cpu_0_instruction_master_requests_sdram_0_s1);

  //sdram_0_s1_any_continuerequest at least one master continues requesting, which is an e_mux
  assign sdram_0_s1_any_continuerequest = cpu_0_instruction_master_continuerequest |
    dma_read_master_continuerequest |
    dma_write_master_continuerequest |
    cpu_0_data_master_continuerequest |
    dma_read_master_continuerequest |
    dma_write_master_continuerequest |
    cpu_0_data_master_continuerequest |
    cpu_0_instruction_master_continuerequest |
    dma_write_master_continuerequest |
    cpu_0_data_master_continuerequest |
    cpu_0_instruction_master_continuerequest |
    dma_read_master_continuerequest;

  //dma/read_master sdram_0/s1 arbiterlock, which is an e_assign
  assign dma_read_master_arbiterlock = sdram_0_s1_slavearbiterlockenable & dma_read_master_continuerequest;

  //dma/read_master sdram_0/s1 arbiterlock2, which is an e_assign
  assign dma_read_master_arbiterlock2 = sdram_0_s1_slavearbiterlockenable2 & dma_read_master_continuerequest;

  //dma/read_master granted sdram_0/s1 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_dma_read_master_granted_slave_sdram_0_s1 <= 0;
      else if (1)
          last_cycle_dma_read_master_granted_slave_sdram_0_s1 <= dma_read_master_saved_grant_sdram_0_s1 ? 1 : (sdram_0_s1_arbitration_holdoff_internal | ~dma_read_master_requests_sdram_0_s1) ? 0 : last_cycle_dma_read_master_granted_slave_sdram_0_s1;
    end


  //dma_read_master_continuerequest continued request, which is an e_mux
  assign dma_read_master_continuerequest = (last_cycle_dma_read_master_granted_slave_sdram_0_s1 & dma_read_master_requests_sdram_0_s1) |
    (last_cycle_dma_read_master_granted_slave_sdram_0_s1 & dma_read_master_requests_sdram_0_s1) |
    (last_cycle_dma_read_master_granted_slave_sdram_0_s1 & dma_read_master_requests_sdram_0_s1);

  //dma/write_master sdram_0/s1 arbiterlock, which is an e_assign
  assign dma_write_master_arbiterlock = sdram_0_s1_slavearbiterlockenable & dma_write_master_continuerequest;

  //dma/write_master sdram_0/s1 arbiterlock2, which is an e_assign
  assign dma_write_master_arbiterlock2 = sdram_0_s1_slavearbiterlockenable2 & dma_write_master_continuerequest;

  //dma/write_master granted sdram_0/s1 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_dma_write_master_granted_slave_sdram_0_s1 <= 0;
      else if (1)
          last_cycle_dma_write_master_granted_slave_sdram_0_s1 <= dma_write_master_saved_grant_sdram_0_s1 ? 1 : (sdram_0_s1_arbitration_holdoff_internal | ~dma_write_master_requests_sdram_0_s1) ? 0 : last_cycle_dma_write_master_granted_slave_sdram_0_s1;
    end


  //dma_write_master_continuerequest continued request, which is an e_mux
  assign dma_write_master_continuerequest = (last_cycle_dma_write_master_granted_slave_sdram_0_s1 & dma_write_master_requests_sdram_0_s1) |
    (last_cycle_dma_write_master_granted_slave_sdram_0_s1 & dma_write_master_requests_sdram_0_s1) |
    (last_cycle_dma_write_master_granted_slave_sdram_0_s1 & dma_write_master_requests_sdram_0_s1);

  assign cpu_0_data_master_qualified_request_sdram_0_s1 = cpu_0_data_master_requests_sdram_0_s1 & ~((cpu_0_data_master_read & (~cpu_0_data_master_waitrequest | (|cpu_0_data_master_read_data_valid_sdram_0_s1_shift_register))) | ((~cpu_0_data_master_waitrequest | cpu_0_data_master_no_byte_enables_and_last_term | !cpu_0_data_master_byteenable_sdram_0_s1) & cpu_0_data_master_write) | cpu_0_instruction_master_arbiterlock | dma_read_master_arbiterlock | dma_write_master_arbiterlock);
  //unique name for sdram_0_s1_move_on_to_next_transaction, which is an e_assign
  assign sdram_0_s1_move_on_to_next_transaction = sdram_0_s1_readdatavalid_from_sa;

  //rdv_fifo_for_cpu_0_data_master_to_sdram_0_s1, which is an e_fifo_with_registered_outputs
  rdv_fifo_for_cpu_0_data_master_to_sdram_0_s1_module rdv_fifo_for_cpu_0_data_master_to_sdram_0_s1
    (
      .clear_fifo           (1'b0),
      .clk                  (clk),
      .data_in              (cpu_0_data_master_granted_sdram_0_s1),
      .data_out             (cpu_0_data_master_rdv_fifo_output_from_sdram_0_s1),
      .empty                (),
      .fifo_contains_ones_n (cpu_0_data_master_rdv_fifo_empty_sdram_0_s1),
      .full                 (),
      .read                 (sdram_0_s1_move_on_to_next_transaction),
      .reset_n              (reset_n),
      .sync_reset           (1'b0),
      .write                (in_a_read_cycle & ~sdram_0_s1_waits_for_read)
    );

  assign cpu_0_data_master_read_data_valid_sdram_0_s1_shift_register = ~cpu_0_data_master_rdv_fifo_empty_sdram_0_s1;
  //local readdatavalid cpu_0_data_master_read_data_valid_sdram_0_s1, which is an e_mux
  assign cpu_0_data_master_read_data_valid_sdram_0_s1 = (sdram_0_s1_readdatavalid_from_sa & cpu_0_data_master_rdv_fifo_output_from_sdram_0_s1) & ~ cpu_0_data_master_rdv_fifo_empty_sdram_0_s1;

  //sdram_0_s1_writedata mux, which is an e_mux
  assign sdram_0_s1_writedata = (cpu_0_data_master_granted_sdram_0_s1)? cpu_0_data_master_dbs_write_16 :
    dma_write_master_dbs_write_16;

  assign cpu_0_instruction_master_requests_sdram_0_s1 = (({cpu_0_instruction_master_address_to_slave[25 : 23] , 23'b0} == 26'h1800000) & (cpu_0_instruction_master_read)) & cpu_0_instruction_master_read;
  //cpu_0/data_master granted sdram_0/s1 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_data_master_granted_slave_sdram_0_s1 <= 0;
      else if (1)
          last_cycle_cpu_0_data_master_granted_slave_sdram_0_s1 <= cpu_0_data_master_saved_grant_sdram_0_s1 ? 1 : (sdram_0_s1_arbitration_holdoff_internal | ~cpu_0_data_master_requests_sdram_0_s1) ? 0 : last_cycle_cpu_0_data_master_granted_slave_sdram_0_s1;
    end


  //cpu_0_data_master_continuerequest continued request, which is an e_mux
  assign cpu_0_data_master_continuerequest = (last_cycle_cpu_0_data_master_granted_slave_sdram_0_s1 & cpu_0_data_master_requests_sdram_0_s1) |
    (last_cycle_cpu_0_data_master_granted_slave_sdram_0_s1 & cpu_0_data_master_requests_sdram_0_s1) |
    (last_cycle_cpu_0_data_master_granted_slave_sdram_0_s1 & cpu_0_data_master_requests_sdram_0_s1);

  assign cpu_0_instruction_master_qualified_request_sdram_0_s1 = cpu_0_instruction_master_requests_sdram_0_s1 & ~((cpu_0_instruction_master_read & ((cpu_0_instruction_master_latency_counter != 0) | (1 < cpu_0_instruction_master_latency_counter))) | cpu_0_data_master_arbiterlock | dma_read_master_arbiterlock | dma_write_master_arbiterlock);
  //rdv_fifo_for_cpu_0_instruction_master_to_sdram_0_s1, which is an e_fifo_with_registered_outputs
  rdv_fifo_for_cpu_0_instruction_master_to_sdram_0_s1_module rdv_fifo_for_cpu_0_instruction_master_to_sdram_0_s1
    (
      .clear_fifo           (1'b0),
      .clk                  (clk),
      .data_in              (cpu_0_instruction_master_granted_sdram_0_s1),
      .data_out             (cpu_0_instruction_master_rdv_fifo_output_from_sdram_0_s1),
      .empty                (),
      .fifo_contains_ones_n (cpu_0_instruction_master_rdv_fifo_empty_sdram_0_s1),
      .full                 (),
      .read                 (sdram_0_s1_move_on_to_next_transaction),
      .reset_n              (reset_n),
      .sync_reset           (1'b0),
      .write                (in_a_read_cycle & ~sdram_0_s1_waits_for_read)
    );

  assign cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register = ~cpu_0_instruction_master_rdv_fifo_empty_sdram_0_s1;
  //local readdatavalid cpu_0_instruction_master_read_data_valid_sdram_0_s1, which is an e_mux
  assign cpu_0_instruction_master_read_data_valid_sdram_0_s1 = (sdram_0_s1_readdatavalid_from_sa & cpu_0_instruction_master_rdv_fifo_output_from_sdram_0_s1) & ~ cpu_0_instruction_master_rdv_fifo_empty_sdram_0_s1;

  assign dma_read_master_requests_sdram_0_s1 = (({dma_read_master_address_to_slave[25 : 23] , 23'b0} == 26'h1800000) & dma_read_master_chipselect) & (~dma_read_master_read_n & dma_read_master_chipselect);
  assign dma_read_master_qualified_request_sdram_0_s1 = dma_read_master_requests_sdram_0_s1 & ~(((~dma_read_master_read_n & dma_read_master_chipselect) & ((dma_read_master_latency_counter != 0) | (1 < dma_read_master_latency_counter))) | cpu_0_data_master_arbiterlock | cpu_0_instruction_master_arbiterlock | dma_write_master_arbiterlock);
  //rdv_fifo_for_dma_read_master_to_sdram_0_s1, which is an e_fifo_with_registered_outputs
  rdv_fifo_for_dma_read_master_to_sdram_0_s1_module rdv_fifo_for_dma_read_master_to_sdram_0_s1
    (
      .clear_fifo           (1'b0),
      .clk                  (clk),
      .data_in              (dma_read_master_granted_sdram_0_s1),
      .data_out             (dma_read_master_rdv_fifo_output_from_sdram_0_s1),
      .empty                (),
      .fifo_contains_ones_n (dma_read_master_rdv_fifo_empty_sdram_0_s1),
      .full                 (),
      .read                 (sdram_0_s1_move_on_to_next_transaction),
      .reset_n              (reset_n),
      .sync_reset           (dma_read_master_flush_qualified_exported),
      .write                (in_a_read_cycle & ~sdram_0_s1_waits_for_read)
    );

  assign dma_read_master_read_data_valid_sdram_0_s1_shift_register = ~dma_read_master_rdv_fifo_empty_sdram_0_s1;
  //local readdatavalid dma_read_master_read_data_valid_sdram_0_s1, which is an e_mux
  assign dma_read_master_read_data_valid_sdram_0_s1 = (sdram_0_s1_readdatavalid_from_sa & dma_read_master_rdv_fifo_output_from_sdram_0_s1) & ~ dma_read_master_rdv_fifo_empty_sdram_0_s1;

  assign dma_write_master_requests_sdram_0_s1 = (({dma_write_master_address_to_slave[25 : 23] , 23'b0} == 26'h1800000) & dma_write_master_chipselect) & (~dma_write_master_write_n & dma_write_master_chipselect);
  assign dma_write_master_qualified_request_sdram_0_s1 = dma_write_master_requests_sdram_0_s1 & ~(((!dma_write_master_byteenable_sdram_0_s1) & (~dma_write_master_write_n & dma_write_master_chipselect)) | cpu_0_data_master_arbiterlock | cpu_0_instruction_master_arbiterlock | dma_read_master_arbiterlock);
  //allow new arb cycle for sdram_0/s1, which is an e_assign
  assign sdram_0_s1_allow_new_arb_cycle = ~cpu_0_data_master_arbiterlock & ~cpu_0_instruction_master_arbiterlock & ~dma_read_master_arbiterlock & ~dma_write_master_arbiterlock;

  //dma/write_master assignment into master qualified-requests vector for sdram_0/s1, which is an e_assign
  assign sdram_0_s1_master_qreq_vector[0] = dma_write_master_qualified_request_sdram_0_s1;

  //dma/write_master grant sdram_0/s1, which is an e_assign
  assign dma_write_master_granted_sdram_0_s1 = sdram_0_s1_grant_vector[0];

  //dma/write_master saved-grant sdram_0/s1, which is an e_assign
  assign dma_write_master_saved_grant_sdram_0_s1 = sdram_0_s1_arb_winner[0] && dma_write_master_requests_sdram_0_s1;

  //dma/read_master assignment into master qualified-requests vector for sdram_0/s1, which is an e_assign
  assign sdram_0_s1_master_qreq_vector[1] = dma_read_master_qualified_request_sdram_0_s1;

  //dma/read_master grant sdram_0/s1, which is an e_assign
  assign dma_read_master_granted_sdram_0_s1 = sdram_0_s1_grant_vector[1];

  //dma/read_master saved-grant sdram_0/s1, which is an e_assign
  assign dma_read_master_saved_grant_sdram_0_s1 = sdram_0_s1_arb_winner[1] && dma_read_master_requests_sdram_0_s1;

  //cpu_0/instruction_master assignment into master qualified-requests vector for sdram_0/s1, which is an e_assign
  assign sdram_0_s1_master_qreq_vector[2] = cpu_0_instruction_master_qualified_request_sdram_0_s1;

  //cpu_0/instruction_master grant sdram_0/s1, which is an e_assign
  assign cpu_0_instruction_master_granted_sdram_0_s1 = sdram_0_s1_grant_vector[2];

  //cpu_0/instruction_master saved-grant sdram_0/s1, which is an e_assign
  assign cpu_0_instruction_master_saved_grant_sdram_0_s1 = sdram_0_s1_arb_winner[2] && cpu_0_instruction_master_requests_sdram_0_s1;

  //cpu_0/data_master assignment into master qualified-requests vector for sdram_0/s1, which is an e_assign
  assign sdram_0_s1_master_qreq_vector[3] = cpu_0_data_master_qualified_request_sdram_0_s1;

  //cpu_0/data_master grant sdram_0/s1, which is an e_assign
  assign cpu_0_data_master_granted_sdram_0_s1 = sdram_0_s1_grant_vector[3];

  //cpu_0/data_master saved-grant sdram_0/s1, which is an e_assign
  assign cpu_0_data_master_saved_grant_sdram_0_s1 = sdram_0_s1_arb_winner[3] && cpu_0_data_master_requests_sdram_0_s1;

  //sdram_0/s1 chosen-master double-vector, which is an e_assign
  assign sdram_0_s1_chosen_master_double_vector = {sdram_0_s1_master_qreq_vector, sdram_0_s1_master_qreq_vector} & ({~sdram_0_s1_master_qreq_vector, ~sdram_0_s1_master_qreq_vector} + sdram_0_s1_arb_addend);

  //stable onehot encoding of arb winner
  assign sdram_0_s1_arb_winner = (sdram_0_s1_allow_new_arb_cycle & | sdram_0_s1_grant_vector) ? sdram_0_s1_grant_vector : sdram_0_s1_saved_chosen_master_vector;

  //saved sdram_0_s1_grant_vector, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          sdram_0_s1_saved_chosen_master_vector <= 0;
      else if (sdram_0_s1_allow_new_arb_cycle)
          sdram_0_s1_saved_chosen_master_vector <= |sdram_0_s1_grant_vector ? sdram_0_s1_grant_vector : sdram_0_s1_saved_chosen_master_vector;
    end


  //onehot encoding of chosen master
  assign sdram_0_s1_grant_vector = {(sdram_0_s1_chosen_master_double_vector[3] | sdram_0_s1_chosen_master_double_vector[7]),
    (sdram_0_s1_chosen_master_double_vector[2] | sdram_0_s1_chosen_master_double_vector[6]),
    (sdram_0_s1_chosen_master_double_vector[1] | sdram_0_s1_chosen_master_double_vector[5]),
    (sdram_0_s1_chosen_master_double_vector[0] | sdram_0_s1_chosen_master_double_vector[4])};

  //sdram_0/s1 chosen master rotated left, which is an e_assign
  assign sdram_0_s1_chosen_master_rot_left = (sdram_0_s1_arb_winner << 1) ? (sdram_0_s1_arb_winner << 1) : 1;

  //sdram_0/s1's addend for next-master-grant
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          sdram_0_s1_arb_addend <= 1;
      else if (|sdram_0_s1_grant_vector)
          sdram_0_s1_arb_addend <= sdram_0_s1_end_xfer? sdram_0_s1_chosen_master_rot_left : sdram_0_s1_grant_vector;
    end


  //sdram_0_s1_reset_n assignment, which is an e_assign
  assign sdram_0_s1_reset_n = reset_n;

  assign sdram_0_s1_chipselect = cpu_0_data_master_granted_sdram_0_s1 | cpu_0_instruction_master_granted_sdram_0_s1 | dma_read_master_granted_sdram_0_s1 | dma_write_master_granted_sdram_0_s1;
  //sdram_0_s1_firsttransfer first transaction, which is an e_assign
  assign sdram_0_s1_firsttransfer = sdram_0_s1_begins_xfer ? sdram_0_s1_unreg_firsttransfer : sdram_0_s1_reg_firsttransfer;

  //sdram_0_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign sdram_0_s1_unreg_firsttransfer = ~(sdram_0_s1_slavearbiterlockenable & sdram_0_s1_any_continuerequest);

  //sdram_0_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          sdram_0_s1_reg_firsttransfer <= 1'b1;
      else if (sdram_0_s1_begins_xfer)
          sdram_0_s1_reg_firsttransfer <= sdram_0_s1_unreg_firsttransfer;
    end


  //sdram_0_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign sdram_0_s1_beginbursttransfer_internal = sdram_0_s1_begins_xfer;

  //sdram_0_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  assign sdram_0_s1_arbitration_holdoff_internal = sdram_0_s1_begins_xfer & sdram_0_s1_firsttransfer;

  //~sdram_0_s1_read_n assignment, which is an e_mux
  assign sdram_0_s1_read_n = ~((cpu_0_data_master_granted_sdram_0_s1 & cpu_0_data_master_read) | (cpu_0_instruction_master_granted_sdram_0_s1 & cpu_0_instruction_master_read) | (dma_read_master_granted_sdram_0_s1 & (~dma_read_master_read_n & dma_read_master_chipselect)));

  //~sdram_0_s1_write_n assignment, which is an e_mux
  assign sdram_0_s1_write_n = ~((cpu_0_data_master_granted_sdram_0_s1 & cpu_0_data_master_write) | (dma_write_master_granted_sdram_0_s1 & (~dma_write_master_write_n & dma_write_master_chipselect)));

  assign shifted_address_to_sdram_0_s1_from_cpu_0_data_master = {cpu_0_data_master_address_to_slave >> 2,
    cpu_0_data_master_dbs_address[1],
    {1 {1'b0}}};

  //sdram_0_s1_address mux, which is an e_mux
  assign sdram_0_s1_address = (cpu_0_data_master_granted_sdram_0_s1)? (shifted_address_to_sdram_0_s1_from_cpu_0_data_master >> 1) :
    (cpu_0_instruction_master_granted_sdram_0_s1)? (shifted_address_to_sdram_0_s1_from_cpu_0_instruction_master >> 1) :
    (dma_read_master_granted_sdram_0_s1)? (shifted_address_to_sdram_0_s1_from_dma_read_master >> 1) :
    (shifted_address_to_sdram_0_s1_from_dma_write_master >> 1);

  assign shifted_address_to_sdram_0_s1_from_cpu_0_instruction_master = {cpu_0_instruction_master_address_to_slave >> 2,
    cpu_0_instruction_master_dbs_address[1],
    {1 {1'b0}}};

  assign shifted_address_to_sdram_0_s1_from_dma_read_master = {dma_read_master_address_to_slave >> 2,
    dma_read_master_dbs_address[1],
    {1 {1'b0}}};

  assign shifted_address_to_sdram_0_s1_from_dma_write_master = {dma_write_master_address_to_slave >> 2,
    dma_write_master_dbs_address[1],
    {1 {1'b0}}};

  //d1_sdram_0_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_sdram_0_s1_end_xfer <= 1;
      else if (1)
          d1_sdram_0_s1_end_xfer <= sdram_0_s1_end_xfer;
    end


  //sdram_0_s1_waits_for_read in a cycle, which is an e_mux
  assign sdram_0_s1_waits_for_read = sdram_0_s1_in_a_read_cycle & sdram_0_s1_waitrequest_from_sa;

  //sdram_0_s1_in_a_read_cycle assignment, which is an e_assign
  assign sdram_0_s1_in_a_read_cycle = (cpu_0_data_master_granted_sdram_0_s1 & cpu_0_data_master_read) | (cpu_0_instruction_master_granted_sdram_0_s1 & cpu_0_instruction_master_read) | (dma_read_master_granted_sdram_0_s1 & (~dma_read_master_read_n & dma_read_master_chipselect));

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = sdram_0_s1_in_a_read_cycle;

  //sdram_0_s1_waits_for_write in a cycle, which is an e_mux
  assign sdram_0_s1_waits_for_write = sdram_0_s1_in_a_write_cycle & sdram_0_s1_waitrequest_from_sa;

  //sdram_0_s1_in_a_write_cycle assignment, which is an e_assign
  assign sdram_0_s1_in_a_write_cycle = (cpu_0_data_master_granted_sdram_0_s1 & cpu_0_data_master_write) | (dma_write_master_granted_sdram_0_s1 & (~dma_write_master_write_n & dma_write_master_chipselect));

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = sdram_0_s1_in_a_write_cycle;

  assign wait_for_sdram_0_s1_counter = 0;
  //~sdram_0_s1_byteenable_n byte enable port mux, which is an e_mux
  assign sdram_0_s1_byteenable_n = ~((cpu_0_data_master_granted_sdram_0_s1)? cpu_0_data_master_byteenable_sdram_0_s1 :
    (dma_write_master_granted_sdram_0_s1)? dma_write_master_byteenable_sdram_0_s1 :
    -1);

  assign {cpu_0_data_master_byteenable_sdram_0_s1_segment_1,
cpu_0_data_master_byteenable_sdram_0_s1_segment_0} = cpu_0_data_master_byteenable;
  assign cpu_0_data_master_byteenable_sdram_0_s1 = ((cpu_0_data_master_dbs_address[1] == 0))? cpu_0_data_master_byteenable_sdram_0_s1_segment_0 :
    cpu_0_data_master_byteenable_sdram_0_s1_segment_1;

  assign {dma_write_master_byteenable_sdram_0_s1_segment_1,
dma_write_master_byteenable_sdram_0_s1_segment_0} = dma_write_master_byteenable;
  assign dma_write_master_byteenable_sdram_0_s1 = ((dma_write_master_dbs_address[1] == 0))? dma_write_master_byteenable_sdram_0_s1_segment_0 :
    dma_write_master_byteenable_sdram_0_s1_segment_1;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //sdram_0/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end


  //grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_0_data_master_granted_sdram_0_s1 + cpu_0_instruction_master_granted_sdram_0_s1 + dma_read_master_granted_sdram_0_s1 + dma_write_master_granted_sdram_0_s1 > 1)
        begin
          $write("%0d ns: > 1 of grant signals are active simultaneously", $time);
          $stop;
        end
    end


  //saved_grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_0_data_master_saved_grant_sdram_0_s1 + cpu_0_instruction_master_saved_grant_sdram_0_s1 + dma_read_master_saved_grant_sdram_0_s1 + dma_write_master_saved_grant_sdram_0_s1 > 1)
        begin
          $write("%0d ns: > 1 of saved_grant signals are active simultaneously", $time);
          $stop;
        end
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module seg78led_0_avalon_slave_0_arbitrator (
                                              // inputs:
                                               clk,
                                               cpu_0_data_master_address_to_slave,
                                               cpu_0_data_master_byteenable,
                                               cpu_0_data_master_dbs_address,
                                               cpu_0_data_master_dbs_write_8,
                                               cpu_0_data_master_no_byte_enables_and_last_term,
                                               cpu_0_data_master_read,
                                               cpu_0_data_master_write,
                                               cpu_0_instruction_master_address_to_slave,
                                               cpu_0_instruction_master_dbs_address,
                                               cpu_0_instruction_master_latency_counter,
                                               cpu_0_instruction_master_read,
                                               cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register,
                                               reset_n,
                                               seg78led_0_avalon_slave_0_readdata,

                                              // outputs:
                                               cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0,
                                               cpu_0_data_master_granted_seg78led_0_avalon_slave_0,
                                               cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0,
                                               cpu_0_data_master_read_data_valid_seg78led_0_avalon_slave_0,
                                               cpu_0_data_master_requests_seg78led_0_avalon_slave_0,
                                               cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0,
                                               cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0,
                                               cpu_0_instruction_master_read_data_valid_seg78led_0_avalon_slave_0,
                                               cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0,
                                               d1_seg78led_0_avalon_slave_0_end_xfer,
                                               seg78led_0_avalon_slave_0_address,
                                               seg78led_0_avalon_slave_0_read_n,
                                               seg78led_0_avalon_slave_0_readdata_from_sa,
                                               seg78led_0_avalon_slave_0_wait_counter_eq_0,
                                               seg78led_0_avalon_slave_0_wait_counter_eq_1,
                                               seg78led_0_avalon_slave_0_write_n,
                                               seg78led_0_avalon_slave_0_writedata
                                            )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0;
  output           cpu_0_data_master_granted_seg78led_0_avalon_slave_0;
  output           cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0;
  output           cpu_0_data_master_read_data_valid_seg78led_0_avalon_slave_0;
  output           cpu_0_data_master_requests_seg78led_0_avalon_slave_0;
  output           cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0;
  output           cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0;
  output           cpu_0_instruction_master_read_data_valid_seg78led_0_avalon_slave_0;
  output           cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0;
  output           d1_seg78led_0_avalon_slave_0_end_xfer;
  output  [  2: 0] seg78led_0_avalon_slave_0_address;
  output           seg78led_0_avalon_slave_0_read_n;
  output  [  7: 0] seg78led_0_avalon_slave_0_readdata_from_sa;
  output           seg78led_0_avalon_slave_0_wait_counter_eq_0;
  output           seg78led_0_avalon_slave_0_wait_counter_eq_1;
  output           seg78led_0_avalon_slave_0_write_n;
  output  [  7: 0] seg78led_0_avalon_slave_0_writedata;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input   [  3: 0] cpu_0_data_master_byteenable;
  input   [  1: 0] cpu_0_data_master_dbs_address;
  input   [  7: 0] cpu_0_data_master_dbs_write_8;
  input            cpu_0_data_master_no_byte_enables_and_last_term;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_write;
  input   [ 25: 0] cpu_0_instruction_master_address_to_slave;
  input   [  1: 0] cpu_0_instruction_master_dbs_address;
  input   [  1: 0] cpu_0_instruction_master_latency_counter;
  input            cpu_0_instruction_master_read;
  input            cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register;
  input            reset_n;
  input   [  7: 0] seg78led_0_avalon_slave_0_readdata;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0;
  wire             cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0_segment_0;
  wire             cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0_segment_1;
  wire             cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0_segment_2;
  wire             cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0_segment_3;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_seg78led_0_avalon_slave_0;
  wire             cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0;
  wire             cpu_0_data_master_read_data_valid_seg78led_0_avalon_slave_0;
  wire             cpu_0_data_master_requests_seg78led_0_avalon_slave_0;
  wire             cpu_0_data_master_saved_grant_seg78led_0_avalon_slave_0;
  wire             cpu_0_instruction_master_arbiterlock;
  wire             cpu_0_instruction_master_arbiterlock2;
  wire             cpu_0_instruction_master_continuerequest;
  wire             cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0;
  wire             cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0;
  wire             cpu_0_instruction_master_read_data_valid_seg78led_0_avalon_slave_0;
  wire             cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0;
  wire             cpu_0_instruction_master_saved_grant_seg78led_0_avalon_slave_0;
  reg              d1_reasons_to_wait;
  reg              d1_seg78led_0_avalon_slave_0_end_xfer;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_seg78led_0_avalon_slave_0;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  reg              last_cycle_cpu_0_data_master_granted_slave_seg78led_0_avalon_slave_0;
  reg              last_cycle_cpu_0_instruction_master_granted_slave_seg78led_0_avalon_slave_0;
  wire    [  2: 0] seg78led_0_avalon_slave_0_address;
  wire             seg78led_0_avalon_slave_0_allgrants;
  wire             seg78led_0_avalon_slave_0_allow_new_arb_cycle;
  wire             seg78led_0_avalon_slave_0_any_bursting_master_saved_grant;
  wire             seg78led_0_avalon_slave_0_any_continuerequest;
  reg     [  1: 0] seg78led_0_avalon_slave_0_arb_addend;
  wire             seg78led_0_avalon_slave_0_arb_counter_enable;
  reg     [  2: 0] seg78led_0_avalon_slave_0_arb_share_counter;
  wire    [  2: 0] seg78led_0_avalon_slave_0_arb_share_counter_next_value;
  wire    [  2: 0] seg78led_0_avalon_slave_0_arb_share_set_values;
  wire    [  1: 0] seg78led_0_avalon_slave_0_arb_winner;
  wire             seg78led_0_avalon_slave_0_arbitration_holdoff_internal;
  wire             seg78led_0_avalon_slave_0_beginbursttransfer_internal;
  wire             seg78led_0_avalon_slave_0_begins_xfer;
  wire    [  3: 0] seg78led_0_avalon_slave_0_chosen_master_double_vector;
  wire    [  1: 0] seg78led_0_avalon_slave_0_chosen_master_rot_left;
  wire    [  4: 0] seg78led_0_avalon_slave_0_counter_load_value;
  wire             seg78led_0_avalon_slave_0_end_xfer;
  wire             seg78led_0_avalon_slave_0_firsttransfer;
  wire    [  1: 0] seg78led_0_avalon_slave_0_grant_vector;
  wire             seg78led_0_avalon_slave_0_in_a_read_cycle;
  wire             seg78led_0_avalon_slave_0_in_a_write_cycle;
  wire    [  1: 0] seg78led_0_avalon_slave_0_master_qreq_vector;
  wire             seg78led_0_avalon_slave_0_non_bursting_master_requests;
  wire             seg78led_0_avalon_slave_0_pretend_byte_enable;
  wire             seg78led_0_avalon_slave_0_read_n;
  wire    [  7: 0] seg78led_0_avalon_slave_0_readdata_from_sa;
  reg              seg78led_0_avalon_slave_0_reg_firsttransfer;
  reg     [  1: 0] seg78led_0_avalon_slave_0_saved_chosen_master_vector;
  reg              seg78led_0_avalon_slave_0_slavearbiterlockenable;
  wire             seg78led_0_avalon_slave_0_slavearbiterlockenable2;
  wire             seg78led_0_avalon_slave_0_unreg_firsttransfer;
  reg     [  4: 0] seg78led_0_avalon_slave_0_wait_counter;
  wire             seg78led_0_avalon_slave_0_wait_counter_eq_0;
  wire             seg78led_0_avalon_slave_0_wait_counter_eq_1;
  wire             seg78led_0_avalon_slave_0_waits_for_read;
  wire             seg78led_0_avalon_slave_0_waits_for_write;
  wire             seg78led_0_avalon_slave_0_write_n;
  wire    [  7: 0] seg78led_0_avalon_slave_0_writedata;
  wire             wait_for_seg78led_0_avalon_slave_0_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~seg78led_0_avalon_slave_0_end_xfer;
    end


  assign seg78led_0_avalon_slave_0_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0 | cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0));
  //assign seg78led_0_avalon_slave_0_readdata_from_sa = seg78led_0_avalon_slave_0_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign seg78led_0_avalon_slave_0_readdata_from_sa = seg78led_0_avalon_slave_0_readdata;

  assign cpu_0_data_master_requests_seg78led_0_avalon_slave_0 = ({cpu_0_data_master_address_to_slave[25 : 3] , 3'b0} == 26'h2003340) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //seg78led_0_avalon_slave_0_arb_share_counter set values, which is an e_mux
  assign seg78led_0_avalon_slave_0_arb_share_set_values = (cpu_0_data_master_granted_seg78led_0_avalon_slave_0)? 4 :
    (cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0)? 4 :
    (cpu_0_data_master_granted_seg78led_0_avalon_slave_0)? 4 :
    (cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0)? 4 :
    1;

  //seg78led_0_avalon_slave_0_non_bursting_master_requests mux, which is an e_mux
  assign seg78led_0_avalon_slave_0_non_bursting_master_requests = cpu_0_data_master_requests_seg78led_0_avalon_slave_0 |
    cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0 |
    cpu_0_data_master_requests_seg78led_0_avalon_slave_0 |
    cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0;

  //seg78led_0_avalon_slave_0_any_bursting_master_saved_grant mux, which is an e_mux
  assign seg78led_0_avalon_slave_0_any_bursting_master_saved_grant = 0;

  //seg78led_0_avalon_slave_0_arb_share_counter_next_value assignment, which is an e_assign
  assign seg78led_0_avalon_slave_0_arb_share_counter_next_value = seg78led_0_avalon_slave_0_firsttransfer ? (seg78led_0_avalon_slave_0_arb_share_set_values - 1) : |seg78led_0_avalon_slave_0_arb_share_counter ? (seg78led_0_avalon_slave_0_arb_share_counter - 1) : 0;

  //seg78led_0_avalon_slave_0_allgrants all slave grants, which is an e_mux
  assign seg78led_0_avalon_slave_0_allgrants = |seg78led_0_avalon_slave_0_grant_vector |
    |seg78led_0_avalon_slave_0_grant_vector |
    |seg78led_0_avalon_slave_0_grant_vector |
    |seg78led_0_avalon_slave_0_grant_vector;

  //seg78led_0_avalon_slave_0_end_xfer assignment, which is an e_assign
  assign seg78led_0_avalon_slave_0_end_xfer = ~(seg78led_0_avalon_slave_0_waits_for_read | seg78led_0_avalon_slave_0_waits_for_write);

  //end_xfer_arb_share_counter_term_seg78led_0_avalon_slave_0 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_seg78led_0_avalon_slave_0 = seg78led_0_avalon_slave_0_end_xfer & (~seg78led_0_avalon_slave_0_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //seg78led_0_avalon_slave_0_arb_share_counter arbitration counter enable, which is an e_assign
  assign seg78led_0_avalon_slave_0_arb_counter_enable = (end_xfer_arb_share_counter_term_seg78led_0_avalon_slave_0 & seg78led_0_avalon_slave_0_allgrants) | (end_xfer_arb_share_counter_term_seg78led_0_avalon_slave_0 & ~seg78led_0_avalon_slave_0_non_bursting_master_requests);

  //seg78led_0_avalon_slave_0_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          seg78led_0_avalon_slave_0_arb_share_counter <= 0;
      else if (seg78led_0_avalon_slave_0_arb_counter_enable)
          seg78led_0_avalon_slave_0_arb_share_counter <= seg78led_0_avalon_slave_0_arb_share_counter_next_value;
    end


  //seg78led_0_avalon_slave_0_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          seg78led_0_avalon_slave_0_slavearbiterlockenable <= 0;
      else if ((|seg78led_0_avalon_slave_0_master_qreq_vector & end_xfer_arb_share_counter_term_seg78led_0_avalon_slave_0) | (end_xfer_arb_share_counter_term_seg78led_0_avalon_slave_0 & ~seg78led_0_avalon_slave_0_non_bursting_master_requests))
          seg78led_0_avalon_slave_0_slavearbiterlockenable <= |seg78led_0_avalon_slave_0_arb_share_counter_next_value;
    end


  //cpu_0/data_master seg78led_0/avalon_slave_0 arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = seg78led_0_avalon_slave_0_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //seg78led_0_avalon_slave_0_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign seg78led_0_avalon_slave_0_slavearbiterlockenable2 = |seg78led_0_avalon_slave_0_arb_share_counter_next_value;

  //cpu_0/data_master seg78led_0/avalon_slave_0 arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = seg78led_0_avalon_slave_0_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //cpu_0/instruction_master seg78led_0/avalon_slave_0 arbiterlock, which is an e_assign
  assign cpu_0_instruction_master_arbiterlock = seg78led_0_avalon_slave_0_slavearbiterlockenable & cpu_0_instruction_master_continuerequest;

  //cpu_0/instruction_master seg78led_0/avalon_slave_0 arbiterlock2, which is an e_assign
  assign cpu_0_instruction_master_arbiterlock2 = seg78led_0_avalon_slave_0_slavearbiterlockenable2 & cpu_0_instruction_master_continuerequest;

  //cpu_0/instruction_master granted seg78led_0/avalon_slave_0 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_instruction_master_granted_slave_seg78led_0_avalon_slave_0 <= 0;
      else if (1)
          last_cycle_cpu_0_instruction_master_granted_slave_seg78led_0_avalon_slave_0 <= cpu_0_instruction_master_saved_grant_seg78led_0_avalon_slave_0 ? 1 : (seg78led_0_avalon_slave_0_arbitration_holdoff_internal | ~cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0) ? 0 : last_cycle_cpu_0_instruction_master_granted_slave_seg78led_0_avalon_slave_0;
    end


  //cpu_0_instruction_master_continuerequest continued request, which is an e_mux
  assign cpu_0_instruction_master_continuerequest = last_cycle_cpu_0_instruction_master_granted_slave_seg78led_0_avalon_slave_0 & cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0;

  //seg78led_0_avalon_slave_0_any_continuerequest at least one master continues requesting, which is an e_mux
  assign seg78led_0_avalon_slave_0_any_continuerequest = cpu_0_instruction_master_continuerequest |
    cpu_0_data_master_continuerequest;

  assign cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0 = cpu_0_data_master_requests_seg78led_0_avalon_slave_0 & ~(((cpu_0_data_master_no_byte_enables_and_last_term | !cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0) & cpu_0_data_master_write) | cpu_0_instruction_master_arbiterlock);
  //seg78led_0_avalon_slave_0_writedata mux, which is an e_mux
  assign seg78led_0_avalon_slave_0_writedata = cpu_0_data_master_dbs_write_8;

  assign cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0 = (({cpu_0_instruction_master_address_to_slave[25 : 3] , 3'b0} == 26'h2003340) & (cpu_0_instruction_master_read)) & cpu_0_instruction_master_read;
  //cpu_0/data_master granted seg78led_0/avalon_slave_0 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_data_master_granted_slave_seg78led_0_avalon_slave_0 <= 0;
      else if (1)
          last_cycle_cpu_0_data_master_granted_slave_seg78led_0_avalon_slave_0 <= cpu_0_data_master_saved_grant_seg78led_0_avalon_slave_0 ? 1 : (seg78led_0_avalon_slave_0_arbitration_holdoff_internal | ~cpu_0_data_master_requests_seg78led_0_avalon_slave_0) ? 0 : last_cycle_cpu_0_data_master_granted_slave_seg78led_0_avalon_slave_0;
    end


  //cpu_0_data_master_continuerequest continued request, which is an e_mux
  assign cpu_0_data_master_continuerequest = last_cycle_cpu_0_data_master_granted_slave_seg78led_0_avalon_slave_0 & cpu_0_data_master_requests_seg78led_0_avalon_slave_0;

  assign cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0 = cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0 & ~((cpu_0_instruction_master_read & ((cpu_0_instruction_master_latency_counter != 0) | (|cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register))) | cpu_0_data_master_arbiterlock);
  //local readdatavalid cpu_0_instruction_master_read_data_valid_seg78led_0_avalon_slave_0, which is an e_mux
  assign cpu_0_instruction_master_read_data_valid_seg78led_0_avalon_slave_0 = cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0 & cpu_0_instruction_master_read & ~seg78led_0_avalon_slave_0_waits_for_read;

  //allow new arb cycle for seg78led_0/avalon_slave_0, which is an e_assign
  assign seg78led_0_avalon_slave_0_allow_new_arb_cycle = ~cpu_0_data_master_arbiterlock & ~cpu_0_instruction_master_arbiterlock;

  //cpu_0/instruction_master assignment into master qualified-requests vector for seg78led_0/avalon_slave_0, which is an e_assign
  assign seg78led_0_avalon_slave_0_master_qreq_vector[0] = cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0;

  //cpu_0/instruction_master grant seg78led_0/avalon_slave_0, which is an e_assign
  assign cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0 = seg78led_0_avalon_slave_0_grant_vector[0];

  //cpu_0/instruction_master saved-grant seg78led_0/avalon_slave_0, which is an e_assign
  assign cpu_0_instruction_master_saved_grant_seg78led_0_avalon_slave_0 = seg78led_0_avalon_slave_0_arb_winner[0] && cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0;

  //cpu_0/data_master assignment into master qualified-requests vector for seg78led_0/avalon_slave_0, which is an e_assign
  assign seg78led_0_avalon_slave_0_master_qreq_vector[1] = cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0;

  //cpu_0/data_master grant seg78led_0/avalon_slave_0, which is an e_assign
  assign cpu_0_data_master_granted_seg78led_0_avalon_slave_0 = seg78led_0_avalon_slave_0_grant_vector[1];

  //cpu_0/data_master saved-grant seg78led_0/avalon_slave_0, which is an e_assign
  assign cpu_0_data_master_saved_grant_seg78led_0_avalon_slave_0 = seg78led_0_avalon_slave_0_arb_winner[1] && cpu_0_data_master_requests_seg78led_0_avalon_slave_0;

  //seg78led_0/avalon_slave_0 chosen-master double-vector, which is an e_assign
  assign seg78led_0_avalon_slave_0_chosen_master_double_vector = {seg78led_0_avalon_slave_0_master_qreq_vector, seg78led_0_avalon_slave_0_master_qreq_vector} & ({~seg78led_0_avalon_slave_0_master_qreq_vector, ~seg78led_0_avalon_slave_0_master_qreq_vector} + seg78led_0_avalon_slave_0_arb_addend);

  //stable onehot encoding of arb winner
  assign seg78led_0_avalon_slave_0_arb_winner = (seg78led_0_avalon_slave_0_allow_new_arb_cycle & | seg78led_0_avalon_slave_0_grant_vector) ? seg78led_0_avalon_slave_0_grant_vector : seg78led_0_avalon_slave_0_saved_chosen_master_vector;

  //saved seg78led_0_avalon_slave_0_grant_vector, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          seg78led_0_avalon_slave_0_saved_chosen_master_vector <= 0;
      else if (seg78led_0_avalon_slave_0_allow_new_arb_cycle)
          seg78led_0_avalon_slave_0_saved_chosen_master_vector <= |seg78led_0_avalon_slave_0_grant_vector ? seg78led_0_avalon_slave_0_grant_vector : seg78led_0_avalon_slave_0_saved_chosen_master_vector;
    end


  //onehot encoding of chosen master
  assign seg78led_0_avalon_slave_0_grant_vector = {(seg78led_0_avalon_slave_0_chosen_master_double_vector[1] | seg78led_0_avalon_slave_0_chosen_master_double_vector[3]),
    (seg78led_0_avalon_slave_0_chosen_master_double_vector[0] | seg78led_0_avalon_slave_0_chosen_master_double_vector[2])};

  //seg78led_0/avalon_slave_0 chosen master rotated left, which is an e_assign
  assign seg78led_0_avalon_slave_0_chosen_master_rot_left = (seg78led_0_avalon_slave_0_arb_winner << 1) ? (seg78led_0_avalon_slave_0_arb_winner << 1) : 1;

  //seg78led_0/avalon_slave_0's addend for next-master-grant
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          seg78led_0_avalon_slave_0_arb_addend <= 1;
      else if (|seg78led_0_avalon_slave_0_grant_vector)
          seg78led_0_avalon_slave_0_arb_addend <= seg78led_0_avalon_slave_0_end_xfer? seg78led_0_avalon_slave_0_chosen_master_rot_left : seg78led_0_avalon_slave_0_grant_vector;
    end


  //seg78led_0_avalon_slave_0_firsttransfer first transaction, which is an e_assign
  assign seg78led_0_avalon_slave_0_firsttransfer = seg78led_0_avalon_slave_0_begins_xfer ? seg78led_0_avalon_slave_0_unreg_firsttransfer : seg78led_0_avalon_slave_0_reg_firsttransfer;

  //seg78led_0_avalon_slave_0_unreg_firsttransfer first transaction, which is an e_assign
  assign seg78led_0_avalon_slave_0_unreg_firsttransfer = ~(seg78led_0_avalon_slave_0_slavearbiterlockenable & seg78led_0_avalon_slave_0_any_continuerequest);

  //seg78led_0_avalon_slave_0_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          seg78led_0_avalon_slave_0_reg_firsttransfer <= 1'b1;
      else if (seg78led_0_avalon_slave_0_begins_xfer)
          seg78led_0_avalon_slave_0_reg_firsttransfer <= seg78led_0_avalon_slave_0_unreg_firsttransfer;
    end


  //seg78led_0_avalon_slave_0_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign seg78led_0_avalon_slave_0_beginbursttransfer_internal = seg78led_0_avalon_slave_0_begins_xfer;

  //seg78led_0_avalon_slave_0_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  assign seg78led_0_avalon_slave_0_arbitration_holdoff_internal = seg78led_0_avalon_slave_0_begins_xfer & seg78led_0_avalon_slave_0_firsttransfer;

  //~seg78led_0_avalon_slave_0_read_n assignment, which is an e_mux
  assign seg78led_0_avalon_slave_0_read_n = ~(((cpu_0_data_master_granted_seg78led_0_avalon_slave_0 & cpu_0_data_master_read) | (cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0 & cpu_0_instruction_master_read))& ~seg78led_0_avalon_slave_0_begins_xfer & (seg78led_0_avalon_slave_0_wait_counter < 10));

  //~seg78led_0_avalon_slave_0_write_n assignment, which is an e_mux
  assign seg78led_0_avalon_slave_0_write_n = ~(((cpu_0_data_master_granted_seg78led_0_avalon_slave_0 & cpu_0_data_master_write)) & ~seg78led_0_avalon_slave_0_begins_xfer & (seg78led_0_avalon_slave_0_wait_counter >= 10) & (seg78led_0_avalon_slave_0_wait_counter < 20) & seg78led_0_avalon_slave_0_pretend_byte_enable);

  //seg78led_0_avalon_slave_0_address mux, which is an e_mux
  assign seg78led_0_avalon_slave_0_address = (cpu_0_data_master_granted_seg78led_0_avalon_slave_0)? ({cpu_0_data_master_address_to_slave >> 2,
    cpu_0_data_master_dbs_address[1 : 0]}) :
    ({cpu_0_instruction_master_address_to_slave >> 2,
    cpu_0_instruction_master_dbs_address[1 : 0]});

  //d1_seg78led_0_avalon_slave_0_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_seg78led_0_avalon_slave_0_end_xfer <= 1;
      else if (1)
          d1_seg78led_0_avalon_slave_0_end_xfer <= seg78led_0_avalon_slave_0_end_xfer;
    end


  //seg78led_0_avalon_slave_0_wait_counter_eq_1 assignment, which is an e_assign
  assign seg78led_0_avalon_slave_0_wait_counter_eq_1 = seg78led_0_avalon_slave_0_wait_counter == 1;

  //seg78led_0_avalon_slave_0_waits_for_read in a cycle, which is an e_mux
  assign seg78led_0_avalon_slave_0_waits_for_read = seg78led_0_avalon_slave_0_in_a_read_cycle & wait_for_seg78led_0_avalon_slave_0_counter;

  //seg78led_0_avalon_slave_0_in_a_read_cycle assignment, which is an e_assign
  assign seg78led_0_avalon_slave_0_in_a_read_cycle = (cpu_0_data_master_granted_seg78led_0_avalon_slave_0 & cpu_0_data_master_read) | (cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0 & cpu_0_instruction_master_read);

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = seg78led_0_avalon_slave_0_in_a_read_cycle;

  //seg78led_0_avalon_slave_0_waits_for_write in a cycle, which is an e_mux
  assign seg78led_0_avalon_slave_0_waits_for_write = seg78led_0_avalon_slave_0_in_a_write_cycle & wait_for_seg78led_0_avalon_slave_0_counter;

  //seg78led_0_avalon_slave_0_in_a_write_cycle assignment, which is an e_assign
  assign seg78led_0_avalon_slave_0_in_a_write_cycle = cpu_0_data_master_granted_seg78led_0_avalon_slave_0 & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = seg78led_0_avalon_slave_0_in_a_write_cycle;

  assign seg78led_0_avalon_slave_0_wait_counter_eq_0 = seg78led_0_avalon_slave_0_wait_counter == 0;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          seg78led_0_avalon_slave_0_wait_counter <= 0;
      else if (1)
          seg78led_0_avalon_slave_0_wait_counter <= seg78led_0_avalon_slave_0_counter_load_value;
    end


  assign seg78led_0_avalon_slave_0_counter_load_value = ((seg78led_0_avalon_slave_0_in_a_write_cycle & seg78led_0_avalon_slave_0_begins_xfer))? 28 :
    ((seg78led_0_avalon_slave_0_in_a_read_cycle & seg78led_0_avalon_slave_0_begins_xfer))? 18 :
    (~seg78led_0_avalon_slave_0_wait_counter_eq_0)? seg78led_0_avalon_slave_0_wait_counter - 1 :
    0;

  assign wait_for_seg78led_0_avalon_slave_0_counter = seg78led_0_avalon_slave_0_begins_xfer | ~seg78led_0_avalon_slave_0_wait_counter_eq_0;
  //seg78led_0_avalon_slave_0_pretend_byte_enable byte enable port mux, which is an e_mux
  assign seg78led_0_avalon_slave_0_pretend_byte_enable = (cpu_0_data_master_granted_seg78led_0_avalon_slave_0)? cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0 :
    -1;

  assign {cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0_segment_3,
cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0_segment_2,
cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0_segment_1,
cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0_segment_0} = cpu_0_data_master_byteenable;
  assign cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0 = ((cpu_0_data_master_dbs_address[1 : 0] == 0))? cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0_segment_0 :
    ((cpu_0_data_master_dbs_address[1 : 0] == 1))? cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0_segment_1 :
    ((cpu_0_data_master_dbs_address[1 : 0] == 2))? cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0_segment_2 :
    cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0_segment_3;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //seg78led_0/avalon_slave_0 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end


  //grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_0_data_master_granted_seg78led_0_avalon_slave_0 + cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0 > 1)
        begin
          $write("%0d ns: > 1 of grant signals are active simultaneously", $time);
          $stop;
        end
    end


  //saved_grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_0_data_master_saved_grant_seg78led_0_avalon_slave_0 + cpu_0_instruction_master_saved_grant_seg78led_0_avalon_slave_0 > 1)
        begin
          $write("%0d ns: > 1 of saved_grant signals are active simultaneously", $time);
          $stop;
        end
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module sysid_control_slave_arbitrator (
                                        // inputs:
                                         clk,
                                         cpu_0_data_master_address_to_slave,
                                         cpu_0_data_master_read,
                                         cpu_0_data_master_write,
                                         reset_n,
                                         sysid_control_slave_readdata,

                                        // outputs:
                                         cpu_0_data_master_granted_sysid_control_slave,
                                         cpu_0_data_master_qualified_request_sysid_control_slave,
                                         cpu_0_data_master_read_data_valid_sysid_control_slave,
                                         cpu_0_data_master_requests_sysid_control_slave,
                                         d1_sysid_control_slave_end_xfer,
                                         sysid_control_slave_address,
                                         sysid_control_slave_readdata_from_sa
                                      )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_sysid_control_slave;
  output           cpu_0_data_master_qualified_request_sysid_control_slave;
  output           cpu_0_data_master_read_data_valid_sysid_control_slave;
  output           cpu_0_data_master_requests_sysid_control_slave;
  output           d1_sysid_control_slave_end_xfer;
  output           sysid_control_slave_address;
  output  [ 31: 0] sysid_control_slave_readdata_from_sa;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_write;
  input            reset_n;
  input   [ 31: 0] sysid_control_slave_readdata;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_sysid_control_slave;
  wire             cpu_0_data_master_qualified_request_sysid_control_slave;
  wire             cpu_0_data_master_read_data_valid_sysid_control_slave;
  wire             cpu_0_data_master_requests_sysid_control_slave;
  wire             cpu_0_data_master_saved_grant_sysid_control_slave;
  reg              d1_reasons_to_wait;
  reg              d1_sysid_control_slave_end_xfer;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_sysid_control_slave;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 25: 0] shifted_address_to_sysid_control_slave_from_cpu_0_data_master;
  wire             sysid_control_slave_address;
  wire             sysid_control_slave_allgrants;
  wire             sysid_control_slave_allow_new_arb_cycle;
  wire             sysid_control_slave_any_bursting_master_saved_grant;
  wire             sysid_control_slave_any_continuerequest;
  wire             sysid_control_slave_arb_counter_enable;
  reg     [  2: 0] sysid_control_slave_arb_share_counter;
  wire    [  2: 0] sysid_control_slave_arb_share_counter_next_value;
  wire    [  2: 0] sysid_control_slave_arb_share_set_values;
  wire             sysid_control_slave_beginbursttransfer_internal;
  wire             sysid_control_slave_begins_xfer;
  wire             sysid_control_slave_end_xfer;
  wire             sysid_control_slave_firsttransfer;
  wire             sysid_control_slave_grant_vector;
  wire             sysid_control_slave_in_a_read_cycle;
  wire             sysid_control_slave_in_a_write_cycle;
  wire             sysid_control_slave_master_qreq_vector;
  wire             sysid_control_slave_non_bursting_master_requests;
  wire    [ 31: 0] sysid_control_slave_readdata_from_sa;
  reg              sysid_control_slave_reg_firsttransfer;
  reg              sysid_control_slave_slavearbiterlockenable;
  wire             sysid_control_slave_slavearbiterlockenable2;
  wire             sysid_control_slave_unreg_firsttransfer;
  wire             sysid_control_slave_waits_for_read;
  wire             sysid_control_slave_waits_for_write;
  wire             wait_for_sysid_control_slave_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~sysid_control_slave_end_xfer;
    end


  assign sysid_control_slave_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_sysid_control_slave));
  //assign sysid_control_slave_readdata_from_sa = sysid_control_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign sysid_control_slave_readdata_from_sa = sysid_control_slave_readdata;

  assign cpu_0_data_master_requests_sysid_control_slave = (({cpu_0_data_master_address_to_slave[25 : 3] , 3'b0} == 26'h2003338) & (cpu_0_data_master_read | cpu_0_data_master_write)) & cpu_0_data_master_read;
  //sysid_control_slave_arb_share_counter set values, which is an e_mux
  assign sysid_control_slave_arb_share_set_values = 1;

  //sysid_control_slave_non_bursting_master_requests mux, which is an e_mux
  assign sysid_control_slave_non_bursting_master_requests = cpu_0_data_master_requests_sysid_control_slave;

  //sysid_control_slave_any_bursting_master_saved_grant mux, which is an e_mux
  assign sysid_control_slave_any_bursting_master_saved_grant = 0;

  //sysid_control_slave_arb_share_counter_next_value assignment, which is an e_assign
  assign sysid_control_slave_arb_share_counter_next_value = sysid_control_slave_firsttransfer ? (sysid_control_slave_arb_share_set_values - 1) : |sysid_control_slave_arb_share_counter ? (sysid_control_slave_arb_share_counter - 1) : 0;

  //sysid_control_slave_allgrants all slave grants, which is an e_mux
  assign sysid_control_slave_allgrants = |sysid_control_slave_grant_vector;

  //sysid_control_slave_end_xfer assignment, which is an e_assign
  assign sysid_control_slave_end_xfer = ~(sysid_control_slave_waits_for_read | sysid_control_slave_waits_for_write);

  //end_xfer_arb_share_counter_term_sysid_control_slave arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_sysid_control_slave = sysid_control_slave_end_xfer & (~sysid_control_slave_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //sysid_control_slave_arb_share_counter arbitration counter enable, which is an e_assign
  assign sysid_control_slave_arb_counter_enable = (end_xfer_arb_share_counter_term_sysid_control_slave & sysid_control_slave_allgrants) | (end_xfer_arb_share_counter_term_sysid_control_slave & ~sysid_control_slave_non_bursting_master_requests);

  //sysid_control_slave_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          sysid_control_slave_arb_share_counter <= 0;
      else if (sysid_control_slave_arb_counter_enable)
          sysid_control_slave_arb_share_counter <= sysid_control_slave_arb_share_counter_next_value;
    end


  //sysid_control_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          sysid_control_slave_slavearbiterlockenable <= 0;
      else if ((|sysid_control_slave_master_qreq_vector & end_xfer_arb_share_counter_term_sysid_control_slave) | (end_xfer_arb_share_counter_term_sysid_control_slave & ~sysid_control_slave_non_bursting_master_requests))
          sysid_control_slave_slavearbiterlockenable <= |sysid_control_slave_arb_share_counter_next_value;
    end


  //cpu_0/data_master sysid/control_slave arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = sysid_control_slave_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //sysid_control_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign sysid_control_slave_slavearbiterlockenable2 = |sysid_control_slave_arb_share_counter_next_value;

  //cpu_0/data_master sysid/control_slave arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = sysid_control_slave_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //sysid_control_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  assign sysid_control_slave_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_sysid_control_slave = cpu_0_data_master_requests_sysid_control_slave;
  //master is always granted when requested
  assign cpu_0_data_master_granted_sysid_control_slave = cpu_0_data_master_qualified_request_sysid_control_slave;

  //cpu_0/data_master saved-grant sysid/control_slave, which is an e_assign
  assign cpu_0_data_master_saved_grant_sysid_control_slave = cpu_0_data_master_requests_sysid_control_slave;

  //allow new arb cycle for sysid/control_slave, which is an e_assign
  assign sysid_control_slave_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign sysid_control_slave_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign sysid_control_slave_master_qreq_vector = 1;

  //sysid_control_slave_firsttransfer first transaction, which is an e_assign
  assign sysid_control_slave_firsttransfer = sysid_control_slave_begins_xfer ? sysid_control_slave_unreg_firsttransfer : sysid_control_slave_reg_firsttransfer;

  //sysid_control_slave_unreg_firsttransfer first transaction, which is an e_assign
  assign sysid_control_slave_unreg_firsttransfer = ~(sysid_control_slave_slavearbiterlockenable & sysid_control_slave_any_continuerequest);

  //sysid_control_slave_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          sysid_control_slave_reg_firsttransfer <= 1'b1;
      else if (sysid_control_slave_begins_xfer)
          sysid_control_slave_reg_firsttransfer <= sysid_control_slave_unreg_firsttransfer;
    end


  //sysid_control_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign sysid_control_slave_beginbursttransfer_internal = sysid_control_slave_begins_xfer;

  assign shifted_address_to_sysid_control_slave_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //sysid_control_slave_address mux, which is an e_mux
  assign sysid_control_slave_address = shifted_address_to_sysid_control_slave_from_cpu_0_data_master >> 2;

  //d1_sysid_control_slave_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_sysid_control_slave_end_xfer <= 1;
      else if (1)
          d1_sysid_control_slave_end_xfer <= sysid_control_slave_end_xfer;
    end


  //sysid_control_slave_waits_for_read in a cycle, which is an e_mux
  assign sysid_control_slave_waits_for_read = sysid_control_slave_in_a_read_cycle & sysid_control_slave_begins_xfer;

  //sysid_control_slave_in_a_read_cycle assignment, which is an e_assign
  assign sysid_control_slave_in_a_read_cycle = cpu_0_data_master_granted_sysid_control_slave & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = sysid_control_slave_in_a_read_cycle;

  //sysid_control_slave_waits_for_write in a cycle, which is an e_mux
  assign sysid_control_slave_waits_for_write = sysid_control_slave_in_a_write_cycle & 0;

  //sysid_control_slave_in_a_write_cycle assignment, which is an e_assign
  assign sysid_control_slave_in_a_write_cycle = cpu_0_data_master_granted_sysid_control_slave & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = sysid_control_slave_in_a_write_cycle;

  assign wait_for_sysid_control_slave_counter = 0;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //sysid/control_slave enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module timer_0_s1_arbitrator (
                               // inputs:
                                clk,
                                cpu_0_data_master_address_to_slave,
                                cpu_0_data_master_read,
                                cpu_0_data_master_waitrequest,
                                cpu_0_data_master_write,
                                cpu_0_data_master_writedata,
                                reset_n,
                                timer_0_s1_irq,
                                timer_0_s1_readdata,

                               // outputs:
                                cpu_0_data_master_granted_timer_0_s1,
                                cpu_0_data_master_qualified_request_timer_0_s1,
                                cpu_0_data_master_read_data_valid_timer_0_s1,
                                cpu_0_data_master_requests_timer_0_s1,
                                d1_timer_0_s1_end_xfer,
                                timer_0_s1_address,
                                timer_0_s1_chipselect,
                                timer_0_s1_irq_from_sa,
                                timer_0_s1_readdata_from_sa,
                                timer_0_s1_reset_n,
                                timer_0_s1_write_n,
                                timer_0_s1_writedata
                             )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_timer_0_s1;
  output           cpu_0_data_master_qualified_request_timer_0_s1;
  output           cpu_0_data_master_read_data_valid_timer_0_s1;
  output           cpu_0_data_master_requests_timer_0_s1;
  output           d1_timer_0_s1_end_xfer;
  output  [  2: 0] timer_0_s1_address;
  output           timer_0_s1_chipselect;
  output           timer_0_s1_irq_from_sa;
  output  [ 15: 0] timer_0_s1_readdata_from_sa;
  output           timer_0_s1_reset_n;
  output           timer_0_s1_write_n;
  output  [ 15: 0] timer_0_s1_writedata;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_waitrequest;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input            reset_n;
  input            timer_0_s1_irq;
  input   [ 15: 0] timer_0_s1_readdata;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_timer_0_s1;
  wire             cpu_0_data_master_qualified_request_timer_0_s1;
  wire             cpu_0_data_master_read_data_valid_timer_0_s1;
  wire             cpu_0_data_master_requests_timer_0_s1;
  wire             cpu_0_data_master_saved_grant_timer_0_s1;
  reg              d1_reasons_to_wait;
  reg              d1_timer_0_s1_end_xfer;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_timer_0_s1;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 25: 0] shifted_address_to_timer_0_s1_from_cpu_0_data_master;
  wire    [  2: 0] timer_0_s1_address;
  wire             timer_0_s1_allgrants;
  wire             timer_0_s1_allow_new_arb_cycle;
  wire             timer_0_s1_any_bursting_master_saved_grant;
  wire             timer_0_s1_any_continuerequest;
  wire             timer_0_s1_arb_counter_enable;
  reg     [  2: 0] timer_0_s1_arb_share_counter;
  wire    [  2: 0] timer_0_s1_arb_share_counter_next_value;
  wire    [  2: 0] timer_0_s1_arb_share_set_values;
  wire             timer_0_s1_beginbursttransfer_internal;
  wire             timer_0_s1_begins_xfer;
  wire             timer_0_s1_chipselect;
  wire             timer_0_s1_end_xfer;
  wire             timer_0_s1_firsttransfer;
  wire             timer_0_s1_grant_vector;
  wire             timer_0_s1_in_a_read_cycle;
  wire             timer_0_s1_in_a_write_cycle;
  wire             timer_0_s1_irq_from_sa;
  wire             timer_0_s1_master_qreq_vector;
  wire             timer_0_s1_non_bursting_master_requests;
  wire    [ 15: 0] timer_0_s1_readdata_from_sa;
  reg              timer_0_s1_reg_firsttransfer;
  wire             timer_0_s1_reset_n;
  reg              timer_0_s1_slavearbiterlockenable;
  wire             timer_0_s1_slavearbiterlockenable2;
  wire             timer_0_s1_unreg_firsttransfer;
  wire             timer_0_s1_waits_for_read;
  wire             timer_0_s1_waits_for_write;
  wire             timer_0_s1_write_n;
  wire    [ 15: 0] timer_0_s1_writedata;
  wire             wait_for_timer_0_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~timer_0_s1_end_xfer;
    end


  assign timer_0_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_timer_0_s1));
  //assign timer_0_s1_readdata_from_sa = timer_0_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign timer_0_s1_readdata_from_sa = timer_0_s1_readdata;

  assign cpu_0_data_master_requests_timer_0_s1 = ({cpu_0_data_master_address_to_slave[25 : 5] , 5'b0} == 26'h2003200) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //timer_0_s1_arb_share_counter set values, which is an e_mux
  assign timer_0_s1_arb_share_set_values = 1;

  //timer_0_s1_non_bursting_master_requests mux, which is an e_mux
  assign timer_0_s1_non_bursting_master_requests = cpu_0_data_master_requests_timer_0_s1;

  //timer_0_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign timer_0_s1_any_bursting_master_saved_grant = 0;

  //timer_0_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign timer_0_s1_arb_share_counter_next_value = timer_0_s1_firsttransfer ? (timer_0_s1_arb_share_set_values - 1) : |timer_0_s1_arb_share_counter ? (timer_0_s1_arb_share_counter - 1) : 0;

  //timer_0_s1_allgrants all slave grants, which is an e_mux
  assign timer_0_s1_allgrants = |timer_0_s1_grant_vector;

  //timer_0_s1_end_xfer assignment, which is an e_assign
  assign timer_0_s1_end_xfer = ~(timer_0_s1_waits_for_read | timer_0_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_timer_0_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_timer_0_s1 = timer_0_s1_end_xfer & (~timer_0_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //timer_0_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign timer_0_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_timer_0_s1 & timer_0_s1_allgrants) | (end_xfer_arb_share_counter_term_timer_0_s1 & ~timer_0_s1_non_bursting_master_requests);

  //timer_0_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          timer_0_s1_arb_share_counter <= 0;
      else if (timer_0_s1_arb_counter_enable)
          timer_0_s1_arb_share_counter <= timer_0_s1_arb_share_counter_next_value;
    end


  //timer_0_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          timer_0_s1_slavearbiterlockenable <= 0;
      else if ((|timer_0_s1_master_qreq_vector & end_xfer_arb_share_counter_term_timer_0_s1) | (end_xfer_arb_share_counter_term_timer_0_s1 & ~timer_0_s1_non_bursting_master_requests))
          timer_0_s1_slavearbiterlockenable <= |timer_0_s1_arb_share_counter_next_value;
    end


  //cpu_0/data_master timer_0/s1 arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = timer_0_s1_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //timer_0_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign timer_0_s1_slavearbiterlockenable2 = |timer_0_s1_arb_share_counter_next_value;

  //cpu_0/data_master timer_0/s1 arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = timer_0_s1_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //timer_0_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  assign timer_0_s1_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_timer_0_s1 = cpu_0_data_master_requests_timer_0_s1 & ~(((~cpu_0_data_master_waitrequest) & cpu_0_data_master_write));
  //timer_0_s1_writedata mux, which is an e_mux
  assign timer_0_s1_writedata = cpu_0_data_master_writedata;

  //master is always granted when requested
  assign cpu_0_data_master_granted_timer_0_s1 = cpu_0_data_master_qualified_request_timer_0_s1;

  //cpu_0/data_master saved-grant timer_0/s1, which is an e_assign
  assign cpu_0_data_master_saved_grant_timer_0_s1 = cpu_0_data_master_requests_timer_0_s1;

  //allow new arb cycle for timer_0/s1, which is an e_assign
  assign timer_0_s1_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign timer_0_s1_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign timer_0_s1_master_qreq_vector = 1;

  //timer_0_s1_reset_n assignment, which is an e_assign
  assign timer_0_s1_reset_n = reset_n;

  assign timer_0_s1_chipselect = cpu_0_data_master_granted_timer_0_s1;
  //timer_0_s1_firsttransfer first transaction, which is an e_assign
  assign timer_0_s1_firsttransfer = timer_0_s1_begins_xfer ? timer_0_s1_unreg_firsttransfer : timer_0_s1_reg_firsttransfer;

  //timer_0_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign timer_0_s1_unreg_firsttransfer = ~(timer_0_s1_slavearbiterlockenable & timer_0_s1_any_continuerequest);

  //timer_0_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          timer_0_s1_reg_firsttransfer <= 1'b1;
      else if (timer_0_s1_begins_xfer)
          timer_0_s1_reg_firsttransfer <= timer_0_s1_unreg_firsttransfer;
    end


  //timer_0_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign timer_0_s1_beginbursttransfer_internal = timer_0_s1_begins_xfer;

  //~timer_0_s1_write_n assignment, which is an e_mux
  assign timer_0_s1_write_n = ~(cpu_0_data_master_granted_timer_0_s1 & cpu_0_data_master_write);

  assign shifted_address_to_timer_0_s1_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //timer_0_s1_address mux, which is an e_mux
  assign timer_0_s1_address = shifted_address_to_timer_0_s1_from_cpu_0_data_master >> 2;

  //d1_timer_0_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_timer_0_s1_end_xfer <= 1;
      else if (1)
          d1_timer_0_s1_end_xfer <= timer_0_s1_end_xfer;
    end


  //timer_0_s1_waits_for_read in a cycle, which is an e_mux
  assign timer_0_s1_waits_for_read = timer_0_s1_in_a_read_cycle & timer_0_s1_begins_xfer;

  //timer_0_s1_in_a_read_cycle assignment, which is an e_assign
  assign timer_0_s1_in_a_read_cycle = cpu_0_data_master_granted_timer_0_s1 & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = timer_0_s1_in_a_read_cycle;

  //timer_0_s1_waits_for_write in a cycle, which is an e_mux
  assign timer_0_s1_waits_for_write = timer_0_s1_in_a_write_cycle & 0;

  //timer_0_s1_in_a_write_cycle assignment, which is an e_assign
  assign timer_0_s1_in_a_write_cycle = cpu_0_data_master_granted_timer_0_s1 & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = timer_0_s1_in_a_write_cycle;

  assign wait_for_timer_0_s1_counter = 0;
  //assign timer_0_s1_irq_from_sa = timer_0_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign timer_0_s1_irq_from_sa = timer_0_s1_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //timer_0/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module tri_state_bridge_0_avalon_slave_arbitrator (
                                                    // inputs:
                                                     clk,
                                                     cpu_0_data_master_address_to_slave,
                                                     cpu_0_data_master_byteenable,
                                                     cpu_0_data_master_dbs_address,
                                                     cpu_0_data_master_dbs_write_8,
                                                     cpu_0_data_master_no_byte_enables_and_last_term,
                                                     cpu_0_data_master_read,
                                                     cpu_0_data_master_write,
                                                     cpu_0_data_master_writedata,
                                                     cpu_0_instruction_master_address_to_slave,
                                                     cpu_0_instruction_master_dbs_address,
                                                     cpu_0_instruction_master_latency_counter,
                                                     cpu_0_instruction_master_read,
                                                     cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register,
                                                     irq_from_the_ctrl_rtl8019_0,
                                                     reset_n,

                                                    // outputs:
                                                     chipselect_to_the_lcd_tri_12864_0,
                                                     chipselect_to_the_lcd_tri_1602_0,
                                                     cpu_0_data_master_byteenable_flash_s1,
                                                     cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                                     cpu_0_data_master_granted_flash_s1,
                                                     cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0,
                                                     cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0,
                                                     cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                                     cpu_0_data_master_qualified_request_flash_s1,
                                                     cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0,
                                                     cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0,
                                                     cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                                     cpu_0_data_master_read_data_valid_flash_s1,
                                                     cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0,
                                                     cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0,
                                                     cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                                     cpu_0_data_master_requests_flash_s1,
                                                     cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0,
                                                     cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0,
                                                     cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                                     cpu_0_instruction_master_granted_flash_s1,
                                                     cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0,
                                                     cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0,
                                                     cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                                     cpu_0_instruction_master_qualified_request_flash_s1,
                                                     cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0,
                                                     cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0,
                                                     cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                                     cpu_0_instruction_master_read_data_valid_flash_s1,
                                                     cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0,
                                                     cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0,
                                                     cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                                     cpu_0_instruction_master_requests_flash_s1,
                                                     cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0,
                                                     cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0,
                                                     ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0,
                                                     ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1,
                                                     d1_irq_from_the_ctrl_rtl8019_0,
                                                     d1_tri_state_bridge_0_avalon_slave_end_xfer,
                                                     flash_s1_wait_counter_eq_0,
                                                     flash_s1_wait_counter_eq_1,
                                                     incoming_tri_state_bridge_0_data,
                                                     incoming_tri_state_bridge_0_data_with_Xs_converted_to_0,
                                                     lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0,
                                                     lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1,
                                                     lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0,
                                                     lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1,
                                                     read_n_to_the_ctrl_rtl8019_0,
                                                     registered_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0,
                                                     registered_cpu_0_data_master_read_data_valid_flash_s1,
                                                     registered_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0,
                                                     registered_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0,
                                                     rst_to_the_ctrl_rtl8019_0,
                                                     select_n_to_the_ctrl_rtl8019_0,
                                                     select_n_to_the_flash,
                                                     tri_state_bridge_0_address,
                                                     tri_state_bridge_0_data,
                                                     tri_state_bridge_0_read,
                                                     tri_state_bridge_0_readn,
                                                     tri_state_bridge_0_write,
                                                     write_n_to_the_ctrl_rtl8019_0,
                                                     write_n_to_the_flash
                                                  )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           chipselect_to_the_lcd_tri_12864_0;
  output           chipselect_to_the_lcd_tri_1602_0;
  output           cpu_0_data_master_byteenable_flash_s1;
  output           cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0;
  output           cpu_0_data_master_granted_flash_s1;
  output           cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0;
  output           cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0;
  output           cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0;
  output           cpu_0_data_master_qualified_request_flash_s1;
  output           cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0;
  output           cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0;
  output           cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0;
  output           cpu_0_data_master_read_data_valid_flash_s1;
  output           cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0;
  output           cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0;
  output           cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0;
  output           cpu_0_data_master_requests_flash_s1;
  output           cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0;
  output           cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0;
  output           cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0;
  output           cpu_0_instruction_master_granted_flash_s1;
  output           cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0;
  output           cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0;
  output           cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0;
  output           cpu_0_instruction_master_qualified_request_flash_s1;
  output           cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0;
  output           cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0;
  output           cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0;
  output           cpu_0_instruction_master_read_data_valid_flash_s1;
  output           cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0;
  output           cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0;
  output           cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0;
  output           cpu_0_instruction_master_requests_flash_s1;
  output           cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0;
  output           cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0;
  output           ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0;
  output           ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1;
  output           d1_irq_from_the_ctrl_rtl8019_0;
  output           d1_tri_state_bridge_0_avalon_slave_end_xfer;
  output           flash_s1_wait_counter_eq_0;
  output           flash_s1_wait_counter_eq_1;
  output  [  7: 0] incoming_tri_state_bridge_0_data;
  output  [  7: 0] incoming_tri_state_bridge_0_data_with_Xs_converted_to_0;
  output           lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0;
  output           lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1;
  output           lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0;
  output           lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1;
  output           read_n_to_the_ctrl_rtl8019_0;
  output           registered_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0;
  output           registered_cpu_0_data_master_read_data_valid_flash_s1;
  output           registered_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0;
  output           registered_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0;
  output           rst_to_the_ctrl_rtl8019_0;
  output           select_n_to_the_ctrl_rtl8019_0;
  output           select_n_to_the_flash;
  output  [ 22: 0] tri_state_bridge_0_address;
  inout   [  7: 0] tri_state_bridge_0_data;
  output           tri_state_bridge_0_read;
  output           tri_state_bridge_0_readn;
  output           tri_state_bridge_0_write;
  output           write_n_to_the_ctrl_rtl8019_0;
  output           write_n_to_the_flash;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input   [  3: 0] cpu_0_data_master_byteenable;
  input   [  1: 0] cpu_0_data_master_dbs_address;
  input   [  7: 0] cpu_0_data_master_dbs_write_8;
  input            cpu_0_data_master_no_byte_enables_and_last_term;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input   [ 25: 0] cpu_0_instruction_master_address_to_slave;
  input   [  1: 0] cpu_0_instruction_master_dbs_address;
  input   [  1: 0] cpu_0_instruction_master_latency_counter;
  input            cpu_0_instruction_master_read;
  input            cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register;
  input            irq_from_the_ctrl_rtl8019_0;
  input            reset_n;

  reg              chipselect_to_the_lcd_tri_12864_0 /* synthesis ALTERA_ATTRIBUTE = "FAST_OUTPUT_REGISTER=ON"  */;
  reg              chipselect_to_the_lcd_tri_1602_0 /* synthesis ALTERA_ATTRIBUTE = "FAST_OUTPUT_REGISTER=ON"  */;
  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_byteenable_flash_s1;
  wire             cpu_0_data_master_byteenable_flash_s1_segment_0;
  wire             cpu_0_data_master_byteenable_flash_s1_segment_1;
  wire             cpu_0_data_master_byteenable_flash_s1_segment_2;
  wire             cpu_0_data_master_byteenable_flash_s1_segment_3;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_granted_flash_s1;
  wire             cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_qualified_request_flash_s1;
  wire             cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0;
  reg     [  1: 0] cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register;
  wire             cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register_in;
  wire             cpu_0_data_master_read_data_valid_flash_s1;
  reg     [  1: 0] cpu_0_data_master_read_data_valid_flash_s1_shift_register;
  wire             cpu_0_data_master_read_data_valid_flash_s1_shift_register_in;
  wire             cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0;
  reg     [  1: 0] cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register;
  wire             cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register_in;
  wire             cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0;
  reg     [  1: 0] cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register;
  wire             cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register_in;
  wire             cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_requests_flash_s1;
  wire             cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_saved_grant_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_saved_grant_flash_s1;
  wire             cpu_0_data_master_saved_grant_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_saved_grant_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_arbiterlock;
  wire             cpu_0_instruction_master_arbiterlock2;
  wire             cpu_0_instruction_master_continuerequest;
  wire             cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_granted_flash_s1;
  wire             cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_qualified_request_flash_s1;
  wire             cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0;
  reg     [  1: 0] cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register;
  wire             cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register_in;
  wire             cpu_0_instruction_master_read_data_valid_flash_s1;
  reg     [  1: 0] cpu_0_instruction_master_read_data_valid_flash_s1_shift_register;
  wire             cpu_0_instruction_master_read_data_valid_flash_s1_shift_register_in;
  wire             cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0;
  reg     [  1: 0] cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register;
  wire             cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register_in;
  wire             cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0;
  reg     [  1: 0] cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register;
  wire             cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register_in;
  wire             cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_requests_flash_s1;
  wire             cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_saved_grant_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_saved_grant_flash_s1;
  wire             cpu_0_instruction_master_saved_grant_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_saved_grant_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire    [  3: 0] ctrl_rtl8019_0_avalon_tristate_slave_0_counter_load_value;
  wire             ctrl_rtl8019_0_avalon_tristate_slave_0_in_a_read_cycle;
  wire             ctrl_rtl8019_0_avalon_tristate_slave_0_in_a_write_cycle;
  wire             ctrl_rtl8019_0_avalon_tristate_slave_0_pretend_byte_enable;
  reg     [  3: 0] ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter;
  wire             ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0;
  wire             ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1;
  wire             ctrl_rtl8019_0_avalon_tristate_slave_0_waits_for_read;
  wire             ctrl_rtl8019_0_avalon_tristate_slave_0_waits_for_write;
  wire             ctrl_rtl8019_0_avalon_tristate_slave_0_with_write_latency;
  reg              d1_in_a_write_cycle /* synthesis ALTERA_ATTRIBUTE = "FAST_OUTPUT_ENABLE_REGISTER=ON"  */;
  reg              d1_irq_from_the_ctrl_rtl8019_0;
  reg     [  7: 0] d1_outgoing_tri_state_bridge_0_data /* synthesis ALTERA_ATTRIBUTE = "FAST_OUTPUT_REGISTER=ON"  */;
  reg              d1_reasons_to_wait;
  reg              d1_tri_state_bridge_0_avalon_slave_end_xfer;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_tri_state_bridge_0_avalon_slave;
  wire    [  2: 0] flash_s1_counter_load_value;
  wire             flash_s1_in_a_read_cycle;
  wire             flash_s1_in_a_write_cycle;
  wire             flash_s1_pretend_byte_enable;
  reg     [  2: 0] flash_s1_wait_counter;
  wire             flash_s1_wait_counter_eq_0;
  wire             flash_s1_wait_counter_eq_1;
  wire             flash_s1_waits_for_read;
  wire             flash_s1_waits_for_write;
  wire             flash_s1_with_write_latency;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  reg     [  7: 0] incoming_tri_state_bridge_0_data /* synthesis ALTERA_ATTRIBUTE = "FAST_INPUT_REGISTER=ON"  */;
  wire             incoming_tri_state_bridge_0_data_bit_0_is_x;
  wire             incoming_tri_state_bridge_0_data_bit_1_is_x;
  wire             incoming_tri_state_bridge_0_data_bit_2_is_x;
  wire             incoming_tri_state_bridge_0_data_bit_3_is_x;
  wire             incoming_tri_state_bridge_0_data_bit_4_is_x;
  wire             incoming_tri_state_bridge_0_data_bit_5_is_x;
  wire             incoming_tri_state_bridge_0_data_bit_6_is_x;
  wire             incoming_tri_state_bridge_0_data_bit_7_is_x;
  wire    [  7: 0] incoming_tri_state_bridge_0_data_with_Xs_converted_to_0;
  reg              last_cycle_cpu_0_data_master_granted_slave_ctrl_rtl8019_0_avalon_tristate_slave_0;
  reg              last_cycle_cpu_0_data_master_granted_slave_flash_s1;
  reg              last_cycle_cpu_0_data_master_granted_slave_lcd_tri_12864_0_avalon_tristate_slave_0;
  reg              last_cycle_cpu_0_data_master_granted_slave_lcd_tri_1602_0_avalon_tristate_slave_0;
  reg              last_cycle_cpu_0_instruction_master_granted_slave_ctrl_rtl8019_0_avalon_tristate_slave_0;
  reg              last_cycle_cpu_0_instruction_master_granted_slave_flash_s1;
  reg              last_cycle_cpu_0_instruction_master_granted_slave_lcd_tri_12864_0_avalon_tristate_slave_0;
  reg              last_cycle_cpu_0_instruction_master_granted_slave_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire    [  5: 0] lcd_tri_12864_0_avalon_tristate_slave_0_counter_load_value;
  wire             lcd_tri_12864_0_avalon_tristate_slave_0_in_a_read_cycle;
  wire             lcd_tri_12864_0_avalon_tristate_slave_0_in_a_write_cycle;
  wire             lcd_tri_12864_0_avalon_tristate_slave_0_pretend_byte_enable;
  reg     [  5: 0] lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter;
  wire             lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0;
  wire             lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1;
  wire             lcd_tri_12864_0_avalon_tristate_slave_0_waits_for_read;
  wire             lcd_tri_12864_0_avalon_tristate_slave_0_waits_for_write;
  wire             lcd_tri_12864_0_avalon_tristate_slave_0_with_write_latency;
  wire    [  5: 0] lcd_tri_1602_0_avalon_tristate_slave_0_counter_load_value;
  wire             lcd_tri_1602_0_avalon_tristate_slave_0_in_a_read_cycle;
  wire             lcd_tri_1602_0_avalon_tristate_slave_0_in_a_write_cycle;
  wire             lcd_tri_1602_0_avalon_tristate_slave_0_pretend_byte_enable;
  reg     [  5: 0] lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter;
  wire             lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0;
  wire             lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1;
  wire             lcd_tri_1602_0_avalon_tristate_slave_0_waits_for_read;
  wire             lcd_tri_1602_0_avalon_tristate_slave_0_waits_for_write;
  wire             lcd_tri_1602_0_avalon_tristate_slave_0_with_write_latency;
  wire    [  7: 0] outgoing_tri_state_bridge_0_data;
  wire             p1_chipselect_to_the_lcd_tri_12864_0;
  wire             p1_chipselect_to_the_lcd_tri_1602_0;
  wire    [  1: 0] p1_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register;
  wire    [  1: 0] p1_cpu_0_data_master_read_data_valid_flash_s1_shift_register;
  wire    [  1: 0] p1_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register;
  wire    [  1: 0] p1_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register;
  wire    [  1: 0] p1_cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register;
  wire    [  1: 0] p1_cpu_0_instruction_master_read_data_valid_flash_s1_shift_register;
  wire    [  1: 0] p1_cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register;
  wire    [  1: 0] p1_cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register;
  wire             p1_read_n_to_the_ctrl_rtl8019_0;
  wire             p1_rst_to_the_ctrl_rtl8019_0;
  wire             p1_select_n_to_the_ctrl_rtl8019_0;
  wire             p1_select_n_to_the_flash;
  wire    [ 22: 0] p1_tri_state_bridge_0_address;
  wire             p1_tri_state_bridge_0_read;
  wire             p1_tri_state_bridge_0_readn;
  wire             p1_tri_state_bridge_0_write;
  wire             p1_write_n_to_the_ctrl_rtl8019_0;
  wire             p1_write_n_to_the_flash;
  reg              read_n_to_the_ctrl_rtl8019_0 /* synthesis ALTERA_ATTRIBUTE = "FAST_OUTPUT_REGISTER=ON"  */;
  wire             registered_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             registered_cpu_0_data_master_read_data_valid_flash_s1;
  wire             registered_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             registered_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0;
  reg              rst_to_the_ctrl_rtl8019_0 /* synthesis ALTERA_ATTRIBUTE = "FAST_OUTPUT_REGISTER=ON"  */;
  reg              select_n_to_the_ctrl_rtl8019_0 /* synthesis ALTERA_ATTRIBUTE = "FAST_OUTPUT_REGISTER=ON"  */;
  reg              select_n_to_the_flash /* synthesis ALTERA_ATTRIBUTE = "FAST_OUTPUT_REGISTER=ON"  */;
  wire    [ 25: 0] shifted_address_to_ctrl_rtl8019_0_avalon_tristate_slave_0_from_cpu_0_data_master;
  wire    [ 25: 0] shifted_address_to_ctrl_rtl8019_0_avalon_tristate_slave_0_from_cpu_0_instruction_master;
  wire    [ 25: 0] shifted_address_to_lcd_tri_12864_0_avalon_tristate_slave_0_from_cpu_0_data_master;
  wire    [ 25: 0] shifted_address_to_lcd_tri_12864_0_avalon_tristate_slave_0_from_cpu_0_instruction_master;
  wire    [ 25: 0] shifted_address_to_lcd_tri_1602_0_avalon_tristate_slave_0_from_cpu_0_data_master;
  wire    [ 25: 0] shifted_address_to_lcd_tri_1602_0_avalon_tristate_slave_0_from_cpu_0_instruction_master;
  wire             time_to_write;
  reg     [ 22: 0] tri_state_bridge_0_address /* synthesis ALTERA_ATTRIBUTE = "FAST_OUTPUT_REGISTER=ON"  */;
  wire             tri_state_bridge_0_avalon_slave_allgrants;
  wire             tri_state_bridge_0_avalon_slave_allow_new_arb_cycle;
  wire             tri_state_bridge_0_avalon_slave_any_bursting_master_saved_grant;
  wire             tri_state_bridge_0_avalon_slave_any_continuerequest;
  reg     [  7: 0] tri_state_bridge_0_avalon_slave_arb_addend;
  wire             tri_state_bridge_0_avalon_slave_arb_counter_enable;
  reg     [  2: 0] tri_state_bridge_0_avalon_slave_arb_share_counter;
  wire    [  2: 0] tri_state_bridge_0_avalon_slave_arb_share_counter_next_value;
  wire    [  2: 0] tri_state_bridge_0_avalon_slave_arb_share_set_values;
  wire    [  7: 0] tri_state_bridge_0_avalon_slave_arb_winner;
  wire             tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal;
  wire             tri_state_bridge_0_avalon_slave_beginbursttransfer_internal;
  wire             tri_state_bridge_0_avalon_slave_begins_xfer;
  wire    [ 15: 0] tri_state_bridge_0_avalon_slave_chosen_master_double_vector;
  wire    [  7: 0] tri_state_bridge_0_avalon_slave_chosen_master_rot_left;
  wire             tri_state_bridge_0_avalon_slave_end_xfer;
  wire             tri_state_bridge_0_avalon_slave_firsttransfer;
  wire    [  7: 0] tri_state_bridge_0_avalon_slave_grant_vector;
  wire    [  7: 0] tri_state_bridge_0_avalon_slave_master_qreq_vector;
  wire             tri_state_bridge_0_avalon_slave_non_bursting_master_requests;
  wire             tri_state_bridge_0_avalon_slave_read_pending;
  reg              tri_state_bridge_0_avalon_slave_reg_firsttransfer;
  reg     [  7: 0] tri_state_bridge_0_avalon_slave_saved_chosen_master_vector;
  reg              tri_state_bridge_0_avalon_slave_slavearbiterlockenable;
  wire             tri_state_bridge_0_avalon_slave_slavearbiterlockenable2;
  wire             tri_state_bridge_0_avalon_slave_unreg_firsttransfer;
  wire             tri_state_bridge_0_avalon_slave_write_pending;
  wire    [  7: 0] tri_state_bridge_0_data;
  reg              tri_state_bridge_0_read /* synthesis ALTERA_ATTRIBUTE = "FAST_OUTPUT_REGISTER=ON"  */;
  reg              tri_state_bridge_0_readn /* synthesis ALTERA_ATTRIBUTE = "FAST_OUTPUT_REGISTER=ON"  */;
  reg              tri_state_bridge_0_write /* synthesis ALTERA_ATTRIBUTE = "FAST_OUTPUT_REGISTER=ON"  */;
  wire             wait_for_ctrl_rtl8019_0_avalon_tristate_slave_0_counter;
  wire             wait_for_flash_s1_counter;
  wire             wait_for_lcd_tri_12864_0_avalon_tristate_slave_0_counter;
  wire             wait_for_lcd_tri_1602_0_avalon_tristate_slave_0_counter;
  reg              write_n_to_the_ctrl_rtl8019_0 /* synthesis ALTERA_ATTRIBUTE = "FAST_OUTPUT_REGISTER=ON"  */;
  reg              write_n_to_the_flash /* synthesis ALTERA_ATTRIBUTE = "FAST_OUTPUT_REGISTER=ON"  */;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~tri_state_bridge_0_avalon_slave_end_xfer;
    end


  assign tri_state_bridge_0_avalon_slave_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0 | cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0 | cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0 | cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0 | cpu_0_data_master_qualified_request_flash_s1 | cpu_0_instruction_master_qualified_request_flash_s1 | cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0 | cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0));
  assign cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0 = ({cpu_0_data_master_address_to_slave[25 : 8] , 8'b0} == 26'h2003100) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //~select_n_to_the_ctrl_rtl8019_0 of type chipselect to ~p1_select_n_to_the_ctrl_rtl8019_0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          select_n_to_the_ctrl_rtl8019_0 <= ~0;
      else if (1)
          select_n_to_the_ctrl_rtl8019_0 <= p1_select_n_to_the_ctrl_rtl8019_0;
    end


  //chipselect_to_the_lcd_tri_12864_0 of type chipselect to p1_chipselect_to_the_lcd_tri_12864_0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          chipselect_to_the_lcd_tri_12864_0 <= 0;
      else if (1)
          chipselect_to_the_lcd_tri_12864_0 <= p1_chipselect_to_the_lcd_tri_12864_0;
    end


  //~select_n_to_the_flash of type chipselect to ~p1_select_n_to_the_flash, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          select_n_to_the_flash <= ~0;
      else if (1)
          select_n_to_the_flash <= p1_select_n_to_the_flash;
    end


  //chipselect_to_the_lcd_tri_1602_0 of type chipselect to p1_chipselect_to_the_lcd_tri_1602_0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          chipselect_to_the_lcd_tri_1602_0 <= 0;
      else if (1)
          chipselect_to_the_lcd_tri_1602_0 <= p1_chipselect_to_the_lcd_tri_1602_0;
    end


  assign tri_state_bridge_0_avalon_slave_write_pending = 0;
  //tri_state_bridge_0/avalon_slave read pending calc, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_read_pending = 0;

  //registered rdv signal_name registered_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0 assignment, which is an e_assign
  assign registered_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0 = cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register[0];

  //tri_state_bridge_0_avalon_slave_arb_share_counter set values, which is an e_mux
  assign tri_state_bridge_0_avalon_slave_arb_share_set_values = (cpu_0_data_master_granted_flash_s1)? 4 :
    (cpu_0_instruction_master_granted_flash_s1)? 4 :
    (cpu_0_data_master_granted_flash_s1)? 4 :
    (cpu_0_instruction_master_granted_flash_s1)? 4 :
    1;

  //tri_state_bridge_0_avalon_slave_non_bursting_master_requests mux, which is an e_mux
  assign tri_state_bridge_0_avalon_slave_non_bursting_master_requests = cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0 |
    cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0 |
    cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0 |
    cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0 |
    cpu_0_data_master_requests_flash_s1 |
    cpu_0_instruction_master_requests_flash_s1 |
    cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0 |
    cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0 |
    cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0 |
    cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0 |
    cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0 |
    cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0 |
    cpu_0_data_master_requests_flash_s1 |
    cpu_0_instruction_master_requests_flash_s1 |
    cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0 |
    cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0;

  //tri_state_bridge_0_avalon_slave_any_bursting_master_saved_grant mux, which is an e_mux
  assign tri_state_bridge_0_avalon_slave_any_bursting_master_saved_grant = 0;

  //tri_state_bridge_0_avalon_slave_arb_share_counter_next_value assignment, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_arb_share_counter_next_value = tri_state_bridge_0_avalon_slave_firsttransfer ? (tri_state_bridge_0_avalon_slave_arb_share_set_values - 1) : |tri_state_bridge_0_avalon_slave_arb_share_counter ? (tri_state_bridge_0_avalon_slave_arb_share_counter - 1) : 0;

  //tri_state_bridge_0_avalon_slave_allgrants all slave grants, which is an e_mux
  assign tri_state_bridge_0_avalon_slave_allgrants = |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector |
    |tri_state_bridge_0_avalon_slave_grant_vector;

  //tri_state_bridge_0_avalon_slave_end_xfer assignment, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_end_xfer = ~(ctrl_rtl8019_0_avalon_tristate_slave_0_waits_for_read | ctrl_rtl8019_0_avalon_tristate_slave_0_waits_for_write | lcd_tri_12864_0_avalon_tristate_slave_0_waits_for_read | lcd_tri_12864_0_avalon_tristate_slave_0_waits_for_write | flash_s1_waits_for_read | flash_s1_waits_for_write | lcd_tri_1602_0_avalon_tristate_slave_0_waits_for_read | lcd_tri_1602_0_avalon_tristate_slave_0_waits_for_write);

  //end_xfer_arb_share_counter_term_tri_state_bridge_0_avalon_slave arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_tri_state_bridge_0_avalon_slave = tri_state_bridge_0_avalon_slave_end_xfer & (~tri_state_bridge_0_avalon_slave_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //tri_state_bridge_0_avalon_slave_arb_share_counter arbitration counter enable, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_arb_counter_enable = (end_xfer_arb_share_counter_term_tri_state_bridge_0_avalon_slave & tri_state_bridge_0_avalon_slave_allgrants) | (end_xfer_arb_share_counter_term_tri_state_bridge_0_avalon_slave & ~tri_state_bridge_0_avalon_slave_non_bursting_master_requests);

  //tri_state_bridge_0_avalon_slave_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          tri_state_bridge_0_avalon_slave_arb_share_counter <= 0;
      else if (tri_state_bridge_0_avalon_slave_arb_counter_enable)
          tri_state_bridge_0_avalon_slave_arb_share_counter <= tri_state_bridge_0_avalon_slave_arb_share_counter_next_value;
    end


  //tri_state_bridge_0_avalon_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          tri_state_bridge_0_avalon_slave_slavearbiterlockenable <= 0;
      else if ((|tri_state_bridge_0_avalon_slave_master_qreq_vector & end_xfer_arb_share_counter_term_tri_state_bridge_0_avalon_slave) | (end_xfer_arb_share_counter_term_tri_state_bridge_0_avalon_slave & ~tri_state_bridge_0_avalon_slave_non_bursting_master_requests))
          tri_state_bridge_0_avalon_slave_slavearbiterlockenable <= |tri_state_bridge_0_avalon_slave_arb_share_counter_next_value;
    end


  //cpu_0/data_master tri_state_bridge_0/avalon_slave arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = tri_state_bridge_0_avalon_slave_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //tri_state_bridge_0_avalon_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_slavearbiterlockenable2 = |tri_state_bridge_0_avalon_slave_arb_share_counter_next_value;

  //cpu_0/data_master tri_state_bridge_0/avalon_slave arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = tri_state_bridge_0_avalon_slave_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //cpu_0/instruction_master tri_state_bridge_0/avalon_slave arbiterlock, which is an e_assign
  assign cpu_0_instruction_master_arbiterlock = tri_state_bridge_0_avalon_slave_slavearbiterlockenable & cpu_0_instruction_master_continuerequest;

  //cpu_0/instruction_master tri_state_bridge_0/avalon_slave arbiterlock2, which is an e_assign
  assign cpu_0_instruction_master_arbiterlock2 = tri_state_bridge_0_avalon_slave_slavearbiterlockenable2 & cpu_0_instruction_master_continuerequest;

  //cpu_0/instruction_master granted ctrl_rtl8019_0/avalon_tristate_slave_0 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_instruction_master_granted_slave_ctrl_rtl8019_0_avalon_tristate_slave_0 <= 0;
      else if (1)
          last_cycle_cpu_0_instruction_master_granted_slave_ctrl_rtl8019_0_avalon_tristate_slave_0 <= cpu_0_instruction_master_saved_grant_ctrl_rtl8019_0_avalon_tristate_slave_0 ? 1 : (tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal | ~cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0) ? 0 : last_cycle_cpu_0_instruction_master_granted_slave_ctrl_rtl8019_0_avalon_tristate_slave_0;
    end


  //cpu_0_instruction_master_continuerequest continued request, which is an e_mux
  assign cpu_0_instruction_master_continuerequest = (last_cycle_cpu_0_instruction_master_granted_slave_ctrl_rtl8019_0_avalon_tristate_slave_0 & cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0) |
    (last_cycle_cpu_0_instruction_master_granted_slave_lcd_tri_12864_0_avalon_tristate_slave_0 & cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0) |
    (last_cycle_cpu_0_instruction_master_granted_slave_flash_s1 & cpu_0_instruction_master_requests_flash_s1) |
    (last_cycle_cpu_0_instruction_master_granted_slave_lcd_tri_1602_0_avalon_tristate_slave_0 & cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0);

  //tri_state_bridge_0_avalon_slave_any_continuerequest at least one master continues requesting, which is an e_mux
  assign tri_state_bridge_0_avalon_slave_any_continuerequest = cpu_0_instruction_master_continuerequest |
    cpu_0_instruction_master_continuerequest |
    cpu_0_instruction_master_continuerequest |
    cpu_0_instruction_master_continuerequest |
    cpu_0_data_master_continuerequest |
    cpu_0_data_master_continuerequest |
    cpu_0_data_master_continuerequest |
    cpu_0_data_master_continuerequest;

  assign cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0 = cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0 & ~((cpu_0_data_master_read & (tri_state_bridge_0_avalon_slave_write_pending | (tri_state_bridge_0_avalon_slave_read_pending) | (|cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register))) | ((tri_state_bridge_0_avalon_slave_read_pending) & cpu_0_data_master_write) | cpu_0_instruction_master_arbiterlock);
  //cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register_in mux for readlatency shift register, which is an e_mux
  assign cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register_in = cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 & cpu_0_data_master_read & ~ctrl_rtl8019_0_avalon_tristate_slave_0_waits_for_read & ~(|cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register);

  //shift register p1 cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register = {cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register, cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register_in};

  //cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register <= 0;
      else if (1)
          cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register <= p1_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register;
    end


  //local readdatavalid cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0, which is an e_mux
  assign cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0 = cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register[1];

  //tri_state_bridge_0_data register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          incoming_tri_state_bridge_0_data <= 0;
      else if (1)
          incoming_tri_state_bridge_0_data <= tri_state_bridge_0_data;
    end


  //ctrl_rtl8019_0_avalon_tristate_slave_0_with_write_latency assignment, which is an e_assign
  assign ctrl_rtl8019_0_avalon_tristate_slave_0_with_write_latency = in_a_write_cycle & (cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0 | cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0);

  //time to write the data, which is an e_mux
  assign time_to_write = (ctrl_rtl8019_0_avalon_tristate_slave_0_with_write_latency)? 1 :
    (lcd_tri_12864_0_avalon_tristate_slave_0_with_write_latency)? 1 :
    (flash_s1_with_write_latency)? 1 :
    (lcd_tri_1602_0_avalon_tristate_slave_0_with_write_latency)? 1 :
    0;

  //d1_outgoing_tri_state_bridge_0_data register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_outgoing_tri_state_bridge_0_data <= 0;
      else if (1)
          d1_outgoing_tri_state_bridge_0_data <= outgoing_tri_state_bridge_0_data;
    end


  //write cycle delayed by 1, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_in_a_write_cycle <= 0;
      else if (1)
          d1_in_a_write_cycle <= time_to_write;
    end


  //d1_outgoing_tri_state_bridge_0_data tristate driver, which is an e_assign
  assign tri_state_bridge_0_data = (d1_in_a_write_cycle)? d1_outgoing_tri_state_bridge_0_data:{8{1'bz}};

  //outgoing_tri_state_bridge_0_data mux, which is an e_mux
  assign outgoing_tri_state_bridge_0_data = (cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0)? cpu_0_data_master_writedata :
    (cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0)? cpu_0_data_master_writedata :
    (cpu_0_data_master_granted_flash_s1)? cpu_0_data_master_dbs_write_8 :
    cpu_0_data_master_writedata;

  assign cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0 = ({cpu_0_data_master_address_to_slave[25 : 4] , 4'b0} == 26'h20032a0) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //registered rdv signal_name registered_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0 assignment, which is an e_assign
  assign registered_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0 = cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register[0];

  //cpu_0/instruction_master granted lcd_tri_12864_0/avalon_tristate_slave_0 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_instruction_master_granted_slave_lcd_tri_12864_0_avalon_tristate_slave_0 <= 0;
      else if (1)
          last_cycle_cpu_0_instruction_master_granted_slave_lcd_tri_12864_0_avalon_tristate_slave_0 <= cpu_0_instruction_master_saved_grant_lcd_tri_12864_0_avalon_tristate_slave_0 ? 1 : (tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal | ~cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0) ? 0 : last_cycle_cpu_0_instruction_master_granted_slave_lcd_tri_12864_0_avalon_tristate_slave_0;
    end


  assign cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0 = cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0 & ~((cpu_0_data_master_read & (tri_state_bridge_0_avalon_slave_write_pending | (tri_state_bridge_0_avalon_slave_read_pending) | (|cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register))) | ((tri_state_bridge_0_avalon_slave_read_pending) & cpu_0_data_master_write) | cpu_0_instruction_master_arbiterlock);
  //cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register_in mux for readlatency shift register, which is an e_mux
  assign cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register_in = cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 & cpu_0_data_master_read & ~lcd_tri_12864_0_avalon_tristate_slave_0_waits_for_read & ~(|cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register);

  //shift register p1 cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register = {cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register, cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register_in};

  //cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register <= 0;
      else if (1)
          cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register <= p1_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register;
    end


  //local readdatavalid cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0, which is an e_mux
  assign cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0 = cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register[1];

  //lcd_tri_12864_0_avalon_tristate_slave_0_with_write_latency assignment, which is an e_assign
  assign lcd_tri_12864_0_avalon_tristate_slave_0_with_write_latency = in_a_write_cycle & (cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0 | cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0);

  assign cpu_0_data_master_requests_flash_s1 = ({cpu_0_data_master_address_to_slave[25 : 23] , 23'b0} == 26'h1000000) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //registered rdv signal_name registered_cpu_0_data_master_read_data_valid_flash_s1 assignment, which is an e_assign
  assign registered_cpu_0_data_master_read_data_valid_flash_s1 = cpu_0_data_master_read_data_valid_flash_s1_shift_register[0];

  //cpu_0/instruction_master granted flash/s1 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_instruction_master_granted_slave_flash_s1 <= 0;
      else if (1)
          last_cycle_cpu_0_instruction_master_granted_slave_flash_s1 <= cpu_0_instruction_master_saved_grant_flash_s1 ? 1 : (tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal | ~cpu_0_instruction_master_requests_flash_s1) ? 0 : last_cycle_cpu_0_instruction_master_granted_slave_flash_s1;
    end


  assign cpu_0_data_master_qualified_request_flash_s1 = cpu_0_data_master_requests_flash_s1 & ~((cpu_0_data_master_read & (tri_state_bridge_0_avalon_slave_write_pending | (tri_state_bridge_0_avalon_slave_read_pending) | (|cpu_0_data_master_read_data_valid_flash_s1_shift_register))) | ((tri_state_bridge_0_avalon_slave_read_pending | cpu_0_data_master_no_byte_enables_and_last_term | !cpu_0_data_master_byteenable_flash_s1) & cpu_0_data_master_write) | cpu_0_instruction_master_arbiterlock);
  //cpu_0_data_master_read_data_valid_flash_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  assign cpu_0_data_master_read_data_valid_flash_s1_shift_register_in = cpu_0_data_master_granted_flash_s1 & cpu_0_data_master_read & ~flash_s1_waits_for_read & ~(|cpu_0_data_master_read_data_valid_flash_s1_shift_register);

  //shift register p1 cpu_0_data_master_read_data_valid_flash_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_cpu_0_data_master_read_data_valid_flash_s1_shift_register = {cpu_0_data_master_read_data_valid_flash_s1_shift_register, cpu_0_data_master_read_data_valid_flash_s1_shift_register_in};

  //cpu_0_data_master_read_data_valid_flash_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_data_master_read_data_valid_flash_s1_shift_register <= 0;
      else if (1)
          cpu_0_data_master_read_data_valid_flash_s1_shift_register <= p1_cpu_0_data_master_read_data_valid_flash_s1_shift_register;
    end


  //local readdatavalid cpu_0_data_master_read_data_valid_flash_s1, which is an e_mux
  assign cpu_0_data_master_read_data_valid_flash_s1 = cpu_0_data_master_read_data_valid_flash_s1_shift_register[1];

  //flash_s1_with_write_latency assignment, which is an e_assign
  assign flash_s1_with_write_latency = in_a_write_cycle & (cpu_0_data_master_qualified_request_flash_s1 | cpu_0_instruction_master_qualified_request_flash_s1);

  assign cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0 = ({cpu_0_data_master_address_to_slave[25 : 4] , 4'b0} == 26'h20032b0) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //registered rdv signal_name registered_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0 assignment, which is an e_assign
  assign registered_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0 = cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register[0];

  //cpu_0/instruction_master granted lcd_tri_1602_0/avalon_tristate_slave_0 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_instruction_master_granted_slave_lcd_tri_1602_0_avalon_tristate_slave_0 <= 0;
      else if (1)
          last_cycle_cpu_0_instruction_master_granted_slave_lcd_tri_1602_0_avalon_tristate_slave_0 <= cpu_0_instruction_master_saved_grant_lcd_tri_1602_0_avalon_tristate_slave_0 ? 1 : (tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal | ~cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0) ? 0 : last_cycle_cpu_0_instruction_master_granted_slave_lcd_tri_1602_0_avalon_tristate_slave_0;
    end


  assign cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0 = cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0 & ~((cpu_0_data_master_read & (tri_state_bridge_0_avalon_slave_write_pending | (tri_state_bridge_0_avalon_slave_read_pending) | (|cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register))) | ((tri_state_bridge_0_avalon_slave_read_pending) & cpu_0_data_master_write) | cpu_0_instruction_master_arbiterlock);
  //cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register_in mux for readlatency shift register, which is an e_mux
  assign cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register_in = cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 & cpu_0_data_master_read & ~lcd_tri_1602_0_avalon_tristate_slave_0_waits_for_read & ~(|cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register);

  //shift register p1 cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register = {cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register, cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register_in};

  //cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register <= 0;
      else if (1)
          cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register <= p1_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register;
    end


  //local readdatavalid cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0, which is an e_mux
  assign cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0 = cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register[1];

  //lcd_tri_1602_0_avalon_tristate_slave_0_with_write_latency assignment, which is an e_assign
  assign lcd_tri_1602_0_avalon_tristate_slave_0_with_write_latency = in_a_write_cycle & (cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0 | cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0);

  assign cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0 = (({cpu_0_instruction_master_address_to_slave[25 : 8] , 8'b0} == 26'h2003100) & (cpu_0_instruction_master_read)) & cpu_0_instruction_master_read;
  //cpu_0/data_master granted ctrl_rtl8019_0/avalon_tristate_slave_0 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_data_master_granted_slave_ctrl_rtl8019_0_avalon_tristate_slave_0 <= 0;
      else if (1)
          last_cycle_cpu_0_data_master_granted_slave_ctrl_rtl8019_0_avalon_tristate_slave_0 <= cpu_0_data_master_saved_grant_ctrl_rtl8019_0_avalon_tristate_slave_0 ? 1 : (tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal | ~cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0) ? 0 : last_cycle_cpu_0_data_master_granted_slave_ctrl_rtl8019_0_avalon_tristate_slave_0;
    end


  //cpu_0_data_master_continuerequest continued request, which is an e_mux
  assign cpu_0_data_master_continuerequest = (last_cycle_cpu_0_data_master_granted_slave_ctrl_rtl8019_0_avalon_tristate_slave_0 & cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0) |
    (last_cycle_cpu_0_data_master_granted_slave_lcd_tri_12864_0_avalon_tristate_slave_0 & cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0) |
    (last_cycle_cpu_0_data_master_granted_slave_flash_s1 & cpu_0_data_master_requests_flash_s1) |
    (last_cycle_cpu_0_data_master_granted_slave_lcd_tri_1602_0_avalon_tristate_slave_0 & cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0);

  assign cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0 = cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0 & ~((cpu_0_instruction_master_read & (tri_state_bridge_0_avalon_slave_write_pending | (tri_state_bridge_0_avalon_slave_read_pending) | (2 < cpu_0_instruction_master_latency_counter) | (|cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register))) | cpu_0_data_master_arbiterlock);
  //cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register_in mux for readlatency shift register, which is an e_mux
  assign cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register_in = cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 & cpu_0_instruction_master_read & ~ctrl_rtl8019_0_avalon_tristate_slave_0_waits_for_read;

  //shift register p1 cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register = {cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register, cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register_in};

  //cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register <= 0;
      else if (1)
          cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register <= p1_cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register;
    end


  //local readdatavalid cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0, which is an e_mux
  assign cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0 = cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0_shift_register[1];

  assign cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0 = (({cpu_0_instruction_master_address_to_slave[25 : 4] , 4'b0} == 26'h20032a0) & (cpu_0_instruction_master_read)) & cpu_0_instruction_master_read;
  //cpu_0/data_master granted lcd_tri_12864_0/avalon_tristate_slave_0 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_data_master_granted_slave_lcd_tri_12864_0_avalon_tristate_slave_0 <= 0;
      else if (1)
          last_cycle_cpu_0_data_master_granted_slave_lcd_tri_12864_0_avalon_tristate_slave_0 <= cpu_0_data_master_saved_grant_lcd_tri_12864_0_avalon_tristate_slave_0 ? 1 : (tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal | ~cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0) ? 0 : last_cycle_cpu_0_data_master_granted_slave_lcd_tri_12864_0_avalon_tristate_slave_0;
    end


  assign cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0 = cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0 & ~((cpu_0_instruction_master_read & (tri_state_bridge_0_avalon_slave_write_pending | (tri_state_bridge_0_avalon_slave_read_pending) | (2 < cpu_0_instruction_master_latency_counter) | (|cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register))) | cpu_0_data_master_arbiterlock);
  //cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register_in mux for readlatency shift register, which is an e_mux
  assign cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register_in = cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 & cpu_0_instruction_master_read & ~lcd_tri_12864_0_avalon_tristate_slave_0_waits_for_read;

  //shift register p1 cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register = {cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register, cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register_in};

  //cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register <= 0;
      else if (1)
          cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register <= p1_cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register;
    end


  //local readdatavalid cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0, which is an e_mux
  assign cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0 = cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0_shift_register[1];

  assign cpu_0_instruction_master_requests_flash_s1 = (({cpu_0_instruction_master_address_to_slave[25 : 23] , 23'b0} == 26'h1000000) & (cpu_0_instruction_master_read)) & cpu_0_instruction_master_read;
  //cpu_0/data_master granted flash/s1 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_data_master_granted_slave_flash_s1 <= 0;
      else if (1)
          last_cycle_cpu_0_data_master_granted_slave_flash_s1 <= cpu_0_data_master_saved_grant_flash_s1 ? 1 : (tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal | ~cpu_0_data_master_requests_flash_s1) ? 0 : last_cycle_cpu_0_data_master_granted_slave_flash_s1;
    end


  assign cpu_0_instruction_master_qualified_request_flash_s1 = cpu_0_instruction_master_requests_flash_s1 & ~((cpu_0_instruction_master_read & (tri_state_bridge_0_avalon_slave_write_pending | (tri_state_bridge_0_avalon_slave_read_pending) | (2 < cpu_0_instruction_master_latency_counter) | (|cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register))) | cpu_0_data_master_arbiterlock);
  //cpu_0_instruction_master_read_data_valid_flash_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  assign cpu_0_instruction_master_read_data_valid_flash_s1_shift_register_in = cpu_0_instruction_master_granted_flash_s1 & cpu_0_instruction_master_read & ~flash_s1_waits_for_read;

  //shift register p1 cpu_0_instruction_master_read_data_valid_flash_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_cpu_0_instruction_master_read_data_valid_flash_s1_shift_register = {cpu_0_instruction_master_read_data_valid_flash_s1_shift_register, cpu_0_instruction_master_read_data_valid_flash_s1_shift_register_in};

  //cpu_0_instruction_master_read_data_valid_flash_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_instruction_master_read_data_valid_flash_s1_shift_register <= 0;
      else if (1)
          cpu_0_instruction_master_read_data_valid_flash_s1_shift_register <= p1_cpu_0_instruction_master_read_data_valid_flash_s1_shift_register;
    end


  //local readdatavalid cpu_0_instruction_master_read_data_valid_flash_s1, which is an e_mux
  assign cpu_0_instruction_master_read_data_valid_flash_s1 = cpu_0_instruction_master_read_data_valid_flash_s1_shift_register[1];

  assign cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0 = (({cpu_0_instruction_master_address_to_slave[25 : 4] , 4'b0} == 26'h20032b0) & (cpu_0_instruction_master_read)) & cpu_0_instruction_master_read;
  //cpu_0/data_master granted lcd_tri_1602_0/avalon_tristate_slave_0 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_0_data_master_granted_slave_lcd_tri_1602_0_avalon_tristate_slave_0 <= 0;
      else if (1)
          last_cycle_cpu_0_data_master_granted_slave_lcd_tri_1602_0_avalon_tristate_slave_0 <= cpu_0_data_master_saved_grant_lcd_tri_1602_0_avalon_tristate_slave_0 ? 1 : (tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal | ~cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0) ? 0 : last_cycle_cpu_0_data_master_granted_slave_lcd_tri_1602_0_avalon_tristate_slave_0;
    end


  assign cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0 = cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0 & ~((cpu_0_instruction_master_read & (tri_state_bridge_0_avalon_slave_write_pending | (tri_state_bridge_0_avalon_slave_read_pending) | (2 < cpu_0_instruction_master_latency_counter) | (|cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register))) | cpu_0_data_master_arbiterlock);
  //cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register_in mux for readlatency shift register, which is an e_mux
  assign cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register_in = cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 & cpu_0_instruction_master_read & ~lcd_tri_1602_0_avalon_tristate_slave_0_waits_for_read;

  //shift register p1 cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register = {cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register, cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register_in};

  //cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register <= 0;
      else if (1)
          cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register <= p1_cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register;
    end


  //local readdatavalid cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0, which is an e_mux
  assign cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0 = cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0_shift_register[1];

  //allow new arb cycle for tri_state_bridge_0/avalon_slave, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_allow_new_arb_cycle = ~cpu_0_data_master_arbiterlock & ~cpu_0_instruction_master_arbiterlock;

  //cpu_0/instruction_master assignment into master qualified-requests vector for ctrl_rtl8019_0/avalon_tristate_slave_0, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_master_qreq_vector[0] = cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0;

  //cpu_0/instruction_master grant ctrl_rtl8019_0/avalon_tristate_slave_0, which is an e_assign
  assign cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 = tri_state_bridge_0_avalon_slave_grant_vector[0];

  //cpu_0/instruction_master saved-grant ctrl_rtl8019_0/avalon_tristate_slave_0, which is an e_assign
  assign cpu_0_instruction_master_saved_grant_ctrl_rtl8019_0_avalon_tristate_slave_0 = tri_state_bridge_0_avalon_slave_arb_winner[0] && cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0;

  //cpu_0/data_master assignment into master qualified-requests vector for ctrl_rtl8019_0/avalon_tristate_slave_0, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_master_qreq_vector[1] = cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0;

  //cpu_0/data_master grant ctrl_rtl8019_0/avalon_tristate_slave_0, which is an e_assign
  assign cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 = tri_state_bridge_0_avalon_slave_grant_vector[1];

  //cpu_0/data_master saved-grant ctrl_rtl8019_0/avalon_tristate_slave_0, which is an e_assign
  assign cpu_0_data_master_saved_grant_ctrl_rtl8019_0_avalon_tristate_slave_0 = tri_state_bridge_0_avalon_slave_arb_winner[1] && cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0;

  //cpu_0/instruction_master assignment into master qualified-requests vector for lcd_tri_12864_0/avalon_tristate_slave_0, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_master_qreq_vector[2] = cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0;

  //cpu_0/instruction_master grant lcd_tri_12864_0/avalon_tristate_slave_0, which is an e_assign
  assign cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 = tri_state_bridge_0_avalon_slave_grant_vector[2];

  //cpu_0/instruction_master saved-grant lcd_tri_12864_0/avalon_tristate_slave_0, which is an e_assign
  assign cpu_0_instruction_master_saved_grant_lcd_tri_12864_0_avalon_tristate_slave_0 = tri_state_bridge_0_avalon_slave_arb_winner[2] && cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0;

  //cpu_0/data_master assignment into master qualified-requests vector for lcd_tri_12864_0/avalon_tristate_slave_0, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_master_qreq_vector[3] = cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0;

  //cpu_0/data_master grant lcd_tri_12864_0/avalon_tristate_slave_0, which is an e_assign
  assign cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 = tri_state_bridge_0_avalon_slave_grant_vector[3];

  //cpu_0/data_master saved-grant lcd_tri_12864_0/avalon_tristate_slave_0, which is an e_assign
  assign cpu_0_data_master_saved_grant_lcd_tri_12864_0_avalon_tristate_slave_0 = tri_state_bridge_0_avalon_slave_arb_winner[3] && cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0;

  //cpu_0/instruction_master assignment into master qualified-requests vector for flash/s1, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_master_qreq_vector[4] = cpu_0_instruction_master_qualified_request_flash_s1;

  //cpu_0/instruction_master grant flash/s1, which is an e_assign
  assign cpu_0_instruction_master_granted_flash_s1 = tri_state_bridge_0_avalon_slave_grant_vector[4];

  //cpu_0/instruction_master saved-grant flash/s1, which is an e_assign
  assign cpu_0_instruction_master_saved_grant_flash_s1 = tri_state_bridge_0_avalon_slave_arb_winner[4] && cpu_0_instruction_master_requests_flash_s1;

  //cpu_0/data_master assignment into master qualified-requests vector for flash/s1, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_master_qreq_vector[5] = cpu_0_data_master_qualified_request_flash_s1;

  //cpu_0/data_master grant flash/s1, which is an e_assign
  assign cpu_0_data_master_granted_flash_s1 = tri_state_bridge_0_avalon_slave_grant_vector[5];

  //cpu_0/data_master saved-grant flash/s1, which is an e_assign
  assign cpu_0_data_master_saved_grant_flash_s1 = tri_state_bridge_0_avalon_slave_arb_winner[5] && cpu_0_data_master_requests_flash_s1;

  //cpu_0/instruction_master assignment into master qualified-requests vector for lcd_tri_1602_0/avalon_tristate_slave_0, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_master_qreq_vector[6] = cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0;

  //cpu_0/instruction_master grant lcd_tri_1602_0/avalon_tristate_slave_0, which is an e_assign
  assign cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 = tri_state_bridge_0_avalon_slave_grant_vector[6];

  //cpu_0/instruction_master saved-grant lcd_tri_1602_0/avalon_tristate_slave_0, which is an e_assign
  assign cpu_0_instruction_master_saved_grant_lcd_tri_1602_0_avalon_tristate_slave_0 = tri_state_bridge_0_avalon_slave_arb_winner[6] && cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0;

  //cpu_0/data_master assignment into master qualified-requests vector for lcd_tri_1602_0/avalon_tristate_slave_0, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_master_qreq_vector[7] = cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0;

  //cpu_0/data_master grant lcd_tri_1602_0/avalon_tristate_slave_0, which is an e_assign
  assign cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 = tri_state_bridge_0_avalon_slave_grant_vector[7];

  //cpu_0/data_master saved-grant lcd_tri_1602_0/avalon_tristate_slave_0, which is an e_assign
  assign cpu_0_data_master_saved_grant_lcd_tri_1602_0_avalon_tristate_slave_0 = tri_state_bridge_0_avalon_slave_arb_winner[7] && cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0;

  //tri_state_bridge_0/avalon_slave chosen-master double-vector, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_chosen_master_double_vector = {tri_state_bridge_0_avalon_slave_master_qreq_vector, tri_state_bridge_0_avalon_slave_master_qreq_vector} & ({~tri_state_bridge_0_avalon_slave_master_qreq_vector, ~tri_state_bridge_0_avalon_slave_master_qreq_vector} + tri_state_bridge_0_avalon_slave_arb_addend);

  //stable onehot encoding of arb winner
  assign tri_state_bridge_0_avalon_slave_arb_winner = (tri_state_bridge_0_avalon_slave_allow_new_arb_cycle & | tri_state_bridge_0_avalon_slave_grant_vector) ? tri_state_bridge_0_avalon_slave_grant_vector : tri_state_bridge_0_avalon_slave_saved_chosen_master_vector;

  //saved tri_state_bridge_0_avalon_slave_grant_vector, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          tri_state_bridge_0_avalon_slave_saved_chosen_master_vector <= 0;
      else if (tri_state_bridge_0_avalon_slave_allow_new_arb_cycle)
          tri_state_bridge_0_avalon_slave_saved_chosen_master_vector <= |tri_state_bridge_0_avalon_slave_grant_vector ? tri_state_bridge_0_avalon_slave_grant_vector : tri_state_bridge_0_avalon_slave_saved_chosen_master_vector;
    end


  //onehot encoding of chosen master
  assign tri_state_bridge_0_avalon_slave_grant_vector = {(tri_state_bridge_0_avalon_slave_chosen_master_double_vector[7] | tri_state_bridge_0_avalon_slave_chosen_master_double_vector[15]),
    (tri_state_bridge_0_avalon_slave_chosen_master_double_vector[6] | tri_state_bridge_0_avalon_slave_chosen_master_double_vector[14]),
    (tri_state_bridge_0_avalon_slave_chosen_master_double_vector[5] | tri_state_bridge_0_avalon_slave_chosen_master_double_vector[13]),
    (tri_state_bridge_0_avalon_slave_chosen_master_double_vector[4] | tri_state_bridge_0_avalon_slave_chosen_master_double_vector[12]),
    (tri_state_bridge_0_avalon_slave_chosen_master_double_vector[3] | tri_state_bridge_0_avalon_slave_chosen_master_double_vector[11]),
    (tri_state_bridge_0_avalon_slave_chosen_master_double_vector[2] | tri_state_bridge_0_avalon_slave_chosen_master_double_vector[10]),
    (tri_state_bridge_0_avalon_slave_chosen_master_double_vector[1] | tri_state_bridge_0_avalon_slave_chosen_master_double_vector[9]),
    (tri_state_bridge_0_avalon_slave_chosen_master_double_vector[0] | tri_state_bridge_0_avalon_slave_chosen_master_double_vector[8])};

  //tri_state_bridge_0/avalon_slave chosen master rotated left, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_chosen_master_rot_left = (tri_state_bridge_0_avalon_slave_arb_winner << 1) ? (tri_state_bridge_0_avalon_slave_arb_winner << 1) : 1;

  //tri_state_bridge_0/avalon_slave's addend for next-master-grant
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          tri_state_bridge_0_avalon_slave_arb_addend <= 1;
      else if (|tri_state_bridge_0_avalon_slave_grant_vector)
          tri_state_bridge_0_avalon_slave_arb_addend <= tri_state_bridge_0_avalon_slave_end_xfer? tri_state_bridge_0_avalon_slave_chosen_master_rot_left : tri_state_bridge_0_avalon_slave_grant_vector;
    end


  //~rst_to_the_ctrl_rtl8019_0 of type reset_n to ~p1_rst_to_the_ctrl_rtl8019_0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          rst_to_the_ctrl_rtl8019_0 <= ~0;
      else if (1)
          rst_to_the_ctrl_rtl8019_0 <= p1_rst_to_the_ctrl_rtl8019_0;
    end


  //~p1_rst_to_the_ctrl_rtl8019_0 assignment, which is an e_assign
  assign p1_rst_to_the_ctrl_rtl8019_0 = ~reset_n;

  assign p1_select_n_to_the_ctrl_rtl8019_0 = ~(cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 | cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0);
  //tri_state_bridge_0_avalon_slave_firsttransfer first transaction, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_firsttransfer = tri_state_bridge_0_avalon_slave_begins_xfer ? tri_state_bridge_0_avalon_slave_unreg_firsttransfer : tri_state_bridge_0_avalon_slave_reg_firsttransfer;

  //tri_state_bridge_0_avalon_slave_unreg_firsttransfer first transaction, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_unreg_firsttransfer = ~(tri_state_bridge_0_avalon_slave_slavearbiterlockenable & tri_state_bridge_0_avalon_slave_any_continuerequest);

  //tri_state_bridge_0_avalon_slave_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          tri_state_bridge_0_avalon_slave_reg_firsttransfer <= 1'b1;
      else if (tri_state_bridge_0_avalon_slave_begins_xfer)
          tri_state_bridge_0_avalon_slave_reg_firsttransfer <= tri_state_bridge_0_avalon_slave_unreg_firsttransfer;
    end


  //tri_state_bridge_0_avalon_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_beginbursttransfer_internal = tri_state_bridge_0_avalon_slave_begins_xfer;

  //tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  assign tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal = tri_state_bridge_0_avalon_slave_begins_xfer & tri_state_bridge_0_avalon_slave_firsttransfer;

  //~read_n_to_the_ctrl_rtl8019_0 of type read to ~p1_read_n_to_the_ctrl_rtl8019_0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          read_n_to_the_ctrl_rtl8019_0 <= ~0;
      else if (1)
          read_n_to_the_ctrl_rtl8019_0 <= p1_read_n_to_the_ctrl_rtl8019_0;
    end


  //~p1_read_n_to_the_ctrl_rtl8019_0 assignment, which is an e_mux
  assign p1_read_n_to_the_ctrl_rtl8019_0 = ~(((cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 & cpu_0_data_master_read) | (cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 & cpu_0_instruction_master_read))& ~tri_state_bridge_0_avalon_slave_begins_xfer & (ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter < 9));

  //~write_n_to_the_ctrl_rtl8019_0 of type write to ~p1_write_n_to_the_ctrl_rtl8019_0, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          write_n_to_the_ctrl_rtl8019_0 <= ~0;
      else if (1)
          write_n_to_the_ctrl_rtl8019_0 <= p1_write_n_to_the_ctrl_rtl8019_0;
    end


  //~p1_write_n_to_the_ctrl_rtl8019_0 assignment, which is an e_mux
  assign p1_write_n_to_the_ctrl_rtl8019_0 = ~(((cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 & cpu_0_data_master_write)) & ~tri_state_bridge_0_avalon_slave_begins_xfer & (ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter >= 3) & (ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter < 12) & ctrl_rtl8019_0_avalon_tristate_slave_0_pretend_byte_enable);

  //tri_state_bridge_0_address of type address to p1_tri_state_bridge_0_address, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          tri_state_bridge_0_address <= 0;
      else if (1)
          tri_state_bridge_0_address <= p1_tri_state_bridge_0_address;
    end


  assign shifted_address_to_ctrl_rtl8019_0_avalon_tristate_slave_0_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //p1_tri_state_bridge_0_address mux, which is an e_mux
  assign p1_tri_state_bridge_0_address = (cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0)? (shifted_address_to_ctrl_rtl8019_0_avalon_tristate_slave_0_from_cpu_0_data_master >> 2) :
    (cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0)? (shifted_address_to_ctrl_rtl8019_0_avalon_tristate_slave_0_from_cpu_0_instruction_master >> 2) :
    (cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0)? (shifted_address_to_lcd_tri_12864_0_avalon_tristate_slave_0_from_cpu_0_data_master >> 2) :
    (cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0)? (shifted_address_to_lcd_tri_12864_0_avalon_tristate_slave_0_from_cpu_0_instruction_master >> 2) :
    (cpu_0_data_master_granted_flash_s1)? ({cpu_0_data_master_address_to_slave >> 2,
    cpu_0_data_master_dbs_address[1 : 0]}) :
    (cpu_0_instruction_master_granted_flash_s1)? ({cpu_0_instruction_master_address_to_slave >> 2,
    cpu_0_instruction_master_dbs_address[1 : 0]}) :
    (cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0)? (shifted_address_to_lcd_tri_1602_0_avalon_tristate_slave_0_from_cpu_0_data_master >> 2) :
    (shifted_address_to_lcd_tri_1602_0_avalon_tristate_slave_0_from_cpu_0_instruction_master >> 2);

  assign shifted_address_to_ctrl_rtl8019_0_avalon_tristate_slave_0_from_cpu_0_instruction_master = cpu_0_instruction_master_address_to_slave;
  //d1_tri_state_bridge_0_avalon_slave_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_tri_state_bridge_0_avalon_slave_end_xfer <= 1;
      else if (1)
          d1_tri_state_bridge_0_avalon_slave_end_xfer <= tri_state_bridge_0_avalon_slave_end_xfer;
    end


  //ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1 assignment, which is an e_assign
  assign ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1 = ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter == 1;

  //ctrl_rtl8019_0_avalon_tristate_slave_0_waits_for_read in a cycle, which is an e_mux
  assign ctrl_rtl8019_0_avalon_tristate_slave_0_waits_for_read = ctrl_rtl8019_0_avalon_tristate_slave_0_in_a_read_cycle & wait_for_ctrl_rtl8019_0_avalon_tristate_slave_0_counter;

  //ctrl_rtl8019_0_avalon_tristate_slave_0_in_a_read_cycle assignment, which is an e_assign
  assign ctrl_rtl8019_0_avalon_tristate_slave_0_in_a_read_cycle = (cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 & cpu_0_data_master_read) | (cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 & cpu_0_instruction_master_read);

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = ctrl_rtl8019_0_avalon_tristate_slave_0_in_a_read_cycle |
    lcd_tri_12864_0_avalon_tristate_slave_0_in_a_read_cycle |
    flash_s1_in_a_read_cycle |
    lcd_tri_1602_0_avalon_tristate_slave_0_in_a_read_cycle;

  //ctrl_rtl8019_0_avalon_tristate_slave_0_waits_for_write in a cycle, which is an e_mux
  assign ctrl_rtl8019_0_avalon_tristate_slave_0_waits_for_write = ctrl_rtl8019_0_avalon_tristate_slave_0_in_a_write_cycle & wait_for_ctrl_rtl8019_0_avalon_tristate_slave_0_counter;

  //ctrl_rtl8019_0_avalon_tristate_slave_0_in_a_write_cycle assignment, which is an e_assign
  assign ctrl_rtl8019_0_avalon_tristate_slave_0_in_a_write_cycle = cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = ctrl_rtl8019_0_avalon_tristate_slave_0_in_a_write_cycle |
    lcd_tri_12864_0_avalon_tristate_slave_0_in_a_write_cycle |
    flash_s1_in_a_write_cycle |
    lcd_tri_1602_0_avalon_tristate_slave_0_in_a_write_cycle;

  assign ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0 = ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter == 0;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter <= 0;
      else if (1)
          ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter <= ctrl_rtl8019_0_avalon_tristate_slave_0_counter_load_value;
    end


  assign ctrl_rtl8019_0_avalon_tristate_slave_0_counter_load_value = ((ctrl_rtl8019_0_avalon_tristate_slave_0_in_a_write_cycle & tri_state_bridge_0_avalon_slave_begins_xfer))? 13 :
    ((ctrl_rtl8019_0_avalon_tristate_slave_0_in_a_read_cycle & tri_state_bridge_0_avalon_slave_begins_xfer))? 10 :
    (~ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0)? ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter - 1 :
    0;

  assign wait_for_ctrl_rtl8019_0_avalon_tristate_slave_0_counter = tri_state_bridge_0_avalon_slave_begins_xfer | ~ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0;
  //ctrl_rtl8019_0_avalon_tristate_slave_0_pretend_byte_enable byte enable port mux, which is an e_mux
  assign ctrl_rtl8019_0_avalon_tristate_slave_0_pretend_byte_enable = (cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0)? cpu_0_data_master_byteenable :
    -1;

  assign p1_chipselect_to_the_lcd_tri_12864_0 = cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 | cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0;
  //tri_state_bridge_0_read of type read to p1_tri_state_bridge_0_read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          tri_state_bridge_0_read <= 0;
      else if (1)
          tri_state_bridge_0_read <= p1_tri_state_bridge_0_read;
    end


  //p1_tri_state_bridge_0_read assignment, which is an e_mux
  assign p1_tri_state_bridge_0_read = (((cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 & cpu_0_data_master_read) | (cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 & cpu_0_instruction_master_read))& ~tri_state_bridge_0_avalon_slave_begins_xfer & (lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter < 13)) |
    (((cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 & cpu_0_data_master_read) | (cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 & cpu_0_instruction_master_read))& ~tri_state_bridge_0_avalon_slave_begins_xfer & (lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter < 13));

  //tri_state_bridge_0_write of type write to p1_tri_state_bridge_0_write, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          tri_state_bridge_0_write <= 0;
      else if (1)
          tri_state_bridge_0_write <= p1_tri_state_bridge_0_write;
    end


  //p1_tri_state_bridge_0_write assignment, which is an e_mux
  assign p1_tri_state_bridge_0_write = ((((cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 & cpu_0_data_master_write)) & ~tri_state_bridge_0_avalon_slave_begins_xfer & (lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter >= 13) & (lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter < 26) & lcd_tri_12864_0_avalon_tristate_slave_0_pretend_byte_enable)) |
    ((((cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 & cpu_0_data_master_write)) & ~tri_state_bridge_0_avalon_slave_begins_xfer & (lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter >= 13) & (lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter < 26) & lcd_tri_1602_0_avalon_tristate_slave_0_pretend_byte_enable));

  assign shifted_address_to_lcd_tri_12864_0_avalon_tristate_slave_0_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  assign shifted_address_to_lcd_tri_12864_0_avalon_tristate_slave_0_from_cpu_0_instruction_master = cpu_0_instruction_master_address_to_slave;
  //lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1 assignment, which is an e_assign
  assign lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1 = lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter == 1;

  //lcd_tri_12864_0_avalon_tristate_slave_0_waits_for_read in a cycle, which is an e_mux
  assign lcd_tri_12864_0_avalon_tristate_slave_0_waits_for_read = lcd_tri_12864_0_avalon_tristate_slave_0_in_a_read_cycle & wait_for_lcd_tri_12864_0_avalon_tristate_slave_0_counter;

  //lcd_tri_12864_0_avalon_tristate_slave_0_in_a_read_cycle assignment, which is an e_assign
  assign lcd_tri_12864_0_avalon_tristate_slave_0_in_a_read_cycle = (cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 & cpu_0_data_master_read) | (cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 & cpu_0_instruction_master_read);

  //lcd_tri_12864_0_avalon_tristate_slave_0_waits_for_write in a cycle, which is an e_mux
  assign lcd_tri_12864_0_avalon_tristate_slave_0_waits_for_write = lcd_tri_12864_0_avalon_tristate_slave_0_in_a_write_cycle & wait_for_lcd_tri_12864_0_avalon_tristate_slave_0_counter;

  //lcd_tri_12864_0_avalon_tristate_slave_0_in_a_write_cycle assignment, which is an e_assign
  assign lcd_tri_12864_0_avalon_tristate_slave_0_in_a_write_cycle = cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 & cpu_0_data_master_write;

  assign lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0 = lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter == 0;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter <= 0;
      else if (1)
          lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter <= lcd_tri_12864_0_avalon_tristate_slave_0_counter_load_value;
    end


  assign lcd_tri_12864_0_avalon_tristate_slave_0_counter_load_value = ((lcd_tri_12864_0_avalon_tristate_slave_0_in_a_read_cycle & tri_state_bridge_0_avalon_slave_begins_xfer))? 24 :
    ((lcd_tri_12864_0_avalon_tristate_slave_0_in_a_write_cycle & tri_state_bridge_0_avalon_slave_begins_xfer))? 37 :
    (~lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0)? lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter - 1 :
    0;

  assign wait_for_lcd_tri_12864_0_avalon_tristate_slave_0_counter = tri_state_bridge_0_avalon_slave_begins_xfer | ~lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0;
  //lcd_tri_12864_0_avalon_tristate_slave_0_pretend_byte_enable byte enable port mux, which is an e_mux
  assign lcd_tri_12864_0_avalon_tristate_slave_0_pretend_byte_enable = (cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0)? cpu_0_data_master_byteenable :
    -1;

  assign p1_select_n_to_the_flash = ~(cpu_0_data_master_granted_flash_s1 | cpu_0_instruction_master_granted_flash_s1);
  //~tri_state_bridge_0_readn of type read to ~p1_tri_state_bridge_0_readn, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          tri_state_bridge_0_readn <= ~0;
      else if (1)
          tri_state_bridge_0_readn <= p1_tri_state_bridge_0_readn;
    end


  //~p1_tri_state_bridge_0_readn assignment, which is an e_mux
  assign p1_tri_state_bridge_0_readn = ~(((cpu_0_data_master_granted_flash_s1 & cpu_0_data_master_read) | (cpu_0_instruction_master_granted_flash_s1 & cpu_0_instruction_master_read))& ~tri_state_bridge_0_avalon_slave_begins_xfer);

  //~write_n_to_the_flash of type write to ~p1_write_n_to_the_flash, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          write_n_to_the_flash <= ~0;
      else if (1)
          write_n_to_the_flash <= p1_write_n_to_the_flash;
    end


  //~p1_write_n_to_the_flash assignment, which is an e_mux
  assign p1_write_n_to_the_flash = ~(((cpu_0_data_master_granted_flash_s1 & cpu_0_data_master_write)) & ~tri_state_bridge_0_avalon_slave_begins_xfer & (flash_s1_wait_counter >= 1) & flash_s1_pretend_byte_enable);

  //flash_s1_wait_counter_eq_1 assignment, which is an e_assign
  assign flash_s1_wait_counter_eq_1 = flash_s1_wait_counter == 1;

  //flash_s1_waits_for_read in a cycle, which is an e_mux
  assign flash_s1_waits_for_read = flash_s1_in_a_read_cycle & wait_for_flash_s1_counter;

  //flash_s1_in_a_read_cycle assignment, which is an e_assign
  assign flash_s1_in_a_read_cycle = (cpu_0_data_master_granted_flash_s1 & cpu_0_data_master_read) | (cpu_0_instruction_master_granted_flash_s1 & cpu_0_instruction_master_read);

  //flash_s1_waits_for_write in a cycle, which is an e_mux
  assign flash_s1_waits_for_write = flash_s1_in_a_write_cycle & wait_for_flash_s1_counter;

  //flash_s1_in_a_write_cycle assignment, which is an e_assign
  assign flash_s1_in_a_write_cycle = cpu_0_data_master_granted_flash_s1 & cpu_0_data_master_write;

  assign flash_s1_wait_counter_eq_0 = flash_s1_wait_counter == 0;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          flash_s1_wait_counter <= 0;
      else if (1)
          flash_s1_wait_counter <= flash_s1_counter_load_value;
    end


  assign flash_s1_counter_load_value = ((flash_s1_in_a_read_cycle & tri_state_bridge_0_avalon_slave_begins_xfer))? 5 :
    ((flash_s1_in_a_write_cycle & tri_state_bridge_0_avalon_slave_begins_xfer))? 6 :
    (~flash_s1_wait_counter_eq_0)? flash_s1_wait_counter - 1 :
    0;

  assign wait_for_flash_s1_counter = tri_state_bridge_0_avalon_slave_begins_xfer | ~flash_s1_wait_counter_eq_0;
  //flash_s1_pretend_byte_enable byte enable port mux, which is an e_mux
  assign flash_s1_pretend_byte_enable = (cpu_0_data_master_granted_flash_s1)? cpu_0_data_master_byteenable_flash_s1 :
    -1;

  assign {cpu_0_data_master_byteenable_flash_s1_segment_3,
cpu_0_data_master_byteenable_flash_s1_segment_2,
cpu_0_data_master_byteenable_flash_s1_segment_1,
cpu_0_data_master_byteenable_flash_s1_segment_0} = cpu_0_data_master_byteenable;
  assign cpu_0_data_master_byteenable_flash_s1 = ((cpu_0_data_master_dbs_address[1 : 0] == 0))? cpu_0_data_master_byteenable_flash_s1_segment_0 :
    ((cpu_0_data_master_dbs_address[1 : 0] == 1))? cpu_0_data_master_byteenable_flash_s1_segment_1 :
    ((cpu_0_data_master_dbs_address[1 : 0] == 2))? cpu_0_data_master_byteenable_flash_s1_segment_2 :
    cpu_0_data_master_byteenable_flash_s1_segment_3;

  assign p1_chipselect_to_the_lcd_tri_1602_0 = cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 | cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0;
  assign shifted_address_to_lcd_tri_1602_0_avalon_tristate_slave_0_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  assign shifted_address_to_lcd_tri_1602_0_avalon_tristate_slave_0_from_cpu_0_instruction_master = cpu_0_instruction_master_address_to_slave;
  //lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1 assignment, which is an e_assign
  assign lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1 = lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter == 1;

  //lcd_tri_1602_0_avalon_tristate_slave_0_waits_for_read in a cycle, which is an e_mux
  assign lcd_tri_1602_0_avalon_tristate_slave_0_waits_for_read = lcd_tri_1602_0_avalon_tristate_slave_0_in_a_read_cycle & wait_for_lcd_tri_1602_0_avalon_tristate_slave_0_counter;

  //lcd_tri_1602_0_avalon_tristate_slave_0_in_a_read_cycle assignment, which is an e_assign
  assign lcd_tri_1602_0_avalon_tristate_slave_0_in_a_read_cycle = (cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 & cpu_0_data_master_read) | (cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 & cpu_0_instruction_master_read);

  //lcd_tri_1602_0_avalon_tristate_slave_0_waits_for_write in a cycle, which is an e_mux
  assign lcd_tri_1602_0_avalon_tristate_slave_0_waits_for_write = lcd_tri_1602_0_avalon_tristate_slave_0_in_a_write_cycle & wait_for_lcd_tri_1602_0_avalon_tristate_slave_0_counter;

  //lcd_tri_1602_0_avalon_tristate_slave_0_in_a_write_cycle assignment, which is an e_assign
  assign lcd_tri_1602_0_avalon_tristate_slave_0_in_a_write_cycle = cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 & cpu_0_data_master_write;

  assign lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0 = lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter == 0;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter <= 0;
      else if (1)
          lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter <= lcd_tri_1602_0_avalon_tristate_slave_0_counter_load_value;
    end


  assign lcd_tri_1602_0_avalon_tristate_slave_0_counter_load_value = ((lcd_tri_1602_0_avalon_tristate_slave_0_in_a_write_cycle & tri_state_bridge_0_avalon_slave_begins_xfer))? 37 :
    ((lcd_tri_1602_0_avalon_tristate_slave_0_in_a_read_cycle & tri_state_bridge_0_avalon_slave_begins_xfer))? 24 :
    (~lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0)? lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter - 1 :
    0;

  assign wait_for_lcd_tri_1602_0_avalon_tristate_slave_0_counter = tri_state_bridge_0_avalon_slave_begins_xfer | ~lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0;
  //lcd_tri_1602_0_avalon_tristate_slave_0_pretend_byte_enable byte enable port mux, which is an e_mux
  assign lcd_tri_1602_0_avalon_tristate_slave_0_pretend_byte_enable = (cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0)? cpu_0_data_master_byteenable :
    -1;

  //first irq irq_from_the_ctrl_rtl8019_0 register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_irq_from_the_ctrl_rtl8019_0 <= 0;
      else if (1)
          d1_irq_from_the_ctrl_rtl8019_0 <= irq_from_the_ctrl_rtl8019_0;
    end



//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //ctrl_rtl8019_0/avalon_tristate_slave_0 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end


  //lcd_tri_12864_0/avalon_tristate_slave_0 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end


  //incoming_tri_state_bridge_0_data_bit_0_is_x x check, which is an e_assign_is_x
  assign incoming_tri_state_bridge_0_data_bit_0_is_x = ^(incoming_tri_state_bridge_0_data[0]) === 1'bx;

  //Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[0] Xs to 0, which is an e_assign
  assign incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[0] = incoming_tri_state_bridge_0_data_bit_0_is_x ? 1'b0 : incoming_tri_state_bridge_0_data[0];

  //incoming_tri_state_bridge_0_data_bit_1_is_x x check, which is an e_assign_is_x
  assign incoming_tri_state_bridge_0_data_bit_1_is_x = ^(incoming_tri_state_bridge_0_data[1]) === 1'bx;

  //Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[1] Xs to 0, which is an e_assign
  assign incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[1] = incoming_tri_state_bridge_0_data_bit_1_is_x ? 1'b0 : incoming_tri_state_bridge_0_data[1];

  //incoming_tri_state_bridge_0_data_bit_2_is_x x check, which is an e_assign_is_x
  assign incoming_tri_state_bridge_0_data_bit_2_is_x = ^(incoming_tri_state_bridge_0_data[2]) === 1'bx;

  //Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[2] Xs to 0, which is an e_assign
  assign incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[2] = incoming_tri_state_bridge_0_data_bit_2_is_x ? 1'b0 : incoming_tri_state_bridge_0_data[2];

  //incoming_tri_state_bridge_0_data_bit_3_is_x x check, which is an e_assign_is_x
  assign incoming_tri_state_bridge_0_data_bit_3_is_x = ^(incoming_tri_state_bridge_0_data[3]) === 1'bx;

  //Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[3] Xs to 0, which is an e_assign
  assign incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[3] = incoming_tri_state_bridge_0_data_bit_3_is_x ? 1'b0 : incoming_tri_state_bridge_0_data[3];

  //incoming_tri_state_bridge_0_data_bit_4_is_x x check, which is an e_assign_is_x
  assign incoming_tri_state_bridge_0_data_bit_4_is_x = ^(incoming_tri_state_bridge_0_data[4]) === 1'bx;

  //Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[4] Xs to 0, which is an e_assign
  assign incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[4] = incoming_tri_state_bridge_0_data_bit_4_is_x ? 1'b0 : incoming_tri_state_bridge_0_data[4];

  //incoming_tri_state_bridge_0_data_bit_5_is_x x check, which is an e_assign_is_x
  assign incoming_tri_state_bridge_0_data_bit_5_is_x = ^(incoming_tri_state_bridge_0_data[5]) === 1'bx;

  //Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[5] Xs to 0, which is an e_assign
  assign incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[5] = incoming_tri_state_bridge_0_data_bit_5_is_x ? 1'b0 : incoming_tri_state_bridge_0_data[5];

  //incoming_tri_state_bridge_0_data_bit_6_is_x x check, which is an e_assign_is_x
  assign incoming_tri_state_bridge_0_data_bit_6_is_x = ^(incoming_tri_state_bridge_0_data[6]) === 1'bx;

  //Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[6] Xs to 0, which is an e_assign
  assign incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[6] = incoming_tri_state_bridge_0_data_bit_6_is_x ? 1'b0 : incoming_tri_state_bridge_0_data[6];

  //incoming_tri_state_bridge_0_data_bit_7_is_x x check, which is an e_assign_is_x
  assign incoming_tri_state_bridge_0_data_bit_7_is_x = ^(incoming_tri_state_bridge_0_data[7]) === 1'bx;

  //Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[7] Xs to 0, which is an e_assign
  assign incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[7] = incoming_tri_state_bridge_0_data_bit_7_is_x ? 1'b0 : incoming_tri_state_bridge_0_data[7];

  //flash/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end


  //lcd_tri_1602_0/avalon_tristate_slave_0 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end


  //grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 + cpu_0_data_master_granted_flash_s1 + cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 + cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 + cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0 + cpu_0_instruction_master_granted_flash_s1 + cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0 + cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0 > 1)
        begin
          $write("%0d ns: > 1 of grant signals are active simultaneously", $time);
          $stop;
        end
    end


  //saved_grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_0_data_master_saved_grant_ctrl_rtl8019_0_avalon_tristate_slave_0 + cpu_0_data_master_saved_grant_flash_s1 + cpu_0_data_master_saved_grant_lcd_tri_12864_0_avalon_tristate_slave_0 + cpu_0_data_master_saved_grant_lcd_tri_1602_0_avalon_tristate_slave_0 + cpu_0_instruction_master_saved_grant_ctrl_rtl8019_0_avalon_tristate_slave_0 + cpu_0_instruction_master_saved_grant_flash_s1 + cpu_0_instruction_master_saved_grant_lcd_tri_12864_0_avalon_tristate_slave_0 + cpu_0_instruction_master_saved_grant_lcd_tri_1602_0_avalon_tristate_slave_0 > 1)
        begin
          $write("%0d ns: > 1 of saved_grant signals are active simultaneously", $time);
          $stop;
        end
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on
//synthesis read_comments_as_HDL on
//  
//  assign incoming_tri_state_bridge_0_data_with_Xs_converted_to_0 = incoming_tri_state_bridge_0_data;
//
//synthesis read_comments_as_HDL off

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module tri_state_bridge_0_bridge_arbitrator 
;



endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module uart_usb_s1_arbitrator (
                                // inputs:
                                 clk,
                                 cpu_0_data_master_address_to_slave,
                                 cpu_0_data_master_read,
                                 cpu_0_data_master_write,
                                 cpu_0_data_master_writedata,
                                 reset_n,
                                 uart_usb_s1_dataavailable,
                                 uart_usb_s1_irq,
                                 uart_usb_s1_readdata,
                                 uart_usb_s1_readyfordata,

                                // outputs:
                                 cpu_0_data_master_granted_uart_usb_s1,
                                 cpu_0_data_master_qualified_request_uart_usb_s1,
                                 cpu_0_data_master_read_data_valid_uart_usb_s1,
                                 cpu_0_data_master_requests_uart_usb_s1,
                                 d1_uart_usb_s1_end_xfer,
                                 uart_usb_s1_address,
                                 uart_usb_s1_begintransfer,
                                 uart_usb_s1_chipselect,
                                 uart_usb_s1_dataavailable_from_sa,
                                 uart_usb_s1_irq_from_sa,
                                 uart_usb_s1_read_n,
                                 uart_usb_s1_readdata_from_sa,
                                 uart_usb_s1_readyfordata_from_sa,
                                 uart_usb_s1_reset_n,
                                 uart_usb_s1_write_n,
                                 uart_usb_s1_writedata
                              )
  /* synthesis auto_dissolve = "FALSE" */ ;

  output           cpu_0_data_master_granted_uart_usb_s1;
  output           cpu_0_data_master_qualified_request_uart_usb_s1;
  output           cpu_0_data_master_read_data_valid_uart_usb_s1;
  output           cpu_0_data_master_requests_uart_usb_s1;
  output           d1_uart_usb_s1_end_xfer;
  output  [  2: 0] uart_usb_s1_address;
  output           uart_usb_s1_begintransfer;
  output           uart_usb_s1_chipselect;
  output           uart_usb_s1_dataavailable_from_sa;
  output           uart_usb_s1_irq_from_sa;
  output           uart_usb_s1_read_n;
  output  [ 15: 0] uart_usb_s1_readdata_from_sa;
  output           uart_usb_s1_readyfordata_from_sa;
  output           uart_usb_s1_reset_n;
  output           uart_usb_s1_write_n;
  output  [ 15: 0] uart_usb_s1_writedata;
  input            clk;
  input   [ 25: 0] cpu_0_data_master_address_to_slave;
  input            cpu_0_data_master_read;
  input            cpu_0_data_master_write;
  input   [ 31: 0] cpu_0_data_master_writedata;
  input            reset_n;
  input            uart_usb_s1_dataavailable;
  input            uart_usb_s1_irq;
  input   [ 15: 0] uart_usb_s1_readdata;
  input            uart_usb_s1_readyfordata;

  wire             cpu_0_data_master_arbiterlock;
  wire             cpu_0_data_master_arbiterlock2;
  wire             cpu_0_data_master_continuerequest;
  wire             cpu_0_data_master_granted_uart_usb_s1;
  wire             cpu_0_data_master_qualified_request_uart_usb_s1;
  wire             cpu_0_data_master_read_data_valid_uart_usb_s1;
  wire             cpu_0_data_master_requests_uart_usb_s1;
  wire             cpu_0_data_master_saved_grant_uart_usb_s1;
  reg              d1_reasons_to_wait;
  reg              d1_uart_usb_s1_end_xfer;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_uart_usb_s1;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 25: 0] shifted_address_to_uart_usb_s1_from_cpu_0_data_master;
  wire    [  2: 0] uart_usb_s1_address;
  wire             uart_usb_s1_allgrants;
  wire             uart_usb_s1_allow_new_arb_cycle;
  wire             uart_usb_s1_any_bursting_master_saved_grant;
  wire             uart_usb_s1_any_continuerequest;
  wire             uart_usb_s1_arb_counter_enable;
  reg     [  2: 0] uart_usb_s1_arb_share_counter;
  wire    [  2: 0] uart_usb_s1_arb_share_counter_next_value;
  wire    [  2: 0] uart_usb_s1_arb_share_set_values;
  wire             uart_usb_s1_beginbursttransfer_internal;
  wire             uart_usb_s1_begins_xfer;
  wire             uart_usb_s1_begintransfer;
  wire             uart_usb_s1_chipselect;
  wire             uart_usb_s1_dataavailable_from_sa;
  wire             uart_usb_s1_end_xfer;
  wire             uart_usb_s1_firsttransfer;
  wire             uart_usb_s1_grant_vector;
  wire             uart_usb_s1_in_a_read_cycle;
  wire             uart_usb_s1_in_a_write_cycle;
  wire             uart_usb_s1_irq_from_sa;
  wire             uart_usb_s1_master_qreq_vector;
  wire             uart_usb_s1_non_bursting_master_requests;
  wire             uart_usb_s1_read_n;
  wire    [ 15: 0] uart_usb_s1_readdata_from_sa;
  wire             uart_usb_s1_readyfordata_from_sa;
  reg              uart_usb_s1_reg_firsttransfer;
  wire             uart_usb_s1_reset_n;
  reg              uart_usb_s1_slavearbiterlockenable;
  wire             uart_usb_s1_slavearbiterlockenable2;
  wire             uart_usb_s1_unreg_firsttransfer;
  wire             uart_usb_s1_waits_for_read;
  wire             uart_usb_s1_waits_for_write;
  wire             uart_usb_s1_write_n;
  wire    [ 15: 0] uart_usb_s1_writedata;
  wire             wait_for_uart_usb_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else if (1)
          d1_reasons_to_wait <= ~uart_usb_s1_end_xfer;
    end


  assign uart_usb_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_0_data_master_qualified_request_uart_usb_s1));
  //assign uart_usb_s1_readdata_from_sa = uart_usb_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign uart_usb_s1_readdata_from_sa = uart_usb_s1_readdata;

  assign cpu_0_data_master_requests_uart_usb_s1 = ({cpu_0_data_master_address_to_slave[25 : 5] , 5'b0} == 26'h2003220) & (cpu_0_data_master_read | cpu_0_data_master_write);
  //assign uart_usb_s1_dataavailable_from_sa = uart_usb_s1_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign uart_usb_s1_dataavailable_from_sa = uart_usb_s1_dataavailable;

  //assign uart_usb_s1_readyfordata_from_sa = uart_usb_s1_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign uart_usb_s1_readyfordata_from_sa = uart_usb_s1_readyfordata;

  //uart_usb_s1_arb_share_counter set values, which is an e_mux
  assign uart_usb_s1_arb_share_set_values = 1;

  //uart_usb_s1_non_bursting_master_requests mux, which is an e_mux
  assign uart_usb_s1_non_bursting_master_requests = cpu_0_data_master_requests_uart_usb_s1;

  //uart_usb_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign uart_usb_s1_any_bursting_master_saved_grant = 0;

  //uart_usb_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign uart_usb_s1_arb_share_counter_next_value = uart_usb_s1_firsttransfer ? (uart_usb_s1_arb_share_set_values - 1) : |uart_usb_s1_arb_share_counter ? (uart_usb_s1_arb_share_counter - 1) : 0;

  //uart_usb_s1_allgrants all slave grants, which is an e_mux
  assign uart_usb_s1_allgrants = |uart_usb_s1_grant_vector;

  //uart_usb_s1_end_xfer assignment, which is an e_assign
  assign uart_usb_s1_end_xfer = ~(uart_usb_s1_waits_for_read | uart_usb_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_uart_usb_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_uart_usb_s1 = uart_usb_s1_end_xfer & (~uart_usb_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //uart_usb_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign uart_usb_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_uart_usb_s1 & uart_usb_s1_allgrants) | (end_xfer_arb_share_counter_term_uart_usb_s1 & ~uart_usb_s1_non_bursting_master_requests);

  //uart_usb_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          uart_usb_s1_arb_share_counter <= 0;
      else if (uart_usb_s1_arb_counter_enable)
          uart_usb_s1_arb_share_counter <= uart_usb_s1_arb_share_counter_next_value;
    end


  //uart_usb_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          uart_usb_s1_slavearbiterlockenable <= 0;
      else if ((|uart_usb_s1_master_qreq_vector & end_xfer_arb_share_counter_term_uart_usb_s1) | (end_xfer_arb_share_counter_term_uart_usb_s1 & ~uart_usb_s1_non_bursting_master_requests))
          uart_usb_s1_slavearbiterlockenable <= |uart_usb_s1_arb_share_counter_next_value;
    end


  //cpu_0/data_master uart_usb/s1 arbiterlock, which is an e_assign
  assign cpu_0_data_master_arbiterlock = uart_usb_s1_slavearbiterlockenable & cpu_0_data_master_continuerequest;

  //uart_usb_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign uart_usb_s1_slavearbiterlockenable2 = |uart_usb_s1_arb_share_counter_next_value;

  //cpu_0/data_master uart_usb/s1 arbiterlock2, which is an e_assign
  assign cpu_0_data_master_arbiterlock2 = uart_usb_s1_slavearbiterlockenable2 & cpu_0_data_master_continuerequest;

  //uart_usb_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  assign uart_usb_s1_any_continuerequest = 1;

  //cpu_0_data_master_continuerequest continued request, which is an e_assign
  assign cpu_0_data_master_continuerequest = 1;

  assign cpu_0_data_master_qualified_request_uart_usb_s1 = cpu_0_data_master_requests_uart_usb_s1;
  //uart_usb_s1_writedata mux, which is an e_mux
  assign uart_usb_s1_writedata = cpu_0_data_master_writedata;

  //master is always granted when requested
  assign cpu_0_data_master_granted_uart_usb_s1 = cpu_0_data_master_qualified_request_uart_usb_s1;

  //cpu_0/data_master saved-grant uart_usb/s1, which is an e_assign
  assign cpu_0_data_master_saved_grant_uart_usb_s1 = cpu_0_data_master_requests_uart_usb_s1;

  //allow new arb cycle for uart_usb/s1, which is an e_assign
  assign uart_usb_s1_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign uart_usb_s1_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign uart_usb_s1_master_qreq_vector = 1;

  assign uart_usb_s1_begintransfer = uart_usb_s1_begins_xfer;
  //uart_usb_s1_reset_n assignment, which is an e_assign
  assign uart_usb_s1_reset_n = reset_n;

  assign uart_usb_s1_chipselect = cpu_0_data_master_granted_uart_usb_s1;
  //uart_usb_s1_firsttransfer first transaction, which is an e_assign
  assign uart_usb_s1_firsttransfer = uart_usb_s1_begins_xfer ? uart_usb_s1_unreg_firsttransfer : uart_usb_s1_reg_firsttransfer;

  //uart_usb_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign uart_usb_s1_unreg_firsttransfer = ~(uart_usb_s1_slavearbiterlockenable & uart_usb_s1_any_continuerequest);

  //uart_usb_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          uart_usb_s1_reg_firsttransfer <= 1'b1;
      else if (uart_usb_s1_begins_xfer)
          uart_usb_s1_reg_firsttransfer <= uart_usb_s1_unreg_firsttransfer;
    end


  //uart_usb_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign uart_usb_s1_beginbursttransfer_internal = uart_usb_s1_begins_xfer;

  //~uart_usb_s1_read_n assignment, which is an e_mux
  assign uart_usb_s1_read_n = ~(cpu_0_data_master_granted_uart_usb_s1 & cpu_0_data_master_read);

  //~uart_usb_s1_write_n assignment, which is an e_mux
  assign uart_usb_s1_write_n = ~(cpu_0_data_master_granted_uart_usb_s1 & cpu_0_data_master_write);

  assign shifted_address_to_uart_usb_s1_from_cpu_0_data_master = cpu_0_data_master_address_to_slave;
  //uart_usb_s1_address mux, which is an e_mux
  assign uart_usb_s1_address = shifted_address_to_uart_usb_s1_from_cpu_0_data_master >> 2;

  //d1_uart_usb_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_uart_usb_s1_end_xfer <= 1;
      else if (1)
          d1_uart_usb_s1_end_xfer <= uart_usb_s1_end_xfer;
    end


  //uart_usb_s1_waits_for_read in a cycle, which is an e_mux
  assign uart_usb_s1_waits_for_read = uart_usb_s1_in_a_read_cycle & uart_usb_s1_begins_xfer;

  //uart_usb_s1_in_a_read_cycle assignment, which is an e_assign
  assign uart_usb_s1_in_a_read_cycle = cpu_0_data_master_granted_uart_usb_s1 & cpu_0_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = uart_usb_s1_in_a_read_cycle;

  //uart_usb_s1_waits_for_write in a cycle, which is an e_mux
  assign uart_usb_s1_waits_for_write = uart_usb_s1_in_a_write_cycle & uart_usb_s1_begins_xfer;

  //uart_usb_s1_in_a_write_cycle assignment, which is an e_assign
  assign uart_usb_s1_in_a_write_cycle = cpu_0_data_master_granted_uart_usb_s1 & cpu_0_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = uart_usb_s1_in_a_write_cycle;

  assign wait_for_uart_usb_s1_counter = 0;
  //assign uart_usb_s1_irq_from_sa = uart_usb_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign uart_usb_s1_irq_from_sa = uart_usb_s1_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //uart_usb/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else if (1)
          enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module nios (
              // 1) global signals:
               clk,
               reset_n,

              // the_E_RST
               out_port_from_the_E_RST,

              // the_adc_tlc549_0
               AD_CLK_from_the_adc_tlc549_0,
               AD_CS_from_the_adc_tlc549_0,
               AD_DATA_to_the_adc_tlc549_0,

              // the_avalon_tlc5620_0
               dac_clk_from_the_avalon_tlc5620_0,
               dac_data_from_the_avalon_tlc5620_0,
               dac_ldac_from_the_avalon_tlc5620_0,
               dac_load_from_the_avalon_tlc5620_0,

              // the_lcd12864_cs
               out_port_from_the_lcd12864_cs,

              // the_oc_i2c_master_0
               scl_pad_io_to_and_from_the_oc_i2c_master_0,
               sda_pad_io_to_and_from_the_oc_i2c_master_0,

              // the_pio_beep
               out_port_from_the_pio_beep,

              // the_pio_key
               in_port_to_the_pio_key,

              // the_pio_led
               out_port_from_the_pio_led,

              // the_ps2_0
               kb_clk_to_the_ps2_0,
               kb_data_to_the_ps2_0,

              // the_pwm_interface_0
               pwm_out_from_the_pwm_interface_0,

              // the_sdram_0
               zs_addr_from_the_sdram_0,
               zs_ba_from_the_sdram_0,
               zs_cas_n_from_the_sdram_0,
               zs_cke_from_the_sdram_0,
               zs_cs_n_from_the_sdram_0,
               zs_dq_to_and_from_the_sdram_0,
               zs_dqm_from_the_sdram_0,
               zs_ras_n_from_the_sdram_0,
               zs_we_n_from_the_sdram_0,

              // the_seg78led_0
               seg_com_from_the_seg78led_0,
               seg_data_from_the_seg78led_0,

              // the_tri_state_bridge_0_avalon_slave
               chipselect_to_the_lcd_tri_12864_0,
               chipselect_to_the_lcd_tri_1602_0,
               irq_from_the_ctrl_rtl8019_0,
               read_n_to_the_ctrl_rtl8019_0,
               rst_to_the_ctrl_rtl8019_0,
               select_n_to_the_ctrl_rtl8019_0,
               select_n_to_the_flash,
               tri_state_bridge_0_address,
               tri_state_bridge_0_data,
               tri_state_bridge_0_read,
               tri_state_bridge_0_readn,
               tri_state_bridge_0_write,
               write_n_to_the_ctrl_rtl8019_0,
               write_n_to_the_flash,

              // the_uart_usb
               rxd_to_the_uart_usb,
               txd_from_the_uart_usb
            )
;

  output           AD_CLK_from_the_adc_tlc549_0;
  output           AD_CS_from_the_adc_tlc549_0;
  output           chipselect_to_the_lcd_tri_12864_0;
  output           chipselect_to_the_lcd_tri_1602_0;
  output           dac_clk_from_the_avalon_tlc5620_0;
  output           dac_data_from_the_avalon_tlc5620_0;
  output           dac_ldac_from_the_avalon_tlc5620_0;
  output           dac_load_from_the_avalon_tlc5620_0;
  output           out_port_from_the_E_RST;
  output  [  1: 0] out_port_from_the_lcd12864_cs;
  output           out_port_from_the_pio_beep;
  output  [  3: 0] out_port_from_the_pio_led;
  output           pwm_out_from_the_pwm_interface_0;
  output           read_n_to_the_ctrl_rtl8019_0;
  output           rst_to_the_ctrl_rtl8019_0;
  inout            scl_pad_io_to_and_from_the_oc_i2c_master_0;
  inout            sda_pad_io_to_and_from_the_oc_i2c_master_0;
  output  [  7: 0] seg_com_from_the_seg78led_0;
  output  [  7: 0] seg_data_from_the_seg78led_0;
  output           select_n_to_the_ctrl_rtl8019_0;
  output           select_n_to_the_flash;
  output  [ 22: 0] tri_state_bridge_0_address;
  inout   [  7: 0] tri_state_bridge_0_data;
  output           tri_state_bridge_0_read;
  output           tri_state_bridge_0_readn;
  output           tri_state_bridge_0_write;
  output           txd_from_the_uart_usb;
  output           write_n_to_the_ctrl_rtl8019_0;
  output           write_n_to_the_flash;
  output  [ 11: 0] zs_addr_from_the_sdram_0;
  output  [  1: 0] zs_ba_from_the_sdram_0;
  output           zs_cas_n_from_the_sdram_0;
  output           zs_cke_from_the_sdram_0;
  output           zs_cs_n_from_the_sdram_0;
  inout   [ 15: 0] zs_dq_to_and_from_the_sdram_0;
  output  [  1: 0] zs_dqm_from_the_sdram_0;
  output           zs_ras_n_from_the_sdram_0;
  output           zs_we_n_from_the_sdram_0;
  input            AD_DATA_to_the_adc_tlc549_0;
  input            clk;
  input   [  3: 0] in_port_to_the_pio_key;
  input            irq_from_the_ctrl_rtl8019_0;
  input            kb_clk_to_the_ps2_0;
  input            kb_data_to_the_ps2_0;
  input            reset_n;
  input            rxd_to_the_uart_usb;

  wire             AD_CLK_from_the_adc_tlc549_0;
  wire             AD_CS_from_the_adc_tlc549_0;
  wire    [  1: 0] E_RST_s1_address;
  wire             E_RST_s1_chipselect;
  wire             E_RST_s1_reset_n;
  wire             E_RST_s1_write_n;
  wire             E_RST_s1_writedata;
  wire             adc_tlc549_0_avalon_slave_0_irq;
  wire             adc_tlc549_0_avalon_slave_0_irq_from_sa;
  wire             adc_tlc549_0_avalon_slave_0_read_n;
  wire    [  7: 0] adc_tlc549_0_avalon_slave_0_readdata;
  wire    [  7: 0] adc_tlc549_0_avalon_slave_0_readdata_from_sa;
  wire    [  1: 0] avalon_tlc5620_0_avalon_slave_address;
  wire             avalon_tlc5620_0_avalon_slave_chipselect;
  wire             avalon_tlc5620_0_avalon_slave_reset_n;
  wire             avalon_tlc5620_0_avalon_slave_write;
  wire    [ 31: 0] avalon_tlc5620_0_avalon_slave_writedata;
  wire             chipselect_to_the_lcd_tri_12864_0;
  wire             chipselect_to_the_lcd_tri_1602_0;
  wire             clk_reset_n;
  wire    [  4: 0] cpu_0_custom_instruction_master_multi_a;
  wire    [  4: 0] cpu_0_custom_instruction_master_multi_b;
  wire    [  4: 0] cpu_0_custom_instruction_master_multi_c;
  wire             cpu_0_custom_instruction_master_multi_clk_en;
  wire    [ 31: 0] cpu_0_custom_instruction_master_multi_dataa;
  wire    [ 31: 0] cpu_0_custom_instruction_master_multi_datab;
  wire             cpu_0_custom_instruction_master_multi_done;
  wire             cpu_0_custom_instruction_master_multi_estatus;
  wire    [ 31: 0] cpu_0_custom_instruction_master_multi_ipending;
  wire    [  7: 0] cpu_0_custom_instruction_master_multi_n;
  wire             cpu_0_custom_instruction_master_multi_readra;
  wire             cpu_0_custom_instruction_master_multi_readrb;
  wire    [ 31: 0] cpu_0_custom_instruction_master_multi_result;
  wire             cpu_0_custom_instruction_master_multi_start;
  wire             cpu_0_custom_instruction_master_multi_status;
  wire             cpu_0_custom_instruction_master_multi_writerc;
  wire             cpu_0_custom_instruction_master_reset_n;
  wire             cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1;
  wire    [ 25: 0] cpu_0_data_master_address;
  wire    [ 25: 0] cpu_0_data_master_address_to_slave;
  wire    [  3: 0] cpu_0_data_master_byteenable;
  wire             cpu_0_data_master_byteenable_flash_s1;
  wire    [  1: 0] cpu_0_data_master_byteenable_sdram_0_s1;
  wire             cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0;
  wire    [  1: 0] cpu_0_data_master_dbs_address;
  wire    [ 15: 0] cpu_0_data_master_dbs_write_16;
  wire    [  7: 0] cpu_0_data_master_dbs_write_8;
  wire             cpu_0_data_master_debugaccess;
  wire             cpu_0_data_master_granted_E_RST_s1;
  wire             cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0;
  wire             cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave;
  wire             cpu_0_data_master_granted_cpu_0_jtag_debug_module;
  wire             cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_granted_dma_control_port_slave;
  wire             cpu_0_data_master_granted_flash_s1;
  wire             cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave;
  wire             cpu_0_data_master_granted_lcd12864_cs_s1;
  wire             cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave;
  wire             cpu_0_data_master_granted_onchip_mem_s1;
  wire             cpu_0_data_master_granted_performance_counter_control_slave;
  wire             cpu_0_data_master_granted_pio_beep_s1;
  wire             cpu_0_data_master_granted_pio_key_s1;
  wire             cpu_0_data_master_granted_pio_led_s1;
  wire             cpu_0_data_master_granted_ps2_0_avalon_slave_0;
  wire             cpu_0_data_master_granted_pwm_interface_0_control_slave;
  wire             cpu_0_data_master_granted_sdram_0_s1;
  wire             cpu_0_data_master_granted_seg78led_0_avalon_slave_0;
  wire             cpu_0_data_master_granted_sysid_control_slave;
  wire             cpu_0_data_master_granted_timer_0_s1;
  wire             cpu_0_data_master_granted_uart_usb_s1;
  wire    [ 31: 0] cpu_0_data_master_irq;
  wire             cpu_0_data_master_no_byte_enables_and_last_term;
  wire             cpu_0_data_master_qualified_request_E_RST_s1;
  wire             cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0;
  wire             cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave;
  wire             cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module;
  wire             cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_qualified_request_dma_control_port_slave;
  wire             cpu_0_data_master_qualified_request_flash_s1;
  wire             cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave;
  wire             cpu_0_data_master_qualified_request_lcd12864_cs_s1;
  wire             cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave;
  wire             cpu_0_data_master_qualified_request_onchip_mem_s1;
  wire             cpu_0_data_master_qualified_request_performance_counter_control_slave;
  wire             cpu_0_data_master_qualified_request_pio_beep_s1;
  wire             cpu_0_data_master_qualified_request_pio_key_s1;
  wire             cpu_0_data_master_qualified_request_pio_led_s1;
  wire             cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0;
  wire             cpu_0_data_master_qualified_request_pwm_interface_0_control_slave;
  wire             cpu_0_data_master_qualified_request_sdram_0_s1;
  wire             cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0;
  wire             cpu_0_data_master_qualified_request_sysid_control_slave;
  wire             cpu_0_data_master_qualified_request_timer_0_s1;
  wire             cpu_0_data_master_qualified_request_uart_usb_s1;
  wire             cpu_0_data_master_read;
  wire             cpu_0_data_master_read_data_valid_E_RST_s1;
  wire             cpu_0_data_master_read_data_valid_adc_tlc549_0_avalon_slave_0;
  wire             cpu_0_data_master_read_data_valid_avalon_tlc5620_0_avalon_slave;
  wire             cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module;
  wire             cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_read_data_valid_dma_control_port_slave;
  wire             cpu_0_data_master_read_data_valid_flash_s1;
  wire             cpu_0_data_master_read_data_valid_jtag_uart_avalon_jtag_slave;
  wire             cpu_0_data_master_read_data_valid_lcd12864_cs_s1;
  wire             cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_read_data_valid_oc_i2c_master_0_avalon_slave;
  wire             cpu_0_data_master_read_data_valid_onchip_mem_s1;
  wire             cpu_0_data_master_read_data_valid_performance_counter_control_slave;
  wire             cpu_0_data_master_read_data_valid_pio_beep_s1;
  wire             cpu_0_data_master_read_data_valid_pio_key_s1;
  wire             cpu_0_data_master_read_data_valid_pio_led_s1;
  wire             cpu_0_data_master_read_data_valid_ps2_0_avalon_slave_0;
  wire             cpu_0_data_master_read_data_valid_pwm_interface_0_control_slave;
  wire             cpu_0_data_master_read_data_valid_sdram_0_s1;
  wire             cpu_0_data_master_read_data_valid_sdram_0_s1_shift_register;
  wire             cpu_0_data_master_read_data_valid_seg78led_0_avalon_slave_0;
  wire             cpu_0_data_master_read_data_valid_sysid_control_slave;
  wire             cpu_0_data_master_read_data_valid_timer_0_s1;
  wire             cpu_0_data_master_read_data_valid_uart_usb_s1;
  wire    [ 31: 0] cpu_0_data_master_readdata;
  wire             cpu_0_data_master_requests_E_RST_s1;
  wire             cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0;
  wire             cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave;
  wire             cpu_0_data_master_requests_cpu_0_jtag_debug_module;
  wire             cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_requests_dma_control_port_slave;
  wire             cpu_0_data_master_requests_flash_s1;
  wire             cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave;
  wire             cpu_0_data_master_requests_lcd12864_cs_s1;
  wire             cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave;
  wire             cpu_0_data_master_requests_onchip_mem_s1;
  wire             cpu_0_data_master_requests_performance_counter_control_slave;
  wire             cpu_0_data_master_requests_pio_beep_s1;
  wire             cpu_0_data_master_requests_pio_key_s1;
  wire             cpu_0_data_master_requests_pio_led_s1;
  wire             cpu_0_data_master_requests_ps2_0_avalon_slave_0;
  wire             cpu_0_data_master_requests_pwm_interface_0_control_slave;
  wire             cpu_0_data_master_requests_sdram_0_s1;
  wire             cpu_0_data_master_requests_seg78led_0_avalon_slave_0;
  wire             cpu_0_data_master_requests_sysid_control_slave;
  wire             cpu_0_data_master_requests_timer_0_s1;
  wire             cpu_0_data_master_requests_uart_usb_s1;
  wire             cpu_0_data_master_waitrequest;
  wire             cpu_0_data_master_write;
  wire    [ 31: 0] cpu_0_data_master_writedata;
  wire             cpu_0_fpoint_s1_clk_en;
  wire    [ 31: 0] cpu_0_fpoint_s1_dataa;
  wire    [ 31: 0] cpu_0_fpoint_s1_datab;
  wire             cpu_0_fpoint_s1_done;
  wire             cpu_0_fpoint_s1_done_from_sa;
  wire    [  1: 0] cpu_0_fpoint_s1_n;
  wire             cpu_0_fpoint_s1_reset;
  wire    [ 31: 0] cpu_0_fpoint_s1_result;
  wire    [ 31: 0] cpu_0_fpoint_s1_result_from_sa;
  wire             cpu_0_fpoint_s1_select;
  wire             cpu_0_fpoint_s1_start;
  wire    [ 25: 0] cpu_0_instruction_master_address;
  wire    [ 25: 0] cpu_0_instruction_master_address_to_slave;
  wire    [  1: 0] cpu_0_instruction_master_dbs_address;
  wire             cpu_0_instruction_master_granted_cpu_0_jtag_debug_module;
  wire             cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_granted_flash_s1;
  wire             cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_granted_onchip_mem_s1;
  wire             cpu_0_instruction_master_granted_sdram_0_s1;
  wire             cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0;
  wire    [  1: 0] cpu_0_instruction_master_latency_counter;
  wire             cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module;
  wire             cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_qualified_request_flash_s1;
  wire             cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_qualified_request_onchip_mem_s1;
  wire             cpu_0_instruction_master_qualified_request_sdram_0_s1;
  wire             cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0;
  wire             cpu_0_instruction_master_read;
  wire             cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module;
  wire             cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_read_data_valid_flash_s1;
  wire             cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_read_data_valid_onchip_mem_s1;
  wire             cpu_0_instruction_master_read_data_valid_sdram_0_s1;
  wire             cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register;
  wire             cpu_0_instruction_master_read_data_valid_seg78led_0_avalon_slave_0;
  wire    [ 31: 0] cpu_0_instruction_master_readdata;
  wire             cpu_0_instruction_master_readdatavalid;
  wire             cpu_0_instruction_master_requests_cpu_0_jtag_debug_module;
  wire             cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_requests_flash_s1;
  wire             cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             cpu_0_instruction_master_requests_onchip_mem_s1;
  wire             cpu_0_instruction_master_requests_sdram_0_s1;
  wire             cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0;
  wire             cpu_0_instruction_master_waitrequest;
  wire    [  8: 0] cpu_0_jtag_debug_module_address;
  wire             cpu_0_jtag_debug_module_begintransfer;
  wire    [  3: 0] cpu_0_jtag_debug_module_byteenable;
  wire             cpu_0_jtag_debug_module_chipselect;
  wire             cpu_0_jtag_debug_module_debugaccess;
  wire    [ 31: 0] cpu_0_jtag_debug_module_readdata;
  wire    [ 31: 0] cpu_0_jtag_debug_module_readdata_from_sa;
  wire             cpu_0_jtag_debug_module_reset;
  wire             cpu_0_jtag_debug_module_resetrequest;
  wire             cpu_0_jtag_debug_module_resetrequest_from_sa;
  wire             cpu_0_jtag_debug_module_write;
  wire    [ 31: 0] cpu_0_jtag_debug_module_writedata;
  wire             ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0;
  wire             ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1;
  wire             d1_E_RST_s1_end_xfer;
  wire             d1_adc_tlc549_0_avalon_slave_0_end_xfer;
  wire             d1_avalon_tlc5620_0_avalon_slave_end_xfer;
  wire             d1_cpu_0_jtag_debug_module_end_xfer;
  wire             d1_dma_control_port_slave_end_xfer;
  wire             d1_irq_from_the_ctrl_rtl8019_0;
  wire             d1_jtag_uart_avalon_jtag_slave_end_xfer;
  wire             d1_lcd12864_cs_s1_end_xfer;
  wire             d1_oc_i2c_master_0_avalon_slave_end_xfer;
  wire             d1_onchip_mem_s1_end_xfer;
  wire             d1_performance_counter_control_slave_end_xfer;
  wire             d1_pio_beep_s1_end_xfer;
  wire             d1_pio_key_s1_end_xfer;
  wire             d1_pio_led_s1_end_xfer;
  wire             d1_ps2_0_avalon_slave_0_end_xfer;
  wire             d1_pwm_interface_0_control_slave_end_xfer;
  wire             d1_sdram_0_s1_end_xfer;
  wire             d1_seg78led_0_avalon_slave_0_end_xfer;
  wire             d1_sysid_control_slave_end_xfer;
  wire             d1_timer_0_s1_end_xfer;
  wire             d1_tri_state_bridge_0_avalon_slave_end_xfer;
  wire             d1_uart_usb_s1_end_xfer;
  wire             dac_clk_from_the_avalon_tlc5620_0;
  wire             dac_data_from_the_avalon_tlc5620_0;
  wire             dac_ldac_from_the_avalon_tlc5620_0;
  wire             dac_load_from_the_avalon_tlc5620_0;
  wire    [  2: 0] dma_control_port_slave_address;
  wire             dma_control_port_slave_chipselect;
  wire             dma_control_port_slave_irq;
  wire             dma_control_port_slave_irq_from_sa;
  wire    [ 25: 0] dma_control_port_slave_readdata;
  wire    [ 25: 0] dma_control_port_slave_readdata_from_sa;
  wire             dma_control_port_slave_readyfordata;
  wire             dma_control_port_slave_readyfordata_from_sa;
  wire             dma_control_port_slave_reset_n;
  wire             dma_control_port_slave_write_n;
  wire    [ 25: 0] dma_control_port_slave_writedata;
  wire    [ 25: 0] dma_read_master_address;
  wire    [ 25: 0] dma_read_master_address_to_slave;
  wire             dma_read_master_chipselect;
  wire    [  1: 0] dma_read_master_dbs_address;
  wire             dma_read_master_endofpacket;
  wire             dma_read_master_flush;
  wire             dma_read_master_flush_qualified_exported;
  wire             dma_read_master_granted_onchip_mem_s1;
  wire             dma_read_master_granted_sdram_0_s1;
  wire             dma_read_master_latency_counter;
  wire             dma_read_master_qualified_request_onchip_mem_s1;
  wire             dma_read_master_qualified_request_sdram_0_s1;
  wire             dma_read_master_read_data_valid_onchip_mem_s1;
  wire             dma_read_master_read_data_valid_sdram_0_s1;
  wire             dma_read_master_read_data_valid_sdram_0_s1_shift_register;
  wire             dma_read_master_read_n;
  wire    [ 31: 0] dma_read_master_readdata;
  wire             dma_read_master_readdatavalid;
  wire             dma_read_master_requests_onchip_mem_s1;
  wire             dma_read_master_requests_sdram_0_s1;
  wire             dma_read_master_waitrequest;
  wire    [ 25: 0] dma_write_master_address;
  wire    [ 25: 0] dma_write_master_address_to_slave;
  wire    [  3: 0] dma_write_master_byteenable;
  wire    [  1: 0] dma_write_master_byteenable_sdram_0_s1;
  wire             dma_write_master_chipselect;
  wire    [  1: 0] dma_write_master_dbs_address;
  wire    [ 15: 0] dma_write_master_dbs_write_16;
  wire             dma_write_master_endofpacket;
  wire             dma_write_master_granted_onchip_mem_s1;
  wire             dma_write_master_granted_sdram_0_s1;
  wire             dma_write_master_qualified_request_onchip_mem_s1;
  wire             dma_write_master_qualified_request_sdram_0_s1;
  wire             dma_write_master_requests_onchip_mem_s1;
  wire             dma_write_master_requests_sdram_0_s1;
  wire             dma_write_master_waitrequest;
  wire             dma_write_master_write_n;
  wire    [ 31: 0] dma_write_master_writedata;
  wire             flash_s1_wait_counter_eq_0;
  wire             flash_s1_wait_counter_eq_1;
  wire    [  7: 0] incoming_tri_state_bridge_0_data;
  wire    [  7: 0] incoming_tri_state_bridge_0_data_with_Xs_converted_to_0;
  wire             jtag_uart_avalon_jtag_slave_address;
  wire             jtag_uart_avalon_jtag_slave_chipselect;
  wire             jtag_uart_avalon_jtag_slave_dataavailable;
  wire             jtag_uart_avalon_jtag_slave_dataavailable_from_sa;
  wire             jtag_uart_avalon_jtag_slave_irq;
  wire             jtag_uart_avalon_jtag_slave_irq_from_sa;
  wire             jtag_uart_avalon_jtag_slave_read_n;
  wire    [ 31: 0] jtag_uart_avalon_jtag_slave_readdata;
  wire    [ 31: 0] jtag_uart_avalon_jtag_slave_readdata_from_sa;
  wire             jtag_uart_avalon_jtag_slave_readyfordata;
  wire             jtag_uart_avalon_jtag_slave_readyfordata_from_sa;
  wire             jtag_uart_avalon_jtag_slave_reset_n;
  wire             jtag_uart_avalon_jtag_slave_waitrequest;
  wire             jtag_uart_avalon_jtag_slave_waitrequest_from_sa;
  wire             jtag_uart_avalon_jtag_slave_write_n;
  wire    [ 31: 0] jtag_uart_avalon_jtag_slave_writedata;
  wire    [  1: 0] lcd12864_cs_s1_address;
  wire             lcd12864_cs_s1_chipselect;
  wire             lcd12864_cs_s1_reset_n;
  wire             lcd12864_cs_s1_write_n;
  wire    [  1: 0] lcd12864_cs_s1_writedata;
  wire             lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0;
  wire             lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1;
  wire             lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0;
  wire             lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1;
  wire    [  2: 0] oc_i2c_master_0_avalon_slave_address;
  wire             oc_i2c_master_0_avalon_slave_chipselect;
  wire             oc_i2c_master_0_avalon_slave_irq;
  wire             oc_i2c_master_0_avalon_slave_irq_from_sa;
  wire    [ 31: 0] oc_i2c_master_0_avalon_slave_readdata;
  wire    [ 31: 0] oc_i2c_master_0_avalon_slave_readdata_from_sa;
  wire             oc_i2c_master_0_avalon_slave_reset;
  wire             oc_i2c_master_0_avalon_slave_waitrequest_n;
  wire             oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa;
  wire             oc_i2c_master_0_avalon_slave_wishbone_err;
  wire             oc_i2c_master_0_avalon_slave_wishbone_err_from_sa;
  wire             oc_i2c_master_0_avalon_slave_write;
  wire    [ 31: 0] oc_i2c_master_0_avalon_slave_writedata;
  wire    [  9: 0] onchip_mem_s1_address;
  wire    [  3: 0] onchip_mem_s1_byteenable;
  wire             onchip_mem_s1_chipselect;
  wire             onchip_mem_s1_clken;
  wire    [ 31: 0] onchip_mem_s1_readdata;
  wire    [ 31: 0] onchip_mem_s1_readdata_from_sa;
  wire             onchip_mem_s1_write;
  wire    [ 31: 0] onchip_mem_s1_writedata;
  wire             out_port_from_the_E_RST;
  wire    [  1: 0] out_port_from_the_lcd12864_cs;
  wire             out_port_from_the_pio_beep;
  wire    [  3: 0] out_port_from_the_pio_led;
  wire    [  3: 0] performance_counter_control_slave_address;
  wire             performance_counter_control_slave_begintransfer;
  wire    [ 31: 0] performance_counter_control_slave_readdata;
  wire    [ 31: 0] performance_counter_control_slave_readdata_from_sa;
  wire             performance_counter_control_slave_reset_n;
  wire             performance_counter_control_slave_write;
  wire    [ 31: 0] performance_counter_control_slave_writedata;
  wire    [  1: 0] pio_beep_s1_address;
  wire             pio_beep_s1_chipselect;
  wire             pio_beep_s1_reset_n;
  wire             pio_beep_s1_write_n;
  wire             pio_beep_s1_writedata;
  wire    [  1: 0] pio_key_s1_address;
  wire             pio_key_s1_chipselect;
  wire             pio_key_s1_irq;
  wire             pio_key_s1_irq_from_sa;
  wire    [  3: 0] pio_key_s1_readdata;
  wire    [  3: 0] pio_key_s1_readdata_from_sa;
  wire             pio_key_s1_reset_n;
  wire             pio_key_s1_write_n;
  wire    [  3: 0] pio_key_s1_writedata;
  wire    [  1: 0] pio_led_s1_address;
  wire             pio_led_s1_chipselect;
  wire             pio_led_s1_reset_n;
  wire             pio_led_s1_write_n;
  wire    [  3: 0] pio_led_s1_writedata;
  wire             ps2_0_avalon_slave_0_irq;
  wire             ps2_0_avalon_slave_0_irq_from_sa;
  wire             ps2_0_avalon_slave_0_read_n;
  wire    [ 15: 0] ps2_0_avalon_slave_0_readdata;
  wire    [ 15: 0] ps2_0_avalon_slave_0_readdata_from_sa;
  wire    [  1: 0] pwm_interface_0_control_slave_address;
  wire             pwm_interface_0_control_slave_chipselect;
  wire             pwm_interface_0_control_slave_read;
  wire    [ 31: 0] pwm_interface_0_control_slave_readdata;
  wire    [ 31: 0] pwm_interface_0_control_slave_readdata_from_sa;
  wire             pwm_interface_0_control_slave_write;
  wire    [ 31: 0] pwm_interface_0_control_slave_writedata;
  wire             pwm_out_from_the_pwm_interface_0;
  wire             read_n_to_the_ctrl_rtl8019_0;
  wire             registered_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0;
  wire             registered_cpu_0_data_master_read_data_valid_flash_s1;
  wire             registered_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0;
  wire             registered_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0;
  wire             registered_cpu_0_data_master_read_data_valid_onchip_mem_s1;
  wire             registered_cpu_0_data_master_read_data_valid_performance_counter_control_slave;
  wire             reset_n_sources;
  wire             rst_to_the_ctrl_rtl8019_0;
  wire             scl_pad_io_to_and_from_the_oc_i2c_master_0;
  wire             sda_pad_io_to_and_from_the_oc_i2c_master_0;
  wire    [ 21: 0] sdram_0_s1_address;
  wire    [  1: 0] sdram_0_s1_byteenable_n;
  wire             sdram_0_s1_chipselect;
  wire             sdram_0_s1_read_n;
  wire    [ 15: 0] sdram_0_s1_readdata;
  wire    [ 15: 0] sdram_0_s1_readdata_from_sa;
  wire             sdram_0_s1_readdatavalid;
  wire             sdram_0_s1_reset_n;
  wire             sdram_0_s1_waitrequest;
  wire             sdram_0_s1_waitrequest_from_sa;
  wire             sdram_0_s1_write_n;
  wire    [ 15: 0] sdram_0_s1_writedata;
  wire    [  2: 0] seg78led_0_avalon_slave_0_address;
  wire             seg78led_0_avalon_slave_0_read_n;
  wire    [  7: 0] seg78led_0_avalon_slave_0_readdata;
  wire    [  7: 0] seg78led_0_avalon_slave_0_readdata_from_sa;
  wire             seg78led_0_avalon_slave_0_wait_counter_eq_0;
  wire             seg78led_0_avalon_slave_0_wait_counter_eq_1;
  wire             seg78led_0_avalon_slave_0_write_n;
  wire    [  7: 0] seg78led_0_avalon_slave_0_writedata;
  wire    [  7: 0] seg_com_from_the_seg78led_0;
  wire    [  7: 0] seg_data_from_the_seg78led_0;
  wire             select_n_to_the_ctrl_rtl8019_0;
  wire             select_n_to_the_flash;
  wire             sysid_control_slave_address;
  wire    [ 31: 0] sysid_control_slave_readdata;
  wire    [ 31: 0] sysid_control_slave_readdata_from_sa;
  wire    [  2: 0] timer_0_s1_address;
  wire             timer_0_s1_chipselect;
  wire             timer_0_s1_irq;
  wire             timer_0_s1_irq_from_sa;
  wire    [ 15: 0] timer_0_s1_readdata;
  wire    [ 15: 0] timer_0_s1_readdata_from_sa;
  wire             timer_0_s1_reset_n;
  wire             timer_0_s1_write_n;
  wire    [ 15: 0] timer_0_s1_writedata;
  wire    [ 22: 0] tri_state_bridge_0_address;
  wire    [  7: 0] tri_state_bridge_0_data;
  wire             tri_state_bridge_0_read;
  wire             tri_state_bridge_0_readn;
  wire             tri_state_bridge_0_write;
  wire             txd_from_the_uart_usb;
  wire    [  2: 0] uart_usb_s1_address;
  wire             uart_usb_s1_begintransfer;
  wire             uart_usb_s1_chipselect;
  wire             uart_usb_s1_dataavailable;
  wire             uart_usb_s1_dataavailable_from_sa;
  wire             uart_usb_s1_irq;
  wire             uart_usb_s1_irq_from_sa;
  wire             uart_usb_s1_read_n;
  wire    [ 15: 0] uart_usb_s1_readdata;
  wire    [ 15: 0] uart_usb_s1_readdata_from_sa;
  wire             uart_usb_s1_readyfordata;
  wire             uart_usb_s1_readyfordata_from_sa;
  wire             uart_usb_s1_reset_n;
  wire             uart_usb_s1_write_n;
  wire    [ 15: 0] uart_usb_s1_writedata;
  wire             write_n_to_the_ctrl_rtl8019_0;
  wire             write_n_to_the_flash;
  wire    [ 11: 0] zs_addr_from_the_sdram_0;
  wire    [  1: 0] zs_ba_from_the_sdram_0;
  wire             zs_cas_n_from_the_sdram_0;
  wire             zs_cke_from_the_sdram_0;
  wire             zs_cs_n_from_the_sdram_0;
  wire    [ 15: 0] zs_dq_to_and_from_the_sdram_0;
  wire    [  1: 0] zs_dqm_from_the_sdram_0;
  wire             zs_ras_n_from_the_sdram_0;
  wire             zs_we_n_from_the_sdram_0;
  E_RST_s1_arbitrator the_E_RST_s1
    (
      .E_RST_s1_address                             (E_RST_s1_address),
      .E_RST_s1_chipselect                          (E_RST_s1_chipselect),
      .E_RST_s1_reset_n                             (E_RST_s1_reset_n),
      .E_RST_s1_write_n                             (E_RST_s1_write_n),
      .E_RST_s1_writedata                           (E_RST_s1_writedata),
      .clk                                          (clk),
      .cpu_0_data_master_address_to_slave           (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_E_RST_s1           (cpu_0_data_master_granted_E_RST_s1),
      .cpu_0_data_master_qualified_request_E_RST_s1 (cpu_0_data_master_qualified_request_E_RST_s1),
      .cpu_0_data_master_read                       (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_E_RST_s1   (cpu_0_data_master_read_data_valid_E_RST_s1),
      .cpu_0_data_master_requests_E_RST_s1          (cpu_0_data_master_requests_E_RST_s1),
      .cpu_0_data_master_waitrequest                (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                      (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                  (cpu_0_data_master_writedata),
      .d1_E_RST_s1_end_xfer                         (d1_E_RST_s1_end_xfer),
      .reset_n                                      (clk_reset_n)
    );

  E_RST the_E_RST
    (
      .address    (E_RST_s1_address),
      .chipselect (E_RST_s1_chipselect),
      .clk        (clk),
      .out_port   (out_port_from_the_E_RST),
      .reset_n    (E_RST_s1_reset_n),
      .write_n    (E_RST_s1_write_n),
      .writedata  (E_RST_s1_writedata)
    );

  adc_tlc549_0_avalon_slave_0_arbitrator the_adc_tlc549_0_avalon_slave_0
    (
      .adc_tlc549_0_avalon_slave_0_irq                                 (adc_tlc549_0_avalon_slave_0_irq),
      .adc_tlc549_0_avalon_slave_0_irq_from_sa                         (adc_tlc549_0_avalon_slave_0_irq_from_sa),
      .adc_tlc549_0_avalon_slave_0_read_n                              (adc_tlc549_0_avalon_slave_0_read_n),
      .adc_tlc549_0_avalon_slave_0_readdata                            (adc_tlc549_0_avalon_slave_0_readdata),
      .adc_tlc549_0_avalon_slave_0_readdata_from_sa                    (adc_tlc549_0_avalon_slave_0_readdata_from_sa),
      .clk                                                             (clk),
      .cpu_0_data_master_address_to_slave                              (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0           (cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0),
      .cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0 (cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0),
      .cpu_0_data_master_read                                          (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_adc_tlc549_0_avalon_slave_0   (cpu_0_data_master_read_data_valid_adc_tlc549_0_avalon_slave_0),
      .cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0          (cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0),
      .cpu_0_data_master_waitrequest                                   (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                                         (cpu_0_data_master_write),
      .d1_adc_tlc549_0_avalon_slave_0_end_xfer                         (d1_adc_tlc549_0_avalon_slave_0_end_xfer),
      .reset_n                                                         (clk_reset_n)
    );

  adc_tlc549_0 the_adc_tlc549_0
    (
      .AD_CLK   (AD_CLK_from_the_adc_tlc549_0),
      .AD_CS    (AD_CS_from_the_adc_tlc549_0),
      .AD_DATA  (AD_DATA_to_the_adc_tlc549_0),
      .clk      (clk),
      .irq      (adc_tlc549_0_avalon_slave_0_irq),
      .read_n   (adc_tlc549_0_avalon_slave_0_read_n),
      .readdata (adc_tlc549_0_avalon_slave_0_readdata)
    );

  avalon_tlc5620_0_avalon_slave_arbitrator the_avalon_tlc5620_0_avalon_slave
    (
      .avalon_tlc5620_0_avalon_slave_address                             (avalon_tlc5620_0_avalon_slave_address),
      .avalon_tlc5620_0_avalon_slave_chipselect                          (avalon_tlc5620_0_avalon_slave_chipselect),
      .avalon_tlc5620_0_avalon_slave_reset_n                             (avalon_tlc5620_0_avalon_slave_reset_n),
      .avalon_tlc5620_0_avalon_slave_write                               (avalon_tlc5620_0_avalon_slave_write),
      .avalon_tlc5620_0_avalon_slave_writedata                           (avalon_tlc5620_0_avalon_slave_writedata),
      .clk                                                               (clk),
      .cpu_0_data_master_address_to_slave                                (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave           (cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave),
      .cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave (cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave),
      .cpu_0_data_master_read                                            (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_avalon_tlc5620_0_avalon_slave   (cpu_0_data_master_read_data_valid_avalon_tlc5620_0_avalon_slave),
      .cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave          (cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave),
      .cpu_0_data_master_waitrequest                                     (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                                           (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                                       (cpu_0_data_master_writedata),
      .d1_avalon_tlc5620_0_avalon_slave_end_xfer                         (d1_avalon_tlc5620_0_avalon_slave_end_xfer),
      .reset_n                                                           (clk_reset_n)
    );

  avalon_tlc5620_0 the_avalon_tlc5620_0
    (
      .address     (avalon_tlc5620_0_avalon_slave_address),
      .chip_select (avalon_tlc5620_0_avalon_slave_chipselect),
      .clock       (clk),
      .dac_clk     (dac_clk_from_the_avalon_tlc5620_0),
      .dac_data    (dac_data_from_the_avalon_tlc5620_0),
      .dac_ldac    (dac_ldac_from_the_avalon_tlc5620_0),
      .dac_load    (dac_load_from_the_avalon_tlc5620_0),
      .reset_n     (avalon_tlc5620_0_avalon_slave_reset_n),
      .write       (avalon_tlc5620_0_avalon_slave_write),
      .write_data  (avalon_tlc5620_0_avalon_slave_writedata)
    );

  cpu_0_jtag_debug_module_arbitrator the_cpu_0_jtag_debug_module
    (
      .clk                                                                (clk),
      .cpu_0_data_master_address_to_slave                                 (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_byteenable                                       (cpu_0_data_master_byteenable),
      .cpu_0_data_master_debugaccess                                      (cpu_0_data_master_debugaccess),
      .cpu_0_data_master_granted_cpu_0_jtag_debug_module                  (cpu_0_data_master_granted_cpu_0_jtag_debug_module),
      .cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module        (cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module),
      .cpu_0_data_master_read                                             (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module          (cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module),
      .cpu_0_data_master_requests_cpu_0_jtag_debug_module                 (cpu_0_data_master_requests_cpu_0_jtag_debug_module),
      .cpu_0_data_master_waitrequest                                      (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                                            (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                                        (cpu_0_data_master_writedata),
      .cpu_0_instruction_master_address_to_slave                          (cpu_0_instruction_master_address_to_slave),
      .cpu_0_instruction_master_granted_cpu_0_jtag_debug_module           (cpu_0_instruction_master_granted_cpu_0_jtag_debug_module),
      .cpu_0_instruction_master_latency_counter                           (cpu_0_instruction_master_latency_counter),
      .cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module (cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module),
      .cpu_0_instruction_master_read                                      (cpu_0_instruction_master_read),
      .cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module   (cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module),
      .cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register (cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register),
      .cpu_0_instruction_master_requests_cpu_0_jtag_debug_module          (cpu_0_instruction_master_requests_cpu_0_jtag_debug_module),
      .cpu_0_jtag_debug_module_address                                    (cpu_0_jtag_debug_module_address),
      .cpu_0_jtag_debug_module_begintransfer                              (cpu_0_jtag_debug_module_begintransfer),
      .cpu_0_jtag_debug_module_byteenable                                 (cpu_0_jtag_debug_module_byteenable),
      .cpu_0_jtag_debug_module_chipselect                                 (cpu_0_jtag_debug_module_chipselect),
      .cpu_0_jtag_debug_module_debugaccess                                (cpu_0_jtag_debug_module_debugaccess),
      .cpu_0_jtag_debug_module_readdata                                   (cpu_0_jtag_debug_module_readdata),
      .cpu_0_jtag_debug_module_readdata_from_sa                           (cpu_0_jtag_debug_module_readdata_from_sa),
      .cpu_0_jtag_debug_module_reset                                      (cpu_0_jtag_debug_module_reset),
      .cpu_0_jtag_debug_module_resetrequest                               (cpu_0_jtag_debug_module_resetrequest),
      .cpu_0_jtag_debug_module_resetrequest_from_sa                       (cpu_0_jtag_debug_module_resetrequest_from_sa),
      .cpu_0_jtag_debug_module_write                                      (cpu_0_jtag_debug_module_write),
      .cpu_0_jtag_debug_module_writedata                                  (cpu_0_jtag_debug_module_writedata),
      .d1_cpu_0_jtag_debug_module_end_xfer                                (d1_cpu_0_jtag_debug_module_end_xfer),
      .reset_n                                                            (clk_reset_n)
    );

  cpu_0_custom_instruction_master_arbitrator the_cpu_0_custom_instruction_master
    (
      .clk                                                   (clk),
      .cpu_0_custom_instruction_master_multi_done            (cpu_0_custom_instruction_master_multi_done),
      .cpu_0_custom_instruction_master_multi_result          (cpu_0_custom_instruction_master_multi_result),
      .cpu_0_custom_instruction_master_multi_start           (cpu_0_custom_instruction_master_multi_start),
      .cpu_0_custom_instruction_master_reset_n               (cpu_0_custom_instruction_master_reset_n),
      .cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1 (cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1),
      .cpu_0_fpoint_s1_done_from_sa                          (cpu_0_fpoint_s1_done_from_sa),
      .cpu_0_fpoint_s1_result_from_sa                        (cpu_0_fpoint_s1_result_from_sa),
      .cpu_0_fpoint_s1_select                                (cpu_0_fpoint_s1_select),
      .reset_n                                               (clk_reset_n)
    );

  cpu_0_data_master_arbitrator the_cpu_0_data_master
    (
      .adc_tlc549_0_avalon_slave_0_irq_from_sa                                              (adc_tlc549_0_avalon_slave_0_irq_from_sa),
      .adc_tlc549_0_avalon_slave_0_readdata_from_sa                                         (adc_tlc549_0_avalon_slave_0_readdata_from_sa),
      .clk                                                                                  (clk),
      .cpu_0_data_master_address                                                            (cpu_0_data_master_address),
      .cpu_0_data_master_address_to_slave                                                   (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_byteenable_flash_s1                                                (cpu_0_data_master_byteenable_flash_s1),
      .cpu_0_data_master_byteenable_sdram_0_s1                                              (cpu_0_data_master_byteenable_sdram_0_s1),
      .cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0                               (cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0),
      .cpu_0_data_master_dbs_address                                                        (cpu_0_data_master_dbs_address),
      .cpu_0_data_master_dbs_write_16                                                       (cpu_0_data_master_dbs_write_16),
      .cpu_0_data_master_dbs_write_8                                                        (cpu_0_data_master_dbs_write_8),
      .cpu_0_data_master_debugaccess                                                        (cpu_0_data_master_debugaccess),
      .cpu_0_data_master_granted_E_RST_s1                                                   (cpu_0_data_master_granted_E_RST_s1),
      .cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0                                (cpu_0_data_master_granted_adc_tlc549_0_avalon_slave_0),
      .cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave                              (cpu_0_data_master_granted_avalon_tlc5620_0_avalon_slave),
      .cpu_0_data_master_granted_cpu_0_jtag_debug_module                                    (cpu_0_data_master_granted_cpu_0_jtag_debug_module),
      .cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0                     (cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_data_master_granted_dma_control_port_slave                                     (cpu_0_data_master_granted_dma_control_port_slave),
      .cpu_0_data_master_granted_flash_s1                                                   (cpu_0_data_master_granted_flash_s1),
      .cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave                                (cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave),
      .cpu_0_data_master_granted_lcd12864_cs_s1                                             (cpu_0_data_master_granted_lcd12864_cs_s1),
      .cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0                    (cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0                     (cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave                               (cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave),
      .cpu_0_data_master_granted_onchip_mem_s1                                              (cpu_0_data_master_granted_onchip_mem_s1),
      .cpu_0_data_master_granted_performance_counter_control_slave                          (cpu_0_data_master_granted_performance_counter_control_slave),
      .cpu_0_data_master_granted_pio_beep_s1                                                (cpu_0_data_master_granted_pio_beep_s1),
      .cpu_0_data_master_granted_pio_key_s1                                                 (cpu_0_data_master_granted_pio_key_s1),
      .cpu_0_data_master_granted_pio_led_s1                                                 (cpu_0_data_master_granted_pio_led_s1),
      .cpu_0_data_master_granted_ps2_0_avalon_slave_0                                       (cpu_0_data_master_granted_ps2_0_avalon_slave_0),
      .cpu_0_data_master_granted_pwm_interface_0_control_slave                              (cpu_0_data_master_granted_pwm_interface_0_control_slave),
      .cpu_0_data_master_granted_sdram_0_s1                                                 (cpu_0_data_master_granted_sdram_0_s1),
      .cpu_0_data_master_granted_seg78led_0_avalon_slave_0                                  (cpu_0_data_master_granted_seg78led_0_avalon_slave_0),
      .cpu_0_data_master_granted_sysid_control_slave                                        (cpu_0_data_master_granted_sysid_control_slave),
      .cpu_0_data_master_granted_timer_0_s1                                                 (cpu_0_data_master_granted_timer_0_s1),
      .cpu_0_data_master_granted_uart_usb_s1                                                (cpu_0_data_master_granted_uart_usb_s1),
      .cpu_0_data_master_irq                                                                (cpu_0_data_master_irq),
      .cpu_0_data_master_no_byte_enables_and_last_term                                      (cpu_0_data_master_no_byte_enables_and_last_term),
      .cpu_0_data_master_qualified_request_E_RST_s1                                         (cpu_0_data_master_qualified_request_E_RST_s1),
      .cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0                      (cpu_0_data_master_qualified_request_adc_tlc549_0_avalon_slave_0),
      .cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave                    (cpu_0_data_master_qualified_request_avalon_tlc5620_0_avalon_slave),
      .cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module                          (cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module),
      .cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0           (cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_data_master_qualified_request_dma_control_port_slave                           (cpu_0_data_master_qualified_request_dma_control_port_slave),
      .cpu_0_data_master_qualified_request_flash_s1                                         (cpu_0_data_master_qualified_request_flash_s1),
      .cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave                      (cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave),
      .cpu_0_data_master_qualified_request_lcd12864_cs_s1                                   (cpu_0_data_master_qualified_request_lcd12864_cs_s1),
      .cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0          (cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0           (cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave                     (cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave),
      .cpu_0_data_master_qualified_request_onchip_mem_s1                                    (cpu_0_data_master_qualified_request_onchip_mem_s1),
      .cpu_0_data_master_qualified_request_performance_counter_control_slave                (cpu_0_data_master_qualified_request_performance_counter_control_slave),
      .cpu_0_data_master_qualified_request_pio_beep_s1                                      (cpu_0_data_master_qualified_request_pio_beep_s1),
      .cpu_0_data_master_qualified_request_pio_key_s1                                       (cpu_0_data_master_qualified_request_pio_key_s1),
      .cpu_0_data_master_qualified_request_pio_led_s1                                       (cpu_0_data_master_qualified_request_pio_led_s1),
      .cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0                             (cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0),
      .cpu_0_data_master_qualified_request_pwm_interface_0_control_slave                    (cpu_0_data_master_qualified_request_pwm_interface_0_control_slave),
      .cpu_0_data_master_qualified_request_sdram_0_s1                                       (cpu_0_data_master_qualified_request_sdram_0_s1),
      .cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0                        (cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0),
      .cpu_0_data_master_qualified_request_sysid_control_slave                              (cpu_0_data_master_qualified_request_sysid_control_slave),
      .cpu_0_data_master_qualified_request_timer_0_s1                                       (cpu_0_data_master_qualified_request_timer_0_s1),
      .cpu_0_data_master_qualified_request_uart_usb_s1                                      (cpu_0_data_master_qualified_request_uart_usb_s1),
      .cpu_0_data_master_read                                                               (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_E_RST_s1                                           (cpu_0_data_master_read_data_valid_E_RST_s1),
      .cpu_0_data_master_read_data_valid_adc_tlc549_0_avalon_slave_0                        (cpu_0_data_master_read_data_valid_adc_tlc549_0_avalon_slave_0),
      .cpu_0_data_master_read_data_valid_avalon_tlc5620_0_avalon_slave                      (cpu_0_data_master_read_data_valid_avalon_tlc5620_0_avalon_slave),
      .cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module                            (cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module),
      .cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0             (cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_data_master_read_data_valid_dma_control_port_slave                             (cpu_0_data_master_read_data_valid_dma_control_port_slave),
      .cpu_0_data_master_read_data_valid_flash_s1                                           (cpu_0_data_master_read_data_valid_flash_s1),
      .cpu_0_data_master_read_data_valid_jtag_uart_avalon_jtag_slave                        (cpu_0_data_master_read_data_valid_jtag_uart_avalon_jtag_slave),
      .cpu_0_data_master_read_data_valid_lcd12864_cs_s1                                     (cpu_0_data_master_read_data_valid_lcd12864_cs_s1),
      .cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0            (cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0             (cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_data_master_read_data_valid_oc_i2c_master_0_avalon_slave                       (cpu_0_data_master_read_data_valid_oc_i2c_master_0_avalon_slave),
      .cpu_0_data_master_read_data_valid_onchip_mem_s1                                      (cpu_0_data_master_read_data_valid_onchip_mem_s1),
      .cpu_0_data_master_read_data_valid_performance_counter_control_slave                  (cpu_0_data_master_read_data_valid_performance_counter_control_slave),
      .cpu_0_data_master_read_data_valid_pio_beep_s1                                        (cpu_0_data_master_read_data_valid_pio_beep_s1),
      .cpu_0_data_master_read_data_valid_pio_key_s1                                         (cpu_0_data_master_read_data_valid_pio_key_s1),
      .cpu_0_data_master_read_data_valid_pio_led_s1                                         (cpu_0_data_master_read_data_valid_pio_led_s1),
      .cpu_0_data_master_read_data_valid_ps2_0_avalon_slave_0                               (cpu_0_data_master_read_data_valid_ps2_0_avalon_slave_0),
      .cpu_0_data_master_read_data_valid_pwm_interface_0_control_slave                      (cpu_0_data_master_read_data_valid_pwm_interface_0_control_slave),
      .cpu_0_data_master_read_data_valid_sdram_0_s1                                         (cpu_0_data_master_read_data_valid_sdram_0_s1),
      .cpu_0_data_master_read_data_valid_sdram_0_s1_shift_register                          (cpu_0_data_master_read_data_valid_sdram_0_s1_shift_register),
      .cpu_0_data_master_read_data_valid_seg78led_0_avalon_slave_0                          (cpu_0_data_master_read_data_valid_seg78led_0_avalon_slave_0),
      .cpu_0_data_master_read_data_valid_sysid_control_slave                                (cpu_0_data_master_read_data_valid_sysid_control_slave),
      .cpu_0_data_master_read_data_valid_timer_0_s1                                         (cpu_0_data_master_read_data_valid_timer_0_s1),
      .cpu_0_data_master_read_data_valid_uart_usb_s1                                        (cpu_0_data_master_read_data_valid_uart_usb_s1),
      .cpu_0_data_master_readdata                                                           (cpu_0_data_master_readdata),
      .cpu_0_data_master_requests_E_RST_s1                                                  (cpu_0_data_master_requests_E_RST_s1),
      .cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0                               (cpu_0_data_master_requests_adc_tlc549_0_avalon_slave_0),
      .cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave                             (cpu_0_data_master_requests_avalon_tlc5620_0_avalon_slave),
      .cpu_0_data_master_requests_cpu_0_jtag_debug_module                                   (cpu_0_data_master_requests_cpu_0_jtag_debug_module),
      .cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0                    (cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_data_master_requests_dma_control_port_slave                                    (cpu_0_data_master_requests_dma_control_port_slave),
      .cpu_0_data_master_requests_flash_s1                                                  (cpu_0_data_master_requests_flash_s1),
      .cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave                               (cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave),
      .cpu_0_data_master_requests_lcd12864_cs_s1                                            (cpu_0_data_master_requests_lcd12864_cs_s1),
      .cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0                   (cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0                    (cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave                              (cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave),
      .cpu_0_data_master_requests_onchip_mem_s1                                             (cpu_0_data_master_requests_onchip_mem_s1),
      .cpu_0_data_master_requests_performance_counter_control_slave                         (cpu_0_data_master_requests_performance_counter_control_slave),
      .cpu_0_data_master_requests_pio_beep_s1                                               (cpu_0_data_master_requests_pio_beep_s1),
      .cpu_0_data_master_requests_pio_key_s1                                                (cpu_0_data_master_requests_pio_key_s1),
      .cpu_0_data_master_requests_pio_led_s1                                                (cpu_0_data_master_requests_pio_led_s1),
      .cpu_0_data_master_requests_ps2_0_avalon_slave_0                                      (cpu_0_data_master_requests_ps2_0_avalon_slave_0),
      .cpu_0_data_master_requests_pwm_interface_0_control_slave                             (cpu_0_data_master_requests_pwm_interface_0_control_slave),
      .cpu_0_data_master_requests_sdram_0_s1                                                (cpu_0_data_master_requests_sdram_0_s1),
      .cpu_0_data_master_requests_seg78led_0_avalon_slave_0                                 (cpu_0_data_master_requests_seg78led_0_avalon_slave_0),
      .cpu_0_data_master_requests_sysid_control_slave                                       (cpu_0_data_master_requests_sysid_control_slave),
      .cpu_0_data_master_requests_timer_0_s1                                                (cpu_0_data_master_requests_timer_0_s1),
      .cpu_0_data_master_requests_uart_usb_s1                                               (cpu_0_data_master_requests_uart_usb_s1),
      .cpu_0_data_master_waitrequest                                                        (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                                                              (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                                                          (cpu_0_data_master_writedata),
      .cpu_0_jtag_debug_module_readdata_from_sa                                             (cpu_0_jtag_debug_module_readdata_from_sa),
      .ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0                             (ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0),
      .ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1                             (ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1),
      .d1_E_RST_s1_end_xfer                                                                 (d1_E_RST_s1_end_xfer),
      .d1_adc_tlc549_0_avalon_slave_0_end_xfer                                              (d1_adc_tlc549_0_avalon_slave_0_end_xfer),
      .d1_avalon_tlc5620_0_avalon_slave_end_xfer                                            (d1_avalon_tlc5620_0_avalon_slave_end_xfer),
      .d1_cpu_0_jtag_debug_module_end_xfer                                                  (d1_cpu_0_jtag_debug_module_end_xfer),
      .d1_dma_control_port_slave_end_xfer                                                   (d1_dma_control_port_slave_end_xfer),
      .d1_irq_from_the_ctrl_rtl8019_0                                                       (d1_irq_from_the_ctrl_rtl8019_0),
      .d1_jtag_uart_avalon_jtag_slave_end_xfer                                              (d1_jtag_uart_avalon_jtag_slave_end_xfer),
      .d1_lcd12864_cs_s1_end_xfer                                                           (d1_lcd12864_cs_s1_end_xfer),
      .d1_oc_i2c_master_0_avalon_slave_end_xfer                                             (d1_oc_i2c_master_0_avalon_slave_end_xfer),
      .d1_onchip_mem_s1_end_xfer                                                            (d1_onchip_mem_s1_end_xfer),
      .d1_performance_counter_control_slave_end_xfer                                        (d1_performance_counter_control_slave_end_xfer),
      .d1_pio_beep_s1_end_xfer                                                              (d1_pio_beep_s1_end_xfer),
      .d1_pio_key_s1_end_xfer                                                               (d1_pio_key_s1_end_xfer),
      .d1_pio_led_s1_end_xfer                                                               (d1_pio_led_s1_end_xfer),
      .d1_ps2_0_avalon_slave_0_end_xfer                                                     (d1_ps2_0_avalon_slave_0_end_xfer),
      .d1_pwm_interface_0_control_slave_end_xfer                                            (d1_pwm_interface_0_control_slave_end_xfer),
      .d1_sdram_0_s1_end_xfer                                                               (d1_sdram_0_s1_end_xfer),
      .d1_seg78led_0_avalon_slave_0_end_xfer                                                (d1_seg78led_0_avalon_slave_0_end_xfer),
      .d1_sysid_control_slave_end_xfer                                                      (d1_sysid_control_slave_end_xfer),
      .d1_timer_0_s1_end_xfer                                                               (d1_timer_0_s1_end_xfer),
      .d1_tri_state_bridge_0_avalon_slave_end_xfer                                          (d1_tri_state_bridge_0_avalon_slave_end_xfer),
      .d1_uart_usb_s1_end_xfer                                                              (d1_uart_usb_s1_end_xfer),
      .dma_control_port_slave_irq_from_sa                                                   (dma_control_port_slave_irq_from_sa),
      .dma_control_port_slave_readdata_from_sa                                              (dma_control_port_slave_readdata_from_sa),
      .flash_s1_wait_counter_eq_0                                                           (flash_s1_wait_counter_eq_0),
      .flash_s1_wait_counter_eq_1                                                           (flash_s1_wait_counter_eq_1),
      .incoming_tri_state_bridge_0_data                                                     (incoming_tri_state_bridge_0_data),
      .incoming_tri_state_bridge_0_data_with_Xs_converted_to_0                              (incoming_tri_state_bridge_0_data_with_Xs_converted_to_0),
      .jtag_uart_avalon_jtag_slave_irq_from_sa                                              (jtag_uart_avalon_jtag_slave_irq_from_sa),
      .jtag_uart_avalon_jtag_slave_readdata_from_sa                                         (jtag_uart_avalon_jtag_slave_readdata_from_sa),
      .jtag_uart_avalon_jtag_slave_waitrequest_from_sa                                      (jtag_uart_avalon_jtag_slave_waitrequest_from_sa),
      .lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0                            (lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0),
      .lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1                            (lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1),
      .lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0                             (lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0),
      .lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1                             (lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1),
      .oc_i2c_master_0_avalon_slave_irq_from_sa                                             (oc_i2c_master_0_avalon_slave_irq_from_sa),
      .oc_i2c_master_0_avalon_slave_readdata_from_sa                                        (oc_i2c_master_0_avalon_slave_readdata_from_sa),
      .oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa                                   (oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa),
      .onchip_mem_s1_readdata_from_sa                                                       (onchip_mem_s1_readdata_from_sa),
      .performance_counter_control_slave_readdata_from_sa                                   (performance_counter_control_slave_readdata_from_sa),
      .pio_key_s1_irq_from_sa                                                               (pio_key_s1_irq_from_sa),
      .pio_key_s1_readdata_from_sa                                                          (pio_key_s1_readdata_from_sa),
      .ps2_0_avalon_slave_0_irq_from_sa                                                     (ps2_0_avalon_slave_0_irq_from_sa),
      .ps2_0_avalon_slave_0_readdata_from_sa                                                (ps2_0_avalon_slave_0_readdata_from_sa),
      .pwm_interface_0_control_slave_readdata_from_sa                                       (pwm_interface_0_control_slave_readdata_from_sa),
      .registered_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0  (registered_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .registered_cpu_0_data_master_read_data_valid_flash_s1                                (registered_cpu_0_data_master_read_data_valid_flash_s1),
      .registered_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0 (registered_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0),
      .registered_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0  (registered_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0),
      .registered_cpu_0_data_master_read_data_valid_onchip_mem_s1                           (registered_cpu_0_data_master_read_data_valid_onchip_mem_s1),
      .registered_cpu_0_data_master_read_data_valid_performance_counter_control_slave       (registered_cpu_0_data_master_read_data_valid_performance_counter_control_slave),
      .reset_n                                                                              (clk_reset_n),
      .sdram_0_s1_readdata_from_sa                                                          (sdram_0_s1_readdata_from_sa),
      .sdram_0_s1_waitrequest_from_sa                                                       (sdram_0_s1_waitrequest_from_sa),
      .seg78led_0_avalon_slave_0_readdata_from_sa                                           (seg78led_0_avalon_slave_0_readdata_from_sa),
      .seg78led_0_avalon_slave_0_wait_counter_eq_0                                          (seg78led_0_avalon_slave_0_wait_counter_eq_0),
      .seg78led_0_avalon_slave_0_wait_counter_eq_1                                          (seg78led_0_avalon_slave_0_wait_counter_eq_1),
      .sysid_control_slave_readdata_from_sa                                                 (sysid_control_slave_readdata_from_sa),
      .timer_0_s1_irq_from_sa                                                               (timer_0_s1_irq_from_sa),
      .timer_0_s1_readdata_from_sa                                                          (timer_0_s1_readdata_from_sa),
      .uart_usb_s1_irq_from_sa                                                              (uart_usb_s1_irq_from_sa),
      .uart_usb_s1_readdata_from_sa                                                         (uart_usb_s1_readdata_from_sa)
    );

  cpu_0_instruction_master_arbitrator the_cpu_0_instruction_master
    (
      .clk                                                                                (clk),
      .cpu_0_instruction_master_address                                                   (cpu_0_instruction_master_address),
      .cpu_0_instruction_master_address_to_slave                                          (cpu_0_instruction_master_address_to_slave),
      .cpu_0_instruction_master_dbs_address                                               (cpu_0_instruction_master_dbs_address),
      .cpu_0_instruction_master_granted_cpu_0_jtag_debug_module                           (cpu_0_instruction_master_granted_cpu_0_jtag_debug_module),
      .cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0            (cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_granted_flash_s1                                          (cpu_0_instruction_master_granted_flash_s1),
      .cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0           (cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0            (cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_granted_onchip_mem_s1                                     (cpu_0_instruction_master_granted_onchip_mem_s1),
      .cpu_0_instruction_master_granted_sdram_0_s1                                        (cpu_0_instruction_master_granted_sdram_0_s1),
      .cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0                         (cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0),
      .cpu_0_instruction_master_latency_counter                                           (cpu_0_instruction_master_latency_counter),
      .cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module                 (cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module),
      .cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0  (cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_qualified_request_flash_s1                                (cpu_0_instruction_master_qualified_request_flash_s1),
      .cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0 (cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0  (cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_qualified_request_onchip_mem_s1                           (cpu_0_instruction_master_qualified_request_onchip_mem_s1),
      .cpu_0_instruction_master_qualified_request_sdram_0_s1                              (cpu_0_instruction_master_qualified_request_sdram_0_s1),
      .cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0               (cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0),
      .cpu_0_instruction_master_read                                                      (cpu_0_instruction_master_read),
      .cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module                   (cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module),
      .cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0    (cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_read_data_valid_flash_s1                                  (cpu_0_instruction_master_read_data_valid_flash_s1),
      .cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0   (cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0    (cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_read_data_valid_onchip_mem_s1                             (cpu_0_instruction_master_read_data_valid_onchip_mem_s1),
      .cpu_0_instruction_master_read_data_valid_sdram_0_s1                                (cpu_0_instruction_master_read_data_valid_sdram_0_s1),
      .cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register                 (cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register),
      .cpu_0_instruction_master_read_data_valid_seg78led_0_avalon_slave_0                 (cpu_0_instruction_master_read_data_valid_seg78led_0_avalon_slave_0),
      .cpu_0_instruction_master_readdata                                                  (cpu_0_instruction_master_readdata),
      .cpu_0_instruction_master_readdatavalid                                             (cpu_0_instruction_master_readdatavalid),
      .cpu_0_instruction_master_requests_cpu_0_jtag_debug_module                          (cpu_0_instruction_master_requests_cpu_0_jtag_debug_module),
      .cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0           (cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_requests_flash_s1                                         (cpu_0_instruction_master_requests_flash_s1),
      .cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0          (cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0           (cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_requests_onchip_mem_s1                                    (cpu_0_instruction_master_requests_onchip_mem_s1),
      .cpu_0_instruction_master_requests_sdram_0_s1                                       (cpu_0_instruction_master_requests_sdram_0_s1),
      .cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0                        (cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0),
      .cpu_0_instruction_master_waitrequest                                               (cpu_0_instruction_master_waitrequest),
      .cpu_0_jtag_debug_module_readdata_from_sa                                           (cpu_0_jtag_debug_module_readdata_from_sa),
      .ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0                           (ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0),
      .ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1                           (ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1),
      .d1_cpu_0_jtag_debug_module_end_xfer                                                (d1_cpu_0_jtag_debug_module_end_xfer),
      .d1_onchip_mem_s1_end_xfer                                                          (d1_onchip_mem_s1_end_xfer),
      .d1_sdram_0_s1_end_xfer                                                             (d1_sdram_0_s1_end_xfer),
      .d1_seg78led_0_avalon_slave_0_end_xfer                                              (d1_seg78led_0_avalon_slave_0_end_xfer),
      .d1_tri_state_bridge_0_avalon_slave_end_xfer                                        (d1_tri_state_bridge_0_avalon_slave_end_xfer),
      .flash_s1_wait_counter_eq_0                                                         (flash_s1_wait_counter_eq_0),
      .flash_s1_wait_counter_eq_1                                                         (flash_s1_wait_counter_eq_1),
      .incoming_tri_state_bridge_0_data                                                   (incoming_tri_state_bridge_0_data),
      .lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0                          (lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0),
      .lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1                          (lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1),
      .lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0                           (lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0),
      .lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1                           (lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1),
      .onchip_mem_s1_readdata_from_sa                                                     (onchip_mem_s1_readdata_from_sa),
      .reset_n                                                                            (clk_reset_n),
      .sdram_0_s1_readdata_from_sa                                                        (sdram_0_s1_readdata_from_sa),
      .sdram_0_s1_waitrequest_from_sa                                                     (sdram_0_s1_waitrequest_from_sa),
      .seg78led_0_avalon_slave_0_readdata_from_sa                                         (seg78led_0_avalon_slave_0_readdata_from_sa),
      .seg78led_0_avalon_slave_0_wait_counter_eq_0                                        (seg78led_0_avalon_slave_0_wait_counter_eq_0),
      .seg78led_0_avalon_slave_0_wait_counter_eq_1                                        (seg78led_0_avalon_slave_0_wait_counter_eq_1)
    );

  cpu_0 the_cpu_0
    (
      .A_ci_multi_a                          (cpu_0_custom_instruction_master_multi_a),
      .A_ci_multi_b                          (cpu_0_custom_instruction_master_multi_b),
      .A_ci_multi_c                          (cpu_0_custom_instruction_master_multi_c),
      .A_ci_multi_clk_en                     (cpu_0_custom_instruction_master_multi_clk_en),
      .A_ci_multi_dataa                      (cpu_0_custom_instruction_master_multi_dataa),
      .A_ci_multi_datab                      (cpu_0_custom_instruction_master_multi_datab),
      .A_ci_multi_done                       (cpu_0_custom_instruction_master_multi_done),
      .A_ci_multi_estatus                    (cpu_0_custom_instruction_master_multi_estatus),
      .A_ci_multi_ipending                   (cpu_0_custom_instruction_master_multi_ipending),
      .A_ci_multi_n                          (cpu_0_custom_instruction_master_multi_n),
      .A_ci_multi_readra                     (cpu_0_custom_instruction_master_multi_readra),
      .A_ci_multi_readrb                     (cpu_0_custom_instruction_master_multi_readrb),
      .A_ci_multi_result                     (cpu_0_custom_instruction_master_multi_result),
      .A_ci_multi_start                      (cpu_0_custom_instruction_master_multi_start),
      .A_ci_multi_status                     (cpu_0_custom_instruction_master_multi_status),
      .A_ci_multi_writerc                    (cpu_0_custom_instruction_master_multi_writerc),
      .clk                                   (clk),
      .d_address                             (cpu_0_data_master_address),
      .d_byteenable                          (cpu_0_data_master_byteenable),
      .d_irq                                 (cpu_0_data_master_irq),
      .d_read                                (cpu_0_data_master_read),
      .d_readdata                            (cpu_0_data_master_readdata),
      .d_waitrequest                         (cpu_0_data_master_waitrequest),
      .d_write                               (cpu_0_data_master_write),
      .d_writedata                           (cpu_0_data_master_writedata),
      .i_address                             (cpu_0_instruction_master_address),
      .i_read                                (cpu_0_instruction_master_read),
      .i_readdata                            (cpu_0_instruction_master_readdata),
      .i_readdatavalid                       (cpu_0_instruction_master_readdatavalid),
      .i_waitrequest                         (cpu_0_instruction_master_waitrequest),
      .jtag_debug_module_address             (cpu_0_jtag_debug_module_address),
      .jtag_debug_module_begintransfer       (cpu_0_jtag_debug_module_begintransfer),
      .jtag_debug_module_byteenable          (cpu_0_jtag_debug_module_byteenable),
      .jtag_debug_module_clk                 (clk),
      .jtag_debug_module_debugaccess         (cpu_0_jtag_debug_module_debugaccess),
      .jtag_debug_module_debugaccess_to_roms (cpu_0_data_master_debugaccess),
      .jtag_debug_module_readdata            (cpu_0_jtag_debug_module_readdata),
      .jtag_debug_module_reset               (cpu_0_jtag_debug_module_reset),
      .jtag_debug_module_resetrequest        (cpu_0_jtag_debug_module_resetrequest),
      .jtag_debug_module_select              (cpu_0_jtag_debug_module_chipselect),
      .jtag_debug_module_write               (cpu_0_jtag_debug_module_write),
      .jtag_debug_module_writedata           (cpu_0_jtag_debug_module_writedata),
      .reset_n                               (cpu_0_custom_instruction_master_reset_n)
    );

  cpu_0_fpoint_s1_arbitrator the_cpu_0_fpoint_s1
    (
      .clk                                                   (clk),
      .cpu_0_custom_instruction_master_multi_clk_en          (cpu_0_custom_instruction_master_multi_clk_en),
      .cpu_0_custom_instruction_master_multi_dataa           (cpu_0_custom_instruction_master_multi_dataa),
      .cpu_0_custom_instruction_master_multi_datab           (cpu_0_custom_instruction_master_multi_datab),
      .cpu_0_custom_instruction_master_multi_n               (cpu_0_custom_instruction_master_multi_n),
      .cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1 (cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1),
      .cpu_0_fpoint_s1_clk_en                                (cpu_0_fpoint_s1_clk_en),
      .cpu_0_fpoint_s1_dataa                                 (cpu_0_fpoint_s1_dataa),
      .cpu_0_fpoint_s1_datab                                 (cpu_0_fpoint_s1_datab),
      .cpu_0_fpoint_s1_done                                  (cpu_0_fpoint_s1_done),
      .cpu_0_fpoint_s1_done_from_sa                          (cpu_0_fpoint_s1_done_from_sa),
      .cpu_0_fpoint_s1_n                                     (cpu_0_fpoint_s1_n),
      .cpu_0_fpoint_s1_reset                                 (cpu_0_fpoint_s1_reset),
      .cpu_0_fpoint_s1_result                                (cpu_0_fpoint_s1_result),
      .cpu_0_fpoint_s1_result_from_sa                        (cpu_0_fpoint_s1_result_from_sa),
      .cpu_0_fpoint_s1_select                                (cpu_0_fpoint_s1_select),
      .cpu_0_fpoint_s1_start                                 (cpu_0_fpoint_s1_start),
      .reset_n                                               (clk_reset_n)
    );

  cpu_0_fpoint the_cpu_0_fpoint
    (
      .clk    (clk),
      .clk_en (cpu_0_fpoint_s1_clk_en),
      .dataa  (cpu_0_fpoint_s1_dataa),
      .datab  (cpu_0_fpoint_s1_datab),
      .done   (cpu_0_fpoint_s1_done),
      .n      (cpu_0_fpoint_s1_n),
      .reset  (cpu_0_fpoint_s1_reset),
      .result (cpu_0_fpoint_s1_result),
      .start  (cpu_0_fpoint_s1_start)
    );

  dma_control_port_slave_arbitrator the_dma_control_port_slave
    (
      .clk                                                        (clk),
      .cpu_0_data_master_address_to_slave                         (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_dma_control_port_slave           (cpu_0_data_master_granted_dma_control_port_slave),
      .cpu_0_data_master_qualified_request_dma_control_port_slave (cpu_0_data_master_qualified_request_dma_control_port_slave),
      .cpu_0_data_master_read                                     (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_dma_control_port_slave   (cpu_0_data_master_read_data_valid_dma_control_port_slave),
      .cpu_0_data_master_requests_dma_control_port_slave          (cpu_0_data_master_requests_dma_control_port_slave),
      .cpu_0_data_master_write                                    (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                                (cpu_0_data_master_writedata),
      .d1_dma_control_port_slave_end_xfer                         (d1_dma_control_port_slave_end_xfer),
      .dma_control_port_slave_address                             (dma_control_port_slave_address),
      .dma_control_port_slave_chipselect                          (dma_control_port_slave_chipselect),
      .dma_control_port_slave_irq                                 (dma_control_port_slave_irq),
      .dma_control_port_slave_irq_from_sa                         (dma_control_port_slave_irq_from_sa),
      .dma_control_port_slave_readdata                            (dma_control_port_slave_readdata),
      .dma_control_port_slave_readdata_from_sa                    (dma_control_port_slave_readdata_from_sa),
      .dma_control_port_slave_readyfordata                        (dma_control_port_slave_readyfordata),
      .dma_control_port_slave_readyfordata_from_sa                (dma_control_port_slave_readyfordata_from_sa),
      .dma_control_port_slave_reset_n                             (dma_control_port_slave_reset_n),
      .dma_control_port_slave_write_n                             (dma_control_port_slave_write_n),
      .dma_control_port_slave_writedata                           (dma_control_port_slave_writedata),
      .reset_n                                                    (clk_reset_n)
    );

  dma_read_master_arbitrator the_dma_read_master
    (
      .clk                                                       (clk),
      .d1_onchip_mem_s1_end_xfer                                 (d1_onchip_mem_s1_end_xfer),
      .d1_sdram_0_s1_end_xfer                                    (d1_sdram_0_s1_end_xfer),
      .dma_read_master_address                                   (dma_read_master_address),
      .dma_read_master_address_to_slave                          (dma_read_master_address_to_slave),
      .dma_read_master_chipselect                                (dma_read_master_chipselect),
      .dma_read_master_dbs_address                               (dma_read_master_dbs_address),
      .dma_read_master_flush                                     (dma_read_master_flush),
      .dma_read_master_flush_qualified_exported                  (dma_read_master_flush_qualified_exported),
      .dma_read_master_granted_onchip_mem_s1                     (dma_read_master_granted_onchip_mem_s1),
      .dma_read_master_granted_sdram_0_s1                        (dma_read_master_granted_sdram_0_s1),
      .dma_read_master_latency_counter                           (dma_read_master_latency_counter),
      .dma_read_master_qualified_request_onchip_mem_s1           (dma_read_master_qualified_request_onchip_mem_s1),
      .dma_read_master_qualified_request_sdram_0_s1              (dma_read_master_qualified_request_sdram_0_s1),
      .dma_read_master_read_data_valid_onchip_mem_s1             (dma_read_master_read_data_valid_onchip_mem_s1),
      .dma_read_master_read_data_valid_sdram_0_s1                (dma_read_master_read_data_valid_sdram_0_s1),
      .dma_read_master_read_data_valid_sdram_0_s1_shift_register (dma_read_master_read_data_valid_sdram_0_s1_shift_register),
      .dma_read_master_read_n                                    (dma_read_master_read_n),
      .dma_read_master_readdata                                  (dma_read_master_readdata),
      .dma_read_master_readdatavalid                             (dma_read_master_readdatavalid),
      .dma_read_master_requests_onchip_mem_s1                    (dma_read_master_requests_onchip_mem_s1),
      .dma_read_master_requests_sdram_0_s1                       (dma_read_master_requests_sdram_0_s1),
      .dma_read_master_waitrequest                               (dma_read_master_waitrequest),
      .onchip_mem_s1_readdata_from_sa                            (onchip_mem_s1_readdata_from_sa),
      .reset_n                                                   (clk_reset_n),
      .sdram_0_s1_readdata_from_sa                               (sdram_0_s1_readdata_from_sa),
      .sdram_0_s1_waitrequest_from_sa                            (sdram_0_s1_waitrequest_from_sa)
    );

  dma_write_master_arbitrator the_dma_write_master
    (
      .clk                                              (clk),
      .d1_onchip_mem_s1_end_xfer                        (d1_onchip_mem_s1_end_xfer),
      .d1_sdram_0_s1_end_xfer                           (d1_sdram_0_s1_end_xfer),
      .dma_write_master_address                         (dma_write_master_address),
      .dma_write_master_address_to_slave                (dma_write_master_address_to_slave),
      .dma_write_master_byteenable_sdram_0_s1           (dma_write_master_byteenable_sdram_0_s1),
      .dma_write_master_chipselect                      (dma_write_master_chipselect),
      .dma_write_master_dbs_address                     (dma_write_master_dbs_address),
      .dma_write_master_dbs_write_16                    (dma_write_master_dbs_write_16),
      .dma_write_master_granted_onchip_mem_s1           (dma_write_master_granted_onchip_mem_s1),
      .dma_write_master_granted_sdram_0_s1              (dma_write_master_granted_sdram_0_s1),
      .dma_write_master_qualified_request_onchip_mem_s1 (dma_write_master_qualified_request_onchip_mem_s1),
      .dma_write_master_qualified_request_sdram_0_s1    (dma_write_master_qualified_request_sdram_0_s1),
      .dma_write_master_requests_onchip_mem_s1          (dma_write_master_requests_onchip_mem_s1),
      .dma_write_master_requests_sdram_0_s1             (dma_write_master_requests_sdram_0_s1),
      .dma_write_master_waitrequest                     (dma_write_master_waitrequest),
      .dma_write_master_write_n                         (dma_write_master_write_n),
      .dma_write_master_writedata                       (dma_write_master_writedata),
      .reset_n                                          (clk_reset_n),
      .sdram_0_s1_waitrequest_from_sa                   (sdram_0_s1_waitrequest_from_sa)
    );

  dma the_dma
    (
      .clk                  (clk),
      .dma_ctl_address      (dma_control_port_slave_address),
      .dma_ctl_chipselect   (dma_control_port_slave_chipselect),
      .dma_ctl_irq          (dma_control_port_slave_irq),
      .dma_ctl_readdata     (dma_control_port_slave_readdata),
      .dma_ctl_readyfordata (dma_control_port_slave_readyfordata),
      .dma_ctl_write_n      (dma_control_port_slave_write_n),
      .dma_ctl_writedata    (dma_control_port_slave_writedata),
      .read_address         (dma_read_master_address),
      .read_chipselect      (dma_read_master_chipselect),
      .read_endofpacket     (dma_read_master_endofpacket),
      .read_flush           (dma_read_master_flush),
      .read_read_n          (dma_read_master_read_n),
      .read_readdata        (dma_read_master_readdata),
      .read_readdatavalid   (dma_read_master_readdatavalid),
      .read_waitrequest     (dma_read_master_waitrequest),
      .system_reset_n       (dma_control_port_slave_reset_n),
      .write_address        (dma_write_master_address),
      .write_byteenable     (dma_write_master_byteenable),
      .write_chipselect     (dma_write_master_chipselect),
      .write_endofpacket    (dma_write_master_endofpacket),
      .write_waitrequest    (dma_write_master_waitrequest),
      .write_write_n        (dma_write_master_write_n),
      .write_writedata      (dma_write_master_writedata)
    );

  jtag_uart_avalon_jtag_slave_arbitrator the_jtag_uart_avalon_jtag_slave
    (
      .clk                                                             (clk),
      .cpu_0_data_master_address_to_slave                              (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave           (cpu_0_data_master_granted_jtag_uart_avalon_jtag_slave),
      .cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave (cpu_0_data_master_qualified_request_jtag_uart_avalon_jtag_slave),
      .cpu_0_data_master_read                                          (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_jtag_uart_avalon_jtag_slave   (cpu_0_data_master_read_data_valid_jtag_uart_avalon_jtag_slave),
      .cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave          (cpu_0_data_master_requests_jtag_uart_avalon_jtag_slave),
      .cpu_0_data_master_waitrequest                                   (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                                         (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                                     (cpu_0_data_master_writedata),
      .d1_jtag_uart_avalon_jtag_slave_end_xfer                         (d1_jtag_uart_avalon_jtag_slave_end_xfer),
      .jtag_uart_avalon_jtag_slave_address                             (jtag_uart_avalon_jtag_slave_address),
      .jtag_uart_avalon_jtag_slave_chipselect                          (jtag_uart_avalon_jtag_slave_chipselect),
      .jtag_uart_avalon_jtag_slave_dataavailable                       (jtag_uart_avalon_jtag_slave_dataavailable),
      .jtag_uart_avalon_jtag_slave_dataavailable_from_sa               (jtag_uart_avalon_jtag_slave_dataavailable_from_sa),
      .jtag_uart_avalon_jtag_slave_irq                                 (jtag_uart_avalon_jtag_slave_irq),
      .jtag_uart_avalon_jtag_slave_irq_from_sa                         (jtag_uart_avalon_jtag_slave_irq_from_sa),
      .jtag_uart_avalon_jtag_slave_read_n                              (jtag_uart_avalon_jtag_slave_read_n),
      .jtag_uart_avalon_jtag_slave_readdata                            (jtag_uart_avalon_jtag_slave_readdata),
      .jtag_uart_avalon_jtag_slave_readdata_from_sa                    (jtag_uart_avalon_jtag_slave_readdata_from_sa),
      .jtag_uart_avalon_jtag_slave_readyfordata                        (jtag_uart_avalon_jtag_slave_readyfordata),
      .jtag_uart_avalon_jtag_slave_readyfordata_from_sa                (jtag_uart_avalon_jtag_slave_readyfordata_from_sa),
      .jtag_uart_avalon_jtag_slave_reset_n                             (jtag_uart_avalon_jtag_slave_reset_n),
      .jtag_uart_avalon_jtag_slave_waitrequest                         (jtag_uart_avalon_jtag_slave_waitrequest),
      .jtag_uart_avalon_jtag_slave_waitrequest_from_sa                 (jtag_uart_avalon_jtag_slave_waitrequest_from_sa),
      .jtag_uart_avalon_jtag_slave_write_n                             (jtag_uart_avalon_jtag_slave_write_n),
      .jtag_uart_avalon_jtag_slave_writedata                           (jtag_uart_avalon_jtag_slave_writedata),
      .reset_n                                                         (clk_reset_n)
    );

  jtag_uart the_jtag_uart
    (
      .av_address     (jtag_uart_avalon_jtag_slave_address),
      .av_chipselect  (jtag_uart_avalon_jtag_slave_chipselect),
      .av_irq         (jtag_uart_avalon_jtag_slave_irq),
      .av_read_n      (jtag_uart_avalon_jtag_slave_read_n),
      .av_readdata    (jtag_uart_avalon_jtag_slave_readdata),
      .av_waitrequest (jtag_uart_avalon_jtag_slave_waitrequest),
      .av_write_n     (jtag_uart_avalon_jtag_slave_write_n),
      .av_writedata   (jtag_uart_avalon_jtag_slave_writedata),
      .clk            (clk),
      .dataavailable  (jtag_uart_avalon_jtag_slave_dataavailable),
      .readyfordata   (jtag_uart_avalon_jtag_slave_readyfordata),
      .rst_n          (jtag_uart_avalon_jtag_slave_reset_n)
    );

  lcd12864_cs_s1_arbitrator the_lcd12864_cs_s1
    (
      .clk                                                (clk),
      .cpu_0_data_master_address_to_slave                 (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_lcd12864_cs_s1           (cpu_0_data_master_granted_lcd12864_cs_s1),
      .cpu_0_data_master_qualified_request_lcd12864_cs_s1 (cpu_0_data_master_qualified_request_lcd12864_cs_s1),
      .cpu_0_data_master_read                             (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_lcd12864_cs_s1   (cpu_0_data_master_read_data_valid_lcd12864_cs_s1),
      .cpu_0_data_master_requests_lcd12864_cs_s1          (cpu_0_data_master_requests_lcd12864_cs_s1),
      .cpu_0_data_master_waitrequest                      (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                            (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                        (cpu_0_data_master_writedata),
      .d1_lcd12864_cs_s1_end_xfer                         (d1_lcd12864_cs_s1_end_xfer),
      .lcd12864_cs_s1_address                             (lcd12864_cs_s1_address),
      .lcd12864_cs_s1_chipselect                          (lcd12864_cs_s1_chipselect),
      .lcd12864_cs_s1_reset_n                             (lcd12864_cs_s1_reset_n),
      .lcd12864_cs_s1_write_n                             (lcd12864_cs_s1_write_n),
      .lcd12864_cs_s1_writedata                           (lcd12864_cs_s1_writedata),
      .reset_n                                            (clk_reset_n)
    );

  lcd12864_cs the_lcd12864_cs
    (
      .address    (lcd12864_cs_s1_address),
      .chipselect (lcd12864_cs_s1_chipselect),
      .clk        (clk),
      .out_port   (out_port_from_the_lcd12864_cs),
      .reset_n    (lcd12864_cs_s1_reset_n),
      .write_n    (lcd12864_cs_s1_write_n),
      .writedata  (lcd12864_cs_s1_writedata)
    );

  oc_i2c_master_0_avalon_slave_arbitrator the_oc_i2c_master_0_avalon_slave
    (
      .clk                                                              (clk),
      .cpu_0_data_master_address_to_slave                               (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave           (cpu_0_data_master_granted_oc_i2c_master_0_avalon_slave),
      .cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave (cpu_0_data_master_qualified_request_oc_i2c_master_0_avalon_slave),
      .cpu_0_data_master_read                                           (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_oc_i2c_master_0_avalon_slave   (cpu_0_data_master_read_data_valid_oc_i2c_master_0_avalon_slave),
      .cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave          (cpu_0_data_master_requests_oc_i2c_master_0_avalon_slave),
      .cpu_0_data_master_waitrequest                                    (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                                          (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                                      (cpu_0_data_master_writedata),
      .d1_oc_i2c_master_0_avalon_slave_end_xfer                         (d1_oc_i2c_master_0_avalon_slave_end_xfer),
      .oc_i2c_master_0_avalon_slave_address                             (oc_i2c_master_0_avalon_slave_address),
      .oc_i2c_master_0_avalon_slave_chipselect                          (oc_i2c_master_0_avalon_slave_chipselect),
      .oc_i2c_master_0_avalon_slave_irq                                 (oc_i2c_master_0_avalon_slave_irq),
      .oc_i2c_master_0_avalon_slave_irq_from_sa                         (oc_i2c_master_0_avalon_slave_irq_from_sa),
      .oc_i2c_master_0_avalon_slave_readdata                            (oc_i2c_master_0_avalon_slave_readdata),
      .oc_i2c_master_0_avalon_slave_readdata_from_sa                    (oc_i2c_master_0_avalon_slave_readdata_from_sa),
      .oc_i2c_master_0_avalon_slave_reset                               (oc_i2c_master_0_avalon_slave_reset),
      .oc_i2c_master_0_avalon_slave_waitrequest_n                       (oc_i2c_master_0_avalon_slave_waitrequest_n),
      .oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa               (oc_i2c_master_0_avalon_slave_waitrequest_n_from_sa),
      .oc_i2c_master_0_avalon_slave_wishbone_err                        (oc_i2c_master_0_avalon_slave_wishbone_err),
      .oc_i2c_master_0_avalon_slave_wishbone_err_from_sa                (oc_i2c_master_0_avalon_slave_wishbone_err_from_sa),
      .oc_i2c_master_0_avalon_slave_write                               (oc_i2c_master_0_avalon_slave_write),
      .oc_i2c_master_0_avalon_slave_writedata                           (oc_i2c_master_0_avalon_slave_writedata),
      .reset_n                                                          (clk_reset_n)
    );

  oc_i2c_master_0 the_oc_i2c_master_0
    (
      .scl_pad_io (scl_pad_io_to_and_from_the_oc_i2c_master_0),
      .sda_pad_io (sda_pad_io_to_and_from_the_oc_i2c_master_0),
      .wb_ack_o   (oc_i2c_master_0_avalon_slave_waitrequest_n),
      .wb_adr_i   (oc_i2c_master_0_avalon_slave_address),
      .wb_clk_i   (clk),
      .wb_cyc_i   (oc_i2c_master_0_avalon_slave_chipselect),
      .wb_dat_i   (oc_i2c_master_0_avalon_slave_writedata),
      .wb_dat_o   (oc_i2c_master_0_avalon_slave_readdata),
      .wb_err_o   (oc_i2c_master_0_avalon_slave_wishbone_err),
      .wb_inta_o  (oc_i2c_master_0_avalon_slave_irq),
      .wb_rst_i   (oc_i2c_master_0_avalon_slave_reset),
      .wb_stb_i   (oc_i2c_master_0_avalon_slave_chipselect),
      .wb_we_i    (oc_i2c_master_0_avalon_slave_write)
    );

  onchip_mem_s1_arbitrator the_onchip_mem_s1
    (
      .clk                                                                (clk),
      .cpu_0_data_master_address_to_slave                                 (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_byteenable                                       (cpu_0_data_master_byteenable),
      .cpu_0_data_master_granted_onchip_mem_s1                            (cpu_0_data_master_granted_onchip_mem_s1),
      .cpu_0_data_master_qualified_request_onchip_mem_s1                  (cpu_0_data_master_qualified_request_onchip_mem_s1),
      .cpu_0_data_master_read                                             (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_onchip_mem_s1                    (cpu_0_data_master_read_data_valid_onchip_mem_s1),
      .cpu_0_data_master_requests_onchip_mem_s1                           (cpu_0_data_master_requests_onchip_mem_s1),
      .cpu_0_data_master_waitrequest                                      (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                                            (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                                        (cpu_0_data_master_writedata),
      .cpu_0_instruction_master_address_to_slave                          (cpu_0_instruction_master_address_to_slave),
      .cpu_0_instruction_master_granted_onchip_mem_s1                     (cpu_0_instruction_master_granted_onchip_mem_s1),
      .cpu_0_instruction_master_latency_counter                           (cpu_0_instruction_master_latency_counter),
      .cpu_0_instruction_master_qualified_request_onchip_mem_s1           (cpu_0_instruction_master_qualified_request_onchip_mem_s1),
      .cpu_0_instruction_master_read                                      (cpu_0_instruction_master_read),
      .cpu_0_instruction_master_read_data_valid_onchip_mem_s1             (cpu_0_instruction_master_read_data_valid_onchip_mem_s1),
      .cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register (cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register),
      .cpu_0_instruction_master_requests_onchip_mem_s1                    (cpu_0_instruction_master_requests_onchip_mem_s1),
      .d1_onchip_mem_s1_end_xfer                                          (d1_onchip_mem_s1_end_xfer),
      .dma_read_master_address_to_slave                                   (dma_read_master_address_to_slave),
      .dma_read_master_chipselect                                         (dma_read_master_chipselect),
      .dma_read_master_flush_qualified_exported                           (dma_read_master_flush_qualified_exported),
      .dma_read_master_granted_onchip_mem_s1                              (dma_read_master_granted_onchip_mem_s1),
      .dma_read_master_latency_counter                                    (dma_read_master_latency_counter),
      .dma_read_master_qualified_request_onchip_mem_s1                    (dma_read_master_qualified_request_onchip_mem_s1),
      .dma_read_master_read_data_valid_onchip_mem_s1                      (dma_read_master_read_data_valid_onchip_mem_s1),
      .dma_read_master_read_data_valid_sdram_0_s1_shift_register          (dma_read_master_read_data_valid_sdram_0_s1_shift_register),
      .dma_read_master_read_n                                             (dma_read_master_read_n),
      .dma_read_master_requests_onchip_mem_s1                             (dma_read_master_requests_onchip_mem_s1),
      .dma_write_master_address_to_slave                                  (dma_write_master_address_to_slave),
      .dma_write_master_byteenable                                        (dma_write_master_byteenable),
      .dma_write_master_chipselect                                        (dma_write_master_chipselect),
      .dma_write_master_granted_onchip_mem_s1                             (dma_write_master_granted_onchip_mem_s1),
      .dma_write_master_qualified_request_onchip_mem_s1                   (dma_write_master_qualified_request_onchip_mem_s1),
      .dma_write_master_requests_onchip_mem_s1                            (dma_write_master_requests_onchip_mem_s1),
      .dma_write_master_write_n                                           (dma_write_master_write_n),
      .dma_write_master_writedata                                         (dma_write_master_writedata),
      .onchip_mem_s1_address                                              (onchip_mem_s1_address),
      .onchip_mem_s1_byteenable                                           (onchip_mem_s1_byteenable),
      .onchip_mem_s1_chipselect                                           (onchip_mem_s1_chipselect),
      .onchip_mem_s1_clken                                                (onchip_mem_s1_clken),
      .onchip_mem_s1_readdata                                             (onchip_mem_s1_readdata),
      .onchip_mem_s1_readdata_from_sa                                     (onchip_mem_s1_readdata_from_sa),
      .onchip_mem_s1_write                                                (onchip_mem_s1_write),
      .onchip_mem_s1_writedata                                            (onchip_mem_s1_writedata),
      .registered_cpu_0_data_master_read_data_valid_onchip_mem_s1         (registered_cpu_0_data_master_read_data_valid_onchip_mem_s1),
      .reset_n                                                            (clk_reset_n)
    );

  onchip_mem the_onchip_mem
    (
      .address    (onchip_mem_s1_address),
      .byteenable (onchip_mem_s1_byteenable),
      .chipselect (onchip_mem_s1_chipselect),
      .clk        (clk),
      .clken      (onchip_mem_s1_clken),
      .readdata   (onchip_mem_s1_readdata),
      .write      (onchip_mem_s1_write),
      .writedata  (onchip_mem_s1_writedata)
    );

  performance_counter_control_slave_arbitrator the_performance_counter_control_slave
    (
      .clk                                                                            (clk),
      .cpu_0_data_master_address_to_slave                                             (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_performance_counter_control_slave                    (cpu_0_data_master_granted_performance_counter_control_slave),
      .cpu_0_data_master_qualified_request_performance_counter_control_slave          (cpu_0_data_master_qualified_request_performance_counter_control_slave),
      .cpu_0_data_master_read                                                         (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_performance_counter_control_slave            (cpu_0_data_master_read_data_valid_performance_counter_control_slave),
      .cpu_0_data_master_requests_performance_counter_control_slave                   (cpu_0_data_master_requests_performance_counter_control_slave),
      .cpu_0_data_master_waitrequest                                                  (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                                                        (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                                                    (cpu_0_data_master_writedata),
      .d1_performance_counter_control_slave_end_xfer                                  (d1_performance_counter_control_slave_end_xfer),
      .performance_counter_control_slave_address                                      (performance_counter_control_slave_address),
      .performance_counter_control_slave_begintransfer                                (performance_counter_control_slave_begintransfer),
      .performance_counter_control_slave_readdata                                     (performance_counter_control_slave_readdata),
      .performance_counter_control_slave_readdata_from_sa                             (performance_counter_control_slave_readdata_from_sa),
      .performance_counter_control_slave_reset_n                                      (performance_counter_control_slave_reset_n),
      .performance_counter_control_slave_write                                        (performance_counter_control_slave_write),
      .performance_counter_control_slave_writedata                                    (performance_counter_control_slave_writedata),
      .registered_cpu_0_data_master_read_data_valid_performance_counter_control_slave (registered_cpu_0_data_master_read_data_valid_performance_counter_control_slave),
      .reset_n                                                                        (clk_reset_n)
    );

  performance_counter the_performance_counter
    (
      .address       (performance_counter_control_slave_address),
      .begintransfer (performance_counter_control_slave_begintransfer),
      .clk           (clk),
      .readdata      (performance_counter_control_slave_readdata),
      .reset_n       (performance_counter_control_slave_reset_n),
      .write         (performance_counter_control_slave_write),
      .writedata     (performance_counter_control_slave_writedata)
    );

  pio_beep_s1_arbitrator the_pio_beep_s1
    (
      .clk                                             (clk),
      .cpu_0_data_master_address_to_slave              (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_pio_beep_s1           (cpu_0_data_master_granted_pio_beep_s1),
      .cpu_0_data_master_qualified_request_pio_beep_s1 (cpu_0_data_master_qualified_request_pio_beep_s1),
      .cpu_0_data_master_read                          (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_pio_beep_s1   (cpu_0_data_master_read_data_valid_pio_beep_s1),
      .cpu_0_data_master_requests_pio_beep_s1          (cpu_0_data_master_requests_pio_beep_s1),
      .cpu_0_data_master_waitrequest                   (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                         (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                     (cpu_0_data_master_writedata),
      .d1_pio_beep_s1_end_xfer                         (d1_pio_beep_s1_end_xfer),
      .pio_beep_s1_address                             (pio_beep_s1_address),
      .pio_beep_s1_chipselect                          (pio_beep_s1_chipselect),
      .pio_beep_s1_reset_n                             (pio_beep_s1_reset_n),
      .pio_beep_s1_write_n                             (pio_beep_s1_write_n),
      .pio_beep_s1_writedata                           (pio_beep_s1_writedata),
      .reset_n                                         (clk_reset_n)
    );

  pio_beep the_pio_beep
    (
      .address    (pio_beep_s1_address),
      .chipselect (pio_beep_s1_chipselect),
      .clk        (clk),
      .out_port   (out_port_from_the_pio_beep),
      .reset_n    (pio_beep_s1_reset_n),
      .write_n    (pio_beep_s1_write_n),
      .writedata  (pio_beep_s1_writedata)
    );

  pio_key_s1_arbitrator the_pio_key_s1
    (
      .clk                                            (clk),
      .cpu_0_data_master_address_to_slave             (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_pio_key_s1           (cpu_0_data_master_granted_pio_key_s1),
      .cpu_0_data_master_qualified_request_pio_key_s1 (cpu_0_data_master_qualified_request_pio_key_s1),
      .cpu_0_data_master_read                         (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_pio_key_s1   (cpu_0_data_master_read_data_valid_pio_key_s1),
      .cpu_0_data_master_requests_pio_key_s1          (cpu_0_data_master_requests_pio_key_s1),
      .cpu_0_data_master_waitrequest                  (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                        (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                    (cpu_0_data_master_writedata),
      .d1_pio_key_s1_end_xfer                         (d1_pio_key_s1_end_xfer),
      .pio_key_s1_address                             (pio_key_s1_address),
      .pio_key_s1_chipselect                          (pio_key_s1_chipselect),
      .pio_key_s1_irq                                 (pio_key_s1_irq),
      .pio_key_s1_irq_from_sa                         (pio_key_s1_irq_from_sa),
      .pio_key_s1_readdata                            (pio_key_s1_readdata),
      .pio_key_s1_readdata_from_sa                    (pio_key_s1_readdata_from_sa),
      .pio_key_s1_reset_n                             (pio_key_s1_reset_n),
      .pio_key_s1_write_n                             (pio_key_s1_write_n),
      .pio_key_s1_writedata                           (pio_key_s1_writedata),
      .reset_n                                        (clk_reset_n)
    );

  pio_key the_pio_key
    (
      .address    (pio_key_s1_address),
      .chipselect (pio_key_s1_chipselect),
      .clk        (clk),
      .in_port    (in_port_to_the_pio_key),
      .irq        (pio_key_s1_irq),
      .readdata   (pio_key_s1_readdata),
      .reset_n    (pio_key_s1_reset_n),
      .write_n    (pio_key_s1_write_n),
      .writedata  (pio_key_s1_writedata)
    );

  pio_led_s1_arbitrator the_pio_led_s1
    (
      .clk                                            (clk),
      .cpu_0_data_master_address_to_slave             (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_pio_led_s1           (cpu_0_data_master_granted_pio_led_s1),
      .cpu_0_data_master_qualified_request_pio_led_s1 (cpu_0_data_master_qualified_request_pio_led_s1),
      .cpu_0_data_master_read                         (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_pio_led_s1   (cpu_0_data_master_read_data_valid_pio_led_s1),
      .cpu_0_data_master_requests_pio_led_s1          (cpu_0_data_master_requests_pio_led_s1),
      .cpu_0_data_master_waitrequest                  (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                        (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                    (cpu_0_data_master_writedata),
      .d1_pio_led_s1_end_xfer                         (d1_pio_led_s1_end_xfer),
      .pio_led_s1_address                             (pio_led_s1_address),
      .pio_led_s1_chipselect                          (pio_led_s1_chipselect),
      .pio_led_s1_reset_n                             (pio_led_s1_reset_n),
      .pio_led_s1_write_n                             (pio_led_s1_write_n),
      .pio_led_s1_writedata                           (pio_led_s1_writedata),
      .reset_n                                        (clk_reset_n)
    );

  pio_led the_pio_led
    (
      .address    (pio_led_s1_address),
      .chipselect (pio_led_s1_chipselect),
      .clk        (clk),
      .out_port   (out_port_from_the_pio_led),
      .reset_n    (pio_led_s1_reset_n),
      .write_n    (pio_led_s1_write_n),
      .writedata  (pio_led_s1_writedata)
    );

  ps2_0_avalon_slave_0_arbitrator the_ps2_0_avalon_slave_0
    (
      .clk                                                      (clk),
      .cpu_0_data_master_address_to_slave                       (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_dbs_address                            (cpu_0_data_master_dbs_address),
      .cpu_0_data_master_granted_ps2_0_avalon_slave_0           (cpu_0_data_master_granted_ps2_0_avalon_slave_0),
      .cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0 (cpu_0_data_master_qualified_request_ps2_0_avalon_slave_0),
      .cpu_0_data_master_read                                   (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_ps2_0_avalon_slave_0   (cpu_0_data_master_read_data_valid_ps2_0_avalon_slave_0),
      .cpu_0_data_master_requests_ps2_0_avalon_slave_0          (cpu_0_data_master_requests_ps2_0_avalon_slave_0),
      .cpu_0_data_master_waitrequest                            (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                                  (cpu_0_data_master_write),
      .d1_ps2_0_avalon_slave_0_end_xfer                         (d1_ps2_0_avalon_slave_0_end_xfer),
      .ps2_0_avalon_slave_0_irq                                 (ps2_0_avalon_slave_0_irq),
      .ps2_0_avalon_slave_0_irq_from_sa                         (ps2_0_avalon_slave_0_irq_from_sa),
      .ps2_0_avalon_slave_0_read_n                              (ps2_0_avalon_slave_0_read_n),
      .ps2_0_avalon_slave_0_readdata                            (ps2_0_avalon_slave_0_readdata),
      .ps2_0_avalon_slave_0_readdata_from_sa                    (ps2_0_avalon_slave_0_readdata_from_sa),
      .reset_n                                                  (clk_reset_n)
    );

  //reset is asserted asynchronously and deasserted synchronously
  nios_reset_clk_domain_synch_module nios_reset_clk_domain_synch
    (
      .clk      (clk),
      .data_in  (1'b1),
      .data_out (clk_reset_n),
      .reset_n  (reset_n_sources)
    );

  //reset sources mux, which is an e_mux
  assign reset_n_sources = ~(~reset_n |
    0 |
    cpu_0_jtag_debug_module_resetrequest_from_sa |
    cpu_0_jtag_debug_module_resetrequest_from_sa);

  ps2_0 the_ps2_0
    (
      .clk      (clk),
      .irq      (ps2_0_avalon_slave_0_irq),
      .kb_clk   (kb_clk_to_the_ps2_0),
      .kb_data  (kb_data_to_the_ps2_0),
      .read_n   (ps2_0_avalon_slave_0_read_n),
      .readdata (ps2_0_avalon_slave_0_readdata),
      .reset_n  (clk_reset_n)
    );

  pwm_interface_0_control_slave_arbitrator the_pwm_interface_0_control_slave
    (
      .clk                                                               (clk),
      .cpu_0_data_master_address_to_slave                                (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_pwm_interface_0_control_slave           (cpu_0_data_master_granted_pwm_interface_0_control_slave),
      .cpu_0_data_master_qualified_request_pwm_interface_0_control_slave (cpu_0_data_master_qualified_request_pwm_interface_0_control_slave),
      .cpu_0_data_master_read                                            (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_pwm_interface_0_control_slave   (cpu_0_data_master_read_data_valid_pwm_interface_0_control_slave),
      .cpu_0_data_master_requests_pwm_interface_0_control_slave          (cpu_0_data_master_requests_pwm_interface_0_control_slave),
      .cpu_0_data_master_waitrequest                                     (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                                           (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                                       (cpu_0_data_master_writedata),
      .d1_pwm_interface_0_control_slave_end_xfer                         (d1_pwm_interface_0_control_slave_end_xfer),
      .pwm_interface_0_control_slave_address                             (pwm_interface_0_control_slave_address),
      .pwm_interface_0_control_slave_chipselect                          (pwm_interface_0_control_slave_chipselect),
      .pwm_interface_0_control_slave_read                                (pwm_interface_0_control_slave_read),
      .pwm_interface_0_control_slave_readdata                            (pwm_interface_0_control_slave_readdata),
      .pwm_interface_0_control_slave_readdata_from_sa                    (pwm_interface_0_control_slave_readdata_from_sa),
      .pwm_interface_0_control_slave_write                               (pwm_interface_0_control_slave_write),
      .pwm_interface_0_control_slave_writedata                           (pwm_interface_0_control_slave_writedata),
      .reset_n                                                           (clk_reset_n)
    );

  pwm_interface_0 the_pwm_interface_0
    (
      .address     (pwm_interface_0_control_slave_address),
      .chip_select (pwm_interface_0_control_slave_chipselect),
      .clock       (clk),
      .pwm_out     (pwm_out_from_the_pwm_interface_0),
      .read        (pwm_interface_0_control_slave_read),
      .read_data   (pwm_interface_0_control_slave_readdata),
      .reset_n     (clk_reset_n),
      .write       (pwm_interface_0_control_slave_write),
      .write_data  (pwm_interface_0_control_slave_writedata)
    );

  sdram_0_s1_arbitrator the_sdram_0_s1
    (
      .clk                                                                (clk),
      .cpu_0_data_master_address_to_slave                                 (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_byteenable                                       (cpu_0_data_master_byteenable),
      .cpu_0_data_master_byteenable_sdram_0_s1                            (cpu_0_data_master_byteenable_sdram_0_s1),
      .cpu_0_data_master_dbs_address                                      (cpu_0_data_master_dbs_address),
      .cpu_0_data_master_dbs_write_16                                     (cpu_0_data_master_dbs_write_16),
      .cpu_0_data_master_granted_sdram_0_s1                               (cpu_0_data_master_granted_sdram_0_s1),
      .cpu_0_data_master_no_byte_enables_and_last_term                    (cpu_0_data_master_no_byte_enables_and_last_term),
      .cpu_0_data_master_qualified_request_sdram_0_s1                     (cpu_0_data_master_qualified_request_sdram_0_s1),
      .cpu_0_data_master_read                                             (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_sdram_0_s1                       (cpu_0_data_master_read_data_valid_sdram_0_s1),
      .cpu_0_data_master_read_data_valid_sdram_0_s1_shift_register        (cpu_0_data_master_read_data_valid_sdram_0_s1_shift_register),
      .cpu_0_data_master_requests_sdram_0_s1                              (cpu_0_data_master_requests_sdram_0_s1),
      .cpu_0_data_master_waitrequest                                      (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                                            (cpu_0_data_master_write),
      .cpu_0_instruction_master_address_to_slave                          (cpu_0_instruction_master_address_to_slave),
      .cpu_0_instruction_master_dbs_address                               (cpu_0_instruction_master_dbs_address),
      .cpu_0_instruction_master_granted_sdram_0_s1                        (cpu_0_instruction_master_granted_sdram_0_s1),
      .cpu_0_instruction_master_latency_counter                           (cpu_0_instruction_master_latency_counter),
      .cpu_0_instruction_master_qualified_request_sdram_0_s1              (cpu_0_instruction_master_qualified_request_sdram_0_s1),
      .cpu_0_instruction_master_read                                      (cpu_0_instruction_master_read),
      .cpu_0_instruction_master_read_data_valid_sdram_0_s1                (cpu_0_instruction_master_read_data_valid_sdram_0_s1),
      .cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register (cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register),
      .cpu_0_instruction_master_requests_sdram_0_s1                       (cpu_0_instruction_master_requests_sdram_0_s1),
      .d1_sdram_0_s1_end_xfer                                             (d1_sdram_0_s1_end_xfer),
      .dma_read_master_address_to_slave                                   (dma_read_master_address_to_slave),
      .dma_read_master_chipselect                                         (dma_read_master_chipselect),
      .dma_read_master_dbs_address                                        (dma_read_master_dbs_address),
      .dma_read_master_flush_qualified_exported                           (dma_read_master_flush_qualified_exported),
      .dma_read_master_granted_sdram_0_s1                                 (dma_read_master_granted_sdram_0_s1),
      .dma_read_master_latency_counter                                    (dma_read_master_latency_counter),
      .dma_read_master_qualified_request_sdram_0_s1                       (dma_read_master_qualified_request_sdram_0_s1),
      .dma_read_master_read_data_valid_sdram_0_s1                         (dma_read_master_read_data_valid_sdram_0_s1),
      .dma_read_master_read_data_valid_sdram_0_s1_shift_register          (dma_read_master_read_data_valid_sdram_0_s1_shift_register),
      .dma_read_master_read_n                                             (dma_read_master_read_n),
      .dma_read_master_requests_sdram_0_s1                                (dma_read_master_requests_sdram_0_s1),
      .dma_write_master_address_to_slave                                  (dma_write_master_address_to_slave),
      .dma_write_master_byteenable                                        (dma_write_master_byteenable),
      .dma_write_master_byteenable_sdram_0_s1                             (dma_write_master_byteenable_sdram_0_s1),
      .dma_write_master_chipselect                                        (dma_write_master_chipselect),
      .dma_write_master_dbs_address                                       (dma_write_master_dbs_address),
      .dma_write_master_dbs_write_16                                      (dma_write_master_dbs_write_16),
      .dma_write_master_granted_sdram_0_s1                                (dma_write_master_granted_sdram_0_s1),
      .dma_write_master_qualified_request_sdram_0_s1                      (dma_write_master_qualified_request_sdram_0_s1),
      .dma_write_master_requests_sdram_0_s1                               (dma_write_master_requests_sdram_0_s1),
      .dma_write_master_write_n                                           (dma_write_master_write_n),
      .reset_n                                                            (clk_reset_n),
      .sdram_0_s1_address                                                 (sdram_0_s1_address),
      .sdram_0_s1_byteenable_n                                            (sdram_0_s1_byteenable_n),
      .sdram_0_s1_chipselect                                              (sdram_0_s1_chipselect),
      .sdram_0_s1_read_n                                                  (sdram_0_s1_read_n),
      .sdram_0_s1_readdata                                                (sdram_0_s1_readdata),
      .sdram_0_s1_readdata_from_sa                                        (sdram_0_s1_readdata_from_sa),
      .sdram_0_s1_readdatavalid                                           (sdram_0_s1_readdatavalid),
      .sdram_0_s1_reset_n                                                 (sdram_0_s1_reset_n),
      .sdram_0_s1_waitrequest                                             (sdram_0_s1_waitrequest),
      .sdram_0_s1_waitrequest_from_sa                                     (sdram_0_s1_waitrequest_from_sa),
      .sdram_0_s1_write_n                                                 (sdram_0_s1_write_n),
      .sdram_0_s1_writedata                                               (sdram_0_s1_writedata)
    );

  sdram_0 the_sdram_0
    (
      .az_addr        (sdram_0_s1_address),
      .az_be_n        (sdram_0_s1_byteenable_n),
      .az_cs          (sdram_0_s1_chipselect),
      .az_data        (sdram_0_s1_writedata),
      .az_rd_n        (sdram_0_s1_read_n),
      .az_wr_n        (sdram_0_s1_write_n),
      .clk            (clk),
      .reset_n        (sdram_0_s1_reset_n),
      .za_data        (sdram_0_s1_readdata),
      .za_valid       (sdram_0_s1_readdatavalid),
      .za_waitrequest (sdram_0_s1_waitrequest),
      .zs_addr        (zs_addr_from_the_sdram_0),
      .zs_ba          (zs_ba_from_the_sdram_0),
      .zs_cas_n       (zs_cas_n_from_the_sdram_0),
      .zs_cke         (zs_cke_from_the_sdram_0),
      .zs_cs_n        (zs_cs_n_from_the_sdram_0),
      .zs_dq          (zs_dq_to_and_from_the_sdram_0),
      .zs_dqm         (zs_dqm_from_the_sdram_0),
      .zs_ras_n       (zs_ras_n_from_the_sdram_0),
      .zs_we_n        (zs_we_n_from_the_sdram_0)
    );

  seg78led_0_avalon_slave_0_arbitrator the_seg78led_0_avalon_slave_0
    (
      .clk                                                                  (clk),
      .cpu_0_data_master_address_to_slave                                   (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_byteenable                                         (cpu_0_data_master_byteenable),
      .cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0               (cpu_0_data_master_byteenable_seg78led_0_avalon_slave_0),
      .cpu_0_data_master_dbs_address                                        (cpu_0_data_master_dbs_address),
      .cpu_0_data_master_dbs_write_8                                        (cpu_0_data_master_dbs_write_8),
      .cpu_0_data_master_granted_seg78led_0_avalon_slave_0                  (cpu_0_data_master_granted_seg78led_0_avalon_slave_0),
      .cpu_0_data_master_no_byte_enables_and_last_term                      (cpu_0_data_master_no_byte_enables_and_last_term),
      .cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0        (cpu_0_data_master_qualified_request_seg78led_0_avalon_slave_0),
      .cpu_0_data_master_read                                               (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_seg78led_0_avalon_slave_0          (cpu_0_data_master_read_data_valid_seg78led_0_avalon_slave_0),
      .cpu_0_data_master_requests_seg78led_0_avalon_slave_0                 (cpu_0_data_master_requests_seg78led_0_avalon_slave_0),
      .cpu_0_data_master_write                                              (cpu_0_data_master_write),
      .cpu_0_instruction_master_address_to_slave                            (cpu_0_instruction_master_address_to_slave),
      .cpu_0_instruction_master_dbs_address                                 (cpu_0_instruction_master_dbs_address),
      .cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0           (cpu_0_instruction_master_granted_seg78led_0_avalon_slave_0),
      .cpu_0_instruction_master_latency_counter                             (cpu_0_instruction_master_latency_counter),
      .cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0 (cpu_0_instruction_master_qualified_request_seg78led_0_avalon_slave_0),
      .cpu_0_instruction_master_read                                        (cpu_0_instruction_master_read),
      .cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register   (cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register),
      .cpu_0_instruction_master_read_data_valid_seg78led_0_avalon_slave_0   (cpu_0_instruction_master_read_data_valid_seg78led_0_avalon_slave_0),
      .cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0          (cpu_0_instruction_master_requests_seg78led_0_avalon_slave_0),
      .d1_seg78led_0_avalon_slave_0_end_xfer                                (d1_seg78led_0_avalon_slave_0_end_xfer),
      .reset_n                                                              (clk_reset_n),
      .seg78led_0_avalon_slave_0_address                                    (seg78led_0_avalon_slave_0_address),
      .seg78led_0_avalon_slave_0_read_n                                     (seg78led_0_avalon_slave_0_read_n),
      .seg78led_0_avalon_slave_0_readdata                                   (seg78led_0_avalon_slave_0_readdata),
      .seg78led_0_avalon_slave_0_readdata_from_sa                           (seg78led_0_avalon_slave_0_readdata_from_sa),
      .seg78led_0_avalon_slave_0_wait_counter_eq_0                          (seg78led_0_avalon_slave_0_wait_counter_eq_0),
      .seg78led_0_avalon_slave_0_wait_counter_eq_1                          (seg78led_0_avalon_slave_0_wait_counter_eq_1),
      .seg78led_0_avalon_slave_0_write_n                                    (seg78led_0_avalon_slave_0_write_n),
      .seg78led_0_avalon_slave_0_writedata                                  (seg78led_0_avalon_slave_0_writedata)
    );

  seg78led_0 the_seg78led_0
    (
      .address   (seg78led_0_avalon_slave_0_address),
      .clk       (clk),
      .read_n    (seg78led_0_avalon_slave_0_read_n),
      .readdata  (seg78led_0_avalon_slave_0_readdata),
      .reset_n   (clk_reset_n),
      .seg_com   (seg_com_from_the_seg78led_0),
      .seg_data  (seg_data_from_the_seg78led_0),
      .write_n   (seg78led_0_avalon_slave_0_write_n),
      .writedata (seg78led_0_avalon_slave_0_writedata)
    );

  sysid_control_slave_arbitrator the_sysid_control_slave
    (
      .clk                                                     (clk),
      .cpu_0_data_master_address_to_slave                      (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_sysid_control_slave           (cpu_0_data_master_granted_sysid_control_slave),
      .cpu_0_data_master_qualified_request_sysid_control_slave (cpu_0_data_master_qualified_request_sysid_control_slave),
      .cpu_0_data_master_read                                  (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_sysid_control_slave   (cpu_0_data_master_read_data_valid_sysid_control_slave),
      .cpu_0_data_master_requests_sysid_control_slave          (cpu_0_data_master_requests_sysid_control_slave),
      .cpu_0_data_master_write                                 (cpu_0_data_master_write),
      .d1_sysid_control_slave_end_xfer                         (d1_sysid_control_slave_end_xfer),
      .reset_n                                                 (clk_reset_n),
      .sysid_control_slave_address                             (sysid_control_slave_address),
      .sysid_control_slave_readdata                            (sysid_control_slave_readdata),
      .sysid_control_slave_readdata_from_sa                    (sysid_control_slave_readdata_from_sa)
    );

  sysid the_sysid
    (
      .address  (sysid_control_slave_address),
      .readdata (sysid_control_slave_readdata)
    );

  timer_0_s1_arbitrator the_timer_0_s1
    (
      .clk                                            (clk),
      .cpu_0_data_master_address_to_slave             (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_timer_0_s1           (cpu_0_data_master_granted_timer_0_s1),
      .cpu_0_data_master_qualified_request_timer_0_s1 (cpu_0_data_master_qualified_request_timer_0_s1),
      .cpu_0_data_master_read                         (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_timer_0_s1   (cpu_0_data_master_read_data_valid_timer_0_s1),
      .cpu_0_data_master_requests_timer_0_s1          (cpu_0_data_master_requests_timer_0_s1),
      .cpu_0_data_master_waitrequest                  (cpu_0_data_master_waitrequest),
      .cpu_0_data_master_write                        (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                    (cpu_0_data_master_writedata),
      .d1_timer_0_s1_end_xfer                         (d1_timer_0_s1_end_xfer),
      .reset_n                                        (clk_reset_n),
      .timer_0_s1_address                             (timer_0_s1_address),
      .timer_0_s1_chipselect                          (timer_0_s1_chipselect),
      .timer_0_s1_irq                                 (timer_0_s1_irq),
      .timer_0_s1_irq_from_sa                         (timer_0_s1_irq_from_sa),
      .timer_0_s1_readdata                            (timer_0_s1_readdata),
      .timer_0_s1_readdata_from_sa                    (timer_0_s1_readdata_from_sa),
      .timer_0_s1_reset_n                             (timer_0_s1_reset_n),
      .timer_0_s1_write_n                             (timer_0_s1_write_n),
      .timer_0_s1_writedata                           (timer_0_s1_writedata)
    );

  timer_0 the_timer_0
    (
      .address    (timer_0_s1_address),
      .chipselect (timer_0_s1_chipselect),
      .clk        (clk),
      .irq        (timer_0_s1_irq),
      .readdata   (timer_0_s1_readdata),
      .reset_n    (timer_0_s1_reset_n),
      .write_n    (timer_0_s1_write_n),
      .writedata  (timer_0_s1_writedata)
    );

  tri_state_bridge_0_avalon_slave_arbitrator the_tri_state_bridge_0_avalon_slave
    (
      .chipselect_to_the_lcd_tri_12864_0                                                    (chipselect_to_the_lcd_tri_12864_0),
      .chipselect_to_the_lcd_tri_1602_0                                                     (chipselect_to_the_lcd_tri_1602_0),
      .clk                                                                                  (clk),
      .cpu_0_data_master_address_to_slave                                                   (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_byteenable                                                         (cpu_0_data_master_byteenable),
      .cpu_0_data_master_byteenable_flash_s1                                                (cpu_0_data_master_byteenable_flash_s1),
      .cpu_0_data_master_dbs_address                                                        (cpu_0_data_master_dbs_address),
      .cpu_0_data_master_dbs_write_8                                                        (cpu_0_data_master_dbs_write_8),
      .cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0                     (cpu_0_data_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_data_master_granted_flash_s1                                                   (cpu_0_data_master_granted_flash_s1),
      .cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0                    (cpu_0_data_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0                     (cpu_0_data_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_data_master_no_byte_enables_and_last_term                                      (cpu_0_data_master_no_byte_enables_and_last_term),
      .cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0           (cpu_0_data_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_data_master_qualified_request_flash_s1                                         (cpu_0_data_master_qualified_request_flash_s1),
      .cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0          (cpu_0_data_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0           (cpu_0_data_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_data_master_read                                                               (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0             (cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_data_master_read_data_valid_flash_s1                                           (cpu_0_data_master_read_data_valid_flash_s1),
      .cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0            (cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0             (cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0                    (cpu_0_data_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_data_master_requests_flash_s1                                                  (cpu_0_data_master_requests_flash_s1),
      .cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0                   (cpu_0_data_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0                    (cpu_0_data_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_data_master_write                                                              (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                                                          (cpu_0_data_master_writedata),
      .cpu_0_instruction_master_address_to_slave                                            (cpu_0_instruction_master_address_to_slave),
      .cpu_0_instruction_master_dbs_address                                                 (cpu_0_instruction_master_dbs_address),
      .cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0              (cpu_0_instruction_master_granted_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_granted_flash_s1                                            (cpu_0_instruction_master_granted_flash_s1),
      .cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0             (cpu_0_instruction_master_granted_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0              (cpu_0_instruction_master_granted_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_latency_counter                                             (cpu_0_instruction_master_latency_counter),
      .cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0    (cpu_0_instruction_master_qualified_request_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_qualified_request_flash_s1                                  (cpu_0_instruction_master_qualified_request_flash_s1),
      .cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0   (cpu_0_instruction_master_qualified_request_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0    (cpu_0_instruction_master_qualified_request_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_read                                                        (cpu_0_instruction_master_read),
      .cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0      (cpu_0_instruction_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_read_data_valid_flash_s1                                    (cpu_0_instruction_master_read_data_valid_flash_s1),
      .cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0     (cpu_0_instruction_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0      (cpu_0_instruction_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register                   (cpu_0_instruction_master_read_data_valid_sdram_0_s1_shift_register),
      .cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0             (cpu_0_instruction_master_requests_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_requests_flash_s1                                           (cpu_0_instruction_master_requests_flash_s1),
      .cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0            (cpu_0_instruction_master_requests_lcd_tri_12864_0_avalon_tristate_slave_0),
      .cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0             (cpu_0_instruction_master_requests_lcd_tri_1602_0_avalon_tristate_slave_0),
      .ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0                             (ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_0),
      .ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1                             (ctrl_rtl8019_0_avalon_tristate_slave_0_wait_counter_eq_1),
      .d1_irq_from_the_ctrl_rtl8019_0                                                       (d1_irq_from_the_ctrl_rtl8019_0),
      .d1_tri_state_bridge_0_avalon_slave_end_xfer                                          (d1_tri_state_bridge_0_avalon_slave_end_xfer),
      .flash_s1_wait_counter_eq_0                                                           (flash_s1_wait_counter_eq_0),
      .flash_s1_wait_counter_eq_1                                                           (flash_s1_wait_counter_eq_1),
      .incoming_tri_state_bridge_0_data                                                     (incoming_tri_state_bridge_0_data),
      .incoming_tri_state_bridge_0_data_with_Xs_converted_to_0                              (incoming_tri_state_bridge_0_data_with_Xs_converted_to_0),
      .irq_from_the_ctrl_rtl8019_0                                                          (irq_from_the_ctrl_rtl8019_0),
      .lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0                            (lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_0),
      .lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1                            (lcd_tri_12864_0_avalon_tristate_slave_0_wait_counter_eq_1),
      .lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0                             (lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_0),
      .lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1                             (lcd_tri_1602_0_avalon_tristate_slave_0_wait_counter_eq_1),
      .read_n_to_the_ctrl_rtl8019_0                                                         (read_n_to_the_ctrl_rtl8019_0),
      .registered_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0  (registered_cpu_0_data_master_read_data_valid_ctrl_rtl8019_0_avalon_tristate_slave_0),
      .registered_cpu_0_data_master_read_data_valid_flash_s1                                (registered_cpu_0_data_master_read_data_valid_flash_s1),
      .registered_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0 (registered_cpu_0_data_master_read_data_valid_lcd_tri_12864_0_avalon_tristate_slave_0),
      .registered_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0  (registered_cpu_0_data_master_read_data_valid_lcd_tri_1602_0_avalon_tristate_slave_0),
      .reset_n                                                                              (clk_reset_n),
      .rst_to_the_ctrl_rtl8019_0                                                            (rst_to_the_ctrl_rtl8019_0),
      .select_n_to_the_ctrl_rtl8019_0                                                       (select_n_to_the_ctrl_rtl8019_0),
      .select_n_to_the_flash                                                                (select_n_to_the_flash),
      .tri_state_bridge_0_address                                                           (tri_state_bridge_0_address),
      .tri_state_bridge_0_data                                                              (tri_state_bridge_0_data),
      .tri_state_bridge_0_read                                                              (tri_state_bridge_0_read),
      .tri_state_bridge_0_readn                                                             (tri_state_bridge_0_readn),
      .tri_state_bridge_0_write                                                             (tri_state_bridge_0_write),
      .write_n_to_the_ctrl_rtl8019_0                                                        (write_n_to_the_ctrl_rtl8019_0),
      .write_n_to_the_flash                                                                 (write_n_to_the_flash)
    );

  uart_usb_s1_arbitrator the_uart_usb_s1
    (
      .clk                                             (clk),
      .cpu_0_data_master_address_to_slave              (cpu_0_data_master_address_to_slave),
      .cpu_0_data_master_granted_uart_usb_s1           (cpu_0_data_master_granted_uart_usb_s1),
      .cpu_0_data_master_qualified_request_uart_usb_s1 (cpu_0_data_master_qualified_request_uart_usb_s1),
      .cpu_0_data_master_read                          (cpu_0_data_master_read),
      .cpu_0_data_master_read_data_valid_uart_usb_s1   (cpu_0_data_master_read_data_valid_uart_usb_s1),
      .cpu_0_data_master_requests_uart_usb_s1          (cpu_0_data_master_requests_uart_usb_s1),
      .cpu_0_data_master_write                         (cpu_0_data_master_write),
      .cpu_0_data_master_writedata                     (cpu_0_data_master_writedata),
      .d1_uart_usb_s1_end_xfer                         (d1_uart_usb_s1_end_xfer),
      .reset_n                                         (clk_reset_n),
      .uart_usb_s1_address                             (uart_usb_s1_address),
      .uart_usb_s1_begintransfer                       (uart_usb_s1_begintransfer),
      .uart_usb_s1_chipselect                          (uart_usb_s1_chipselect),
      .uart_usb_s1_dataavailable                       (uart_usb_s1_dataavailable),
      .uart_usb_s1_dataavailable_from_sa               (uart_usb_s1_dataavailable_from_sa),
      .uart_usb_s1_irq                                 (uart_usb_s1_irq),
      .uart_usb_s1_irq_from_sa                         (uart_usb_s1_irq_from_sa),
      .uart_usb_s1_read_n                              (uart_usb_s1_read_n),
      .uart_usb_s1_readdata                            (uart_usb_s1_readdata),
      .uart_usb_s1_readdata_from_sa                    (uart_usb_s1_readdata_from_sa),
      .uart_usb_s1_readyfordata                        (uart_usb_s1_readyfordata),
      .uart_usb_s1_readyfordata_from_sa                (uart_usb_s1_readyfordata_from_sa),
      .uart_usb_s1_reset_n                             (uart_usb_s1_reset_n),
      .uart_usb_s1_write_n                             (uart_usb_s1_write_n),
      .uart_usb_s1_writedata                           (uart_usb_s1_writedata)
    );

  uart_usb the_uart_usb
    (
      .address       (uart_usb_s1_address),
      .begintransfer (uart_usb_s1_begintransfer),
      .chipselect    (uart_usb_s1_chipselect),
      .clk           (clk),
      .dataavailable (uart_usb_s1_dataavailable),
      .irq           (uart_usb_s1_irq),
      .read_n        (uart_usb_s1_read_n),
      .readdata      (uart_usb_s1_readdata),
      .readyfordata  (uart_usb_s1_readyfordata),
      .reset_n       (uart_usb_s1_reset_n),
      .rxd           (rxd_to_the_uart_usb),
      .txd           (txd_from_the_uart_usb),
      .write_n       (uart_usb_s1_write_n),
      .writedata     (uart_usb_s1_writedata)
    );

  //dma_read_master_endofpacket of type endofpacket does not connect to anything so wire it to default (0)
  assign dma_read_master_endofpacket = 0;

  //dma_write_master_endofpacket of type endofpacket does not connect to anything so wire it to default (0)
  assign dma_write_master_endofpacket = 0;


endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module flash_lane0_module (
                            // inputs:
                             data,
                             rdaddress,
                             rdclken,
                             wraddress,
                             wrclock,
                             wren,

                            // outputs:
                             q
                          )
;

  output  [  7: 0] q;
  input   [  7: 0] data;
  input   [ 22: 0] rdaddress;
  input            rdclken;
  input   [ 22: 0] wraddress;
  input            wrclock;
  input            wren;

  reg     [  7: 0] mem_array [8388607: 0];
  wire    [  7: 0] q;
  reg     [ 22: 0] read_address;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  always @(rdaddress)
    begin
      if (1)
          read_address <= rdaddress;
    end


  // Data read is asynchronous.
  assign q = mem_array[read_address];

initial
    $readmemh("flash.dat", mem_array);
  always @(posedge wrclock)
    begin
      // Write data
      if (wren)
          mem_array[wraddress] <= data;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on
//synthesis read_comments_as_HDL on
//  always @(rdaddress)
//    begin
//      if (1)
//          read_address <= rdaddress;
//    end
//
//
//  lpm_ram_dp lpm_ram_dp_component
//    (
//      .data (data),
//      .q (q),
//      .rdaddress (read_address),
//      .rdclken (rdclken),
//      .wraddress (wraddress),
//      .wrclock (wrclock),
//      .wren (wren)
//    );
//
//  defparam lpm_ram_dp_component.lpm_file = "flash.mif",
//           lpm_ram_dp_component.lpm_hint = "USE_EAB=ON",
//           lpm_ram_dp_component.lpm_indata = "REGISTERED",
//           lpm_ram_dp_component.lpm_outdata = "UNREGISTERED",
//           lpm_ram_dp_component.lpm_rdaddress_control = "UNREGISTERED",
//           lpm_ram_dp_component.lpm_width = 8,
//           lpm_ram_dp_component.lpm_widthad = 23,
//           lpm_ram_dp_component.lpm_wraddress_control = "REGISTERED",
//           lpm_ram_dp_component.suppress_memory_conversion_warnings = "ON";
//
//synthesis read_comments_as_HDL off

endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module flash (
               // inputs:
                address,
                read_n,
                select_n,
                write_n,

               // outputs:
                data
             )
;

  inout   [  7: 0] data;
  input   [ 22: 0] address;
  input            read_n;
  input            select_n;
  input            write_n;

  wire    [  7: 0] data;
  wire    [  7: 0] data_0;
  wire    [  7: 0] logic_vector_gasket;
  wire    [  7: 0] q_0;
  //s1, which is an e_ptf_slave

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  assign logic_vector_gasket = data;
  assign data_0 = logic_vector_gasket[7 : 0];
  //flash_lane0, which is an e_ram
  flash_lane0_module flash_lane0
    (
      .data      (data_0),
      .q         (q_0),
      .rdaddress (address),
      .rdclken   (1'b1),
      .wraddress (address),
      .wrclock   (write_n),
      .wren      (~select_n)
    );

  assign data = (~select_n & ~read_n)? q_0: {8{1'bz}};

//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


//synthesis translate_off



// <ALTERA_NOTE> CODE INSERTED BETWEEN HERE

// AND HERE WILL BE PRESERVED </ALTERA_NOTE>


// If user logic components use Altsync_Ram with convert_hex2ver.dll,
// set USE_convert_hex2ver in the user comments section above

// `ifdef USE_convert_hex2ver
// `else
// `define NO_PLI 1
// `endif

`include "g:/altera/72/quartus/eda/sim_lib/altera_mf.v"
`include "g:/altera/72/quartus/eda/sim_lib/220model.v"
`include "g:/altera/72/quartus/eda/sim_lib/sgate.v"
`include "timer_0.v"
`include "cpu_0_fpoint.v"
`include "sysid.v"
`include "E_RST.v"
`include "cpu_0_test_bench.v"
`include "cpu_0_mult_cell.v"
`include "cpu_0_jtag_debug_module.v"
`include "cpu_0_jtag_debug_module_wrapper.v"
`include "cpu_0.v"
`include "dma.v"
`include "pio_led.v"
`include "jtag_uart.v"
// convert.vhd
// data_scanC.vhd
// mydff.vhd
`include "ps2_top.v"
`include "ps2_0.v"
`include "sdram_0.v"
`include "sdram_0_test_component.v"
`include "uart_usb.v"
`include "ADC_TLC549.v"
`include "adc_tlc549_0.v"
`include "performance_counter.v"
`include "seg78led.v"
`include "seg78led_0.v"
`include "pwm_avalon_interface.v"
`include "pwm_register_file.v"
`include "pwm_task_logic.v"
`include "pwm_interface_0.v"
`include "pio_key.v"
`include "onchip_mem.v"
// i2c_master_bit_ctrl.vhd
// i2c_master_byte_ctrl.vhd
// i2c_master_top.vhd
// oc_i2c_master.vhd
`include "oc_i2c_master_0.v"
`include "lcd12864_cs.v"
`include "pio_beep.v"
`include "tlc5620_avalon_interface.v"
`include "tlc5620_register_file.v"
`include "tlc5620_task_logic.v"
`include "avalon_tlc5620_0.v"

`timescale 1ns / 1ps

module test_bench 
;


  wire             AD_CLK_from_the_adc_tlc549_0;
  wire             AD_CS_from_the_adc_tlc549_0;
  wire             AD_DATA_to_the_adc_tlc549_0;
  wire             chipselect_to_the_lcd_tri_12864_0;
  wire             chipselect_to_the_lcd_tri_1602_0;
  reg              clk;
  wire    [  4: 0] cpu_0_custom_instruction_master_multi_a;
  wire    [  4: 0] cpu_0_custom_instruction_master_multi_b;
  wire    [  4: 0] cpu_0_custom_instruction_master_multi_c;
  wire             cpu_0_custom_instruction_master_multi_estatus;
  wire    [ 31: 0] cpu_0_custom_instruction_master_multi_ipending;
  wire             cpu_0_custom_instruction_master_multi_readra;
  wire             cpu_0_custom_instruction_master_multi_readrb;
  wire             cpu_0_custom_instruction_master_multi_status;
  wire             cpu_0_custom_instruction_master_multi_writerc;
  wire             dac_clk_from_the_avalon_tlc5620_0;
  wire             dac_data_from_the_avalon_tlc5620_0;
  wire             dac_ldac_from_the_avalon_tlc5620_0;
  wire             dac_load_from_the_avalon_tlc5620_0;
  wire             dma_control_port_slave_readyfordata_from_sa;
  wire             dma_read_master_endofpacket;
  wire             dma_write_master_endofpacket;
  wire    [  3: 0] in_port_to_the_pio_key;
  wire             irq_from_the_ctrl_rtl8019_0;
  wire             jtag_uart_avalon_jtag_slave_dataavailable_from_sa;
  wire             jtag_uart_avalon_jtag_slave_readyfordata_from_sa;
  wire             kb_clk_to_the_ps2_0;
  wire             kb_data_to_the_ps2_0;
  wire             oc_i2c_master_0_avalon_slave_wishbone_err_from_sa;
  wire             out_port_from_the_E_RST;
  wire    [  1: 0] out_port_from_the_lcd12864_cs;
  wire             out_port_from_the_pio_beep;
  wire    [  3: 0] out_port_from_the_pio_led;
  wire             pwm_out_from_the_pwm_interface_0;
  wire             read_n_to_the_ctrl_rtl8019_0;
  reg              reset_n;
  wire             rst_to_the_ctrl_rtl8019_0;
  wire             rxd_to_the_uart_usb;
  wire             scl_pad_io_to_and_from_the_oc_i2c_master_0;
  wire             sda_pad_io_to_and_from_the_oc_i2c_master_0;
  wire    [  7: 0] seg_com_from_the_seg78led_0;
  wire    [  7: 0] seg_data_from_the_seg78led_0;
  wire             select_n_to_the_ctrl_rtl8019_0;
  wire             select_n_to_the_flash;
  wire    [ 22: 0] tri_state_bridge_0_address;
  wire    [  7: 0] tri_state_bridge_0_data;
  wire             tri_state_bridge_0_read;
  wire             tri_state_bridge_0_readn;
  wire             tri_state_bridge_0_write;
  wire             txd_from_the_uart_usb;
  wire             uart_usb_s1_dataavailable_from_sa;
  wire             uart_usb_s1_readyfordata_from_sa;
  wire             write_n_to_the_ctrl_rtl8019_0;
  wire             write_n_to_the_flash;
  wire    [ 11: 0] zs_addr_from_the_sdram_0;
  wire    [  1: 0] zs_ba_from_the_sdram_0;
  wire             zs_cas_n_from_the_sdram_0;
  wire             zs_cke_from_the_sdram_0;
  wire             zs_cs_n_from_the_sdram_0;
  wire    [ 15: 0] zs_dq_to_and_from_the_sdram_0;
  wire    [  1: 0] zs_dqm_from_the_sdram_0;
  wire             zs_ras_n_from_the_sdram_0;
  wire             zs_we_n_from_the_sdram_0;


// <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
//  add your signals and additional architecture here
// AND HERE WILL BE PRESERVED </ALTERA_NOTE>

  //Set us up the Dut
  nios DUT
    (
      .AD_CLK_from_the_adc_tlc549_0               (AD_CLK_from_the_adc_tlc549_0),
      .AD_CS_from_the_adc_tlc549_0                (AD_CS_from_the_adc_tlc549_0),
      .AD_DATA_to_the_adc_tlc549_0                (AD_DATA_to_the_adc_tlc549_0),
      .chipselect_to_the_lcd_tri_12864_0          (chipselect_to_the_lcd_tri_12864_0),
      .chipselect_to_the_lcd_tri_1602_0           (chipselect_to_the_lcd_tri_1602_0),
      .clk                                        (clk),
      .dac_clk_from_the_avalon_tlc5620_0          (dac_clk_from_the_avalon_tlc5620_0),
      .dac_data_from_the_avalon_tlc5620_0         (dac_data_from_the_avalon_tlc5620_0),
      .dac_ldac_from_the_avalon_tlc5620_0         (dac_ldac_from_the_avalon_tlc5620_0),
      .dac_load_from_the_avalon_tlc5620_0         (dac_load_from_the_avalon_tlc5620_0),
      .in_port_to_the_pio_key                     (in_port_to_the_pio_key),
      .irq_from_the_ctrl_rtl8019_0                (irq_from_the_ctrl_rtl8019_0),
      .kb_clk_to_the_ps2_0                        (kb_clk_to_the_ps2_0),
      .kb_data_to_the_ps2_0                       (kb_data_to_the_ps2_0),
      .out_port_from_the_E_RST                    (out_port_from_the_E_RST),
      .out_port_from_the_lcd12864_cs              (out_port_from_the_lcd12864_cs),
      .out_port_from_the_pio_beep                 (out_port_from_the_pio_beep),
      .out_port_from_the_pio_led                  (out_port_from_the_pio_led),
      .pwm_out_from_the_pwm_interface_0           (pwm_out_from_the_pwm_interface_0),
      .read_n_to_the_ctrl_rtl8019_0               (read_n_to_the_ctrl_rtl8019_0),
      .reset_n                                    (reset_n),
      .rst_to_the_ctrl_rtl8019_0                  (rst_to_the_ctrl_rtl8019_0),
      .rxd_to_the_uart_usb                        (rxd_to_the_uart_usb),
      .scl_pad_io_to_and_from_the_oc_i2c_master_0 (scl_pad_io_to_and_from_the_oc_i2c_master_0),
      .sda_pad_io_to_and_from_the_oc_i2c_master_0 (sda_pad_io_to_and_from_the_oc_i2c_master_0),
      .seg_com_from_the_seg78led_0                (seg_com_from_the_seg78led_0),
      .seg_data_from_the_seg78led_0               (seg_data_from_the_seg78led_0),
      .select_n_to_the_ctrl_rtl8019_0             (select_n_to_the_ctrl_rtl8019_0),
      .select_n_to_the_flash                      (select_n_to_the_flash),
      .tri_state_bridge_0_address                 (tri_state_bridge_0_address),
      .tri_state_bridge_0_data                    (tri_state_bridge_0_data),
      .tri_state_bridge_0_read                    (tri_state_bridge_0_read),
      .tri_state_bridge_0_readn                   (tri_state_bridge_0_readn),
      .tri_state_bridge_0_write                   (tri_state_bridge_0_write),
      .txd_from_the_uart_usb                      (txd_from_the_uart_usb),
      .write_n_to_the_ctrl_rtl8019_0              (write_n_to_the_ctrl_rtl8019_0),
      .write_n_to_the_flash                       (write_n_to_the_flash),
      .zs_addr_from_the_sdram_0                   (zs_addr_from_the_sdram_0),
      .zs_ba_from_the_sdram_0                     (zs_ba_from_the_sdram_0),
      .zs_cas_n_from_the_sdram_0                  (zs_cas_n_from_the_sdram_0),
      .zs_cke_from_the_sdram_0                    (zs_cke_from_the_sdram_0),
      .zs_cs_n_from_the_sdram_0                   (zs_cs_n_from_the_sdram_0),
      .zs_dq_to_and_from_the_sdram_0              (zs_dq_to_and_from_the_sdram_0),
      .zs_dqm_from_the_sdram_0                    (zs_dqm_from_the_sdram_0),
      .zs_ras_n_from_the_sdram_0                  (zs_ras_n_from_the_sdram_0),
      .zs_we_n_from_the_sdram_0                   (zs_we_n_from_the_sdram_0)
    );

  flash the_flash
    (
      .address  (tri_state_bridge_0_address),
      .data     (tri_state_bridge_0_data),
      .read_n   (tri_state_bridge_0_readn),
      .select_n (select_n_to_the_flash),
      .write_n  (write_n_to_the_flash)
    );

  //default value specified in MODULE pio_key ptf port section
  assign in_port_to_the_pio_key = 0;

  sdram_0_test_component the_sdram_0_test_component
    (
      .clk      (clk),
      .zs_addr  (zs_addr_from_the_sdram_0),
      .zs_ba    (zs_ba_from_the_sdram_0),
      .zs_cas_n (zs_cas_n_from_the_sdram_0),
      .zs_cke   (zs_cke_from_the_sdram_0),
      .zs_cs_n  (zs_cs_n_from_the_sdram_0),
      .zs_dq    (zs_dq_to_and_from_the_sdram_0),
      .zs_dqm   (zs_dqm_from_the_sdram_0),
      .zs_ras_n (zs_ras_n_from_the_sdram_0),
      .zs_we_n  (zs_we_n_from_the_sdram_0)
    );

  initial
    clk = 1'b0;
  always
    #10 clk <= ~clk;
  
  initial 
    begin
      reset_n <= 0;
      #200 reset_n <= 1;
    end

endmodule


//synthesis translate_on